# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

DEFAULT_ADMIN_GROUP = None

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

TABLE_MANGLE    = 'mangle'
TABLE_CORRELATE = 'correlate'
TABLE_NOTIFY    = 'notify'

TABLE_DEFAULT_POLITY_TARGET = 'continue'

DEFAULT_TABLES = [
	[30, TABLE_MANGLE   ],
	[50, TABLE_CORRELATE],
	[70, TABLE_NOTIFY   ],
]

DEFAULT_CHAIN = 'default'

RESERVED_CHAIN_NAMES = [ DEFAULT_CHAIN, ]  # ALTRI NOMI RISERVATI PER LE CATENE?

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

FIRST_RULE_POS = 1

# Le posizioni delle regole nelle chain sono numerate da 1 a N
# La posizione 0 non esiste
# La posizione -1 e' la policy di default 
RULESTACK_POS_FIRSTRULE = FIRST_RULE_POS
RULESTACK_POS_POLICY    = -1 

RULE_STATE_ACTIVE         = 0
RULE_STATE_DISABLED       = 1
RULE_STATE_DISABLED_ERROR = 2


#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

# Routing flow return values
ROUTING_OUTCOME_ERROR    = 0

ROUTING_OUTCOME_CONTINUE = 100 # routing may continue to next rulestak element
ROUTING_OUTCOME_DROP     = 200 # exit rule, chain, table and stop routing (flush rulestack)

ROUTING_OUTCOME_HOLD     = 300 # exit rule, chain, table. Stop routing, save stack and hold alarm 
ROUTING_OUTCOME_HOLDNEXT = 301 

ROUTING_OUTCOME_MERGED   = 400

ROUTING_OUTCOME_RETURN   = 500 # exit current chian, net step is  rule after jump rule in caller chain
ROUTING_OUTCOME_ENDTABLE = 600 # routing may proceed to the next table only 

ROUTING_OUTCOME_STR = {
	ROUTING_OUTCOME_ERROR   : 'ERROR',
	ROUTING_OUTCOME_CONTINUE: 'CONTINUE',
	ROUTING_OUTCOME_DROP    : 'DROP',
	
	ROUTING_OUTCOME_HOLD    : 'HOLD', 
	ROUTING_OUTCOME_HOLDNEXT: 'HOLDNEXT', 

	ROUTING_OUTCOME_RETURN  : 'RETURN',
	ROUTING_OUTCOME_ENDTABLE: 'ENDTABLE',

	ROUTING_OUTCOME_MERGED  : 'MERGED',
}


#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

# Possibili stati di un allarme
ALARM_STATUS_NEW       = 'new'        # Allarme appena creato.
ALARM_STATUS_ROUTING   = 'routing'    # L'allarme e' in attesa di essere processato completamente (tutti gli stage sono stati completati)
ALARM_STATUS_ERROR     = "error"      # Elaborazione interrota definitivamente con errore
ALARM_STATUS_DROPPED   = "dropped"   
ALARM_STATUS_COMPLETED = "completed"  # Elaborazione finita con successo.
ALARM_STATUS_HOLD      = "hold"       # L'allarme e' in attesa di essere riprocessato 

ALARM_STATUS_MERGED    = "merged"     # Questo allarme e' stato processato e "mergato" da un allarme creato exnuovo

_ALARM_STATUS_STR_DICT = {
	 ALARM_STATUS_NEW       : 'NEW'       
	,ALARM_STATUS_COMPLETED : "COMPLETED" 
	,ALARM_STATUS_ERROR     : "ERROR"     
	,ALARM_STATUS_ROUTING   : 'ROUTING'   
	,ALARM_STATUS_HOLD      : "HOLD"      
	,ALARM_STATUS_MERGED    : "MERGED"    
	,ALARM_STATUS_DROPPED   : "DROPPED"   
}
	
def ALARM_STATUS_STR(status):
	return _ALARM_STATUS_STR_DICT[status]

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

# Tipi di stage
# I TIPI DEGLI STAGE PROBABILMENTE NON SERVONO
# SI PUO' RICAVARE IL TIPO IN BASE ALL'HANDLER
#STAGE_TYPE_ROUTING 	= "routing"
#STAGE_TYPE_RECEPTION 	= "reception"
#STAGE_TYPE_DISPATCH 	= "dispatch"

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

# Stati di uno stage
#STAGE_STATE_REQUESTED 		= 0 #"requested" # In attesa di gestione da parte del main thread
#STAGE_STATE_COMPLETED 		= 1 #"completed"
#STAGE_STATE_PROCESSING          = 2
#STAGE_STATE_ERROR               = 3

# FIX: RIVEDERE QUESTI STATI SE SERVONO!!!!!!
#STAGE_STATE_INTERRUPTED 	= 2 #"interrupted"
#STAGE_STATE_RETRY 		= 3 #"retry"
#STAGE_STATE_ERROR 		= 4 #"error"
#STAGE_STATE_EXAUSTED 		= 5 #"exausted"
#STAGE_STATE_HOLD 	 	= 6 #"hold"

#_STAGE_STATE_STR = {
#	STAGE_STATE_REQUESTED: "REQUESTED",
#	STAGE_STATE_COMPLETED: "COMPLETED"
#
#}
#def STAGE_STATE_STR(state):
#	return _STAGE_STATE_STR[state]


