# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

"""

entables_cmdline
========================================================================

Syntax:

	::
		
		sanet-manage entables_cmdline [options]

or:

	::
		
		entables [options]

See :ref:`entables-command-line`.

"""

from django.core.management.base import BaseCommand

from django.utils.translation import ugettext as _

#----------------------------------------------------------------------#
#                                                                      #
#----------------------------------------------------------------------#

class Command(BaseCommand):

	help = _("Entables CLI tool")
	
	#
	# HACK: avoid default django command line parsing!
	#

	def run_from_argv(self, argv):

		from entables.ui.cmdline import entables_launch_cmdline

		# argv = manage.py <cmd> <args>
		argv = argv[2:]

		entables_launch_cmdline(argv)

