# -*- coding: utf-8 -*-
# Generated by Django 1.11.14 on 2018-10-08 08:43
from __future__ import unicode_literals

from django.db import migrations, models
import django.db.models.deletion
import sanet_common.uuids


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('auth', '0008_alter_user_username_max_length'),
        ('core', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='Alarm',
            fields=[
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('priority', models.IntegerField(default=0)),
                ('status', models.TextField(default=b'new')),
                ('data', models.TextField()),
                ('stages', models.TextField()),
                ('ctime', models.DateTimeField(auto_now_add=True, db_index=True)),
                ('mtime', models.DateTimeField(auto_now=True, db_index=True)),
                ('rulestack', models.TextField(default=None, null=True)),
                ('hold_time', models.PositiveIntegerField(db_index=True, default=0)),
                ('hold_wakeuptime', models.PositiveIntegerField(db_index=True, default=0)),
                ('hold_handler', models.TextField(default=None, null=True)),
                ('merge_group_key', models.TextField(db_index=True, default=None, null=True)),
                ('tenant', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='entables_alarm_related', to='core.Tenant')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='AlarmArchive',
            fields=[
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('priority', models.IntegerField(default=0)),
                ('status', models.TextField(default=b'new')),
                ('data', models.TextField()),
                ('stages', models.TextField()),
                ('ctime', models.DateTimeField()),
                ('tenant', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='entables_alarmarchive_related', to='core.Tenant')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='Chain',
            fields=[
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('mtime', models.DateTimeField(auto_now=True)),
                ('name', models.TextField()),
                ('group', models.ForeignKey(default=None, null=True, on_delete=django.db.models.deletion.CASCADE, to='auth.Group')),
            ],
        ),
        migrations.CreateModel(
            name='Match',
            fields=[
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('mtime', models.DateTimeField(auto_now=True)),
                ('handler_name', models.TextField()),
            ],
        ),
        migrations.CreateModel(
            name='MatchOptions',
            fields=[
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('mtime', models.DateTimeField(auto_now=True)),
                ('name', models.TextField()),
                ('value', models.TextField(default=None, null=True)),
                ('match', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='match_options', to='entables.Match')),
                ('tenant', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='entables_matchoptions_related', to='core.Tenant')),
            ],
        ),
        migrations.CreateModel(
            name='Rule',
            fields=[
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('mtime', models.DateTimeField(auto_now=True)),
                ('position', models.IntegerField()),
                ('hitcounter', models.IntegerField(default=0)),
                ('stop_if_match', models.BooleanField(default=False)),
                ('disabled', models.IntegerField(default=0)),
                ('chain', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='rules', to='entables.Chain')),
            ],
        ),
        migrations.CreateModel(
            name='Table',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.TextField(unique=True)),
                ('priority', models.IntegerField(unique=True)),
            ],
        ),
        migrations.CreateModel(
            name='Target',
            fields=[
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('mtime', models.DateTimeField(auto_now=True)),
                ('handler_name', models.TextField()),
                ('tenant', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='entables_target_related', to='core.Tenant')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TargetData',
            fields=[
                ('key', models.TextField(primary_key=True, serialize=False)),
                ('mtime', models.DateTimeField(auto_now=True)),
                ('data', models.TextField(default=None, null=True)),
                ('tenant', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='entables_targetdata_related', to='core.Tenant')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.CreateModel(
            name='TargetOptions',
            fields=[
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('mtime', models.DateTimeField(auto_now=True)),
                ('name', models.TextField()),
                ('value', models.TextField(default=None, null=True)),
                ('target', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='target_options', to='entables.Target')),
                ('tenant', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='entables_targetoptions_related', to='core.Tenant')),
            ],
        ),
        migrations.CreateModel(
            name='Template',
            fields=[
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('mtime', models.DateTimeField(auto_now=True)),
                ('name', models.TextField(unique=True)),
                ('data', models.TextField(default=b'')),
                ('tenant', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='entables_template_related', to='core.Tenant')),
            ],
            options={
                'abstract': False,
            },
        ),
        migrations.AddField(
            model_name='rule',
            name='target',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='rule', to='entables.Target'),
        ),
        migrations.AddField(
            model_name='rule',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='entables_rule_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='match',
            name='rule',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='matches', to='entables.Rule'),
        ),
        migrations.AddField(
            model_name='match',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='entables_match_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='chain',
            name='policy',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='chain', to='entables.Target'),
        ),
        migrations.AddField(
            model_name='chain',
            name='table',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='chains', to='entables.Table'),
        ),
        migrations.AddField(
            model_name='chain',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='entables_chain_related', to='core.Tenant'),
        ),
        migrations.AlterUniqueTogether(
            name='targetoptions',
            unique_together=set([('target', 'name')]),
        ),
        migrations.AlterUniqueTogether(
            name='rule',
            unique_together=set([('chain', 'position')]),
        ),
        migrations.AlterUniqueTogether(
            name='matchoptions',
            unique_together=set([('match', 'name')]),
        ),
        migrations.AlterUniqueTogether(
            name='match',
            unique_together=set([('rule', 'handler_name')]),
        ),
        migrations.AlterUniqueTogether(
            name='chain',
            unique_together=set([('table', 'name')]),
        ),
    ]
