# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

import os
import sys
from os.path import join, dirname, abspath

#----------------------------------------------------------------------#
#                                                                      #
#----------------------------------------------------------------------#

SANET_INSTALL_DIR = None

SANET_INSTALL_DIR = os.environ.get("SANET_HOME", SANET_INSTALL_DIR)

if not SANET_INSTALL_DIR:
    SANET_INSTALL_DIR = abspath(os.path.join(os.path.dirname(abspath(__file__)),"..",".." ))

sys.path.append( SANET_INSTALL_DIR )


os.environ.setdefault("DJANGO_SETTINGS_MODULE", "conf.settings")

#----------------------------------------------------------------------#
#                                                                      #
#----------------------------------------------------------------------#

if __name__ == "__main__":
		
	from django.conf import settings

	from entables.server.entablesd import entablesd_main
	
	entables_configuration = settings.ENTABLESD_SETTINGS
	
	entablesd_main(entables_configuration, sys.argv)
