# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

"""

Tag Provider
---------------------

Un tag provider permette di usare simboli nei template in due modi:

::
	
	{{ <tag provider>.<symbol> }} 

Oppure:

::
	
	{{<symbol>}}


Sintassi deprecata
---------------------

Un tag provider permette di usare simboli nei template in due modi

	${tags["<tag provider>:<simbolo>"]}

Oppure:

	${<shortcut>}

Un simbolo fornito da un tagprovidere di solito ha uno shortcut corrispondente, ma non necessariamente.

"""

class BaseTagProvider(object):

	SYMBOL_NOTDEFINED = '*NOTDEFINED*'
	SYMBOL_NULL_VALUE = '*NULL*'
	SYMBOL_ERROR      = '*ERROR (%s)*'

	def get_provider_symbol(self, alarm, log=None):
		"""
		Restituisce un oggetto (dict o object) i cui attributi/chiavi con
		nome <name> verranno espansi {{ <name> }}.
		"""
		return {}


	# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	# DEPRECATO >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	# >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

	# Elenco dei diboli supportati
	VALID_SYMBOLS = [
	]

	# Elenco degli shortcut supportati
	VALID_SHORTCUTS = [
	]


	def __init__(self):
		self.name = None

	def get_name(self):
		return self.name

	def has_symbol(self, alarm, symbol):
		"""
		Restituisce true se il tag provider risconosce (puo' espandere) il simbolo
		"""
		return symbol in self.VALID_SYMBOLS
		
	def get_symbol(self, alarm, symbol):
		"""
		Restituisce il valore del simbolo relativamente all'allarme
		"""
		return None

	def has_shortcut_symbol(self, alarm, symbol):
		"""
		Restituisce true se il tag provider risconosce (puo' espandere) lo shortcut
		"""
		return symbol in self.VALID_SHORTCUTS

	def get_shortcut_symbol(self, alarm, symbol):
		"""
		Restituisce il valore dello shortcut
		"""
		return None

	# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	# DEPRECATO <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	# <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<







