# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.
"""

.. _sanet_common:

################################################################################
Sanet Common Lib (sanet_common)
################################################################################

.. contents:: Indice
   :backlinks: none
   :depth: 6

================================================================================
Introduction
================================================================================

This is the common library used by Sanet server and plugins.

================================================================================
General modules
================================================================================

.. automodule:: sanet_common.uuids

.. automodule:: sanet_common.binary
   
.. automodule:: sanet_common.pythonutils
   
.. automodule:: sanet_common.termutils

.. automodule:: sanet_common.timeutils

.. automodule:: sanet_common.mailing

.. automodule:: sanet_common.netutils

.. automodule:: sanet_common.osutils

================================================================================
String and formatting utilities
================================================================================

.. automodule:: sanet_common.formatutils

.. automodule:: sanet_common.table

================================================================================
Sanet specific modules
================================================================================

.. automodule:: sanet_common.sanetdefs

.. automodule:: sanet_common.exceptions

.. automodule:: sanet_common.django.auth.backends

.. automodule:: sanet_common.cache

.. automodule:: sanet_common.exprparser
   
.. automodule:: sanet_common.ipc

"""

__version__ = '0.0.1'

__all__ = [
	'exceptions',
	'table',
	'django',
]

