# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

"""
########################################################################
Eccezioni
########################################################################

Tutte le eccezioni sollevate dai diversi moduli di Sanet hanno come tipo base *BaseSanetException*.

::
	
	                        Exception
	                            |
	                   BaseSanetException
	                            |                  SanetCommon
	_______________________________________________________________                             
	                            |               Server/Poller/ecc,
	                            |
	      +---------------------+---------------------+
	      |                     |                     |
	  *Exception           *Exception            *Exception

"""

class BaseSanetException(Exception):
	"""
	Classe di base per tutte le eccezioni generate dal codice di Sanet.
		* server
		* poller
		* entables
	"""
	pass
