# $ANTLR 3.1.1 ExprScript.g 2018-03-16 18:19:16

import sys
from antlr3 import *
from antlr3.compat import set, frozenset
                         

from .ExprFactory import LexicalError




# for convenience in actions
HIDDEN = BaseRecognizer.HIDDEN

# token types
DATA_ID=66
COLUMN=17
LT=35
ALPHA=57
NEQUAL=32
MINUS=27
TYPE_NEW=18
SEMICOLON=16
ELSE=47
TRY=48
IF=45
LOGIC_AND=39
LOGIC_NOT=38
DOT=22
VAR_ID=58
TRUE=5
UNESCAPE_STR=20
EQ=10
RIGHT_SPAREN=14
FUNCTION_ID=59
HexDigit=60
PLUS_PLUS=23
OID_SEQUENCE=51
NOT=9
GEQ=36
LOGIC_OR=40
AND=7
THEN=46
OctalEscape=56
PLUS=26
FLOAT=65
RSTRING=55
Exponent=64
RIGHT_PAREN=12
ASSIGN=21
LEFT_PAREN=11
LEFT_SPAREN=13
OCTAL=63
BITOR=42
ESC=54
CATCH=49
MINUS_MINUS=24
WS=4
EOF=-1
COMMA=15
BITAND=41
BITXOR=43
OR=8
MOD=30
DEC=62
EQUAL=31
EscapeSequence=52
POWER=25
REGEXPQUAL=33
TYPE_OLD=19
GT=34
DIGIT=50
DIV=29
BITONE=44
LEQ=37
STRING=53
FALSE=6
HEX=61
MULTI=28


class ExprScriptLexer(Lexer):

    grammarFileName = "ExprScript.g"
    antlr_version = version_str_to_tuple("3.1.1")
    antlr_version_str = "3.1.1"

    def __init__(self, input=None, state=None):
        if state is None:
            state = RecognizerSharedState()
        Lexer.__init__(self, input, state)

        self.dfa26 = self.DFA26(
            self, 26,
            eot = self.DFA26_eot,
            eof = self.DFA26_eof,
            min = self.DFA26_min,
            max = self.DFA26_max,
            accept = self.DFA26_accept,
            special = self.DFA26_special,
            transition = self.DFA26_transition
            )

        self.dfa30 = self.DFA30(
            self, 30,
            eot = self.DFA30_eot,
            eof = self.DFA30_eof,
            min = self.DFA30_min,
            max = self.DFA30_max,
            accept = self.DFA30_accept,
            special = self.DFA30_special,
            transition = self.DFA30_transition
            )


                             
        pass



                               

    #
    # Implements a simple handler for lexical exceptions.
    # Stop lexical analisys as soon as it discovers an error.
    #
    def reportError(self, e):
        raise LexicalError(e)

    #
    # Debug methods
    #
    def debug(self, str):
    #	print str,
    	pass

    #
    # The next token belogs to the previews OID token
    # if is stars with a '.' and a number
    #
    #   previews oid      next token
    #   1.2.3.4.5.6.7  +  .121.1.3.2.3
    #                     ^^
    #
    # FIX: This is an hack function for the OID_SEQUENCE token!!
    #
    def checkOID(self):
    	return (chr(self.input.LA(1)) == '.') and (chr(self.input.LA(2)) in "0123456789")
        	



    # $ANTLR start "WS"
    def mWS(self, ):

        try:
            _type = WS
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:166:3: ( ( ' ' | '\\r' | '\\t' | '\\u000C' | '\\n' )+ )
            # ExprScript.g:166:5: ( ' ' | '\\r' | '\\t' | '\\u000C' | '\\n' )+
            pass 
            # ExprScript.g:166:5: ( ' ' | '\\r' | '\\t' | '\\u000C' | '\\n' )+
            cnt1 = 0
            while True: #loop1
                alt1 = 2
                LA1_0 = self.input.LA(1)

                if ((9 <= LA1_0 <= 10) or (12 <= LA1_0 <= 13) or LA1_0 == 32) :
                    alt1 = 1


                if alt1 == 1:
                    # ExprScript.g:
                    pass 
                    if (9 <= self.input.LA(1) <= 10) or (12 <= self.input.LA(1) <= 13) or self.input.LA(1) == 32:
                        self.input.consume()
                    else:
                        mse = MismatchedSetException(None, self.input)
                        self.recover(mse)
                        raise mse



                else:
                    if cnt1 >= 1:
                        break #loop1

                    eee = EarlyExitException(1, self.input)
                    raise eee

                cnt1 += 1


            #action start
            self.debug("' '") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "WS"



    # $ANTLR start "TRUE"
    def mTRUE(self, ):

        try:
            _type = TRUE
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:180:6: ( 'True' )
            # ExprScript.g:180:8: 'True'
            pass 
            self.match("True")
            #action start
            self.debug("BOOL(true)") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "TRUE"



    # $ANTLR start "FALSE"
    def mFALSE(self, ):

        try:
            _type = FALSE
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:181:6: ( 'False' )
            # ExprScript.g:181:8: 'False'
            pass 
            self.match("False")
            #action start
            self.debug("BOOL(false)") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "FALSE"



    # $ANTLR start "AND"
    def mAND(self, ):

        try:
            _type = AND
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:182:6: ( 'and' )
            # ExprScript.g:182:8: 'and'
            pass 
            self.match("and")
            #action start
            self.debug("and") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "AND"



    # $ANTLR start "OR"
    def mOR(self, ):

        try:
            _type = OR
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:183:6: ( 'or' )
            # ExprScript.g:183:8: 'or'
            pass 
            self.match("or")
            #action start
            self.debug("or") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "OR"



    # $ANTLR start "NOT"
    def mNOT(self, ):

        try:
            _type = NOT
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:184:6: ( 'not' )
            # ExprScript.g:184:8: 'not'
            pass 
            self.match("not")
            #action start
            self.debug("not") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "NOT"



    # $ANTLR start "EQ"
    def mEQ(self, ):

        try:
            _type = EQ
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:185:6: ( 'eq' )
            # ExprScript.g:185:8: 'eq'
            pass 
            self.match("eq")
            #action start
            self.debug("eq") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "EQ"



    # $ANTLR start "LEFT_PAREN"
    def mLEFT_PAREN(self, ):

        try:
            _type = LEFT_PAREN
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:191:11: ( '(' )
            # ExprScript.g:191:13: '('
            pass 
            self.match(40)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "LEFT_PAREN"



    # $ANTLR start "RIGHT_PAREN"
    def mRIGHT_PAREN(self, ):

        try:
            _type = RIGHT_PAREN
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:192:12: ( ')' )
            # ExprScript.g:192:14: ')'
            pass 
            self.match(41)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "RIGHT_PAREN"



    # $ANTLR start "LEFT_SPAREN"
    def mLEFT_SPAREN(self, ):

        try:
            _type = LEFT_SPAREN
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:193:12: ( '[' )
            # ExprScript.g:193:14: '['
            pass 
            self.match(91)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "LEFT_SPAREN"



    # $ANTLR start "RIGHT_SPAREN"
    def mRIGHT_SPAREN(self, ):

        try:
            _type = RIGHT_SPAREN
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:194:13: ( ']' )
            # ExprScript.g:194:15: ']'
            pass 
            self.match(93)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "RIGHT_SPAREN"



    # $ANTLR start "COMMA"
    def mCOMMA(self, ):

        try:
            _type = COMMA
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:195:6: ( ',' )
            # ExprScript.g:195:8: ','
            pass 
            self.match(44)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "COMMA"



    # $ANTLR start "SEMICOLON"
    def mSEMICOLON(self, ):

        try:
            _type = SEMICOLON
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:196:10: ( ';' )
            # ExprScript.g:196:12: ';'
            pass 
            self.match(59)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "SEMICOLON"



    # $ANTLR start "COLUMN"
    def mCOLUMN(self, ):

        try:
            _type = COLUMN
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:199:7: ( ':' )
            # ExprScript.g:199:9: ':'
            pass 
            self.match(58)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "COLUMN"



    # $ANTLR start "TYPE_NEW"
    def mTYPE_NEW(self, ):

        try:
            _type = TYPE_NEW
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:200:9: ( '@' )
            # ExprScript.g:200:11: '@'
            pass 
            self.match(64)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "TYPE_NEW"



    # $ANTLR start "TYPE_OLD"
    def mTYPE_OLD(self, ):

        try:
            _type = TYPE_OLD
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:201:9: ( '#' )
            # ExprScript.g:201:11: '#'
            pass 
            self.match(35)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "TYPE_OLD"



    # $ANTLR start "UNESCAPE_STR"
    def mUNESCAPE_STR(self, ):

        try:
            _type = UNESCAPE_STR
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:204:13: ( 'r' )
            # ExprScript.g:204:15: 'r'
            pass 
            self.match(114)
            #action start
            self.debug("UNESCPAE") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "UNESCAPE_STR"



    # $ANTLR start "ASSIGN"
    def mASSIGN(self, ):

        try:
            _type = ASSIGN
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:211:7: ( '=' )
            # ExprScript.g:211:9: '='
            pass 
            self.match(61)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "ASSIGN"



    # $ANTLR start "DOT"
    def mDOT(self, ):

        try:
            _type = DOT
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:214:5: ( '.' )
            # ExprScript.g:214:7: '.'
            pass 
            self.match(46)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "DOT"



    # $ANTLR start "PLUS_PLUS"
    def mPLUS_PLUS(self, ):

        try:
            _type = PLUS_PLUS
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:216:10: ( '++' )
            # ExprScript.g:216:12: '++'
            pass 
            self.match("++")
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "PLUS_PLUS"



    # $ANTLR start "MINUS_MINUS"
    def mMINUS_MINUS(self, ):

        try:
            _type = MINUS_MINUS
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:217:12: ( '--' )
            # ExprScript.g:217:14: '--'
            pass 
            self.match("--")
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "MINUS_MINUS"



    # $ANTLR start "POWER"
    def mPOWER(self, ):

        try:
            _type = POWER
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:219:6: ( '**' )
            # ExprScript.g:219:8: '**'
            pass 
            self.match("**")
            #action start
            self.debug("power") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "POWER"



    # $ANTLR start "PLUS"
    def mPLUS(self, ):

        try:
            _type = PLUS
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:221:5: ( '+' )
            # ExprScript.g:221:7: '+'
            pass 
            self.match(43)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "PLUS"



    # $ANTLR start "MINUS"
    def mMINUS(self, ):

        try:
            _type = MINUS
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:222:6: ( '-' )
            # ExprScript.g:222:8: '-'
            pass 
            self.match(45)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "MINUS"



    # $ANTLR start "MULTI"
    def mMULTI(self, ):

        try:
            _type = MULTI
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:223:6: ( '*' )
            # ExprScript.g:223:8: '*'
            pass 
            self.match(42)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "MULTI"



    # $ANTLR start "DIV"
    def mDIV(self, ):

        try:
            _type = DIV
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:224:4: ( '/' )
            # ExprScript.g:224:6: '/'
            pass 
            self.match(47)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "DIV"



    # $ANTLR start "MOD"
    def mMOD(self, ):

        try:
            _type = MOD
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:225:4: ( '%' )
            # ExprScript.g:225:6: '%'
            pass 
            self.match(37)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "MOD"



    # $ANTLR start "EQUAL"
    def mEQUAL(self, ):

        try:
            _type = EQUAL
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:228:7: ( '==' )
            # ExprScript.g:228:9: '=='
            pass 
            self.match("==")
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "EQUAL"



    # $ANTLR start "NEQUAL"
    def mNEQUAL(self, ):

        try:
            _type = NEQUAL
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:229:7: ( '!=' )
            # ExprScript.g:229:9: '!='
            pass 
            self.match("!=")
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "NEQUAL"



    # $ANTLR start "REGEXPQUAL"
    def mREGEXPQUAL(self, ):

        try:
            _type = REGEXPQUAL
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:231:11: ( '=~' )
            # ExprScript.g:231:13: '=~'
            pass 
            self.match("=~")
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "REGEXPQUAL"



    # $ANTLR start "GT"
    def mGT(self, ):

        try:
            _type = GT
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:233:5: ( '>' )
            # ExprScript.g:233:7: '>'
            pass 
            self.match(62)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "GT"



    # $ANTLR start "LT"
    def mLT(self, ):

        try:
            _type = LT
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:234:5: ( '<' )
            # ExprScript.g:234:7: '<'
            pass 
            self.match(60)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "LT"



    # $ANTLR start "GEQ"
    def mGEQ(self, ):

        try:
            _type = GEQ
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:235:5: ( '>=' )
            # ExprScript.g:235:7: '>='
            pass 
            self.match(">=")
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "GEQ"



    # $ANTLR start "LEQ"
    def mLEQ(self, ):

        try:
            _type = LEQ
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:236:5: ( '<=' )
            # ExprScript.g:236:7: '<='
            pass 
            self.match("<=")
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "LEQ"



    # $ANTLR start "LOGIC_NOT"
    def mLOGIC_NOT(self, ):

        try:
            _type = LOGIC_NOT
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:238:11: ( '!' )
            # ExprScript.g:238:13: '!'
            pass 
            self.match(33)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "LOGIC_NOT"



    # $ANTLR start "LOGIC_AND"
    def mLOGIC_AND(self, ):

        try:
            _type = LOGIC_AND
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:239:11: ( '&&' )
            # ExprScript.g:239:13: '&&'
            pass 
            self.match("&&")
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "LOGIC_AND"



    # $ANTLR start "LOGIC_OR"
    def mLOGIC_OR(self, ):

        try:
            _type = LOGIC_OR
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:240:11: ( '||' )
            # ExprScript.g:240:13: '||'
            pass 
            self.match("||")
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "LOGIC_OR"



    # $ANTLR start "BITAND"
    def mBITAND(self, ):

        try:
            _type = BITAND
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:242:8: ( '&' )
            # ExprScript.g:242:10: '&'
            pass 
            self.match(38)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "BITAND"



    # $ANTLR start "BITOR"
    def mBITOR(self, ):

        try:
            _type = BITOR
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:243:8: ( '|' )
            # ExprScript.g:243:10: '|'
            pass 
            self.match(124)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "BITOR"



    # $ANTLR start "BITXOR"
    def mBITXOR(self, ):

        try:
            _type = BITXOR
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:244:8: ( '^' )
            # ExprScript.g:244:10: '^'
            pass 
            self.match(94)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "BITXOR"



    # $ANTLR start "BITONE"
    def mBITONE(self, ):

        try:
            _type = BITONE
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:247:8: ( '~' )
            # ExprScript.g:247:10: '~'
            pass 
            self.match(126)
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "BITONE"



    # $ANTLR start "IF"
    def mIF(self, ):

        try:
            _type = IF
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:249:3: ( 'if' )
            # ExprScript.g:249:5: 'if'
            pass 
            self.match("if")
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "IF"



    # $ANTLR start "THEN"
    def mTHEN(self, ):

        try:
            _type = THEN
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:250:5: ( 'then' )
            # ExprScript.g:250:7: 'then'
            pass 
            self.match("then")
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "THEN"



    # $ANTLR start "ELSE"
    def mELSE(self, ):

        try:
            _type = ELSE
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:251:5: ( 'else' )
            # ExprScript.g:251:7: 'else'
            pass 
            self.match("else")
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "ELSE"



    # $ANTLR start "TRY"
    def mTRY(self, ):

        try:
            _type = TRY
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:253:6: ( 'try' )
            # ExprScript.g:253:8: 'try'
            pass 
            self.match("try")
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "TRY"



    # $ANTLR start "CATCH"
    def mCATCH(self, ):

        try:
            _type = CATCH
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:254:6: ( 'catch' )
            # ExprScript.g:254:8: 'catch'
            pass 
            self.match("catch")
            #action start
            self.debug("'"+self.getText()+"'") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "CATCH"



    # $ANTLR start "OID_SEQUENCE"
    def mOID_SEQUENCE(self, ):

        try:
            _type = OID_SEQUENCE
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:269:5: ( ( DIGIT )+ '.' ( DIGIT )+ '.' ( DIGIT )+ ({...}? => '.' ( DIGIT )+ )* )
            # ExprScript.g:269:7: ( DIGIT )+ '.' ( DIGIT )+ '.' ( DIGIT )+ ({...}? => '.' ( DIGIT )+ )*
            pass 
            # ExprScript.g:269:7: ( DIGIT )+
            cnt2 = 0
            while True: #loop2
                alt2 = 2
                LA2_0 = self.input.LA(1)

                if ((48 <= LA2_0 <= 57)) :
                    alt2 = 1


                if alt2 == 1:
                    # ExprScript.g:269:7: DIGIT
                    pass 
                    self.mDIGIT()


                else:
                    if cnt2 >= 1:
                        break #loop2

                    eee = EarlyExitException(2, self.input)
                    raise eee

                cnt2 += 1


            self.match(46)
            # ExprScript.g:269:18: ( DIGIT )+
            cnt3 = 0
            while True: #loop3
                alt3 = 2
                LA3_0 = self.input.LA(1)

                if ((48 <= LA3_0 <= 57)) :
                    alt3 = 1


                if alt3 == 1:
                    # ExprScript.g:269:18: DIGIT
                    pass 
                    self.mDIGIT()


                else:
                    if cnt3 >= 1:
                        break #loop3

                    eee = EarlyExitException(3, self.input)
                    raise eee

                cnt3 += 1


            self.match(46)
            # ExprScript.g:269:29: ( DIGIT )+
            cnt4 = 0
            while True: #loop4
                alt4 = 2
                LA4_0 = self.input.LA(1)

                if ((48 <= LA4_0 <= 57)) :
                    alt4 = 1


                if alt4 == 1:
                    # ExprScript.g:269:29: DIGIT
                    pass 
                    self.mDIGIT()


                else:
                    if cnt4 >= 1:
                        break #loop4

                    eee = EarlyExitException(4, self.input)
                    raise eee

                cnt4 += 1


            # ExprScript.g:270:6: ({...}? => '.' ( DIGIT )+ )*
            while True: #loop6
                alt6 = 2
                LA6_0 = self.input.LA(1)

                if (LA6_0 == 46) and ((self.checkOID()==True )):
                    alt6 = 1


                if alt6 == 1:
                    # ExprScript.g:270:8: {...}? => '.' ( DIGIT )+
                    pass 
                    if not ((self.checkOID()==True )):
                        raise FailedPredicateException(self.input, "OID_SEQUENCE", " self.checkOID()==True ")

                    self.match(46)
                    # ExprScript.g:270:42: ( DIGIT )+
                    cnt5 = 0
                    while True: #loop5
                        alt5 = 2
                        LA5_0 = self.input.LA(1)

                        if ((48 <= LA5_0 <= 57)) :
                            alt5 = 1


                        if alt5 == 1:
                            # ExprScript.g:270:42: DIGIT
                            pass 
                            self.mDIGIT()


                        else:
                            if cnt5 >= 1:
                                break #loop5

                            eee = EarlyExitException(5, self.input)
                            raise eee

                        cnt5 += 1




                else:
                    break #loop6


            #action start
            self.debug("OID(" + self.getText() + ")") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "OID_SEQUENCE"



    # $ANTLR start "STRING"
    def mSTRING(self, ):

        try:
            _type = STRING
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:282:5: ( ( '\\'' ) ( EscapeSequence | ~ ( '\\'' | '\\\\' ) )* ( '\\'' ) | ( '\"' ) ( EscapeSequence | ~ ( '\"' | '\\\\' ) )* ( '\"' ) )
            alt9 = 2
            LA9_0 = self.input.LA(1)

            if (LA9_0 == 39) :
                alt9 = 1
            elif (LA9_0 == 34) :
                alt9 = 2
            else:
                nvae = NoViableAltException("", 9, 0, self.input)

                raise nvae

            if alt9 == 1:
                # ExprScript.g:282:9: ( '\\'' ) ( EscapeSequence | ~ ( '\\'' | '\\\\' ) )* ( '\\'' )
                pass 
                # ExprScript.g:282:9: ( '\\'' )
                # ExprScript.g:282:10: '\\''
                pass 
                self.match(39)



                # ExprScript.g:282:16: ( EscapeSequence | ~ ( '\\'' | '\\\\' ) )*
                while True: #loop7
                    alt7 = 3
                    LA7_0 = self.input.LA(1)

                    if (LA7_0 == 92) :
                        alt7 = 1
                    elif ((0 <= LA7_0 <= 38) or (40 <= LA7_0 <= 91) or (93 <= LA7_0 <= 65535)) :
                        alt7 = 2


                    if alt7 == 1:
                        # ExprScript.g:282:18: EscapeSequence
                        pass 
                        self.mEscapeSequence()


                    elif alt7 == 2:
                        # ExprScript.g:282:35: ~ ( '\\'' | '\\\\' )
                        pass 
                        if (0 <= self.input.LA(1) <= 38) or (40 <= self.input.LA(1) <= 91) or (93 <= self.input.LA(1) <= 65535):
                            self.input.consume()
                        else:
                            mse = MismatchedSetException(None, self.input)
                            self.recover(mse)
                            raise mse



                    else:
                        break #loop7


                # ExprScript.g:282:55: ( '\\'' )
                # ExprScript.g:282:56: '\\''
                pass 
                self.match(39)



                #action start
                self.debug("STRING(" + self.getText() + ")") 
                #action end


            elif alt9 == 2:
                # ExprScript.g:283:9: ( '\"' ) ( EscapeSequence | ~ ( '\"' | '\\\\' ) )* ( '\"' )
                pass 
                # ExprScript.g:283:9: ( '\"' )
                # ExprScript.g:283:10: '\"'
                pass 
                self.match(34)



                # ExprScript.g:283:16: ( EscapeSequence | ~ ( '\"' | '\\\\' ) )*
                while True: #loop8
                    alt8 = 3
                    LA8_0 = self.input.LA(1)

                    if (LA8_0 == 92) :
                        alt8 = 1
                    elif ((0 <= LA8_0 <= 33) or (35 <= LA8_0 <= 91) or (93 <= LA8_0 <= 65535)) :
                        alt8 = 2


                    if alt8 == 1:
                        # ExprScript.g:283:18: EscapeSequence
                        pass 
                        self.mEscapeSequence()


                    elif alt8 == 2:
                        # ExprScript.g:283:35: ~ ( '\"' | '\\\\' )
                        pass 
                        if (0 <= self.input.LA(1) <= 33) or (35 <= self.input.LA(1) <= 91) or (93 <= self.input.LA(1) <= 65535):
                            self.input.consume()
                        else:
                            mse = MismatchedSetException(None, self.input)
                            self.recover(mse)
                            raise mse



                    else:
                        break #loop8


                # ExprScript.g:283:55: ( '\"' )
                # ExprScript.g:283:56: '\"'
                pass 
                self.match(34)



                #action start
                self.debug("STRING(" + self.getText() + ")") 
                #action end


            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "STRING"



    # $ANTLR start "RSTRING"
    def mRSTRING(self, ):

        try:
            _type = RSTRING
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:287:5: ( 'r' ( '\\'' ) ( ESC | ~ ( '\\'' | '\\\\' ) )* ( '\\'' ) | 'r' ( '\"' ) ( ESC | ~ ( '\\\"' | '\\\\' ) )* ( '\"' ) )
            alt12 = 2
            LA12_0 = self.input.LA(1)

            if (LA12_0 == 114) :
                LA12_1 = self.input.LA(2)

                if (LA12_1 == 34) :
                    alt12 = 2
                elif (LA12_1 == 39) :
                    alt12 = 1
                else:
                    nvae = NoViableAltException("", 12, 1, self.input)

                    raise nvae

            else:
                nvae = NoViableAltException("", 12, 0, self.input)

                raise nvae

            if alt12 == 1:
                # ExprScript.g:287:7: 'r' ( '\\'' ) ( ESC | ~ ( '\\'' | '\\\\' ) )* ( '\\'' )
                pass 
                self.match(114)
                # ExprScript.g:287:11: ( '\\'' )
                # ExprScript.g:287:12: '\\''
                pass 
                self.match(39)



                # ExprScript.g:287:18: ( ESC | ~ ( '\\'' | '\\\\' ) )*
                while True: #loop10
                    alt10 = 3
                    LA10_0 = self.input.LA(1)

                    if (LA10_0 == 92) :
                        alt10 = 1
                    elif ((0 <= LA10_0 <= 38) or (40 <= LA10_0 <= 91) or (93 <= LA10_0 <= 65535)) :
                        alt10 = 2


                    if alt10 == 1:
                        # ExprScript.g:287:20: ESC
                        pass 
                        self.mESC()


                    elif alt10 == 2:
                        # ExprScript.g:287:26: ~ ( '\\'' | '\\\\' )
                        pass 
                        if (0 <= self.input.LA(1) <= 38) or (40 <= self.input.LA(1) <= 91) or (93 <= self.input.LA(1) <= 65535):
                            self.input.consume()
                        else:
                            mse = MismatchedSetException(None, self.input)
                            self.recover(mse)
                            raise mse



                    else:
                        break #loop10


                # ExprScript.g:287:46: ( '\\'' )
                # ExprScript.g:287:47: '\\''
                pass 
                self.match(39)



                #action start
                self.debug("STRING(" + self.getText() + ")") 
                #action end


            elif alt12 == 2:
                # ExprScript.g:288:7: 'r' ( '\"' ) ( ESC | ~ ( '\\\"' | '\\\\' ) )* ( '\"' )
                pass 
                self.match(114)
                # ExprScript.g:288:11: ( '\"' )
                # ExprScript.g:288:12: '\"'
                pass 
                self.match(34)



                # ExprScript.g:288:17: ( ESC | ~ ( '\\\"' | '\\\\' ) )*
                while True: #loop11
                    alt11 = 3
                    LA11_0 = self.input.LA(1)

                    if (LA11_0 == 92) :
                        alt11 = 1
                    elif ((0 <= LA11_0 <= 33) or (35 <= LA11_0 <= 91) or (93 <= LA11_0 <= 65535)) :
                        alt11 = 2


                    if alt11 == 1:
                        # ExprScript.g:288:19: ESC
                        pass 
                        self.mESC()


                    elif alt11 == 2:
                        # ExprScript.g:288:25: ~ ( '\\\"' | '\\\\' )
                        pass 
                        if (0 <= self.input.LA(1) <= 33) or (35 <= self.input.LA(1) <= 91) or (93 <= self.input.LA(1) <= 65535):
                            self.input.consume()
                        else:
                            mse = MismatchedSetException(None, self.input)
                            self.recover(mse)
                            raise mse



                    else:
                        break #loop11


                # ExprScript.g:288:46: ( '\"' )
                # ExprScript.g:288:47: '\"'
                pass 
                self.match(34)



                #action start
                self.debug("STRING(" + self.getText() + ")") 
                #action end


            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "RSTRING"



    # $ANTLR start "EscapeSequence"
    def mEscapeSequence(self, ):

        try:
            # ExprScript.g:293:5: ( '\\\\' ( 'b' | 't' | 'n' | 'f' | 'r' | '\\\"' | '\\'' | '\\\\' ) | OctalEscape )
            alt13 = 2
            LA13_0 = self.input.LA(1)

            if (LA13_0 == 92) :
                LA13_1 = self.input.LA(2)

                if (LA13_1 == 34 or LA13_1 == 39 or LA13_1 == 92 or LA13_1 == 98 or LA13_1 == 102 or LA13_1 == 110 or LA13_1 == 114 or LA13_1 == 116) :
                    alt13 = 1
                elif ((48 <= LA13_1 <= 55)) :
                    alt13 = 2
                else:
                    nvae = NoViableAltException("", 13, 1, self.input)

                    raise nvae

            else:
                nvae = NoViableAltException("", 13, 0, self.input)

                raise nvae

            if alt13 == 1:
                # ExprScript.g:293:9: '\\\\' ( 'b' | 't' | 'n' | 'f' | 'r' | '\\\"' | '\\'' | '\\\\' )
                pass 
                self.match(92)
                if self.input.LA(1) == 34 or self.input.LA(1) == 39 or self.input.LA(1) == 92 or self.input.LA(1) == 98 or self.input.LA(1) == 102 or self.input.LA(1) == 110 or self.input.LA(1) == 114 or self.input.LA(1) == 116:
                    self.input.consume()
                else:
                    mse = MismatchedSetException(None, self.input)
                    self.recover(mse)
                    raise mse



            elif alt13 == 2:
                # ExprScript.g:294:9: OctalEscape
                pass 
                self.mOctalEscape()



        finally:

            pass

    # $ANTLR end "EscapeSequence"



    # $ANTLR start "OctalEscape"
    def mOctalEscape(self, ):

        try:
            # ExprScript.g:297:5: ( '\\\\' ( '0' .. '3' ) ( '0' .. '7' ) ( '0' .. '7' ) | '\\\\' ( '0' .. '7' ) ( '0' .. '7' ) | '\\\\' ( '0' .. '7' ) )
            alt14 = 3
            LA14_0 = self.input.LA(1)

            if (LA14_0 == 92) :
                LA14_1 = self.input.LA(2)

                if ((48 <= LA14_1 <= 51)) :
                    LA14_2 = self.input.LA(3)

                    if ((48 <= LA14_2 <= 55)) :
                        LA14_4 = self.input.LA(4)

                        if ((48 <= LA14_4 <= 55)) :
                            alt14 = 1
                        else:
                            alt14 = 2
                    else:
                        alt14 = 3
                elif ((52 <= LA14_1 <= 55)) :
                    LA14_3 = self.input.LA(3)

                    if ((48 <= LA14_3 <= 55)) :
                        alt14 = 2
                    else:
                        alt14 = 3
                else:
                    nvae = NoViableAltException("", 14, 1, self.input)

                    raise nvae

            else:
                nvae = NoViableAltException("", 14, 0, self.input)

                raise nvae

            if alt14 == 1:
                # ExprScript.g:297:9: '\\\\' ( '0' .. '3' ) ( '0' .. '7' ) ( '0' .. '7' )
                pass 
                self.match(92)
                # ExprScript.g:297:14: ( '0' .. '3' )
                # ExprScript.g:297:15: '0' .. '3'
                pass 
                self.matchRange(48, 51)



                # ExprScript.g:297:25: ( '0' .. '7' )
                # ExprScript.g:297:26: '0' .. '7'
                pass 
                self.matchRange(48, 55)



                # ExprScript.g:297:36: ( '0' .. '7' )
                # ExprScript.g:297:37: '0' .. '7'
                pass 
                self.matchRange(48, 55)





            elif alt14 == 2:
                # ExprScript.g:298:9: '\\\\' ( '0' .. '7' ) ( '0' .. '7' )
                pass 
                self.match(92)
                # ExprScript.g:298:14: ( '0' .. '7' )
                # ExprScript.g:298:15: '0' .. '7'
                pass 
                self.matchRange(48, 55)



                # ExprScript.g:298:25: ( '0' .. '7' )
                # ExprScript.g:298:26: '0' .. '7'
                pass 
                self.matchRange(48, 55)





            elif alt14 == 3:
                # ExprScript.g:299:9: '\\\\' ( '0' .. '7' )
                pass 
                self.match(92)
                # ExprScript.g:299:14: ( '0' .. '7' )
                # ExprScript.g:299:15: '0' .. '7'
                pass 
                self.matchRange(48, 55)






        finally:

            pass

    # $ANTLR end "OctalEscape"



    # $ANTLR start "ESC"
    def mESC(self, ):

        try:
            # ExprScript.g:303:5: ( '\\\\' . )
            # ExprScript.g:303:9: '\\\\' .
            pass 
            self.match(92)
            self.matchAny()




        finally:

            pass

    # $ANTLR end "ESC"



    # $ANTLR start "VAR_ID"
    def mVAR_ID(self, ):

        try:
            _type = VAR_ID
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:308:7: ( '\\$' ( ALPHA | '_' ) ( ( ALPHA | '_' ) | DIGIT )* )
            # ExprScript.g:308:9: '\\$' ( ALPHA | '_' ) ( ( ALPHA | '_' ) | DIGIT )*
            pass 
            self.match(36)
            if (65 <= self.input.LA(1) <= 90) or self.input.LA(1) == 95 or (97 <= self.input.LA(1) <= 122):
                self.input.consume()
            else:
                mse = MismatchedSetException(None, self.input)
                self.recover(mse)
                raise mse

            # ExprScript.g:308:26: ( ( ALPHA | '_' ) | DIGIT )*
            while True: #loop15
                alt15 = 2
                LA15_0 = self.input.LA(1)

                if ((48 <= LA15_0 <= 57) or (65 <= LA15_0 <= 90) or LA15_0 == 95 or (97 <= LA15_0 <= 122)) :
                    alt15 = 1


                if alt15 == 1:
                    # ExprScript.g:
                    pass 
                    if (48 <= self.input.LA(1) <= 57) or (65 <= self.input.LA(1) <= 90) or self.input.LA(1) == 95 or (97 <= self.input.LA(1) <= 122):
                        self.input.consume()
                    else:
                        mse = MismatchedSetException(None, self.input)
                        self.recover(mse)
                        raise mse



                else:
                    break #loop15


            #action start
            self.debug("VAR(" + self.getText() + ")") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "VAR_ID"



    # $ANTLR start "FUNCTION_ID"
    def mFUNCTION_ID(self, ):

        try:
            _type = FUNCTION_ID
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:313:12: ( ( ALPHA | '_' ) ( ( ALPHA | '_' ) | DIGIT )* )
            # ExprScript.g:313:14: ( ALPHA | '_' ) ( ( ALPHA | '_' ) | DIGIT )*
            pass 
            if (65 <= self.input.LA(1) <= 90) or self.input.LA(1) == 95 or (97 <= self.input.LA(1) <= 122):
                self.input.consume()
            else:
                mse = MismatchedSetException(None, self.input)
                self.recover(mse)
                raise mse

            # ExprScript.g:313:26: ( ( ALPHA | '_' ) | DIGIT )*
            while True: #loop16
                alt16 = 2
                LA16_0 = self.input.LA(1)

                if ((48 <= LA16_0 <= 57) or (65 <= LA16_0 <= 90) or LA16_0 == 95 or (97 <= LA16_0 <= 122)) :
                    alt16 = 1


                if alt16 == 1:
                    # ExprScript.g:
                    pass 
                    if (48 <= self.input.LA(1) <= 57) or (65 <= self.input.LA(1) <= 90) or self.input.LA(1) == 95 or (97 <= self.input.LA(1) <= 122):
                        self.input.consume()
                    else:
                        mse = MismatchedSetException(None, self.input)
                        self.recover(mse)
                        raise mse



                else:
                    break #loop16


            #action start
            self.debug("ID(" + self.getText() + ")") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "FUNCTION_ID"



    # $ANTLR start "ALPHA"
    def mALPHA(self, ):

        try:
            # ExprScript.g:315:15: ( ( 'A' .. 'Z' | 'a' .. 'z' ) )
            # ExprScript.g:315:17: ( 'A' .. 'Z' | 'a' .. 'z' )
            pass 
            if (65 <= self.input.LA(1) <= 90) or (97 <= self.input.LA(1) <= 122):
                self.input.consume()
            else:
                mse = MismatchedSetException(None, self.input)
                self.recover(mse)
                raise mse





        finally:

            pass

    # $ANTLR end "ALPHA"



    # $ANTLR start "DIGIT"
    def mDIGIT(self, ):

        try:
            # ExprScript.g:316:15: ( '0' .. '9' )
            # ExprScript.g:316:17: '0' .. '9'
            pass 
            self.matchRange(48, 57)




        finally:

            pass

    # $ANTLR end "DIGIT"



    # $ANTLR start "HEX"
    def mHEX(self, ):

        try:
            _type = HEX
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:321:4: ( '0' ( 'x' | 'X' ) ( HexDigit )+ )
            # ExprScript.g:321:6: '0' ( 'x' | 'X' ) ( HexDigit )+
            pass 
            self.match(48)
            if self.input.LA(1) == 88 or self.input.LA(1) == 120:
                self.input.consume()
            else:
                mse = MismatchedSetException(None, self.input)
                self.recover(mse)
                raise mse

            # ExprScript.g:321:20: ( HexDigit )+
            cnt17 = 0
            while True: #loop17
                alt17 = 2
                LA17_0 = self.input.LA(1)

                if ((48 <= LA17_0 <= 57) or (65 <= LA17_0 <= 70) or (97 <= LA17_0 <= 102)) :
                    alt17 = 1


                if alt17 == 1:
                    # ExprScript.g:321:20: HexDigit
                    pass 
                    self.mHexDigit()


                else:
                    if cnt17 >= 1:
                        break #loop17

                    eee = EarlyExitException(17, self.input)
                    raise eee

                cnt17 += 1


            #action start
            self.debug("HEX(" + self.getText() + ")") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "HEX"



    # $ANTLR start "HexDigit"
    def mHexDigit(self, ):

        try:
            # ExprScript.g:322:19: ( ( '0' .. '9' | 'a' .. 'f' | 'A' .. 'F' ) )
            # ExprScript.g:322:21: ( '0' .. '9' | 'a' .. 'f' | 'A' .. 'F' )
            pass 
            if (48 <= self.input.LA(1) <= 57) or (65 <= self.input.LA(1) <= 70) or (97 <= self.input.LA(1) <= 102):
                self.input.consume()
            else:
                mse = MismatchedSetException(None, self.input)
                self.recover(mse)
                raise mse





        finally:

            pass

    # $ANTLR end "HexDigit"



    # $ANTLR start "DEC"
    def mDEC(self, ):

        try:
            _type = DEC
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:324:4: ( ( '0' | '1' .. '9' ( '0' .. '9' )* ) )
            # ExprScript.g:324:6: ( '0' | '1' .. '9' ( '0' .. '9' )* )
            pass 
            # ExprScript.g:324:6: ( '0' | '1' .. '9' ( '0' .. '9' )* )
            alt19 = 2
            LA19_0 = self.input.LA(1)

            if (LA19_0 == 48) :
                alt19 = 1
            elif ((49 <= LA19_0 <= 57)) :
                alt19 = 2
            else:
                nvae = NoViableAltException("", 19, 0, self.input)

                raise nvae

            if alt19 == 1:
                # ExprScript.g:324:7: '0'
                pass 
                self.match(48)


            elif alt19 == 2:
                # ExprScript.g:324:13: '1' .. '9' ( '0' .. '9' )*
                pass 
                self.matchRange(49, 57)
                # ExprScript.g:324:22: ( '0' .. '9' )*
                while True: #loop18
                    alt18 = 2
                    LA18_0 = self.input.LA(1)

                    if ((48 <= LA18_0 <= 57)) :
                        alt18 = 1


                    if alt18 == 1:
                        # ExprScript.g:324:22: '0' .. '9'
                        pass 
                        self.matchRange(48, 57)


                    else:
                        break #loop18





            #action start
            self.debug("DEC(" + self.getText() + ")") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "DEC"



    # $ANTLR start "OCTAL"
    def mOCTAL(self, ):

        try:
            _type = OCTAL
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:326:6: ( '0' ( '0' .. '7' )+ )
            # ExprScript.g:326:8: '0' ( '0' .. '7' )+
            pass 
            self.match(48)
            # ExprScript.g:326:12: ( '0' .. '7' )+
            cnt20 = 0
            while True: #loop20
                alt20 = 2
                LA20_0 = self.input.LA(1)

                if ((48 <= LA20_0 <= 55)) :
                    alt20 = 1


                if alt20 == 1:
                    # ExprScript.g:326:13: '0' .. '7'
                    pass 
                    self.matchRange(48, 55)


                else:
                    if cnt20 >= 1:
                        break #loop20

                    eee = EarlyExitException(20, self.input)
                    raise eee

                cnt20 += 1


            #action start
            self.debug("OCTAL(" + self.getText() + ")") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "OCTAL"



    # $ANTLR start "FLOAT"
    def mFLOAT(self, ):

        try:
            _type = FLOAT
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:328:6: ( ( '0' .. '9' )+ '.' ( '0' .. '9' )+ ( Exponent )? | ( '0' .. '9' )+ ( Exponent )? )
            alt26 = 2
            alt26 = self.dfa26.predict(self.input)
            if alt26 == 1:
                # ExprScript.g:330:6: ( '0' .. '9' )+ '.' ( '0' .. '9' )+ ( Exponent )?
                pass 
                # ExprScript.g:330:6: ( '0' .. '9' )+
                cnt21 = 0
                while True: #loop21
                    alt21 = 2
                    LA21_0 = self.input.LA(1)

                    if ((48 <= LA21_0 <= 57)) :
                        alt21 = 1


                    if alt21 == 1:
                        # ExprScript.g:330:7: '0' .. '9'
                        pass 
                        self.matchRange(48, 57)


                    else:
                        if cnt21 >= 1:
                            break #loop21

                        eee = EarlyExitException(21, self.input)
                        raise eee

                    cnt21 += 1


                self.match(46)
                # ExprScript.g:330:22: ( '0' .. '9' )+
                cnt22 = 0
                while True: #loop22
                    alt22 = 2
                    LA22_0 = self.input.LA(1)

                    if ((48 <= LA22_0 <= 57)) :
                        alt22 = 1


                    if alt22 == 1:
                        # ExprScript.g:330:23: '0' .. '9'
                        pass 
                        self.matchRange(48, 57)


                    else:
                        if cnt22 >= 1:
                            break #loop22

                        eee = EarlyExitException(22, self.input)
                        raise eee

                    cnt22 += 1


                # ExprScript.g:330:34: ( Exponent )?
                alt23 = 2
                LA23_0 = self.input.LA(1)

                if (LA23_0 == 69 or LA23_0 == 101) :
                    alt23 = 1
                if alt23 == 1:
                    # ExprScript.g:330:34: Exponent
                    pass 
                    self.mExponent()



                #action start
                self.debug("FLOAT(" + self.getText() + ")") 
                #action end


            elif alt26 == 2:
                # ExprScript.g:332:8: ( '0' .. '9' )+ ( Exponent )?
                pass 
                # ExprScript.g:332:8: ( '0' .. '9' )+
                cnt24 = 0
                while True: #loop24
                    alt24 = 2
                    LA24_0 = self.input.LA(1)

                    if ((48 <= LA24_0 <= 57)) :
                        alt24 = 1


                    if alt24 == 1:
                        # ExprScript.g:332:9: '0' .. '9'
                        pass 
                        self.matchRange(48, 57)


                    else:
                        if cnt24 >= 1:
                            break #loop24

                        eee = EarlyExitException(24, self.input)
                        raise eee

                    cnt24 += 1


                # ExprScript.g:332:20: ( Exponent )?
                alt25 = 2
                LA25_0 = self.input.LA(1)

                if (LA25_0 == 69 or LA25_0 == 101) :
                    alt25 = 1
                if alt25 == 1:
                    # ExprScript.g:332:20: Exponent
                    pass 
                    self.mExponent()



                #action start
                self.debug("FLOAT(" + self.getText() + ")") 
                #action end


            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "FLOAT"



    # $ANTLR start "Exponent"
    def mExponent(self, ):

        try:
            # ExprScript.g:334:19: ( ( 'e' | 'E' ) ( '+' | '-' )? ( '0' .. '9' )+ )
            # ExprScript.g:334:21: ( 'e' | 'E' ) ( '+' | '-' )? ( '0' .. '9' )+
            pass 
            if self.input.LA(1) == 69 or self.input.LA(1) == 101:
                self.input.consume()
            else:
                mse = MismatchedSetException(None, self.input)
                self.recover(mse)
                raise mse

            # ExprScript.g:334:31: ( '+' | '-' )?
            alt27 = 2
            LA27_0 = self.input.LA(1)

            if (LA27_0 == 43 or LA27_0 == 45) :
                alt27 = 1
            if alt27 == 1:
                # ExprScript.g:
                pass 
                if self.input.LA(1) == 43 or self.input.LA(1) == 45:
                    self.input.consume()
                else:
                    mse = MismatchedSetException(None, self.input)
                    self.recover(mse)
                    raise mse




            # ExprScript.g:334:42: ( '0' .. '9' )+
            cnt28 = 0
            while True: #loop28
                alt28 = 2
                LA28_0 = self.input.LA(1)

                if ((48 <= LA28_0 <= 57)) :
                    alt28 = 1


                if alt28 == 1:
                    # ExprScript.g:334:43: '0' .. '9'
                    pass 
                    self.matchRange(48, 57)


                else:
                    if cnt28 >= 1:
                        break #loop28

                    eee = EarlyExitException(28, self.input)
                    raise eee

                cnt28 += 1






        finally:

            pass

    # $ANTLR end "Exponent"



    # $ANTLR start "DATA_ID"
    def mDATA_ID(self, ):

        try:
            _type = DATA_ID
            _channel = DEFAULT_CHANNEL

            # ExprScript.g:340:8: ( '{' ( ALPHA | '_' | '-' ) ( ( ALPHA | '_' | '-' ) | DIGIT | '.' )* ( '@' | '#' ) '}' )
            # ExprScript.g:340:10: '{' ( ALPHA | '_' | '-' ) ( ( ALPHA | '_' | '-' ) | DIGIT | '.' )* ( '@' | '#' ) '}'
            pass 
            self.match(123)
            if self.input.LA(1) == 45 or (65 <= self.input.LA(1) <= 90) or self.input.LA(1) == 95 or (97 <= self.input.LA(1) <= 122):
                self.input.consume()
            else:
                mse = MismatchedSetException(None, self.input)
                self.recover(mse)
                raise mse

            # ExprScript.g:340:30: ( ( ALPHA | '_' | '-' ) | DIGIT | '.' )*
            while True: #loop29
                alt29 = 2
                LA29_0 = self.input.LA(1)

                if ((45 <= LA29_0 <= 46) or (48 <= LA29_0 <= 57) or (65 <= LA29_0 <= 90) or LA29_0 == 95 or (97 <= LA29_0 <= 122)) :
                    alt29 = 1


                if alt29 == 1:
                    # ExprScript.g:
                    pass 
                    if (45 <= self.input.LA(1) <= 46) or (48 <= self.input.LA(1) <= 57) or (65 <= self.input.LA(1) <= 90) or self.input.LA(1) == 95 or (97 <= self.input.LA(1) <= 122):
                        self.input.consume()
                    else:
                        mse = MismatchedSetException(None, self.input)
                        self.recover(mse)
                        raise mse



                else:
                    break #loop29


            if self.input.LA(1) == 35 or self.input.LA(1) == 64:
                self.input.consume()
            else:
                mse = MismatchedSetException(None, self.input)
                self.recover(mse)
                raise mse

            self.match(125)
            #action start
            self.debug("DATA(" + self.getText() + ")") 
            #action end



            self._state.type = _type
            self._state.channel = _channel

        finally:

            pass

    # $ANTLR end "DATA_ID"



    def mTokens(self):
        # ExprScript.g:1:8: ( WS | TRUE | FALSE | AND | OR | NOT | EQ | LEFT_PAREN | RIGHT_PAREN | LEFT_SPAREN | RIGHT_SPAREN | COMMA | SEMICOLON | COLUMN | TYPE_NEW | TYPE_OLD | UNESCAPE_STR | ASSIGN | DOT | PLUS_PLUS | MINUS_MINUS | POWER | PLUS | MINUS | MULTI | DIV | MOD | EQUAL | NEQUAL | REGEXPQUAL | GT | LT | GEQ | LEQ | LOGIC_NOT | LOGIC_AND | LOGIC_OR | BITAND | BITOR | BITXOR | BITONE | IF | THEN | ELSE | TRY | CATCH | OID_SEQUENCE | STRING | RSTRING | VAR_ID | FUNCTION_ID | HEX | DEC | OCTAL | FLOAT | DATA_ID )
        alt30 = 56
        alt30 = self.dfa30.predict(self.input)
        if alt30 == 1:
            # ExprScript.g:1:10: WS
            pass 
            self.mWS()


        elif alt30 == 2:
            # ExprScript.g:1:13: TRUE
            pass 
            self.mTRUE()


        elif alt30 == 3:
            # ExprScript.g:1:18: FALSE
            pass 
            self.mFALSE()


        elif alt30 == 4:
            # ExprScript.g:1:24: AND
            pass 
            self.mAND()


        elif alt30 == 5:
            # ExprScript.g:1:28: OR
            pass 
            self.mOR()


        elif alt30 == 6:
            # ExprScript.g:1:31: NOT
            pass 
            self.mNOT()


        elif alt30 == 7:
            # ExprScript.g:1:35: EQ
            pass 
            self.mEQ()


        elif alt30 == 8:
            # ExprScript.g:1:38: LEFT_PAREN
            pass 
            self.mLEFT_PAREN()


        elif alt30 == 9:
            # ExprScript.g:1:49: RIGHT_PAREN
            pass 
            self.mRIGHT_PAREN()


        elif alt30 == 10:
            # ExprScript.g:1:61: LEFT_SPAREN
            pass 
            self.mLEFT_SPAREN()


        elif alt30 == 11:
            # ExprScript.g:1:73: RIGHT_SPAREN
            pass 
            self.mRIGHT_SPAREN()


        elif alt30 == 12:
            # ExprScript.g:1:86: COMMA
            pass 
            self.mCOMMA()


        elif alt30 == 13:
            # ExprScript.g:1:92: SEMICOLON
            pass 
            self.mSEMICOLON()


        elif alt30 == 14:
            # ExprScript.g:1:102: COLUMN
            pass 
            self.mCOLUMN()


        elif alt30 == 15:
            # ExprScript.g:1:109: TYPE_NEW
            pass 
            self.mTYPE_NEW()


        elif alt30 == 16:
            # ExprScript.g:1:118: TYPE_OLD
            pass 
            self.mTYPE_OLD()


        elif alt30 == 17:
            # ExprScript.g:1:127: UNESCAPE_STR
            pass 
            self.mUNESCAPE_STR()


        elif alt30 == 18:
            # ExprScript.g:1:140: ASSIGN
            pass 
            self.mASSIGN()


        elif alt30 == 19:
            # ExprScript.g:1:147: DOT
            pass 
            self.mDOT()


        elif alt30 == 20:
            # ExprScript.g:1:151: PLUS_PLUS
            pass 
            self.mPLUS_PLUS()


        elif alt30 == 21:
            # ExprScript.g:1:161: MINUS_MINUS
            pass 
            self.mMINUS_MINUS()


        elif alt30 == 22:
            # ExprScript.g:1:173: POWER
            pass 
            self.mPOWER()


        elif alt30 == 23:
            # ExprScript.g:1:179: PLUS
            pass 
            self.mPLUS()


        elif alt30 == 24:
            # ExprScript.g:1:184: MINUS
            pass 
            self.mMINUS()


        elif alt30 == 25:
            # ExprScript.g:1:190: MULTI
            pass 
            self.mMULTI()


        elif alt30 == 26:
            # ExprScript.g:1:196: DIV
            pass 
            self.mDIV()


        elif alt30 == 27:
            # ExprScript.g:1:200: MOD
            pass 
            self.mMOD()


        elif alt30 == 28:
            # ExprScript.g:1:204: EQUAL
            pass 
            self.mEQUAL()


        elif alt30 == 29:
            # ExprScript.g:1:210: NEQUAL
            pass 
            self.mNEQUAL()


        elif alt30 == 30:
            # ExprScript.g:1:217: REGEXPQUAL
            pass 
            self.mREGEXPQUAL()


        elif alt30 == 31:
            # ExprScript.g:1:228: GT
            pass 
            self.mGT()


        elif alt30 == 32:
            # ExprScript.g:1:231: LT
            pass 
            self.mLT()


        elif alt30 == 33:
            # ExprScript.g:1:234: GEQ
            pass 
            self.mGEQ()


        elif alt30 == 34:
            # ExprScript.g:1:238: LEQ
            pass 
            self.mLEQ()


        elif alt30 == 35:
            # ExprScript.g:1:242: LOGIC_NOT
            pass 
            self.mLOGIC_NOT()


        elif alt30 == 36:
            # ExprScript.g:1:252: LOGIC_AND
            pass 
            self.mLOGIC_AND()


        elif alt30 == 37:
            # ExprScript.g:1:262: LOGIC_OR
            pass 
            self.mLOGIC_OR()


        elif alt30 == 38:
            # ExprScript.g:1:271: BITAND
            pass 
            self.mBITAND()


        elif alt30 == 39:
            # ExprScript.g:1:278: BITOR
            pass 
            self.mBITOR()


        elif alt30 == 40:
            # ExprScript.g:1:284: BITXOR
            pass 
            self.mBITXOR()


        elif alt30 == 41:
            # ExprScript.g:1:291: BITONE
            pass 
            self.mBITONE()


        elif alt30 == 42:
            # ExprScript.g:1:298: IF
            pass 
            self.mIF()


        elif alt30 == 43:
            # ExprScript.g:1:301: THEN
            pass 
            self.mTHEN()


        elif alt30 == 44:
            # ExprScript.g:1:306: ELSE
            pass 
            self.mELSE()


        elif alt30 == 45:
            # ExprScript.g:1:311: TRY
            pass 
            self.mTRY()


        elif alt30 == 46:
            # ExprScript.g:1:315: CATCH
            pass 
            self.mCATCH()


        elif alt30 == 47:
            # ExprScript.g:1:321: OID_SEQUENCE
            pass 
            self.mOID_SEQUENCE()


        elif alt30 == 48:
            # ExprScript.g:1:334: STRING
            pass 
            self.mSTRING()


        elif alt30 == 49:
            # ExprScript.g:1:341: RSTRING
            pass 
            self.mRSTRING()


        elif alt30 == 50:
            # ExprScript.g:1:349: VAR_ID
            pass 
            self.mVAR_ID()


        elif alt30 == 51:
            # ExprScript.g:1:356: FUNCTION_ID
            pass 
            self.mFUNCTION_ID()


        elif alt30 == 52:
            # ExprScript.g:1:368: HEX
            pass 
            self.mHEX()


        elif alt30 == 53:
            # ExprScript.g:1:372: DEC
            pass 
            self.mDEC()


        elif alt30 == 54:
            # ExprScript.g:1:376: OCTAL
            pass 
            self.mOCTAL()


        elif alt30 == 55:
            # ExprScript.g:1:382: FLOAT
            pass 
            self.mFLOAT()


        elif alt30 == 56:
            # ExprScript.g:1:388: DATA_ID
            pass 
            self.mDATA_ID()







    # lookup tables for DFA #26

    DFA26_eot = DFA.unpack(
        u"\1\uffff\1\3\2\uffff"
        )

    DFA26_eof = DFA.unpack(
        u"\4\uffff"
        )

    DFA26_min = DFA.unpack(
        u"\1\60\1\56\2\uffff"
        )

    DFA26_max = DFA.unpack(
        u"\2\71\2\uffff"
        )

    DFA26_accept = DFA.unpack(
        u"\2\uffff\1\1\1\2"
        )

    DFA26_special = DFA.unpack(
        u"\4\uffff"
        )

            
    DFA26_transition = [
        DFA.unpack(u"\12\1"),
        DFA.unpack(u"\1\2\1\uffff\12\1"),
        DFA.unpack(u""),
        DFA.unpack(u"")
    ]

    # class definition for DFA #26

    DFA26 = DFA
    # lookup tables for DFA #30

    DFA30_eot = DFA.unpack(
        u"\2\uffff\6\46\11\uffff\1\60\1\64\1\uffff\1\66\1\70\1\72\2\uffff"
        u"\1\74\1\76\1\100\1\102\1\104\2\uffff\3\46\1\112\3\uffff\1\112\1"
        u"\uffff\3\46\1\123\1\46\1\125\1\46\25\uffff\1\127\3\46\3\uffff\1"
        u"\134\1\116\1\uffff\1\112\2\46\1\137\1\uffff\1\140\1\uffff\1\46"
        u"\1\uffff\1\46\1\143\1\46\1\116\1\uffff\1\146\1\46\2\uffff\1\150"
        u"\1\151\1\uffff\1\46\2\uffff\1\153\2\uffff\1\154\2\uffff"
        )

    DFA30_eof = DFA.unpack(
        u"\155\uffff"
        )

    DFA30_min = DFA.unpack(
        u"\1\11\1\uffff\1\162\1\141\1\156\1\162\1\157\1\154\11\uffff\1\42"
        u"\1\75\1\uffff\1\53\1\55\1\52\2\uffff\3\75\1\46\1\174\2\uffff\1"
        u"\146\1\150\1\141\1\56\3\uffff\1\56\1\uffff\1\165\1\154\1\144\1"
        u"\60\1\164\1\60\1\163\25\uffff\1\60\1\145\1\171\1\164\2\uffff\1"
        u"\60\2\56\1\uffff\1\56\1\145\1\163\1\60\1\uffff\1\60\1\uffff\1\145"
        u"\1\uffff\1\156\1\60\1\143\1\56\1\uffff\1\60\1\145\2\uffff\2\60"
        u"\1\uffff\1\150\2\uffff\1\60\2\uffff\1\60\2\uffff"
        )

    DFA30_max = DFA.unpack(
        u"\1\176\1\uffff\1\162\1\141\1\156\1\162\1\157\1\161\11\uffff\1\172"
        u"\1\176\1\uffff\1\53\1\55\1\52\2\uffff\3\75\1\46\1\174\2\uffff\1"
        u"\146\1\162\1\141\1\170\3\uffff\1\145\1\uffff\1\165\1\154\1\144"
        u"\1\172\1\164\1\172\1\163\25\uffff\1\172\1\145\1\171\1\164\2\uffff"
        u"\1\71\1\145\1\71\1\uffff\2\145\1\163\1\172\1\uffff\1\172\1\uffff"
        u"\1\145\1\uffff\1\156\1\172\1\143\1\71\1\uffff\1\172\1\145\2\uffff"
        u"\2\172\1\uffff\1\150\2\uffff\1\172\2\uffff\1\172\2\uffff"
        )

    DFA30_accept = DFA.unpack(
        u"\1\uffff\1\1\6\uffff\1\10\1\11\1\12\1\13\1\14\1\15\1\16\1\17\1"
        u"\20\2\uffff\1\23\3\uffff\1\32\1\33\5\uffff\1\50\1\51\4\uffff\1"
        u"\60\1\62\1\63\1\uffff\1\70\7\uffff\1\21\1\61\1\34\1\36\1\22\1\24"
        u"\1\27\1\25\1\30\1\26\1\31\1\35\1\43\1\41\1\37\1\42\1\40\1\44\1"
        u"\46\1\45\1\47\4\uffff\1\64\1\65\3\uffff\1\67\4\uffff\1\5\1\uffff"
        u"\1\7\1\uffff\1\52\4\uffff\1\66\2\uffff\1\4\1\6\2\uffff\1\55\1\uffff"
        u"\1\57\1\2\1\uffff\1\54\1\53\1\uffff\1\3\1\56"
        )

    DFA30_special = DFA.unpack(
        u"\155\uffff"
        )

            
    DFA30_transition = [
        DFA.unpack(u"\2\1\1\uffff\2\1\22\uffff\1\1\1\31\1\44\1\20\1\45\1"
        u"\30\1\34\1\44\1\10\1\11\1\26\1\24\1\14\1\25\1\23\1\27\1\43\11\47"
        u"\1\16\1\15\1\33\1\22\1\32\1\uffff\1\17\5\46\1\3\15\46\1\2\6\46"
        u"\1\12\1\uffff\1\13\1\36\1\46\1\uffff\1\4\1\46\1\42\1\46\1\7\3\46"
        u"\1\40\4\46\1\6\1\5\2\46\1\21\1\46\1\41\6\46\1\50\1\35\1\uffff\1"
        u"\37"),
        DFA.unpack(u""),
        DFA.unpack(u"\1\51"),
        DFA.unpack(u"\1\52"),
        DFA.unpack(u"\1\53"),
        DFA.unpack(u"\1\54"),
        DFA.unpack(u"\1\55"),
        DFA.unpack(u"\1\57\4\uffff\1\56"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"\1\61\4\uffff\1\61\10\uffff\12\46\7\uffff\32\46\4\uffff"
        u"\1\46\1\uffff\32\46"),
        DFA.unpack(u"\1\62\100\uffff\1\63"),
        DFA.unpack(u""),
        DFA.unpack(u"\1\65"),
        DFA.unpack(u"\1\67"),
        DFA.unpack(u"\1\71"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"\1\73"),
        DFA.unpack(u"\1\75"),
        DFA.unpack(u"\1\77"),
        DFA.unpack(u"\1\101"),
        DFA.unpack(u"\1\103"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"\1\105"),
        DFA.unpack(u"\1\106\11\uffff\1\107"),
        DFA.unpack(u"\1\110"),
        DFA.unpack(u"\1\113\1\uffff\10\114\2\115\13\uffff\1\116\22\uffff"
        u"\1\111\14\uffff\1\116\22\uffff\1\111"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"\1\113\1\uffff\12\117\13\uffff\1\116\37\uffff\1\116"),
        DFA.unpack(u""),
        DFA.unpack(u"\1\120"),
        DFA.unpack(u"\1\121"),
        DFA.unpack(u"\1\122"),
        DFA.unpack(u"\12\46\7\uffff\32\46\4\uffff\1\46\1\uffff\32\46"),
        DFA.unpack(u"\1\124"),
        DFA.unpack(u"\12\46\7\uffff\32\46\4\uffff\1\46\1\uffff\32\46"),
        DFA.unpack(u"\1\126"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"\12\46\7\uffff\32\46\4\uffff\1\46\1\uffff\32\46"),
        DFA.unpack(u"\1\130"),
        DFA.unpack(u"\1\131"),
        DFA.unpack(u"\1\132"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"\12\133"),
        DFA.unpack(u"\1\113\1\uffff\10\114\2\115\13\uffff\1\116\37\uffff"
        u"\1\116"),
        DFA.unpack(u"\1\113\1\uffff\12\115"),
        DFA.unpack(u""),
        DFA.unpack(u"\1\113\1\uffff\12\117\13\uffff\1\116\37\uffff\1\116"),
        DFA.unpack(u"\1\135"),
        DFA.unpack(u"\1\136"),
        DFA.unpack(u"\12\46\7\uffff\32\46\4\uffff\1\46\1\uffff\32\46"),
        DFA.unpack(u""),
        DFA.unpack(u"\12\46\7\uffff\32\46\4\uffff\1\46\1\uffff\32\46"),
        DFA.unpack(u""),
        DFA.unpack(u"\1\141"),
        DFA.unpack(u""),
        DFA.unpack(u"\1\142"),
        DFA.unpack(u"\12\46\7\uffff\32\46\4\uffff\1\46\1\uffff\32\46"),
        DFA.unpack(u"\1\144"),
        DFA.unpack(u"\1\145\1\uffff\12\133"),
        DFA.unpack(u""),
        DFA.unpack(u"\12\46\7\uffff\32\46\4\uffff\1\46\1\uffff\32\46"),
        DFA.unpack(u"\1\147"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"\12\46\7\uffff\32\46\4\uffff\1\46\1\uffff\32\46"),
        DFA.unpack(u"\12\46\7\uffff\32\46\4\uffff\1\46\1\uffff\32\46"),
        DFA.unpack(u""),
        DFA.unpack(u"\1\152"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"\12\46\7\uffff\32\46\4\uffff\1\46\1\uffff\32\46"),
        DFA.unpack(u""),
        DFA.unpack(u""),
        DFA.unpack(u"\12\46\7\uffff\32\46\4\uffff\1\46\1\uffff\32\46"),
        DFA.unpack(u""),
        DFA.unpack(u"")
    ]

    # class definition for DFA #30

    DFA30 = DFA
 



def main(argv, stdin=sys.stdin, stdout=sys.stdout, stderr=sys.stderr):
    from antlr3.main import LexerMain
    main = LexerMain(ExprScriptLexer)
    main.stdin = stdin
    main.stdout = stdout
    main.stderr = stderr
    main.execute(argv)


if __name__ == '__main__':
    main(sys.argv)
