# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.
"""
################################################################################
SNMP TRAP utilities
################################################################################

TODO

"""

def decode(s):
	# from a raw UDP packet, or raw ASN.1 BER data substrate, return
	# a dictionary representing the trap, in v2 format (even if the original was v1)

	rv=dict()
	rv['version'] = s[0][1][0][1] + 1
	rv['community'] = s[0][1][1][1]
	if rv['version'] == 1:
		enterprise =       s[0][1][2][1][0][1]
		agent =            s[0][1][2][1][1][1]
		traptype =         s[0][1][2][1][2][1]
		specifictraptype = s[0][1][2][1][3][1] 
		timestamp =        s[0][1][2][1][4][1]
		varbindlist =      s[0][1][2][1][5][1]
		varbindlist = map(lambda x: [x[1][0][1], x[1][1][1]], varbindlist)
		vbl_keys = set(map(lambda x: x[0], varbindlist))
		if not '1.3.6.1.6.3.18.1.3.0' in vbl_keys:
			varbindlist.append(['1.3.6.1.6.3.18.1.3.0', agent])
		if not '1.3.6.1.6.3.18.1.4.0' in vbl_keys:
			varbindlist.append(['1.3.6.1.6.3.18.1.4.0', rv['community']])
		if not '1.3.6.1.6.3.1.1.4.3.0' in vbl_keys:
			varbindlist.append(['1.3.6.1.6.3.1.1.4.3.0', enterprise])
		if traptype == 6:
			varbindlist.append(['1.3.6.1.6.3.1.1.4.1.0', enterprise + '.0.' + str(specifictraptype)])
		else:
			varbindlist.append(['1.3.6.1.6.3.1.1.4.1.0', '1.3.6.1.6.3.1.1.5.' + str(traptype)])
	elif rv['version'] == 2:
		varbindlist = map(lambda x: [x[1][0][1], x[1][1][1]], s[0][1][2][1][3][1])
	rv['varbindlist'] = varbindlist
	return rv

if __name__ == '__main__':

	import socket
	from pprint import pprint
	import ber

	s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
	s.bind(('', 162))

	print("waiting...")

	while True:
		o=s.recvfrom(4096)

		print('')
		print('Trap from %s port %d' % o[1])
		pprint(o[0])

		print('')
		print(ber.decode(o[0]))
		print('')

		pprint(decode(ber.decode(o[0])))
