# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

"""
################################################################################
Process utilities
################################################################################

TODO

"""

import os
import signal

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

def convert_exit_status_to_verb_reason(status):
	"""
	TODO
	"""

	if os.WIFEXITED(status):
		exit_code = os.WEXITSTATUS(status)
	else:
		exit_code = None

	sig = None
	if os.WIFSIGNALED(status):
		sig_code = os.WTERMSIG(status)

		# Get name of the signal
		for symbol in signal.__dict__:
			if symbol.startswith('SIG'):
				if signal.__dict__[symbol] == sig_code:
					sig = symbol

	return "exit code: %s, signal: %s, core dump: %s" % (exit_code, sig, os.WCOREDUMP(status))

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

def _parse_proc_stat(VmKey):
	"""
	TODO
	"""

	_scale = {
		'KB': 1024.0, 
		'MB': 1024.0 * 1024.0
	}

	_proc_status = '/proc/%d/status' % (os.getpid(),)

	try:
		t = open(_proc_status)
		v = t.read()
		t.close()
	except:
		return None

	i = v.index(VmKey)

	v = v[i:].split(None, 3)  # whitespace
	if len(v) < 3:
		return None

	return float(v[1]) * _scale[v[2].upper()]

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

def get_proc_memory(since=0.0):
	"""
	TODO
	"""
	return _parse_proc_stat('VmSize:') - since

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

def get_proc_resident(since=0.0):
	"""
	TODO
	"""
	return _parse_proc_stat('VmRSS:') - since

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

def get_proc_stacksize(since=0.0):
	"""
	TODO
	"""
	return _parse_proc_stat('VmStk:') - since
