# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

import time
import binascii
import types

#-----------------------------------------------------------------------------#
#                                                                             #
#-----------------------------------------------------------------------------#

def get_time():
	return int(time.time())

#-----------------------------------------------------------------------------#
#                                                                             #
#-----------------------------------------------------------------------------#

def crc32(s):
	# FIX: write a better one?
	return abs(binascii.crc32(s))

def bin2hex(bin):
	"""
	Convert binary byte string [0x11,0xAA,0xFF,0x44]
	to the string '11AAFF44'
	"""
	return binascii.hexlify(bin)

def macbin2blob(bin):	
	if len(bin) == 6:
		#print "macbin2blob: %s %s %s" % (binascii.b2a_hex(bin),type(bin),len(bin))
		return binascii.b2a_hex(bin)
	else:
		#print "macbin2blob: %s %s %s" % (bin[3:],type(bin),len(bin))
		return bin[3:]

def datestr():
	year, mon, mday, hour, minu, sec, wday, yday, isdst = time.localtime(get_time())
	
	return "%04d%02d%02d%02d%02d%02d" % (year, mon , mday, hour, minu, sec)





