# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

import sys

def str_to_bool(string):

	if string == 'False':
		return False
	else:
		try:
			return bool(float(string))
		except ValueError:
			return bool(string)

def load_symbol_from_line(params, l):

		ptypes = {
			'num': float,
			'int': int,
			'str': str,
			'bool': str_to_bool,
		}

		l = l.strip()

		if l.find("=") < 0:
			return
			
		param_def = l.split('=')
		
		if len(param_def) == 2:
			#  $var = value
			name = param_def[0].strip()
			val  = param_def[1].strip()
			params[ name ] = val
		else:
			# $var = type = value
			name  = param_def[0].strip()
			ptype = param_def[1].strip()
			val   = param_def[2].strip()
			params[ name ] = ptypes[ptype](val)

def load_symbols_from_stdin():
	
	expr = None
	params = {}

	read_expr = False

	lines = sys.stdin.readlines()
	for l in lines:

		if l.strip() == "":
			read_expr = True
			continue

		if not read_expr:
			load_symbol_from_line(params, l)
		else:
			expr = l
			break

	return expr, params
