#!/bin/bash

### BEGIN INIT INFO
# Provides:          sanetremotepoller
# Required-Start:    $local_fs
# Required-Stop:     $local_fs
# Should-Start:      $remote_fs $time $syslog redis-server
# Should-Stop:       $remote_fs $time $syslog redis-server
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Sanet 3 remote poller
### END INIT INFO

#
# SANET Remote agent start/stop script
#


SANET_REMOTE_INSTALL_DIR=

if test -z "$SANET_REMOTE_INSTALL_DIR"
then
	export SANET_REMOTE_INSTALL_DIR=$SANET_REMOTE_HOME
fi

if test -z "$SANET_REMOTE_INSTALL_DIR"
then
	export SANET_REMOTE_INSTALL_DIR=/usr/share/sanet-remote-poller
	echo "Warning: SANET_REMOTE_HOME is not set, assuming $SANET_REMOTE_INSTALL_DIR"
fi

#echo "Sanet remote global script ($SANET_REMOTE_INSTALL_DIR)"




cd $SANET_REMOTE_INSTALL_DIR
case "$1" in
	'start')
		ulimit -n 16000
		echo "Starting all agents..."
		$HPRI python launcher.py start $2
		;;
	'stop')
		echo "Stopping all agents..."
		$HPRI python launcher.py stop $2
		;;

	'restart')
		$0 stop $2
		sleep 3
		$0 start $2
		;;

	'list')
		$HPRI python launcher.py list
		;;

	*)
		echo ""
		echo "Usage: $0 <command> <args>"
		echo ""
		echo "Command can be:"
		echo ""
		echo "start    <agent>    Start agents"
		echo "stop     <agent>    Stop agents"
		echo "restart  <agent>    Stop agents"
		echo "list                List agents"
		;;
esac

