#!/bin/bash

RELEASE=$1
echo "RELEASE:" $1

SVN_OPTIONS=""

if [ "$RELEASE" != "" ]; then
	SVN_OPTIONS="$SVN_OPTIONS --revision $RELEASE"
fi

echo $SVN_OPTIONS

export SVN_OPTIONS


#----------------------------------------------------------------------#
# ASK REPOSITORY USER+PASSWORD                                         #
#----------------------------------------------------------------------#

read    -p "Username: " USERNAME
read -s -p "Password: " PASSWORD

#echo "$USERNAME" "$PASSWORD"

if [ "$USERNAME" == "" ]; then
	echo "Invalid username"
	exit -1
fi

if [ "$PASSWORD" == "" ]; then
	echo "Invalid password"
	exit -1
fi


SVN_OPTIONS="$SVN_OPTIONS --non-interactive"        # do no interactive prompting
SVN_OPTIONS="$SVN_OPTIONS --trust-server-cert" 
SVN_OPTIONS="$SVN_OPTIONS --username $USERNAME --password $PASSWORD"

export SVN_OPTIONS

#----------------------------------------------------------------------#
#----------------------------------------------------------------------#
#----------------------------------------------------------------------#

function module_dir()
{
	NAME=$1
	CMD="import os\nimport $NAME\nprint os.path.dirname($NAME.__file__)"
	echo -e $CMD | python 2> /dev/null
}


function update_svn_dir()
{
	#FAKE=$SVN_OPTIONS 

	svn update $SVN_OPTIONS
	ret=$?
	if [ "$ret" != "0" ]; then
		echo -en "$COLOR_RED_BOLD"
		echo "ERROR while update" $(pwd)
		echo -en "$COLOR_OFF"
		exit -1
	fi
}


COLOR_GREEN='\e[0;32m'
COLOR_RED_BOLD='\e[1;31m'
COLOR_OFF='\e[0m'
COLOR_YELLOW='\e[0;93m'

function check_svn_status()
{


	OUTPUT=$(svn info 2>& 1)
	if [ "$?" != "0" ]; then
		echo -en "$COLOR_RED_BOLD"
		echo "ERRORE in " $(pwd)
		echo "$OUTPUT"
		echo -en "$COLOR_OFF"
		exit -1
	fi



	OUTPUT=$(svn status | grep '^C')
	OUTPUT=`echo $OUTPUT` #trim
	if [ "$OUTPUT" ]; then
		echo -en "$COLOR_RED_BOLD" 
		echo "ERRORE: ci sono conflitti svn, esegui svn status" 
		echo -en "$COLOR_OFF"
		exit -1
	else
		echo -ne "$COLOR_GREEN" 
		echo "Aggiornamento completato" 
		echo -ne "$COLOR_OFF"
	fi
}




#----------------------------------------------------------------------#
# UPDATE                                                               #
#----------------------------------------------------------------------#

MODULE_DIR=$(pwd)
echo "Update SANET" "($MODULE_DIR)"

update_svn_dir 
check_svn_status 
rm -f $(find . -name '*.pyc')

#----------------------------------------------------------------------#

MODULE_DIR=$(module_dir "sanet_common")
cd $MODULE_DIR 

echo "Update sanet-common" "($MODULE_DIR)"
update_svn_dir
check_svn_status
rm -f $(find . -name '*.pyc')

#----------------------------------------------------------------------#

MODULE_DIR=$(module_dir "sanet_libsnmp") 
cd $MODULE_DIR 

echo "Update sanet-libsnmp" "($MODULE_DIR)"
update_svn_dir
check_svn_status
rm -f $(find . -name '*.pyc')

#----------------------------------------------------------------------#

MODULE_DIR=$(module_dir "sanet_poller") 
cd $MODULE_DIR 

echo "Update sanet-poller" "($MODULE_DIR)"
update_svn_dir
check_svn_status
rm -f $(find . -name '*.pyc')

#----------------------------------------------------------------------#

MODULE_DIR=$(module_dir "ipmon")
cd $MODULE_DIR 

echo "Update sanet-ipmon" "($MODULE_DIR)"
update_svn_dir 
check_svn_status
rm -f $(find . -name '*.pyc')


