# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.


from core.api.base import db_set_current_tenant_schema, tenant_get

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

def cli_action_tenant_dependent(cli_action):

	def _cli_action_tenant_dependent(cli):
		
		tenant_name = cli.env.get('CURRENT_TENANT',None)
		tenant = tenant_get(tenant_name)
		db_set_current_tenant_schema(tenant.name)

		return cli_action(cli, tenant)
		
	return _cli_action_tenant_dependent

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

def cli_admin_command(cli_command):
	"""
	Decoratore da usare su tutti i comandi di CLI che non devono essere eseguiti da un utente normale.
	"""

	def _cli_admin_reserved_command(cli):

		user = cli.env['CURRENT_USER']

		if user and not user.is_superuser:
			cli.warning("NORMAL USER CAN NOT LAUNCH THIS COMMAND")
			return

		return cli_command(cli)

	return _cli_admin_reserved_command
