# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

import logging

from django.dispatch import receiver

from core.models import sanet_init_subapp
from core.models import sanet_check_tenant
from core.models import sanet_cleanup_tenant
from core.models import sanet_post_check

#------------------------------------------------------------------------------#
# SANET SIGNALS                                                                #
#------------------------------------------------------------------------------#

@receiver(sanet_init_subapp)
def _sanet_init_subapp_cli(sender, **kwargs):
	
	logger = logging.getLogger('sanet.global')
	
	logger.info( "[cli] Init" )

@receiver(sanet_check_tenant)
def _sanet_check_tenant_cli(sender, **kwargs):
	
	logger = logging.getLogger('sanet.global')
	
	t = kwargs['instance']
	logger.info(  "[cli] Check tenant %s" % (t) )

@receiver(sanet_cleanup_tenant)
def _sanet_cleanup_tenant_cli(sender, **kwargs):
	
	logger = logging.getLogger('sanet.global')
	
	t = kwargs['instance']
	logger.info(  "[cli] Cleanup tenant %s" % (t) )

@receiver(sanet_post_check)
def _sanet_post_check_cli(sender, **kwargs):
	
	logger = logging.getLogger('sanet.global')
	
	logger.info(  "[cli] Post check" )












#import time
#import datetime
#
#from django.db import models
#from django.contrib.contenttypes import generic
#from django.contrib.contenttypes.models import ContentType
#
#from django.contrib.auth.models import User
#
#from sanet_common.timeutils import datetime_to_timestamp
#
#from core.models import CapabilityException
#
#from core.models import Tenant, MonitoredElement, Condition, UUIDKeyModel, TenantDependentModel
#
#from tags.models import Tag
#from tags.models import TAG_FILTER

#import time

#from django.db import models

#from django.dispatch import receiver

#from core.models import sanet_config_user_action

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

#class CliLog(models.Model):
#
#	timestamp      = models.PositiveIntegerField(null=False, db_index=True)
#
#	user           = models.TextField(null=False, blank=True)
#
#	tenant         = models.TextField(null=True, blank=True, default=None)
#	
#	entity_type    = models.TextField(null=True, blank=True, default=None)
#	
#	entity_id      = models.TextField(null=True, blank=True, default=None)
#
#
#	msg            = models.TextField(null=False, blank=True)
#
#	class Meta:
#		db_table = "clilog"
#		unique_together = (
#		)

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

#@receiver(sanet_config_user_action)
#def _update_tagged_condition_update(sender, **kwargs):
#
#	tenant      = kwargs.get('tenant'     , None)
#	user        = kwargs.get('user'       , None)
#	msg         = kwargs.get('msg'        , None)
#	entity_type = kwargs.get('entity_type', None)
#	entity_id   = kwargs.get('entity_id'  , None)
#
#	#
#	# Implementare un meccanismo di filtraggio
#	#
#
#	log = CliLog(
#		timestamp   = int(time.time()), 
#		user        = user, 
#		tenant      = tenant, 
#		entity_type = entity_type,
#		entity_id   = entity_id,
#		msg         = msg,
#	)
#	log.save()
#
#	return 
