"""
La CLI permette di definire entry-point o hook e associare a questi hook funzioni o menu.
In qualunque momento il codice della CLI puo' richiamare questi hook o menu
e usarli per i propri scopi.

I menu aggiuntivi possono a loro volta utilizzare hook interni.

 TODO: stilare elenco delgi elenco hook standard
"""

__cli_menus = {}

__cli_hooks = {}


def cli_register_menu(contextid, menu_id, menu_entries):
	global __cli_menus
	entries = __cli_menus.get(contextid, {})
	entries[menu_id] = menu_entries
	__cli_menus[contextid] = entries



def print_registerd_menus():
	for contexid, menus in sorted(__cli_menus.items()):
		print "Context:", contexid
		for menuid, entries in menus.items():
			print "\t", menuid
			for e in entries:
				print "\t", "\t", e

def cli_get_registered_menus(contextid):#
	registered_menus = __cli_menus.get(contextid, {})
	r = []
	for (mid, re) in registered_menus.items():
		r += re
	return r

def cli_register_hook(contextid, hook_id, handler, priority=0):
	
	global __cli_hooks
	
	entries = __cli_hooks.get(contextid, {})
	entries[hook_id] = (priority, handler)
	__cli_hooks[contextid] = entries

def cli_get_registered_hooks(contextid):
	
	global __cli_hooks
	
	registered_hooks = __cli_hooks.get(contextid, {})
	r = []
	for (hookid, pri_handler) in registered_hooks.items():
		r.append(pri_handler)
		
	r = [ handler for pri, handler in sorted(r) ]
		
	return r

def print_registerd_hooks():
	for contexid, hooks in sorted(__cli_hooks.items()):
		print "Context:", contexid
		for hookid, handler in hooks.items():
			print "\t", hookid, handler
