# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

from django.utils.translation import ugettext as _

from core.api.base import db_set_current_tenant_schema, tenant_get
from core.models import PriorityLabel

from cli.clilib.ioslike import *
from cli.textformat import *

from cli.prompts.common import output_table

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

def cmd_show_priority_levels(cli):

	env = cli.env
	cols = env['COLS']

	current_user = env.get('CURRENT_USER', None)

	t = tenant_get(env['CURRENT_TENANT'])

	# FIX: use API
	db_set_current_tenant_schema(t.name)
	levels = PriorityLabel.objects.all().order_by('min_level')
 
	pos = 1
	r = [[
		[_('N.'         ),  3],
		[_('MIN'        ),  3],
		[_('MAX'        ),  3],
		[_('LABEL'      ), -4],
		[_('DESCRIPTION'), 12],
	]]
	for l in levels:
		r = r + [[
			pos,
			l.min_level,
			l.max_level,
			l.label,
			l.description,
		]]
		pos += 1
		
	output_table(cli, r)

