# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

from sanet_common.table import table

from cli.utils import generic_details_aoa

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

def text_table(aoa, term_width=None):

	t = table(map(lambda x: x[0], aoa[0]), column_widths=map(lambda x: x[1], aoa[0]), rows=aoa[1:])

	return t.text(max_width=term_width)

def text_details(line):
	ml = 0
	rv = u''
	max_len = max(map(lambda f : len(f[0]), line))
	form = u'%-' + unicode(max_len) + u's : %s\n'
	for f in line:
		rv = rv + form % (unicode(f[0]), unicode( f[1] if f[1] is not None else ''  ))
	return rv

def generic_details(*args, **kwargs):
	return text_details(generic_details_aoa(*args, **kwargs))

