# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

#
# DO NOT EDIT THIS FILE !!!!!
# DO NOT EDIT THIS FILE !!!!!
# DO NOT EDIT THIS FILE !!!!!
# DO NOT EDIT THIS FILE !!!!!
# DO NOT EDIT THIS FILE !!!!!
# DO NOT EDIT THIS FILE !!!!!
#
# Copy settings_dist.py to settings.py and edit settings.py.
# This file will be overwritten
#

"""
default_settings
========================================================================

Questo file contiene tutte le configurazioni di default di Sanet.

Questo file deve essere modificato solo in fase di sviluppo.

"""

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

import os.path

from .sanet_version import *

from .default_dirs import *

from django.urls import reverse_lazy

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

# for django 1.11
SILENCED_SYSTEM_CHECKS = [
	# core.MonitoredNode.ip4_mgt        : (fields.W900) IPAddressField has been deprecated. Support for it (except in historical migrations) will be removed in Django 1.9. HINT: Use GenericIPAddressField instead.
	"fields.W900",
	# core.SANETGroupProfile.group      : (fields.W342) Setting unique=True on a ForeignKey has the same effect as using a OneToOneField. HINT: ForeignKey(unique=True) is usually better served by a OneToOneField.
	# core.SANETUserProfile.user        : (fields.W342) Setting unique=True on a ForeignKey has the same effect as using a OneToOneField. HINT: ForeignKey(unique=True) is usually better served by a OneToOneField.
	"fields.W342",
]

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

#
# General settings
#======================================================================

# Activate debug mode:
# - Web interface show debug pages with tracebacks
# - 
DEBUG = False           

# Sanet's javascripts log informations on browser's javascript console
DEBUG_JS = DEBUG

# Enable debug-mode in CLI commands (verbose output)
DEBUG_CONFIG = DEBUG

# (Internal) Enabel debug-mode in web templates.
#TEMPLATE_DEBUG = DEBUG  # for django 1.11


#
# Web application settings
#======================================================================

ALLOWED_HOSTS = ['*']  # for django 1.11

# URL for application deployment. Change this to deploy to a different location.
# If you change this value you MUST execute the `manage.py deploy` command again.
#
#    http(s)://<host>/<URL_PREFIX>......
#
BASE_URL_PREFIX = ''

#
# Internal settings
#======================================================================

ADMINS = (
)

MANAGERS = ADMINS

#
# Database backend settings
#======================================================================

# Django database backend module (NEVER CHANGE THIS)
DEFAULT_DATABASE_BACKEND = 'django.db.backends.postgresql_psycopg2'

# Database options
DATABASES = {
    'default': {
        'ENGINE': DEFAULT_DATABASE_BACKEND,    # Add 'postgresql_psycopg2', 'mysql', 'sqlite3' or 'oracle'.
        'NAME': 'sanet3',                      # Or path to database file if using sqlite3.
        'USER': 'sanet3',                      # Not used with sqlite3.
        'PASSWORD': '',                        # Not used with sqlite3.
        'HOST': '',                            # Set to empty string for localhost. Not used with sqlite3.
        'PORT': '',                            # Set to empty string for default. Not used with sqlite3.
    }
}

# DO NOT CHANGE THIS
SITE_ID = 1

#FIXTURE_DIRS = 'fixtures/' # for django 1.11

#
# Web interface
#======================================================================

# Web cookie name
SESSION_COOKIE_NAME = 'sanet3'

# Make this unique, and don't share it with anybody.
SECRET_KEY = 'upf1k+!u_!at_rl^n=2e%#^dy0nu)nbwv3m5u-(=i44*ykh-04'

# User assigned to by web-server
WEBSERVER_USER = 'www-data'

#
# internationalization & localization
#======================================================================


# Local time zone for this installation. Choices can be found here:
# http://en.wikipedia.org/wiki/List_of_tz_zones_by_name
# although not all choices may be available on all operating systems.
# In a Windows environment this must be set to your system time zone.
TIME_ZONE = 'Europe/Rome'
DATE_FORMAT = "Y-m-d H:i:s"


# Language code for this installation. All choices can be found here:
# http://www.i18nguy.com/unicode/language-identifiers.html
LANGUAGE_CODE = 'en'

# If you set this to False, Django will make some optimizations so as not
# to load the internationalization machinery.
USE_I18N = True

#LOCALE_PATHS = (
#	os.sep.join( [BASE_DIR, 'locale'] )
#)

# If you set this to False, Django will not format dates, numbers and
# calendars according to the current locale.
USE_L10N = True

# If you set this to False, Django will not use timezone-aware datetimes.
USE_TZ = False

#
# Web static content
#======================================================================

# Absolute path to the directory static files should be collected to.
# Don't put anything in this directory yourself; store your static files
# in apps' "static/" subdirectories and in STATICFILES_DIRS.
# Example: "/home/media/media.lawrence.com/static/"
STATIC_ROOT = os.path.join( BASE_DIR , 'static' )   # es: $SANET_HOME/static

# URL prefix for static files.
# Example: "http://media.lawrence.com/static/"
STATIC_URL = BASE_URL_PREFIX + 'static/'            # es: sanet/static/


# Additional locations of static files
STATICFILES_DIRS = (
    # Put strings here, like "/home/html/static" or "C:/www/django/static".
    # Always use forward slashes, even on Windows.
    # Don't forget to use absolute paths, not relative paths.
)

# List of finder classes that know how to find static files in
# various locations.
STATICFILES_FINDERS = (
    #'django.contrib.staticfiles.finders.FileSystemFinder',       # --> STATICFILES_DIRS 
    #'django.contrib.staticfiles.finders.AppDirectoriesFinder',   # --> <app>/static
    #'django.contrib.staticfiles.finders.DefaultStorageFinder',
)

#
# Media content
#======================================================================

# Absolute filesystem path to the directory that will hold user-uploaded files.
# Example: "/home/media/media.lawrence.com/media/"
MEDIA_ROOT = os.path.join( MEDIA_DIR )

# URL that handles the media served from MEDIA_ROOT. Make sure to use a
# trailing slash.
# Examples: "http://media.lawrence.com/media/", "http://example.com/media/"
MEDIA_URL = BASE_URL_PREFIX + 'media/' 



#
# Template settings
#======================================================================

# Django 1.11
TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [
            # insert your TEMPLATE_DIRS here
        ],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                # Insert your TEMPLATE_CONTEXT_PROCESSORS here or use this
                # list if you haven't customized them:
                'django.contrib.auth.context_processors.auth',
                'django.template.context_processors.debug',
                'django.template.context_processors.i18n',
                'django.template.context_processors.media',
                'django.template.context_processors.static',
                'django.template.context_processors.tz',
                'django.contrib.messages.context_processors.messages',
                
                
                #'django.core.context_processors.debug',           # Adds {{DEBUG}}
                #'django.core.context_processors.static',          # Adds {{STATIC_URL}}
                #'django.contrib.auth.context_processors.auth',    # Adds {{user]} and {{perm}}
                
                'conf.global_template_processors.load_sanet_settings',    # Adds sanet settings
                
                'webui.processors.webui_template_processor',              # Adds WEBUI specific settings
                
                'django.contrib.messages.context_processors.messages', # ADMIN
                               
            ],
        },
    },
]

#
# Middleware classes
#======================================================================

MIDDLEWARE_CLASSES = (

	'django.middleware.common.CommonMiddleware',

	'django.contrib.sessions.middleware.SessionMiddleware',

	#'django.middleware.csrf.CsrfViewMiddleware',
	'django.contrib.auth.middleware.AuthenticationMiddleware',

	'django.contrib.messages.middleware.MessageMiddleware',
	# Uncomment the next line for simple clickjacking protection:

	# Utility Handler
	'webui.middleware.RequestGetPostMiddleware', # for django 1.11

	# Handle Sanet tenancy
	'webui.middleware.TenantMiddleware',

	# Analytics
	#'webui.middleware.AnalyticsMiddleware',  # FOR TESTING PURPOSE ONLY
)

# Entry point for every URL (classic web or mobile web apps)
ROOT_URLCONF = 'conf.urls'

# Python dotted path to the WSGI application used by Django's runserver.
WSGI_APPLICATION = 'conf.wsgi.application'

#
# Sanet apps
#======================================================================

_DJANGO_APPS = [
	'django.contrib.auth',
	'django.contrib.contenttypes',
	'django.contrib.sessions',
	'django.contrib.sites',

	'django.contrib.messages',
	#'django.contrib.staticfiles',

	# Uncomment the next line to enable the admin:
	'django.contrib.admin',
	# Uncomment the next line to enable admin documentation:
	#'django.contrib.admindocs',
]

DJANGO_APPS = _DJANGO_APPS

_SANET_CORE_APPS = [
	'conf',
	'core',
	'cli',

	'webui',

	'tags',
]

SANET_BASE_APPS = _DJANGO_APPS + _SANET_CORE_APPS

SANET_DEFAULT_APPS = [

	'entables',
	'notes',
	'utils',
	'rest_api',
]

INSTALLED_APPS = SANET_BASE_APPS + SANET_DEFAULT_APPS

#
# Logging
#======================================================================


# A sample logging configuration. The only tangible logging
# performed by this configuration is to send an email to
# the site admins on every HTTP 500 error when DEBUG=False.
# See http://docs.djangoproject.com/en/dev/topics/logging for
# more details on how to customize your logging configuration.

import logging

LOGGING_LEVEL = logging.ERROR

LOGGING = {
	'version': 1,

	'disable_existing_loggers': False,

	'formatters': {
		'default': {
			'format': '%(asctime)s [%(pathname)s %(funcName)s ] - %(levelname)s > %(message)s'
		},
		'global': {
			'format': '%(asctime)s %(levelname)s > %(message)s'
		},
		'web': {
			'format': '%(asctime)s %(levelname)s %(pathname)s > %(message)s'
		},
	},
	'handlers': {
		'console': {
			'class'    : 'logging.StreamHandler',
			'level'    : 1,
			'formatter': 'global',
		},
		'global_file': {
			'class'    : 'core.loggingutils.MakeWatchedFileHandler',
			'level'    : 1,
			'formatter': 'global',
			
			'owner'    : 'www-data',
			'group'    : 'www-data',
			'mod'      : 666,
			'filename' : os.path.join(LOG_DIR, 'global.log'),
		},
		'web': {
			'class'    : 'logging.StreamHandler',
			'level'    : 1,
			'formatter': 'web',
		},
	},
	'loggers': {
		'sanet.global': {
			'handlers' : [
				'console', 
				'global_file',
			],
			'level'    : LOGGING_LEVEL,
			'propagate': True,
		},
		'sanet.reports': {
			'handlers' : ['console'],
			'level'    : LOGGING_LEVEL,
			'propagate': True,
		},
		'sanet.web': {
			'handlers' : ['web'],
			'level'    : LOGGING_LEVEL,
			'propagate': True,
		}
	}
}

#
# Authentication Backend settings
#======================================================================

# Authentication moduels used by web interface.
AUTHENTICATION_BACKENDS = [
	'sanet_common.django.auth.backends.localdb.LocalDBBackend',      # local DB (django auth module)
]

AUTH_PROFILE_MODULE = 'core.SANETUserProfile'

#
# Users and groups
#======================================================================

# Default admin user name
DEFAULT_ADMIN_USERNAME = 'admin'

# Default group name for administrators
DEFAULT_ADMIN_GROUP    = 'admins'

# 
# IPC Broker
#======================================================================

BROKER_ADDRESS = ('localhost', )
BROKER_AUTH    = ('sanet', 'sanet')

#
# sanetd Configuration
#======================================================================

# Server deamon instances on the same server.
SANETD_INSTANCES = [
	'main',
]

# Set the number of working threads for processing incoming update events
SANETD_WORKING_THREADS_NUM = 4

# Set the lengths of the update queue size. -1 = no limit
# IMPORTANT: THIS IS FOR DEBUG MODE ONLY. DO NOT CHANGE THIS.
SANETD_WORKING_THREADS_QUEUE_SIZE = -1


# Log level for sanetd (only) process .
SANETD_LOG_LEVEL = 20  # Info

#
# MAIL settings
#

# SMTP internal module. You do not need to change this setting
SANETD_MAIL_HANDLER = 'sanet_common.mailing.djangosmtp.DjangoMailHandler'

# SMTP parameters
SANETD_MAIL_HANDLER_PARAMS = {
	'HOST'               : 'localhost',
	'PORT'               : 25,
	'DEFAULT_DOMAIN_NAME': None,           # Use default full qualified domain name for this host
	'ENVELOPE_SENDER'    : 'noc@labs.it',  # Return-Path:
}

#
# ALARMS PROCESSING
#

# Specify modules to process alarms. 
# Server tries to process a new alarm with each processor sequentially and
# stop after the first successful processing.
SANET_ALARM_PROCESSORS = [

	# Send alarms to entables
	'entables.lib.alarms_processors.EntablesAlarmProcessor',
	
	# Base process, never remove this from the end of the list or your alarms will not be sent to anyone.
	'server.sanetd.sanetdlogic.MailAlarmProcessor',
]

#
# EXTRA PROCESSES
#

# List of extra processes executed by sanetd supervisor
SANETD_EXTRA_PROCESSES = [ 

	# ( '<logic name>', '<pid file name.pid>', <priority>, [ '<program path>', 'arg1', 'arg2', ... ] ),

	( 'trapd'    , 'trapd.pid'    , 0, [ "python", "python", os.path.join(BASE_DIR, 'server'  , 'trapd' , 'main.py'         ), BASE_DIR, ] ),

	( 'tagsd'    , 'tagsd.pid'    , 0, [ "python", "python", os.path.join(BASE_DIR, 'tags'    , 'server', 'tagsd', 'main.py'), BASE_DIR, ] ),
]

#
# LOCAL SCRIPTS
#
SANETD_EXEC_DIR = os.path.join( DATA_DIR , '_action_scripts' )

#
# Datasource storage
#======================================================================

DATASOURCE_STORAGE_HANDLER = 'core.api.datasource.rrd.RRDTOOLDataSourceStore'

DATASOURCE_STORAGE_PARAMS  = { 
	# Base directory where the storage will put RRD files ( $DATA_DIR / <tenant_id> /rrds/ <rrd file id>.rrd )
	"storage_base_dir"           : DATA_DIR, 
	
	# RRD file's heartbead = DATASOURCE.min_period * heartbeat_factor
	#heartbeat_factor: 60,
	
	# Send FLUSH command to RRDCACHED before read fetching data from RRDs
	# Be sure RRDCACHED_ADDRESS is in your environment!!
	#"rrdcached_flush_before_read": False
}


#
# Caching
#======================================================================

CACHE_HANDLER        = 'sanet_common.cache.rediscache.RedisCacheManager'

CACHE_HANDLER_PARAMS = { }


#
# STATS
#======================================================================

SANET_STATS_VERSION = 2

#
# Watchdog settings
#======================================================================

SANETD_WATCHDOG_CONF = {

	# 1 = Watchdog process active
	# 0 = Watchdog process not active. YOU SHOULD NEVER DISABLE THIS
	"enabled" : 1,   

	# Check system status every "inverval" seconds. 
	"interval": 60,  

	# The status is considered valid for "valid_interval" seconds.
	"valid_interval": 90,  

	# Minimum log level (10:Debug, 20:Info, 30:Error). 
	'log_level': 20, 

	# Do not send notification when problems are derected
	'send_notification_on_errors': False,

	# Set to '' to disable email notification
	"to"      : 'root@localhost',  
	"from"    : 'sanet3watchdog',
	"subject" : '[Sanet3] System status',

	# Message body static part (wdog message will be appended to this).
	"body"    : '* This message is automatically generate by Sanet3. Do not replay to this message! *',


	#
	# Options
	#
	'timeouts': {
	
		# Default timeout for all status requests
		'default': 7,  


		# 'sanetd': 6, 
		
		# 'tagsd': 6, 
		
		# 'entables': 1

		# Timeout specific for every tenant
		#'tenants': {
		#	'site': {
		#		'agents': {
		#			'main-agent'  : 1,
		#		}
		#	}
		#},
	},

	#
	# Check constants
	#

	# Max number of allowed update data packets unprocessed by sanetd server (inside global event queue) .
	"sanetd_event_queue_max_size": 1000,
	
	# Limits for every agent. The format is:
	#
	#     "<agent-name>" : {
	#
	#         "wait_queue_max_size": <number>
	#     }
	#
	"agents": {

		"main-agent": {
			# Minimum agent check rate (datagroups/s). 
			# The rate of datagroups/s can be less than 0.1 if you have very few datagroups in your configuration.
			#"min_check_per_second": 0, 
			
			# Max size of waiting queue inside the agent.
			# The expected size should be less than 100.
			#"wait_queue_max_size" : 100,
		}

	}
}

#
# STATUSD settings
#
STATUSD_LOG_LEVEL = 20

#
# TAGSD serttings
#======================================================================

TAGSD_LOG_LEVEL = 20


#
# Local Agents
#======================================================================

#
# Specify additional python modules for local poller
# This additional modules MUST be in the PYTHONPATH!
#
# Es: /var/lib/sanet3/extra_modules/mymodule.py 
#
#   Set path ->   export PYTHONPATH=/var/lib/sanet3/extra_modules
#      
#   Add      ->   LOCAL_POLLER_EXTRA_MODULES = [ 'mymodule' ]
#
LOCAL_POLLER_EXTRA_MODULES = [
]

#
# Specify here additional subprocess to launch with the local pollers
#
#   ( <logic name> , <python handler name>  [ , <params dictionary>  ] )
#
LOCAL_POLLER_EXTRA_PROCESSES = [
	#( 'subprocess1'  , 'foo.bar.c.subprocess1_handler_function' ),
	#( 'subprocess1'  , 'foo.bar.c.subprocess1_handler_function', { 'opt1': 'a', 'opt2': 3 } ),
]


#
# NETWORK SETTINGS
#======================================================================

DEFAULT_SNMP_VERSION = 2

#
# UI Settings
#======================================================================

# String used to hide "sensible" data (SNMPv3 params, ecc.)
HIDDEN_DATA = '***HIDDEN DATA***'

#
# CLI settings
#======================================================================

# Set to *true* in order to enable CLI authentication/authorization mode.
CLI_AUTHENTICATED = False

# OS user allowed to launch CLI with a specific user (-U option)
CLI_SHELL_ROOT_USERS = [ 
	"root",              # Only "root" can open the CLI without password
]

CLI_DEFAULT_ADMIN_USER = 'admin'

#
#CLI_ADMIN_USER = "admin"

#
# Agents
#======================================================================
#
# FIX: FEATURE DISABLED
# AGENT_REMOTE_SEND_BUFFER_MAX_SIZE = 0 # 1024 * 1024 * 50

AGENT_REMOTE_SEND_BUFFER_MAX_SIZE = 0 # 1024 * 1024 * 50

#
# Web interface settings
#======================================================================


#
# Shortcuts for 'webui' app
#======================================================================

BASE_WEB_URL_PREFIX    = BASE_URL_PREFIX + 'web'      # DO NOT EDIT THIS

STATIC_WEB_ROOT        = STATIC_ROOT + '/webui/'

STATIC_WEB_URL_PREFIX  = STATIC_URL + 'webui'      # DO NOT EDIT THIS

MEDIA_WEB_ROOT         = MEDIA_ROOT
MEDIA_WEB_URL_PREFIX   = MEDIA_URL


#
# login url
#======================================================================

LOGIN_URL          = reverse_lazy('login_page') #webui.views.auth.remember_me_login')

LOGIN_REDIRECT_URL = reverse_lazy('core.views.index')

#============================================================
# priority value for Alert web view >= (gte)

MIN_PRIORITY_ALERT_VIEW = 1



# 
# REST API
#======================================================================

# Token di authenticazione per la comunicazione tramite api rest
REST_API_AUTH_COOKIE = "6801299861414c64a6c30a90b7643ce1"

#
# Geographyc settings
#=======================================================================

# Default geographic position
GEO_DEFAULT_SITE_POSITION = (44.4942132, 11.3464736)  # Bologna, ItalyGEO_DEFAULT_SITE_POSITION = (44.4942132, 11.3464736)  # Bologna, Italy



#
# ENTABLES settings                                                     
#=======================================================================

# If entables is not running Sanet tries to send emails directly to the
# email recipient.
# Set to "False" to disable this backup method.
ENABLE_BACKUP_MAIL_DELIVERY = True

ENTABLESD_SETTINGS = {

	# Rule reload from DB in seconds
	'refresh_interval': 15, 

	# IPC broker 
	"broker": {
		#"address"        : ('127.0.0.1', None),
		#"username"       : 'sanet',
		#"password"       : 'sanet',
	},

	# Active listeners
	"listeners": [
		('entables.listeners.qpid', {
			#"brokerip"       : '127.0.0.1',
			#"username"       : 'sanet',
			#"password"       : 'sanet',
			#"qpid_queue_name": "entables-alarms",
		})
	],

	# Active matches
	"matches": [
		'entables.matches.tag_match',
		'entables.matches.attributes',
		'entables.matches.times',
		'entables.matches.tests',
		'entables.matches.status',

		'entables.matches.counters',

	],

	# Active targets
	"targets": [
		"entables.targets.syslogger",
		"entables.targets.smtp",
		"entables.targets.delay",
		"entables.targets.digest",
		"entables.targets.setattr",
		"entables.targets.smtp_digest",

		"entables.targets.silence",

		"entables.targets.json_http",

		"entables.targets.updatecounters",
	],

	# Active tags
	"tagproviders": [
		'entables.tagproviders.system',
		'entables.tagproviders.builtin',
		'entables.tagproviders.alarmpath',
		'entables.tagproviders.digest',
		'entables.tagproviders.notestags',
	],
}

#
# Calendars
#=======================================================================

# All holidays are treated as the selected day of the week (default is "sunday")
#      1 = Monday
#      2 = Tuesday
#      3 = Wednesday
#      4 = Thursday
#      5 = Friday
#      6 = Saturday
#      7 = Sunday
#
# To disable special holidays handling set to None:
#
#   HOLIDAYS_AS_WDAY = None
#

# FIX: per il momento e' disabilitata
HOLIDAYS_AS_WDAY = None

# Special days always treated HOLIDAYS 
HOLIDAYS = {
	'DEFAULT': set([
		# All years, only 4 digits MMDD
		'0101',
		'0106',
		'0425',
		'0501',
		'0602',
		'0815',
		'1101',
		'1208',
		'1225',
		'1226',
		# Specific year, 4 digits YYYYMMDD
		# Giorni di pasquetta dal 2015 al 2034
		'20150406',
		'20160328',
		'20170417',
		'20180402',
		'20190422',
		'20200413',
		'20210405',
		'20220418',
		'20230410',
		'20240401',
		'20250421',
		'20260406',
		'20270329',
		'20280417',
		'20290402',
		'20300422',
		'20310414',
		'20320329',
		'20330418',
		'20340410',
		#'20150105',
	]),
}













#
# WEB INTERFACE TUNING
#=======================================================================

# Default colors for DataSource states
OUTCOME_COLOR_MAPPING = {
	'OK': '00ff00', 
	'SV': 'ffff00',
	'CA': 'a0a0a0',
	'DO': 'a0a0a0',
	'UN': 'a0a0a0',
	'ER': 'ff0000',
}

# DEfault colors for Conditions states
STATE_COLOR_MAPPING = {

	#"NONE": "33CCFF",
	"NONE": "a0a0a0",

	"DN": 'ff0000',
	"FA": 'ffff00',

	"UD": 'a0a0a0',
	"UU": 'a0a0a0',

	"DD": 'a0a0a0',
	"DU": 'a0a0a0',

	"TD": 'a0a0a0',
	"TU": 'a0a0a0',

	"IN": 'f0f0f0',
	"UP": '00ff00',
}

# Default color for Tag states
TAG_STATE_COLOR_MAPPING = {

	#"NONE": "33CCFF",
	"NONE": "a0a0a0",

	"DN": 'ff0000',
	"FA": '000000',

	"UD": 'a0a0a0',
	"UU": 'a0a0a0',

	"DD": 'a0a0a0',
	"DU": 'a0a0a0',

	"TD": 'a0a0a0',
	"TU": 'a0a0a0',

	"IN": 'f0f0f0',
	"UP": '00ff00',
}

MINIMUM_DOWN_PRIORITY_LEVEL = 1

WEBUI_STATE_SHOW_OLD_ICON = False

#==============================================
# one day max age for icon cache

ICON_MAX_AGE = 24*60


#
# NOTIFICATION
#=======================================================================

# Base URL 
# 
# Notification alarms will contains urls with the following sintaxt
#
#       <alarm_url_base>  /....resource specific page url......
#
# It can contain the following wildcards:
#
#    %(hostname)s    The hostname where Sanet server (sanetd) is running.
#
ALARM_URL_BASE     = 'https://%(hostname)s/sanet3'










#
# XFORM ALIASES
#=======================================================================


XFORMS_ALIASES = {
#       section          alias            alternatives (the first one will be used when setting new xforms)
	'interfaces': {          
			'ifdescr'           : [ 
			                        "byRegexpUnique(1.3.6.1.2.1.2.2.1.2@, '^'+re_escape($distinguisher)+'$')", 
			                        "byRegexpUnique(1.3.6.1.2.1.2.2.1.2@, '^'+$distinguisher+'$')", 
			                        'byRegexpUnique(1.3.6.1.2.1.2.2.1.2@, "^"+re_escape($distinguisher)+"$")',
			                        'byRegexpUnique(1.3.6.1.2.1.2.2.1.2@, "^"+$distinguisher+"$")',
			                      ],
	},                                  
	'storages': {                       
			'storagedescr'      : [ 
			                        "byRegexpUnique(1.3.6.1.2.1.25.2.3.1.3@, '^'+re_escape($distinguisher)+'$')",
			                        "byRegexpUnique(1.3.6.1.2.1.25.2.3.1.3@, '^'+$distinguisher+'$')",
			                      ],
	},                                  
	'services': {                       
			'procdescr'         : [
			                        "byRegexpUnique(1.3.6.1.2.1.25.4.2.1.2@, '^'+re_escape($distinguisher)+'$')",
			                      ],
			'procdescrargs'     : [
			                        "byMultiRegexpUnique( 1.3.6.1.2.1.25.4.2.1@ , '4', 's/'+re_escape(strsplit($distinguisher,' ')[0]), '5', 's/'+re_escape(strsplit($distinguisher, ' ',1)[1]) ) " ,
			                      ],
			'procdescrregex'    : [
			                        "byRegexpUnique(1.3.6.1.2.1.25.4.2.1.2@, '^'+$distinguisher+'$')",
			                      ],
			'procdescrargsregex': [
			                       "byMultiRegexpUnique( 1.3.6.1.2.1.25.4.2.1@ , '4', 's/'+strsplit($distinguisher,' ')[0], '5', 's/'+strsplit($distinguisher, ' ',1)[1] ) " ,
			                      ],
			'windowsservicename': [
			                       "byRegexpUnique(1.3.6.1.4.1.77.1.2.3.1.1@, '^'+$distinguisher+'$')" ,
			                      ],
	},
	'devices': {
			#
			# HP
			#
			'hpsensdescr'       : [ 
			                        "byRegexpUnique(1.3.6.1.4.1.11.2.14.11.1.2.6.1.7@, '^'+re_escape($distinguisher)+'$')",
			                        "byRegexpUnique(1.3.6.1.4.1.11.2.14.11.1.2.6.1.7@, '^'+$distinguisher+'$')",
			                      ] ,
			#
			# CISCO
			#
			# sensor temperature
			'ciscosensortemp'   : [ 
			                        "byRegexpUnique(1.3.6.1.4.1.9.9.13.1.3.1.2@, '.*'+$distinguisher+'.*')", 
			                      ],
			# sensor powersupply
			'ciscosensorps'     : [ 
			                        "byRegexpUnique(1.3.6.1.4.1.9.9.13.1.5.1.2@, '.*'+$distinguisher+'.*')", 
			                      ],
			# sensor fan
			'ciscosensorfan'    : [ 
			                      "byRegexpUnique(1.3.6.1.4.1.9.9.13.1.4.1.2@, '.*'+$distinguisher+'.*')", 
			                      ],
	}
}

#
# CACHING
#======================================================================

# Activate tag cache 
#TAGS_STATE_CACHE = False

# Refresh interval in seconds
TAGS_STATE_CACHE_REFRESH_RATE = 120


# TRAPD
#======================================================================

# Listening tuple 
#
#    ( <address> , <port> )
#
# Example:
#
#    SNMPTRAP_LISTEN = ('127.0.0.1', 162) 
#
# Set to None to disable snmptrap server
#
SNMPTRAP_LISTEN = None

# Log verbosity 
SNMPTRAP_LOG_LEVEL = 20

# Wait N seconds before restart when a unknown exception occurs
SNMPTRAP_ON_ERROR_RESTART = 3

SNMPTRAP_MAIL_CONF = {
	'from': 'sanet.trapd@localhost',
	#
	# Settings for TRAPs from unknown hosts
	#
	'unknown': {
		# You can use the following wildcard inside the subject/body text: 
		#
		#    {{receive_time}}  = timestamp
		#    {{source_ip}}     = Source IP
		#    {{trap_oid}}      = TRAP OID
		#    {{trap_msg}}      = Verbose TRAP description
		#
		'to'      : 'root@localhost',
		'subject' : '[sanet trapd] Trap from unknown host {{source_ip}}',
		'body'    : 'Received SNMP Trap at {{receive_time}}.\n\n{{trap_msg}}s',
	},
	#
	# Settings for unhandled TRAPs linked to sanet nodes 
	#
	'unmanaged': {
		# Default notification address. If a node specifies the 'notify-address' 
		# field, the field will be used instead of this default.
		'to'      : 'root@localhost',

		# You can use the following wildcard inside the subject/body text: 
		#
		#    {{receive_time}}  = timestamp
		#    {{source_ip}}     = Source IP
		#    {{trap_oid}}      = TRAP OID
		#    {{trap_msg}}      = Verbose TRAP description
		#    {{sanet_node}}    = Sanet node name
		#
		'subject' : '[sanet trapd] Unmanaged TRAP from {{source_ip}} for node {{sanet_node}}',
		'body'    : 'Received SNMP Trap at {{receive_time}}.\n\n{{trap_msg}}',
	}
}

#
# Default number of visibile alarms in the alarms list block
#
ALARMS_TABLE_SHORT_VIEW_LIMIT = 15


#
# Refresh timers for webui
#
WEBUI_REFRESH_TIMERS = {

	'alarms_count'           :  60,   # tabella contatori allarmi
	'alarms_list'            :  60,   # tabella elenco allarmi

	'primary_graph'          :  60,
	
	'logs'                   : 120,
	
	'datagroup_timegraph'    :  60,   # Timegraph visibili nella sezione di un datagroup

	'notes_list'             : 120,

	'tags'                   : 120,
}


#
# WEB INTERFACE 
#======================================================================

#
# Change "Alarms Section"'s view mode in tenant homepage.
# Set to "True" to view "Alarm Section" page wide.
#
TENANT_HOMEPAGE_ALARMS_SECTION_PAGE_WIDE = False


#
# Turn case sensitive login ON and OFF
#
AUTH_WEB_LOGIN_USERNAME_CASE_SENSITIVE = True


#
# Force all timegraph to line
#
TIMEGRAPH_FORCE_AREA_TO_LINE = False
