# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.


"""
========================================================================
Gestione base dei template Django
========================================================================

TODO

.. autofunction:: load_sanet_settings


{{ SETTINGS }}
------------------------------------------------------------------------

TODO

	::
		
		{{ SETTINGS.<key> }}

Esempio:

	::
		
		{{ SETTINGS.BASE_DIR }}

Scorciatoie
~~~~~~~~~~~~~~~~~~~~~~

Le seguenti macro sono equivalenti:

	::
		
		{{ SETTINGS.BASE_URL_PREFIX }}
		
		{{ BASE_URL_PREFIX }}
"""

from django.conf import settings

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

def load_sanet_settings(request):
	"""
	Automatically defines some global settings inside templates' context
	"""

	context = {
		'SETTINGS'       : settings,

		'BASE_URL_PREFIX': settings.BASE_URL_PREFIX,
	}

	return context
