# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.#
# DO NOT EDIT THIS FILE MANUALLY.
#

from conf.settings import *

"""

Introduction
---------------

::
    
                              https://<host>/sanetxxx              localhost:8000                        
                                                                                                         
        BROWSER ----https------> APACHE [ProxyPass] ------http----> uWSGI .... SANET [conf/wsgi.py]      
                                                                                                         


Apache2.4 configuration
-------------------------

This is apache configuration:

::
	
	<IfModule mod_ssl.c>
		<VirtualHost _default_:443>
			...
			...
			...
			ProxyRequests Off
			SSLProxyEngine On
			
			ProxyPass        /sanetxxx/  http://localhost:8000/sanetxxx/
			ProxyPassReverse /sanetxxx/  http://localhost:8000/sanetxxx/
			
			<Location /sanetxxx/>
				Require all granted
			</Location>
			...
			...
			...
		</VirtualHost>
	</IfModule>
	
"""


BASE_URL_PREFIX        = 'sanetxxx/'

STATIC_URL             = BASE_URL_PREFIX + 'static/'            # es: sanet/static/
MEDIA_URL              = BASE_URL_PREFIX + 'media/' 
BASE_WEB_URL_PREFIX    = BASE_URL_PREFIX + 'web'    

STATIC_WEB_URL_PREFIX  = STATIC_URL + 'webui'      

# HACK: Inside uWSGI we can't see tracebacks in the log as like as Apache2 does.
LOGGING['loggers']['django'] = {
	'handlers' : ['console'],
	'level'    : 'ERROR',
	'propagate': False,
}


DEBUG = True


