# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

"""

**Core**

..
	+-----------------------------+----------------------------------------------------------------------------+
	| Codice                      | Descrizione                                                                |
	+=============================+============================================================================+
	|core.tenant.create           | Aggiungere un tenant                                                       |
	+-----------------------------+----------------------------------------------------------------------------+
	|core.tenant.delete           | Cancellare un tenant                                                       |
	+-----------------------------+----------------------------------------------------------------------------+
	|core.tenant.edit             | Modificare qualunque parametro globale del tenant (priorita' minima, ecc.) |
	+-----------------------------+----------------------------------------------------------------------------+

**Configurazione template di un tenant**

+-----------------------------+----------------------------------------------------------------------------+
| Codice                      | Descrizione                                                                |
+=============================+============================================================================+
|core.template.dg.edit        | Creare/modificare/cancellare datagroup-template                            |
+-----------------------------+----------------------------------------------------------------------------+

+-----------------------------+----------------------------------------------------------------------------+
| Codice                      | Descrizione                                                                |
+=============================+============================================================================+
|core.template.element.edit   | Creare/modificare/cancellare element-template (node-template,ecc.)         |
+-----------------------------+----------------------------------------------------------------------------+

**Configurazione elementi di monitoraggio di un tenant**

+-----------------------------+----------------------------------------------------------------------------+
| Codice                      | Descrizione                                                                |
+=============================+============================================================================+
|core.element.create          | Creare un elemento (node, interface, storage, service, device)             |
+-----------------------------+----------------------------------------------------------------------------+
|core.element.delete          | Cancellare un elemento                                                     |
+-----------------------------+----------------------------------------------------------------------------+
|core.element.conf            | Modificare gli attributi di un elemento (nome, xform, ecc.)                |
+-----------------------------+----------------------------------------------------------------------------+
|core.element.conf_monitoring | Aggiungere/cancellare/modificare i datagroup di un elemento                |
+-----------------------------+----------------------------------------------------------------------------+
|core.link.edit               | Aggiungere/cancellare/modificare link tra interfacce                       |
+-----------------------------+----------------------------------------------------------------------------+

**Gestione note**

+-----------------------------+----------------------------------------------------------------------------+
| Codice                      | Descrizione                                                                |
+=============================+============================================================================+
|notes.note.tenant.edit       | Aggiungi/rimuovi note al tenant                                            |
+-----------------------------+----------------------------------------------------------------------------+
|notes.note.element.edit      | Aggiungi/rimuovi note di un elemento                                       |
+-----------------------------+----------------------------------------------------------------------------+
|notes.note.tag.edit          | Aggiungi/rimuovi note di un tag                                            |
+-----------------------------+----------------------------------------------------------------------------+

**Gestione Tagging** 

+-----------------------------+----------------------------------------------------------------------------+
| Codice                      | Descrizione                                                                |
+=============================+============================================================================+
|tags.tagtree.create          | Crea nuovo                                                                 |
+-----------------------------+----------------------------------------------------------------------------+
|tags.tagtree.delete          | Cancella                                                                   |
+-----------------------------+----------------------------------------------------------------------------+
|tags.tagtree.edit            | Modifica flag (allnodes, nostate, ecc.)                                    |
+-----------------------------+----------------------------------------------------------------------------+
|tags.tag.create              | Create a tag                                                               |
+-----------------------------+----------------------------------------------------------------------------+
|tags.tag.delete              | Delete a tag                                                               |
+-----------------------------+----------------------------------------------------------------------------+
|tags.tag.edit                | Edit tag  ( change tag map, ecc..)                                         |
+-----------------------------+----------------------------------------------------------------------------+
|tags.tag.tag_element         | Tag/Untag                                                                  |
+-----------------------------+----------------------------------------------------------------------------+
|tags.tag.state.force_reload  | Force tag's state reload                                                   |
+-----------------------------+----------------------------------------------------------------------------+

**Mappe Logiche**

+-----------------------------+----------------------------------------------------------------------------+
| Codice                      | Descrizione                                                                |
+=============================+============================================================================+
|maps.logic.create            | Create a logic map                                                         |
+-----------------------------+----------------------------------------------------------------------------+
|maps.logic.delete            | Delete a logic map                                                         |
+-----------------------------+----------------------------------------------------------------------------+
|maps.logic.edit              | Edit a logic map                                                           |
+-----------------------------+----------------------------------------------------------------------------+

**Geo referenziazione** 


+-----------------------------+----------------------------------------------------------------------------+
| Codice                      | Descrizione                                                                |
+=============================+============================================================================+
|geomaps.set_pos              | Set geo position of an element                                             |
+-----------------------------+----------------------------------------------------------------------------+

**Reportistica**


+-----------------------------+----------------------------------------------------------------------------+
| Codice                      | Descrizione                                                                |
+=============================+============================================================================+
|report.read                  | Vedere i report (sia normali che periodici)                                |
+-----------------------------+----------------------------------------------------------------------------+
|report.normal.create         | Creare un nuovo report                                                     |
+-----------------------------+----------------------------------------------------------------------------+
|report.normal.delete         | Cancellare un report                                                       |
+-----------------------------+----------------------------------------------------------------------------+
|report.periodic.create       | Creare un nuovo report periodico                                           |
+-----------------------------+----------------------------------------------------------------------------+
|report.periodic.delete       | Cancellare un report periodico                                             |
+-----------------------------+----------------------------------------------------------------------------+
|report.normal.process        | Forzare la generazione di un report via web                                |
+-----------------------------+----------------------------------------------------------------------------+


**Sistema di Discovery**

+-----------------------------+----------------------------------------------------------------------------+
| Codice                      | Descrizione                                                                |
+=============================+============================================================================+
|discovery.read               | Visualizzare lo stato del discovery                                        |
+-----------------------------+----------------------------------------------------------------------------+
|discovery.element.edit       | Modificare un elemento scoperto in fase di discovery                       |
+-----------------------------+----------------------------------------------------------------------------+
|discovery.element.link       | Collegare/scollegare un elemento scoperto con un elemento di monitoraggio  |
+-----------------------------+----------------------------------------------------------------------------+
|discovery.element.edit       | Modificare un elemento scoperto in fase di discovery                       |
+-----------------------------+----------------------------------------------------------------------------+
|discovery.element.link       | Collegare/scollegare un elemento scoperto con un elemento di monitoraggio  |
+-----------------------------+----------------------------------------------------------------------------+

**Interfaccia Web** 

+-----------------------------+----------------------------------------------------------------------------+
| Codice                      | Descrizione                                                                |
+=============================+============================================================================+
|gui.view_sensible_data       | Mostare/Non mostare dati "sensibili" via web (community, SNMPv3)           |
+-----------------------------+----------------------------------------------------------------------------+
|gui.view.extra_menus         | Vedere o meno i pulsanti per accedere alle applicazioni esterne            |
+-----------------------------+----------------------------------------------------------------------------+
|gui.view.system_status       | Vedere lo stato del sistema dal pulsante system                            |
+-----------------------------+----------------------------------------------------------------------------+

**Gestione WebScenario** 

+-----------------------------+----------------------------------------------------------------------------+
| Codice                      | Descrizione                                                                |
+=============================+============================================================================+
|webscenario.access           | Permette di accedere ai webscenario                                        |
+-----------------------------+----------------------------------------------------------------------------+
|webscenario.element.create   | Crea un nuovo webscenario                                                  |
+-----------------------------+----------------------------------------------------------------------------+


"""


CAPABILITIES_LIST = [
	("core.test.dummy"                , "Capability di test"                                                          ),

	("core.tenant.create"            , "Aggiungere un tenant"                                                        ),
	("core.tenant.delete"            , "Cancellare un tenant"                                                        ),
	("core.tenant.edit"              , "Modificare qualunque parametro globale del tenant (priorita' minima, ecc.)"  ),

	#
	# DataGroup Template
	#
	("core.template.dg.create"       , "Creare datagroup-template"                                                   ),
	("core.template.dg.edit"         , "Modificare datagroup-template"                                               ),
	("core.template.dg.delete"       , "Cancellare datagroup-template"                                               ),

	("core.template.dg.acl.edit"     , "Modificare ACL di un datagroup-template"                                     ),

	#
	# Element Template
	#
	("core.template.element.create"  , "Creare element-template (node-template,ecc.)"                                ),
	("core.template.element.edit"    , "Modificare element-template (node-template,ecc.)"                            ),
	("core.template.element.delete"  , "Cancellare element-template (node-template,ecc.)"                            ),

	("core.template.element.acl.edit", "Modificare ACL di un datagroup-template"                                     ),

	#
	# Monitored Elements
	#
	("core.element.create"          , "Creare un elemento (node, interface, storage, service, device)"              ),
	("core.element.delete"          , "Cancellare un elemento"                                                      ),
	("core.element.conf"            , "Modificare gli attributi di un elemento (nome, xform, ecc.)"                 ),
	("core.element.conf_monitoring" , "Aggiungere/cancellare/modificare i datagroup di un elemento"                 ),
	("core.link.edit"               , "Aggiungere/cancellare/modificare link tra interfacce"                        ),

	#
	# Tags
	#
	("tags.tagtree.create"          , "Crea nuovo tagree"                                                           ),
	("tags.tagtree.delete"          , "Cancella tagtree"                                                            ),
	("tags.tagtree.edit"            , "Modifica flag tagtree (allnodes, nostate, ecc.)"                             ),

	("tags.tagtree.acl.edit"        , "Modificare ACL di un tagtree"                                                ),
	
	("tags.tag.create"              , "Create a tag"                                                                ),
	("tags.tag.delete"              , "Delete a tag"                                                                ),
	("tags.tag.edit"                , "Edit tag properties"                                                         ),
	("tags.tag.tag_element"         , "Tag/Untag"                                                                   ),

	("tags.tag.state.force_reload"  , "Force tag's state reload"                                                    ),

	#
	# WEB interfaces (webui)
	#
	("gui.view_sensible_data"       , "Mostare/Non mostare dati 'sensibili' via web (community, SNMPv3)"            ),
	("gui.view.extra_menus"         , "Vedere o meno i pulsanti per accedere alle applicazioni esterne"             ),
	("gui.view.system_status"       , "Vedere lo stato del sistema dal pulsante system"                             ),

	#
	# Notes
	#
	("notes.note.tenant.edit"       , "Aggiungi/rimuovi note al tenant"                                             ),
	("notes.note.element.edit"      , "Aggiungi/rimuovi note di un elemento"                                        ),
	("notes.note.tag.edit"          , "Aggiungi/rimuovi note di un tag"                                             ),

]

CAPABILITIES = dict(CAPABILITIES_LIST)

CAPABILITIES_IDS = CAPABILITIES.keys()
