# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

"""
change_password
========================================================================

Syntax:

	::
		
		sanet-manage change_password [options] [ <username> ]

Changes password of the given user *username*. 

It *username* is not specified, the current *shell user* is used.

Example:

	::
		
		sanet-mange change_password user1


.. note:: This is an alias for the *changepassword* django command.

"""

import os
import sys
#from optparse import make_option

from django.utils.translation import ugettext as _

from core.management.commands import SanetBaseCommand

from django.contrib.auth.management.commands.changepassword import Command as ChangePasswordCommand

#----------------------------------------------------------------------#
#                                                                      #
#----------------------------------------------------------------------#

class Command(SanetBaseCommand, ChangePasswordCommand):
	pass
