# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

"""
create_super_user
========================================================================

Syntax:

	::
		
		sanet-manage create_super_user [options]

Create a new user with *superuser* privileges (flag set to *true*).

	::
		
		--username <username>
		--email    <email>

Example:

	::
		
		sanet-manage create_super_user --username admin2 --email admin2@labs.it

.. note:: This is an alias for the *createsuperuser* django command.

"""

import os
import sys

from django.utils.translation import ugettext as _

from core.management.commands import SanetBaseCommand

from django.contrib.auth.management.commands.createsuperuser import Command as CreateSuperuser


#----------------------------------------------------------------------#
#                                                                      #
#----------------------------------------------------------------------#

class Command(SanetBaseCommand, CreateSuperuser):
	pass

