# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

"""
erase_dg_logs
========================

TODO

"""

import os
import sys

import redis

from sanet_common.ipc.redisipc import _USE_REDIS_IPC_DB, REDIS_QUEUE_ADDRESS

from conf import get_configuration

from core.models import DataGroup, MonitoredNode
from core.management.commands import SanetInternalCommand, TenantBasedCommand

#----------------------------------------------------------------------#
#                                                                      #
#----------------------------------------------------------------------#

class Command(SanetInternalCommand, TenantBasedCommand):

	help = "Deletes a queue from the IPC broker"

	def add_arguments(self, parser):

		super(Command, self).add_arguments(parser)

		parser.add_argument('--datagroup'          , action='store'     , dest='datagroup'         , default=None                     , help=''),
		parser.add_argument('--node'               , action='store'     , dest='node'              , default=None                     , help=''),

	def handle(self, *args, **options):

		datagroup = options['datagroup']
		node      = options['node']

		if not (datagroup or node):
			raise Exception("Must specify --node or --datagroup")

		tenant = self.get_tenant(options)

		tenant.db_set_current_schema()

		if datagroup:
			e = DataGroup.objects.get(path=path)

		if node:
			e = MonitoredNode.objects.get(name=node)

		

		logs = e.get_logs()
		
		c = 0
		for l in logs.all():
			print l
			l.delete()
			c += 1
			
		print "Deleted: %d" % (c) 

