# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

"""
erase_queue
========================

Syntax:

	::
		
		erase_queue <queue_id>

Erase the given IPC queue *queue_id*.

.. warning:: This is an internal Sanet command. It is not recommended to use this command.

"""

import os
import sys

import redis

from sanet_common.ipc.redisipc import _USE_REDIS_IPC_DB, REDIS_QUEUE_ADDRESS

from conf import get_configuration

from core.management.commands import SanetInternalCommand

#----------------------------------------------------------------------#
#                                                                      #
#----------------------------------------------------------------------#

class Command(SanetInternalCommand):

	help = "Deletes a queue from the IPC broker"

	#option_list = SanetInternalCommand.option_list

	def add_arguments(self, parser):

		super(Command, self).add_arguments(parser)

		#
		# Positional arguments
		#
		parser.add_argument('queue', nargs='?', default=None)

	#def handle(self, queue, *args, **options):
	def handle(self, *args, **options):

		queue = options['queue']

		config = get_configuration()

		#broker = options['broker']
		#if broker == None:
		#	broker = config.BROKER_ADDRESS[0]
		#	if len(config.BROKER_ADDRESS)>1 and config.BROKER_ADDRESS[1] is not None:
		#		broker = '%s:%s' % (broker, config.BROKER_ADDRESS[1])
		#	if config.BROKER_AUTH:
		#		broker = '%s/%s@%s' % (config.BROKER_AUTH[0], config.BROKER_AUTH[1], broker)
		
		#
		# FIX: handle broker address in redis connection
		#

		queue_id = REDIS_QUEUE_ADDRESS(queue)
		
		r = redis.Redis()
		
		r.execute_command("SELECT", _USE_REDIS_IPC_DB)
		
		r.delete(queue_id)
