# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

"""
"""
import time

from django.utils.translation import ugettext as _

from core.models import Tenant
from core.models import DataSource

from core.management.commands import TenantBasedCommand

#----------------------------------------------------------------------#
#                                                                      #
#----------------------------------------------------------------------#

class Command(TenantBasedCommand):

	help = _("todo")

	sanet_internal = True

	#option_list = TenantBasedCommand.option_list 

	def handle(self, *args, **options):

		tenant_name = options['tenant']
		if tenant_name == None:
			tenants  = Tenant.objects.all()
		else:
			tenants  = [ Tenant.objects.get(name=tenant_name) ]

		for tenant in tenants:
			tenant.db_set_current_schema()
			
			datasources = DataSource.objects
			datasources = datasources.order_by('path').all()
			
			for ds in datasources:
				
				t1 = time.time()
				updated = ds.check_storage_spec_changes()
				t2 = time.time()
				
				print "%5s %-32s %-32s %2.5f %s" % (updated, ds.tenant_id, ds.uuid, t2-t1, ds.path,)
