# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.
import sys

from django.conf import settings

#from django.core.management.base import NoArgsCommand
from django.core.management.base import BaseCommand

from django.core.management import get_commands, load_command_class

#----------------------------------------------------------------------#
#                                                                      #
#----------------------------------------------------------------------#

class Command(BaseCommand):

	#option_list = NoArgsCommand.option_list + (
	#)
	
	help = "***INTERNAL COMMAND***"
	
	sanet_internal = True

	#def handle_noargs(self, **options):
	def handle(self, *args, **options):

		commands_by_app = {}
		for cmd_name, app_name in get_commands().items(): 

			if app_name.startswith('django.core'): 
				continue

			try:
				from sanet_common.pythonutils import load_symbol

				command_module_name = "%s.management.commands.%s" % (app_name, cmd_name)

				m = load_symbol("%s.__doc__" % (command_module_name))

				if not m:
					continue

			except Exception, e:
				print __file__, "ERROR", type(e), str(e)
				print ">>>>>>>", app_name, cmd_name
				continue

			try:
				k = load_command_class(app_name, cmd_name)
			except Exception, e:
				print >>sys.stderr, "ERRORE", type(e), str(e), app_name, cmd_name
				continue

			#if hasattr(k, 'sanet_internal') and k.sanet_internal == True:
			#	continue

			l = commands_by_app.get(app_name, commands_by_app.setdefault(app_name, []))
			l.append(cmd_name)

		print """
		
.. _command_line_tools:

######################################################################
Command line tools
######################################################################

.. contents:: Contenuti
	:depth: 4

====================================================================
Indroduzione
====================================================================

Questi sono tutti i sotto-comandi del comando:

	::
		
		sanet-manage  <comando>  [ <parametri> ]

.. note:: Questo comando e' equivalente al comando:
	
	::
		
		python {{SANET_INSTALL_DIR}}/manage.py <comando> [ <parametri> ]

"""


		print "=" * 30
		print "Main modules"
		print "=" * 30
		print 

		for app_name in settings.SANET_BASE_APPS:

			commands = commands_by_app.get(app_name,None)
			if not commands:
				continue

			self.print_commands(app_name, commands)

		print "=" * 30
		print "Other modules"
		print "=" * 30
		print 

		for app_name in settings.SANET_DEFAULT_APPS:

			commands = commands_by_app.get(app_name,None)
			if not commands:
				continue

			self.print_commands(app_name, commands)

	def print_commands(self, app_name, commands):

			#print "=" * 30
			print "%-30s" % (app_name)
			print "-" * 30
			print 

			for cmd_name in sorted(commands):

				try:
					command_module_name = "%s.management.commands.%s" % (app_name, cmd_name)

					k = load_command_class(app_name, cmd_name)

					#if hasattr(k, 'sanet_internal') and k.sanet_internal == True:
					#	continue

					print ""
					print ".. automodule:: %s" % (command_module_name,)
					print ""

				except Exception, e:
					print >>sys.stderr, "Unable to generate command doc", type(e), str(e)

				#print ""
				#print "Utilizzzo"
				#print "---------"
				#print ""
				#
				#print k.print_help(cmd_name, "prova")
				#
				#print ""
				#print ""
