# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

"""

get_ds_path
====================================================================================

Reads DataSource UUIDS from stdin and returns the corrisponding Sanet Path. 

Uso:

	::
		
		sanet-manage get_ds_path [options]

Opzioni:

	::
		
		--tenant name   	Seleziona il tenant di riferimento.

Esempio 1:

	::
		
		sanet-manage get_ds_filename
		481c58593e2e43aba411b39ce2c71936
		Cltr+D
		localhost;;cpu-hr;cpuperc-hr

"""

import os
import sys

from core.models import DataSource

from core.management.commands import TenantBasedCommand

#----------------------------------------------------------------------#
#                                                                      #
#----------------------------------------------------------------------#

class Command(TenantBasedCommand):

	help = "Reads DataSource UUIDS from stdin and returns the corrisponding Sanet Path."

	#option_list = TenantBasedCommand.option_list 

	def handle(self, cmd='', *args, **options):

		tenant = self.get_tenant(options)

		line = sys.stdin.readline()
		while line:
			line= line.strip()

			ds = DataSource.objects.get(uuid=line)

			print ds.path

			line = sys.stdin.readline()
