# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.
"""
INTERNAL COMMAND. DO NOT USE.
"""

import sys
import traceback

#from django.core.management.base import NoArgsCommand
from django.core.management.base import BaseCommand
from django.core import management

from django.db import connection, transaction

from core.models import Tenant
from core.api.base import db_set_current_tenant_schema


#----------------------------------------------------------------------#
#                                                                      #
#----------------------------------------------------------------------#

class Command(BaseCommand):
	

	help = "Create the database tables for all apps in INSTALLED_APPS whose tables haven't already been created."
	
	sanet_internal = True
	
	#option_list = NoArgsCommand.option_list + (
	#)

	#def handle_noargs(self, **options):
	def handle(self, *args, **options):
		
		cursor = connection.cursor()
		
		index_all_tenants(cursor)

@transaction.atomic #@transaction.commit_on_success changed for django 1.8
def index_all_tenants(cursor):
	
	# fix: cursor used?

	for tenant in Tenant.objects.all():
		
		db_set_current_tenant_schema(tenant.name)

		management.call_command('rebuild_index')
