# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

"""

statusdinfo
==========================================================================================

Syntax:

	::
		
		sanet-manage statusdinfo --status

Returns internal status of the statusd subprocess.

.. warning:: This is an internal Sanet command. It is not recommended to use this command.

"""

import os
import sys
import time
from optparse import make_option

from django.db import connection

from core.management.commands import SanetInternalCommand

from server.statusd.statusdctl import statusd_get_server_status

#----------------------------------------------------------------------#
#                                                                      #
#----------------------------------------------------------------------#

class Command(SanetInternalCommand):

	help = "Send commands to statusd subsystem"

	#option_list = SanetInternalCommand.option_list + (
	#	make_option('--status'      , action='store_true'     , dest='server_status'     , default=False , help=''),
	#)

	def add_arguments(self, parser):
		super(Command, self).add_arguments(parser)

		parser.add_argument('--status'      , action='store_true'     , dest='server_status'     , default=False , help=''),

	#def handle(self, cmd='', *args, **options):
	def handle(self, *args, **options):

		connection.close()

		#
		# FIX: implement other options
		#
		if options['server_status']:

			status_data = statusd_get_server_status()

			print status_data['status'], status_data['info']

