# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.
import logging

#from django.core.management.base import NoArgsCommand
from django.core.management.base import BaseCommand

from django.db import transaction
from django.db import connection

from core.models import Tenant
from core.api.base import tenant_syncdb

#----------------------------------------------------------------------#
#                                                                      #
#----------------------------------------------------------------------#

class Command(BaseCommand):
	
	sanet_internal = True
	
	#option_list = NoArgsCommand.option_list 
	
	# Create the database tables for all apps in INSTALLED_APPS whose tables haven't already been created.
	help = "*INTERNAL COMMAND. DO NOT USE*"

	#def handle_noargs(self, **options):
	def handle(self, *args, **options):
		
		#cursor = connection.cursor()

		#sync_all_tenants(cursor)
		
		sync_all_tenants(connection)

@transaction.atomic #@transaction.commit_on_success changed for django 1.8
#def sync_all_tenants(cursor):
def sync_all_tenants(connection):
	return _sync_all_tenants(connection)
	
def _sync_all_tenants(connection):

	logger = logging.getLogger('sanet.global')

	logger.info("Syncing all tenants")

	names = ['public'] + [ t.name for t in Tenant.objects.all() ]

	for name in names:

		logger.info("Checking fo rsync %s", name)

		#tenant_syncdb(tenant.name, cursor)
		tenant_syncdb(name, connection, logger=logger)

