# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

import os
import sys, time

from optparse import make_option

from django.core.management.base import BaseCommand

from core.models import Condition
from core.api.base import db_set_current_tenant_schema

from core.management.commands import TenantBasedCommand

#----------------------------------------------------------------------#
#                                                                      #
#----------------------------------------------------------------------#

class Command(TenantBasedCommand):
	
	#help = "Test logchanges_sequence"
	help = "INTERNAL COMMAND. DO NOT USE"
	
	sanet_internal = True

	#option_list = BaseCommand.option_list + (
	#	make_option('--tenant', action='store', dest='tenant', default=None, help=''),
	#	make_option('--condition', action='store', dest='condition', default=None, help=''),
	#	make_option('--start', action='store', dest='start', default=None, help=''),
	#	make_option('--end', action='store', dest='end', default=None, help=''),
	#)

	def add_arguments(self, parser):
		super(Command, self).add_arguments(parser)

		#parser.add_argument('--tenant'   , action='store', dest='tenant'   , default=None, help=''),
		parser.add_argument('--condition', action='store', dest='condition', default=None, help=''),
		parser.add_argument('--start'    , action='store', dest='start'    , default=None, help=''),
		parser.add_argument('--end'      , action='store', dest='end'      , default=None, help=''),

	#def handle(self, cmd='', *args, **options):
	def handle(self, *args, **options):

		if options['tenant'] and options['condition']:
			
			db_set_current_tenant_schema(options['tenant'])
			
			condition = Condition.objects.get(uuid=options['condition'])
			#condition = Condition.objects.all()
			
			start = None
			if options['start'] == None: # se start non e' inserito mettiamo un'ora fa
				start = time.time() - (60*60)
			else:
				start = int(options['start'])
			
			end = None
			if options['end'] != None:
				end = int(options['end'])
			
			print "start %s. end %s" % (start, end)
			
			_time = time.time()
			print condition.logchanges_sequence(start, end)
			#for x in range(0,1000):
			#	for c in condition:
			#		a = c.logchanges_sequence(start, end)
			print "tempo di esecuzione della logchanges_sequence: %s" % (time.time() - _time)
			#print i
		else:
			print "insert tenant and condition uuid"
			exit(1)
