# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.
"""

test_user_password
================================================================================================

Questo comando verifica le credenziali di accesso di un utente utilizzando il modulo di autenticazione configurato per il sistema: 

	::
		
		sanet-manage test_user_password <username>

Esempio: 

	::
		
		$ sanet-manage test_user_password foo
		Password: *********
		Invalid credentials

E' utile per controllare se il sistema di autenticazione utilizzato funziona correttamente:

"""

import sys
import getpass

from django.contrib.auth import authenticate

from core.management.commands import SanetBaseCommand

#---------------------------------------------------------------------#
#                                                                     #
#---------------------------------------------------------------------#

class Command(SanetBaseCommand):

	help = "Test user login credentials from command line"

	args = ''

	#option_list = SanetBaseCommand.option_list
	def add_arguments(self, parser):
		super(SanetBaseCommand, self).add_arguments(parser)
		
		parser.add_argument('username', nargs='?', default=None)
		parser.add_argument('password', nargs='?', default=None)

	#def handle(self, username=None, password=None, *args, **options):
	def handle(self, *args, **options):

		username = options['username']
		password = options['password']
		
		if username is None:
			username = raw_input("Username:")

		if password is None:
			password = getpass.getpass()

		user = authenticate(username=username, password=password)

		if user:
			print ""
			print ""
			print "User: ", user
		else:
			print "Invalid credentials"
			sys.exit(-1)

