# -*- coding: utf-8 -*-
# Generated by Django 1.11.14 on 2018-10-08 08:43
from __future__ import unicode_literals

import time

from django.conf import settings
import django.core.validators
from django.db import migrations, models
import django.db.models.deletion

import sanet_common.uuids

import core.cachemodels
import core.models

class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('auth', '0008_alter_user_username_max_length'),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Ack',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('timestamp', models.PositiveIntegerField(db_index=True, default=0)),
                ('timestamplastchange', models.PositiveIntegerField(db_index=True, default=0)),
                ('reason', models.TextField()),
                ('user_name', models.TextField(db_index=True)),
            ],
            options={
                'db_table': 'acknowledgementlog',
            },
        ),
        migrations.CreateModel(
            name='AcknowledgementType',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('name', models.CharField(db_index=True, max_length=255, unique=True)),
                ('descr', models.TextField(blank=True, default=b'')),
            ],
            options={
                'db_table': 'acknowledgementtype',
            },
        ),
        migrations.CreateModel(
            name='Agent',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('name', models.TextField(db_index=True)),
                ('description', models.TextField(blank=True, default=b'')),
                ('is_enabled', models.BooleanField(default=True)),
                ('is_primary', models.BooleanField(default=False)),
                ('is_remote', models.BooleanField(default=False)),
                ('threads', models.PositiveSmallIntegerField(default=20)),
                ('config_update_minperiod', models.PositiveSmallIntegerField(default=180)),
                ('scheduling_min_gap', models.PositiveSmallIntegerField(blank=True, default=None, null=True, validators=[django.core.validators.MinValueValidator(1)])),
                ('scheduling_max_parallel', models.PositiveSmallIntegerField(blank=True, default=None, null=True, validators=[django.core.validators.MinValueValidator(1)])),
                ('scheduling_max_deadline', models.PositiveSmallIntegerField(blank=True, null=True, validators=[django.core.validators.MinValueValidator(1)])),
            ],
            options={
                'db_table': 'agent',
            },
            bases=(models.Model, core.cachemodels.AbstractCachedFieldModel),
        ),
        migrations.CreateModel(
            name='Alarm',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('ack_needed', models.BooleanField(db_index=True, default=False)),
                ('flow_information', models.TextField(default=None, null=True)),
                ('ack', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='core.Ack')),
            ],
            options={
                'db_table': 'alarm',
            },
        ),
        migrations.CreateModel(
            name='Capability',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('code', models.TextField()),
                ('group', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='auth.Group')),
            ],
            options={
                'db_table': 'capability',
            },
        ),
        migrations.CreateModel(
            name='CConditionFieldValue',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('value', models.TextField(blank=True, default=None, null=True)),
            ],
            options={
                'db_table': 'c_cconditionfieldvalue',
            },
        ),
        migrations.CreateModel(
            name='CDataGroup',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('name', models.TextField(default=None)),
            ],
            options={
                'db_table': 'c_cdatagroup',
            },
        ),
        migrations.CreateModel(
            name='CDataGroupFieldValue',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('value', models.TextField(blank=True, default=None, null=True)),
                ('cdatagroup', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.CDataGroup')),
            ],
            options={
                'db_table': 'c_cdatagroupfieldvalue',
            },
        ),
        migrations.CreateModel(
            name='CDataGroupParameterValue',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('name', models.TextField(db_index=True)),
                ('vtype', models.PositiveSmallIntegerField(default=1)),
                ('value', models.TextField(blank=True, default=b'')),
                ('cdatagroup', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.CDataGroup')),
            ],
            options={
                'db_table': 'c_cdatagroupparametervalue',
            },
        ),
        migrations.CreateModel(
            name='CDataSourceFieldValue',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('value', models.TextField(blank=True, default=None, null=True)),
                ('cdatagroup', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.CDataGroup')),
            ],
            options={
                'db_table': 'c_cdatasourcefieldvalue',
            },
        ),
        migrations.CreateModel(
            name='Cluster',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('name', models.TextField()),
                ('description', models.TextField(blank=True, default=b'')),
                ('owner', models.ForeignKey(default=None, null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'db_table': 'cluster',
            },
        ),
        migrations.CreateModel(
            name='ClusterGroupPermission',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('auth_type', models.PositiveSmallIntegerField(default=1)),
                ('cluster', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.Cluster')),
                ('group', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='auth.Group')),
            ],
            options={
                'db_table': 'cluster_group_permission',
            },
        ),
        migrations.CreateModel(
            name='Condition',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('path', models.TextField(db_index=True)),
                ('name', models.TextField(db_index=True)),
                ('title', models.TextField(blank=True, db_index=True, default=b'')),
                ('primary', models.BooleanField(default=False)),
                ('expr', models.TextField(blank=True, default=b'')),
                ('max_tries', models.PositiveSmallIntegerField(default=3)),
                ('uncheckable_fallback', models.SmallIntegerField(default=None, null=True)),
                ('statuschange_action', models.TextField(null=True)),
                ('priority', models.IntegerField(db_index=True, default=0)),
                ('classification', models.TextField(blank=True, db_index=True, default=b'')),
                ('email', models.EmailField(blank=True, default=b'netwarning', max_length=1000)),
                ('upemail', models.EmailField(blank=True, default=b'', max_length=1000, null=True)),
                ('msg_downsubj', models.TextField(blank=True, default=b'', null=True)),
                ('msg_downbody', models.TextField(blank=True, default=b'', null=True)),
                ('msg_upsubj', models.TextField(blank=True, default=b'', null=True)),
                ('msg_upbody', models.TextField(blank=True, default=b'', null=True)),
                ('status', models.SmallIntegerField(db_index=True, default=40)),
                ('statuslast', models.SmallIntegerField(db_index=True, default=40)),
                ('statuslastchange', models.PositiveIntegerField(db_index=True, default=0)),
                ('statuslastnotablechange', models.PositiveIntegerField(db_index=True, default=0)),
                ('deleted', models.BooleanField(db_index=True, default=False)),
                ('agent', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='monitored_conditions', to='core.Agent')),
            ],
            options={
                'db_table': 'condition',
            },
            bases=(core.cachemodels.AbstractCachedFieldModel, core.models.ModelFieldsUtils, core.models.CachedUtil, models.Model),
        ),
        migrations.CreateModel(
            name='CTimeGraphFieldValue',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('value', models.TextField(blank=True, default=None, null=True)),
                ('cdatagroup', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.CDataGroup')),
            ],
            options={
                'db_table': 'c_ctimegraphfieldvalue',
            },
        ),
        migrations.CreateModel(
            name='CTimeGraphSerieFieldValue',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('value', models.TextField(blank=True, default=None, null=True)),
                ('cdatagroup', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.CDataGroup')),
            ],
            options={
                'db_table': 'c_ctimegraphseriefieldvalue',
            },
        ),
        migrations.CreateModel(
            name='DataGroup',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('path', models.TextField(db_index=True)),
                ('name', models.TextField(db_index=True)),
                ('title', models.TextField(blank=True, db_index=True, default=b'')),
                ('minperiod', models.PositiveIntegerField(default=60)),
                ('shorttries', models.PositiveSmallIntegerField(default=3)),
                ('timeout', models.FloatField(default=3.0)),
                ('deleted', models.BooleanField(db_index=True, default=False)),
                ('suspended', models.BooleanField(db_index=True, default=False)),
                ('suspend_reason', models.TextField(default=b'')),
                ('suspend_time', models.PositiveIntegerField(db_index=True, default=None, null=True)),
                ('suspend_resume_time', models.PositiveIntegerField(db_index=True, default=None, null=True)),
                ('classification', models.TextField(blank=True, db_index=True, default=b'')),
                ('passive_match', models.TextField(blank=True, db_index=True, default=b'')),
                ('agent', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='monitored_datagroups', to='core.Agent')),
                ('cdatagroup', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.CDataGroup')),
                ('dependson', models.ForeignKey(blank=True, default=None, null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='depending_datagroups', to='core.Condition')),
            ],
            options={
                'db_table': 'datagroup',
            },
            bases=(core.cachemodels.AbstractCachedFieldModel, core.models.ModelFieldsUtils, core.models.CachedUtil, models.Model),
        ),
        migrations.CreateModel(
            name='DataGroupParameter',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('name', models.TextField(db_index=True)),
                ('vtype', models.PositiveSmallIntegerField(default=1)),
                ('value', models.TextField(blank=True, default=b'')),
                ('datagroup', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.DataGroup')),
            ],
            options={
                'db_table': 'datagroup_parameter',
            },
        ),
        migrations.CreateModel(
            name='DataSource',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('path', models.TextField(db_index=True)),
                ('name', models.TextField(db_index=True)),
                ('title', models.TextField(blank=True, db_index=True, default=b'')),
                ('expr', models.TextField(blank=True, default=b'')),
                ('status', models.SmallIntegerField(db_index=True, default=0)),
                ('order', models.PositiveSmallIntegerField(default=0)),
                ('cascade', models.BooleanField(default=False)),
                ('save_value', models.BooleanField(default=True)),
                ('gauge', models.BooleanField(default=True)),
                ('min_val', models.FloatField(default=None, null=True)),
                ('max_val', models.FloatField(default=None, null=True)),
                ('storage_spec', models.TextField(default=None, null=True)),
                ('classification', models.TextField(blank=True, db_index=True, default=b'')),
                ('deleted', models.BooleanField(db_index=True, default=False)),
                ('agent', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='monitored_datasources', to='core.Agent')),
                ('datagroup', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='datasources', to='core.DataGroup')),
            ],
            options={
                'db_table': 'datasource',
            },
            bases=(core.cachemodels.AbstractCachedFieldModel, core.models.ModelFieldsUtils, core.models.CachedUtil, models.Model),
        ),
        migrations.CreateModel(
            name='DBSetting',
            fields=[
                ('name', models.TextField(db_index=True, primary_key=True, serialize=False)),
                ('value', models.TextField()),
            ],
            options={
                'db_table': 'dbsetting',
            },
        ),
        migrations.CreateModel(
            name='ElementTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('applyorder', models.PositiveIntegerField(default=0)),
            ],
            options={
                'db_table': 'c_element_template',
            },
        ),
        migrations.CreateModel(
            name='Event',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('kind', models.SmallIntegerField(db_index=True)),
                ('timestamp', models.PositiveIntegerField(db_index=True, default=0)),
                ('msg', models.TextField(blank=True)),
                ('element_path', models.CharField(db_index=True, max_length=256)),
                ('condition_path', models.CharField(db_index=True, max_length=256)),
                ('element_uuid', models.CharField(db_index=True, max_length=32, null=True)),
                ('condition_uuid', models.CharField(db_index=True, max_length=32, null=True)),
                ('status', models.SmallIntegerField(db_index=True, null=True)),
                ('statuslast', models.SmallIntegerField(db_index=True, null=True)),
                ('statuslastchange', models.PositiveIntegerField(blank=True, db_index=True, null=True)),
                ('lastdone', models.PositiveIntegerField(blank=True, db_index=True, null=True)),
                ('penalty', models.PositiveSmallIntegerField(blank=True, null=True)),
                ('dampened', models.NullBooleanField(db_index=True)),
                ('priority', models.IntegerField(db_index=True, null=True)),
                ('sourceip', models.CharField(blank=True, db_index=True, max_length=64, null=True)),
                ('facility', models.PositiveIntegerField(blank=True, db_index=True, null=True)),
                ('severity', models.PositiveIntegerField(blank=True, db_index=True, null=True)),
                ('trapoid', models.TextField(blank=True, db_index=True, null=True)),
                ('varbindlist', models.TextField(blank=True, null=True)),
                ('datetime', models.CharField(blank=True, db_index=True, max_length=20, null=True)),
                ('timeticks', models.PositiveIntegerField(blank=True, db_index=True, default=0, null=True)),
                ('sysuptime', models.PositiveIntegerField(blank=True, db_index=True, default=0, null=True)),
            ],
            options={
                'ordering': ('-timestamp',),
                'db_table': 'event',
            },
        ),
        migrations.CreateModel(
            name='Link',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('name', models.TextField(unique=True)),
                ('description', models.TextField(blank=True, default=b'')),
                ('ltype', models.PositiveIntegerField(default=2)),
            ],
            options={
                'db_table': 'link',
            },
        ),
        migrations.CreateModel(
            name='LinkElement',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('link', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='ifaces', to='core.Link')),
            ],
            options={
                'db_table': 'link_element',
            },
        ),
        migrations.CreateModel(
            name='MonitoredElement',
            fields=[
                ('ctime', models.IntegerField(db_index=True, default=time.time)),
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('kind', models.PositiveIntegerField(default=1)),
                ('name', models.TextField(verbose_name=b'Name')),
                ('description', models.TextField(blank=True, default=b'', verbose_name=b'Description')),
                ('is_abstract', models.BooleanField(default=False)),
                ('cluster_role', models.PositiveIntegerField(default=0, null=True, verbose_name=b'Cluster role')),
                ('cluster_distinguisher', models.TextField(blank=True, default=None, null=True, verbose_name=b'Cluster distinguisher')),
                ('cluster_xform', models.TextField(blank=True, default=None, null=True, verbose_name=b'Cluster Xform')),
                ('cluster_instance', models.TextField(blank=True, default=None, null=True, verbose_name=b'Cluster instance')),
                ('priority', models.IntegerField(db_index=True, default=0, verbose_name=b'Default Priority')),
                ('icon', models.TextField(blank=True, default=None, null=True, verbose_name=b'Icon name')),
                ('notify_address', models.TextField(blank=True, default=None, null=True, verbose_name=b'Email used for system anomialies.')),
            ],
            options={
                'ordering': ['name'],
                'db_table': 'monitoredelement',
            },
            bases=(core.models.CachedUtil, core.cachemodels.AbstractCachedFieldModel, core.models.ModelFieldsUtils, models.Model),
        ),
        migrations.CreateModel(
            name='PriorityLabel',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('min_level', models.IntegerField(db_index=True)),
                ('max_level', models.IntegerField(db_index=True)),
                ('label', models.TextField(unique=True)),
                ('description', models.TextField()),
            ],
            options={
                'db_table': 'prioritylabel',
            },
        ),
        migrations.CreateModel(
            name='SANETGroupProfile',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('description', models.TextField(blank=True, default=b'')),
                ('group', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='auth.Group', unique=True)),
            ],
            options={
                'db_table': 'sanetgroupprofile',
            },
        ),
        migrations.CreateModel(
            name='SANETUserProfile',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL, unique=True)),
            ],
            options={
                'db_table': 'sanetuserprofile',
            },
        ),
        migrations.CreateModel(
            name='SchedulingGroup',
            fields=[
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('is_real', models.BooleanField(default=True)),
                ('name', models.TextField(unique=True)),
                ('description', models.TextField(blank=True, default=b'')),
                ('min_gap', models.PositiveSmallIntegerField(blank=True, default=None, null=True, validators=[django.core.validators.MinValueValidator(1)])),
                ('max_parallel', models.PositiveSmallIntegerField(blank=True, default=None, null=True, validators=[django.core.validators.MinValueValidator(1)])),
                ('max_deadline', models.PositiveSmallIntegerField(blank=True, null=True, validators=[django.core.validators.MinValueValidator(1)])),
                ('owner', models.ForeignKey(default=None, null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'db_table': 'scheduling_group',
            },
            bases=(core.models.ModelFieldsUtils, models.Model),
        ),
        migrations.CreateModel(
            name='SchedulingGroupPermission',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('auth_type', models.PositiveSmallIntegerField(default=1)),
                ('group', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='auth.Group')),
                ('schedulinggroup', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.SchedulingGroup')),
            ],
            options={
                'db_table': 'schedulinggroup_group_permission',
            },
        ),
        migrations.CreateModel(
            name='TCondition',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('name', models.TextField(db_index=True)),
            ],
            options={
                'db_table': 'c_tcondition',
            },
        ),
        migrations.CreateModel(
            name='TConditionFieldValue',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('value', models.TextField(blank=True, default=None, null=True)),
                ('tcondition', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TCondition')),
            ],
            options={
                'db_table': 'c_tconditionfieldvalue',
            },
        ),
        migrations.CreateModel(
            name='TDataGroup',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('source', models.SmallIntegerField(db_index=True, default=1)),
                ('name', models.TextField(db_index=True)),
                ('description', models.TextField(default=b'')),
                ('owner', models.ForeignKey(default=None, null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL)),
                ('parent', models.ForeignKey(blank=True, default=None, null=True, on_delete=django.db.models.deletion.CASCADE, to='core.TDataGroup')),
            ],
            options={
                'db_table': 'c_tdatagroup',
            },
        ),
        migrations.CreateModel(
            name='TDataGroupFieldValue',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('value', models.TextField(blank=True, default=None, null=True)),
                ('tdatagroup', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TDataGroup')),
            ],
            options={
                'db_table': 'c_tdatagroupfieldvalue',
            },
        ),
        migrations.CreateModel(
            name='TDataGroupParameterValue',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('name', models.TextField(db_index=True)),
                ('vtype', models.PositiveSmallIntegerField(default=1)),
                ('value', models.TextField(blank=True, default=b'')),
                ('tdatagroup', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TDataGroup')),
            ],
            options={
                'db_table': 'c_tdatagroupparametervalue',
            },
        ),
        migrations.CreateModel(
            name='TDataGroupPermission',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('auth_type', models.PositiveSmallIntegerField(default=1)),
                ('group', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='auth.Group')),
                ('tdatagroup', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TDataGroup')),
            ],
            options={
                'db_table': 'tdatagroup_group_permission',
            },
        ),
        migrations.CreateModel(
            name='TDataSource',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('name', models.TextField(db_index=True)),
                ('tdatagroup', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TDataGroup')),
            ],
            options={
                'db_table': 'c_tdatasource',
            },
        ),
        migrations.CreateModel(
            name='TDataSourceFieldValue',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('value', models.TextField(blank=True, default=None, null=True)),
                ('tdatasource', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TDataSource')),
            ],
            options={
                'db_table': 'c_tdatasourcefieldvalue',
            },
        ),
        migrations.CreateModel(
            name='TEConditionFieldValue',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('value', models.TextField(blank=True, default=None, null=True)),
                ('tcondition', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TCondition')),
            ],
            options={
                'db_table': 'c_teconditionfieldvalue',
            },
        ),
        migrations.CreateModel(
            name='TEDataGroup',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.TextField(default=None, null=True)),
                ('tdatagroup', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TDataGroup')),
            ],
            options={
                'db_table': 'c_tedatagroup',
            },
        ),
        migrations.CreateModel(
            name='TEDataGroupFieldValue',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('value', models.TextField(blank=True, default=None, null=True)),
                ('tedatagroup', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TEDataGroup')),
            ],
            options={
                'db_table': 'c_tedatagroupfieldvalue',
            },
        ),
        migrations.CreateModel(
            name='TEDataGroupParameterValue',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('name', models.TextField(db_index=True)),
                ('vtype', models.PositiveSmallIntegerField(default=1)),
                ('value', models.TextField(blank=True, default=b'')),
                ('tedatagroup', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TEDataGroup')),
            ],
            options={
                'db_table': 'c_tedatagroupparametervalue',
            },
        ),
        migrations.CreateModel(
            name='TEDataSourceFieldValue',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('value', models.TextField(blank=True, default=None, null=True)),
                ('tdatasource', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TDataSource')),
                ('tedatagroup', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TEDataGroup')),
            ],
            options={
                'db_table': 'c_tedatasourcefieldvalue',
            },
        ),
        migrations.CreateModel(
            name='TElement',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('kind', models.PositiveIntegerField(default=1)),
                ('name', models.TextField(default=None, null=True)),
                ('description', models.TextField(default=b'')),
                ('is_switch', models.BooleanField(default=False)),
                ('is_router', models.BooleanField(default=False)),
                ('priority', models.IntegerField(db_index=True, default=0)),
                ('distinguisher', models.TextField(default=None, null=True)),
                ('xform', models.TextField(default=None, null=True)),
                ('instance', models.TextField(default=None, null=True)),
                ('owner', models.ForeignKey(default=None, null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL)),
                ('parent', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='core.TElement')),
            ],
            options={
                'db_table': 'c_telement',
            },
        ),
        migrations.CreateModel(
            name='TElementAppliedTemplate',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('applyorder', models.PositiveIntegerField(default=0)),
                ('telement', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='telements_applied', to='core.TElement')),
                ('telementapplied', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TElement')),
            ],
            options={
                'db_table': 'c_telementappliedtemplate',
            },
        ),
        migrations.CreateModel(
            name='TElementPermission',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('auth_type', models.PositiveSmallIntegerField(default=1)),
                ('group', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='auth.Group')),
                ('telement', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TElement')),
            ],
            options={
                'db_table': 'telement_group_permission',
            },
        ),
        migrations.CreateModel(
            name='Tenant',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('name', models.TextField(unique=True)),
                ('long_name', models.TextField()),
                ('timezone', models.TextField(default=b'Europe/Rome')),
                ('is_primary', models.BooleanField(default=False)),
            ],
            options={
                'db_table': 'tenant',
            },
        ),
        migrations.CreateModel(
            name='TenantGroup',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('default_min_priority', models.IntegerField(db_index=True, default=0)),
                ('group', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='auth.Group')),
                ('tenant', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.Tenant')),
            ],
            options={
                'db_table': 'tenant_group',
            },
        ),
        migrations.CreateModel(
            name='TenantSetting',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.TextField()),
                ('value', models.TextField(blank=True, default=None, null=True)),
                ('tenant', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_tenantsetting_related', to='core.Tenant')),
            ],
            options={
                'db_table': 'tenantsetting',
            },
        ),
        migrations.CreateModel(
            name='TenantUserSettings',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('default_min_priority', models.IntegerField(db_index=True, default=0)),
                ('is_default', models.BooleanField(default=False)),
                ('tenant', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.Tenant')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'db_table': 'tenant_user',
            },
        ),
        migrations.CreateModel(
            name='TETimeGraphFieldValue',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('value', models.TextField(blank=True, default=None, null=True)),
                ('tedatagroup', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TEDataGroup')),
                ('tenant', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_tetimegraphfieldvalue_related', to='core.Tenant')),
            ],
            options={
                'db_table': 'c_tetimegraphfieldvalue',
            },
        ),
        migrations.CreateModel(
            name='TETimeGraphSerieFieldValue',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('value', models.TextField(blank=True, default=None, null=True)),
                ('tedatagroup', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TEDataGroup')),
                ('tenant', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_tetimegraphseriefieldvalue_related', to='core.Tenant')),
            ],
            options={
                'db_table': 'c_tetimegraphseriefieldvalue',
            },
        ),
        migrations.CreateModel(
            name='TField',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('fclass', models.SmallIntegerField(db_index=True)),
                ('vtype', models.TextField()),
                ('name', models.TextField(db_index=True)),
            ],
            options={
                'db_table': 'c_tfield',
            },
        ),
        migrations.CreateModel(
            name='TimeGraph',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('name', models.TextField(db_index=True)),
                ('title', models.TextField(db_index=True, default=b'')),
                ('primary', models.BooleanField(default=False)),
                ('stacked', models.BooleanField(default=True)),
                ('ylegend', models.TextField(blank=True, default=b'')),
                ('deleted', models.BooleanField(default=False)),
                ('classification', models.TextField(blank=True, db_index=True, default=b'')),
                ('datagroup', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='timegraphs', to='core.DataGroup')),
            ],
            options={
                'db_table': 'timegraph',
            },
            bases=(core.models.ModelFieldsUtils, core.models.CachedUtil, models.Model),
        ),
        migrations.CreateModel(
            name='TimeGraphSerie',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('name', models.TextField(db_index=True)),
                ('legend', models.TextField(blank=True, default=b'')),
                ('color', models.TextField(default=b'')),
                ('style', models.TextField(default=b'area')),
                ('render_order', models.PositiveSmallIntegerField(default=0)),
                ('variable_value', models.TextField(blank=True, default=None, null=True)),
                ('computed_value_expr', models.TextField(blank=True, default=None, null=True)),
                ('deleted', models.BooleanField(default=False)),
                ('owner', models.ForeignKey(default=None, null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL)),
                ('tenant', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_timegraphserie_related', to='core.Tenant')),
                ('timegraph', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='series', to='core.TimeGraph')),
            ],
            options={
                'db_table': 'timegraphserie',
            },
            bases=(core.models.ModelFieldsUtils, models.Model),
        ),
        migrations.CreateModel(
            name='TTimeGraph',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('name', models.TextField(db_index=True)),
                ('tdatagroup', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TDataGroup')),
                ('tenant', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_ttimegraph_related', to='core.Tenant')),
            ],
            options={
                'db_table': 'c_ttimegraph',
            },
        ),
        migrations.CreateModel(
            name='TTimeGraphFieldValue',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('value', models.TextField(blank=True, default=None, null=True)),
                ('tenant', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_ttimegraphfieldvalue_related', to='core.Tenant')),
                ('tfield', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TField')),
                ('ttimegraph', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TTimeGraph')),
            ],
            options={
                'db_table': 'c_ttimegraphfieldvalue',
            },
        ),
        migrations.CreateModel(
            name='TTimeGraphSerie',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('name', models.TextField(db_index=True)),
                ('tenant', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_ttimegraphserie_related', to='core.Tenant')),
                ('ttimegraph', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TTimeGraph')),
            ],
            options={
                'db_table': 'c_ttimegraphserie',
            },
        ),
        migrations.CreateModel(
            name='TTimeGraphSerieFieldValue',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('value', models.TextField(blank=True, default=None, null=True)),
                ('tenant', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_ttimegraphseriefieldvalue_related', to='core.Tenant')),
                ('tfield', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TField')),
                ('ttimegraphserie', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TTimeGraphSerie')),
            ],
            options={
                'db_table': 'c_ttimegraphseriefieldvalue',
            },
        ),
        migrations.CreateModel(
            name='UserCustomSetting',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('key', models.TextField()),
                ('value', models.TextField()),
                ('tenant', models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='core.Tenant')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='customsettings', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'db_table': 'usercustomsetting',
            },
        ),
        migrations.CreateModel(
            name='MonitoredDevice',
            fields=[
                ('monitoredelement_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='core.MonitoredElement')),
                ('distinguisher', models.TextField(db_index=True, default=None, null=True)),
                ('xform', models.TextField(default=None, null=True)),
                ('devindex', models.TextField(db_index=True, default=None, null=True)),
            ],
            options={
                'ordering': ['name'],
                'db_table': 'device',
            },
            bases=('core.monitoredelement',),
        ),
        migrations.CreateModel(
            name='MonitoredIface',
            fields=[
                ('monitoredelement_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='core.MonitoredElement')),
                ('distinguisher', models.TextField(db_index=True, null=True)),
                ('xform', models.TextField(null=True)),
                ('ifindex', models.TextField(db_index=True, default=None, null=True)),
                ('backbone', models.BooleanField(db_index=True, default=False)),
                ('speed', models.BigIntegerField(db_index=True, default=None, null=True)),
            ],
            options={
                'ordering': ['name'],
                'db_table': 'iface',
            },
            bases=('core.monitoredelement',),
        ),
        migrations.CreateModel(
            name='MonitoredNode',
            fields=[
                ('monitoredelement_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='core.MonitoredElement')),
                ('use_ipv4', models.BooleanField(default=True, verbose_name=b'IPv4')),
                ('dns_name', models.TextField(blank=True, default=None, null=True, verbose_name=b'DNS name (A)')),
                ('dns6_name', models.TextField(blank=True, default=None, null=True, verbose_name=b'DNS v6 name (AAAA)')),
                ('ip4_mgt', core.models.IPAddressFieldNullable(blank=True, default=None, null=True, verbose_name=b'IPv4 address')),
                ('ip6_mgt', models.TextField(blank=True, default=None, null=True, verbose_name=b'IPv6 address')),
                ('timezone', models.TextField(default=None, null=True, verbose_name=b'Timezone')),
                ('snmp_version', models.PositiveSmallIntegerField(default=2, verbose_name=b'SNMP version')),
                ('snmp_port', models.PositiveSmallIntegerField(default=161, verbose_name=b'SNMP UDP port')),
                ('snmp_community', models.TextField(blank=True, default=b'public', verbose_name=b'SNMP Community')),
                ('snmp_v3_authdata', models.TextField(blank=True, default=None, null=True)),
                ('dft_timeout', models.PositiveSmallIntegerField(default=1)),
                ('agent_runningon', models.BooleanField(default=False)),
                ('is_switch', models.BooleanField(default=False, verbose_name=b'Switch capabilities')),
                ('is_router', models.BooleanField(default=False, verbose_name=b'Router capabilities')),
                ('effective_ip', models.TextField(blank=True, default=None, null=True, verbose_name=b'Effective IP')),
            ],
            options={
                'ordering': ['name'],
                'db_table': 'node',
            },
            bases=('core.monitoredelement',),
        ),
        migrations.CreateModel(
            name='MonitoredService',
            fields=[
                ('monitoredelement_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='core.MonitoredElement')),
                ('distinguisher', models.TextField(blank=True, db_index=True, default=None, null=True)),
                ('xform', models.TextField(blank=True, default=None, null=True)),
                ('swrunindex', models.TextField(blank=True, db_index=True, default=None, null=True)),
            ],
            options={
                'db_table': 'service',
            },
            bases=('core.monitoredelement',),
        ),
        migrations.CreateModel(
            name='MonitoredStorage',
            fields=[
                ('monitoredelement_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='core.MonitoredElement')),
                ('distinguisher', models.TextField(blank=True, db_index=True, null=True)),
                ('xform', models.TextField(blank=True, null=True)),
                ('stindex', models.TextField(blank=True, db_index=True, default=None, null=True)),
            ],
            options={
                'ordering': ['name'],
                'db_table': 'storage',
            },
            bases=('core.monitoredelement',),
        ),
        migrations.AddField(
            model_name='timegraph',
            name='element',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='core.MonitoredElement'),
        ),
        migrations.AddField(
            model_name='timegraph',
            name='owner',
            field=models.ForeignKey(default=None, null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='timegraph',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_timegraph_related', to='core.Tenant'),
        ),
        migrations.AlterUniqueTogether(
            name='tfield',
            unique_together=set([('fclass', 'name')]),
        ),
        migrations.AddField(
            model_name='tetimegraphseriefieldvalue',
            name='tfield',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TField'),
        ),
        migrations.AddField(
            model_name='tetimegraphseriefieldvalue',
            name='ttimegraphserie',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TTimeGraphSerie'),
        ),
        migrations.AddField(
            model_name='tetimegraphfieldvalue',
            name='tfield',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TField'),
        ),
        migrations.AddField(
            model_name='tetimegraphfieldvalue',
            name='ttimegraph',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TTimeGraph'),
        ),
        migrations.AddField(
            model_name='tenant',
            name='groups',
            field=models.ManyToManyField(through='core.TenantGroup', to='auth.Group'),
        ),
        migrations.AddField(
            model_name='telementpermission',
            name='tenant',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_telementpermission_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='telementappliedtemplate',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_telementappliedtemplate_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='telement',
            name='tenant',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_telement_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='tedatasourcefieldvalue',
            name='tenant',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_tedatasourcefieldvalue_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='tedatasourcefieldvalue',
            name='tfield',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TField'),
        ),
        migrations.AddField(
            model_name='tedatagroupparametervalue',
            name='tenant',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_tedatagroupparametervalue_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='tedatagroupfieldvalue',
            name='tenant',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_tedatagroupfieldvalue_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='tedatagroupfieldvalue',
            name='tfield',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TField'),
        ),
        migrations.AddField(
            model_name='tedatagroup',
            name='telement',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TElement'),
        ),
        migrations.AddField(
            model_name='tedatagroup',
            name='tenant',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_tedatagroup_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='teconditionfieldvalue',
            name='tedatagroup',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TEDataGroup'),
        ),
        migrations.AddField(
            model_name='teconditionfieldvalue',
            name='tenant',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_teconditionfieldvalue_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='teconditionfieldvalue',
            name='tfield',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TField'),
        ),
        migrations.AddField(
            model_name='tdatasourcefieldvalue',
            name='tenant',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_tdatasourcefieldvalue_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='tdatasourcefieldvalue',
            name='tfield',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TField'),
        ),
        migrations.AddField(
            model_name='tdatasource',
            name='tenant',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_tdatasource_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='tdatagrouppermission',
            name='tenant',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_tdatagrouppermission_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='tdatagroupparametervalue',
            name='tenant',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_tdatagroupparametervalue_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='tdatagroupfieldvalue',
            name='tenant',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_tdatagroupfieldvalue_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='tdatagroupfieldvalue',
            name='tfield',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TField'),
        ),
        migrations.AddField(
            model_name='tdatagroup',
            name='tenant',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_tdatagroup_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='tconditionfieldvalue',
            name='tenant',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_tconditionfieldvalue_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='tconditionfieldvalue',
            name='tfield',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TField'),
        ),
        migrations.AddField(
            model_name='tcondition',
            name='tdatagroup',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TDataGroup'),
        ),
        migrations.AddField(
            model_name='tcondition',
            name='tenant',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_tcondition_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='schedulinggrouppermission',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_schedulinggrouppermission_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='schedulinggroup',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_schedulinggroup_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='prioritylabel',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_prioritylabel_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='monitoredelement',
            name='agent',
            field=models.ForeignKey(default=None, null=True, on_delete=django.db.models.deletion.CASCADE, to='core.Agent', verbose_name=b'Agent'),
        ),
        migrations.AddField(
            model_name='monitoredelement',
            name='cluster',
            field=models.ForeignKey(default=None, null=True, on_delete=django.db.models.deletion.CASCADE, to='core.Cluster', verbose_name=b'Cluster'),
        ),
        migrations.AddField(
            model_name='monitoredelement',
            name='owner',
            field=models.ForeignKey(default=None, null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='monitoredelement',
            name='parent',
            field=models.ForeignKey(default=None, null=True, on_delete=django.db.models.deletion.CASCADE, to='core.MonitoredElement'),
        ),
        migrations.AddField(
            model_name='monitoredelement',
            name='scheduling_group',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, to='core.SchedulingGroup'),
        ),
        migrations.AddField(
            model_name='monitoredelement',
            name='telement_generator',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='core.TElement'),
        ),
        migrations.AddField(
            model_name='monitoredelement',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_monitoredelement_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='linkelement',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_linkelement_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='link',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_link_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='event',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_event_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='elementtemplate',
            name='melement',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.MonitoredElement'),
        ),
        migrations.AddField(
            model_name='elementtemplate',
            name='telement',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TElement'),
        ),
        migrations.AddField(
            model_name='elementtemplate',
            name='telementappliedtemplate',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, to='core.TElementAppliedTemplate'),
        ),
        migrations.AddField(
            model_name='elementtemplate',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_elementtemplate_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='datasource',
            name='element',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='monitored_datasources', to='core.MonitoredElement'),
        ),
        migrations.AddField(
            model_name='datasource',
            name='owner',
            field=models.ForeignKey(default=None, null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='datasource',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_datasource_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='datagroupparameter',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_datagroupparameter_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='datagroup',
            name='element',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='datagroups', to='core.MonitoredElement'),
        ),
        migrations.AddField(
            model_name='datagroup',
            name='owner',
            field=models.ForeignKey(default=None, null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='datagroup',
            name='scheduling_group',
            field=models.ForeignKey(default=None, null=True, on_delete=django.db.models.deletion.SET_NULL, to='core.SchedulingGroup'),
        ),
        migrations.AddField(
            model_name='datagroup',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_datagroup_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='ctimegraphseriefieldvalue',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_ctimegraphseriefieldvalue_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='ctimegraphseriefieldvalue',
            name='tfield',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TField'),
        ),
        migrations.AddField(
            model_name='ctimegraphseriefieldvalue',
            name='ttimegraphserie',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TTimeGraphSerie'),
        ),
        migrations.AddField(
            model_name='ctimegraphfieldvalue',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_ctimegraphfieldvalue_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='ctimegraphfieldvalue',
            name='tfield',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TField'),
        ),
        migrations.AddField(
            model_name='ctimegraphfieldvalue',
            name='ttimegraph',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TTimeGraph'),
        ),
        migrations.AddField(
            model_name='condition',
            name='datagroup',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='conditions', to='core.DataGroup'),
        ),
        migrations.AddField(
            model_name='condition',
            name='dependson',
            field=models.ForeignKey(default=None, null=True, on_delete=django.db.models.deletion.SET_NULL, to='core.Condition'),
        ),
        migrations.AddField(
            model_name='condition',
            name='element',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='monitored_conditions', to='core.MonitoredElement'),
        ),
        migrations.AddField(
            model_name='condition',
            name='owner',
            field=models.ForeignKey(default=None, null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL),
        ),
        migrations.AddField(
            model_name='condition',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_condition_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='clustergrouppermission',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_clustergrouppermission_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='cluster',
            name='scheduling_group',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, to='core.SchedulingGroup'),
        ),
        migrations.AddField(
            model_name='cluster',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_cluster_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='cdatasourcefieldvalue',
            name='tdatasource',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TDataSource'),
        ),
        migrations.AddField(
            model_name='cdatasourcefieldvalue',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_cdatasourcefieldvalue_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='cdatasourcefieldvalue',
            name='tfield',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TField'),
        ),
        migrations.AddField(
            model_name='cdatagroupparametervalue',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_cdatagroupparametervalue_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='cdatagroupfieldvalue',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_cdatagroupfieldvalue_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='cdatagroupfieldvalue',
            name='tfield',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TField'),
        ),
        migrations.AddField(
            model_name='cdatagroup',
            name='element',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.MonitoredElement'),
        ),
        migrations.AddField(
            model_name='cdatagroup',
            name='tdatagroup',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='additional_datagroups', to='core.TDataGroup'),
        ),
        migrations.AddField(
            model_name='cdatagroup',
            name='tedatagroup',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='telement_datagroups', to='core.TEDataGroup'),
        ),
        migrations.AddField(
            model_name='cdatagroup',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_cdatagroup_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='cconditionfieldvalue',
            name='cdatagroup',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.CDataGroup'),
        ),
        migrations.AddField(
            model_name='cconditionfieldvalue',
            name='tcondition',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TCondition'),
        ),
        migrations.AddField(
            model_name='cconditionfieldvalue',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_cconditionfieldvalue_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='cconditionfieldvalue',
            name='tfield',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.TField'),
        ),
        migrations.AddField(
            model_name='capability',
            name='tenant',
            field=models.ForeignKey(null=True, on_delete=django.db.models.deletion.CASCADE, related_name='core_capability_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='alarm',
            name='event',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='core.Event'),
        ),
        migrations.AddField(
            model_name='alarm',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_alarm_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='agent',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_agent_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='acknowledgementtype',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_acknowledgementtype_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='ack',
            name='acktype',
            field=models.ForeignKey(db_column=b'acktype_id', on_delete=django.db.models.deletion.CASCADE, to='core.AcknowledgementType'),
        ),
        migrations.AddField(
            model_name='ack',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='core_ack_related', to='core.Tenant'),
        ),
        migrations.AlterUniqueTogether(
            name='usercustomsetting',
            unique_together=set([('user', 'tenant', 'key')]),
        ),
        migrations.AlterUniqueTogether(
            name='ttimegraphseriefieldvalue',
            unique_together=set([('tenant', 'ttimegraphserie', 'tfield')]),
        ),
        migrations.AlterUniqueTogether(
            name='ttimegraphserie',
            unique_together=set([('tenant', 'ttimegraph', 'name')]),
        ),
        migrations.AlterUniqueTogether(
            name='ttimegraphfieldvalue',
            unique_together=set([('tenant', 'ttimegraph', 'tfield')]),
        ),
        migrations.AlterUniqueTogether(
            name='ttimegraph',
            unique_together=set([('tenant', 'tdatagroup', 'name')]),
        ),
        migrations.AlterUniqueTogether(
            name='tetimegraphseriefieldvalue',
            unique_together=set([('tenant', 'tedatagroup', 'ttimegraphserie', 'tfield')]),
        ),
        migrations.AlterUniqueTogether(
            name='tetimegraphfieldvalue',
            unique_together=set([('tenant', 'tedatagroup', 'ttimegraph', 'tfield')]),
        ),
        migrations.AlterUniqueTogether(
            name='tenantusersettings',
            unique_together=set([('user', 'tenant')]),
        ),
        migrations.AlterUniqueTogether(
            name='tenantsetting',
            unique_together=set([('tenant', 'name')]),
        ),
        migrations.AlterUniqueTogether(
            name='tenantgroup',
            unique_together=set([('group', 'tenant')]),
        ),
        migrations.AlterUniqueTogether(
            name='telementappliedtemplate',
            unique_together=set([('tenant', 'telement', 'telementapplied')]),
        ),
        migrations.AlterUniqueTogether(
            name='telement',
            unique_together=set([('tenant', 'kind', 'name')]),
        ),
        migrations.AlterUniqueTogether(
            name='tedatasourcefieldvalue',
            unique_together=set([('tenant', 'tedatagroup', 'tdatasource', 'tfield')]),
        ),
        migrations.AlterUniqueTogether(
            name='tedatagroupparametervalue',
            unique_together=set([('tenant', 'tedatagroup', 'name')]),
        ),
        migrations.AlterUniqueTogether(
            name='tedatagroupfieldvalue',
            unique_together=set([('tenant', 'tedatagroup', 'tfield')]),
        ),
        migrations.AlterUniqueTogether(
            name='tedatagroup',
            unique_together=set([('tenant', 'telement', 'tdatagroup', 'name')]),
        ),
        migrations.AlterUniqueTogether(
            name='teconditionfieldvalue',
            unique_together=set([('tenant', 'tedatagroup', 'tcondition', 'tfield')]),
        ),
        migrations.AlterUniqueTogether(
            name='tdatasourcefieldvalue',
            unique_together=set([('tenant', 'tdatasource', 'tfield')]),
        ),
        migrations.AlterUniqueTogether(
            name='tdatasource',
            unique_together=set([('tenant', 'tdatagroup', 'name')]),
        ),
        migrations.AlterUniqueTogether(
            name='tdatagroupparametervalue',
            unique_together=set([('tenant', 'tdatagroup', 'name')]),
        ),
        migrations.AlterUniqueTogether(
            name='tdatagroupfieldvalue',
            unique_together=set([('tenant', 'tdatagroup', 'tfield')]),
        ),
        migrations.AlterUniqueTogether(
            name='tdatagroup',
            unique_together=set([('tenant', 'source', 'name')]),
        ),
        migrations.AlterUniqueTogether(
            name='tconditionfieldvalue',
            unique_together=set([('tenant', 'tcondition', 'tfield')]),
        ),
        migrations.AlterUniqueTogether(
            name='tcondition',
            unique_together=set([('tenant', 'tdatagroup', 'name')]),
        ),
        migrations.AlterUniqueTogether(
            name='schedulinggroup',
            unique_together=set([('tenant', 'name')]),
        ),
        migrations.AlterUniqueTogether(
            name='prioritylabel',
            unique_together=set([('label', 'tenant')]),
        ),
        migrations.AlterUniqueTogether(
            name='monitoredelement',
            unique_together=set([('tenant', 'kind', 'name', 'parent')]),
        ),
        migrations.AddField(
            model_name='linkelement',
            name='iface',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='links', to='core.MonitoredIface'),
        ),
        migrations.AlterUniqueTogether(
            name='link',
            unique_together=set([('tenant', 'name')]),
        ),
        migrations.AlterUniqueTogether(
            name='datasource',
            unique_together=set([('tenant', 'path')]),
        ),
        migrations.AlterUniqueTogether(
            name='datagroup',
            unique_together=set([('tenant', 'path')]),
        ),
        migrations.AlterUniqueTogether(
            name='ctimegraphseriefieldvalue',
            unique_together=set([('tenant', 'cdatagroup', 'ttimegraphserie', 'tfield')]),
        ),
        migrations.AlterUniqueTogether(
            name='ctimegraphfieldvalue',
            unique_together=set([('tenant', 'cdatagroup', 'ttimegraph', 'tfield')]),
        ),
        migrations.AlterUniqueTogether(
            name='condition',
            unique_together=set([('tenant', 'path')]),
        ),
        migrations.AlterUniqueTogether(
            name='cluster',
            unique_together=set([('tenant', 'name')]),
        ),
        migrations.AlterUniqueTogether(
            name='cdatasourcefieldvalue',
            unique_together=set([('tenant', 'cdatagroup', 'tdatasource', 'tfield')]),
        ),
        migrations.AlterUniqueTogether(
            name='cdatagroupparametervalue',
            unique_together=set([('tenant', 'cdatagroup', 'name')]),
        ),
        migrations.AlterUniqueTogether(
            name='cdatagroupfieldvalue',
            unique_together=set([('tenant', 'cdatagroup', 'tfield')]),
        ),
        migrations.AlterUniqueTogether(
            name='cdatagroup',
            unique_together=set([('tenant', 'tdatagroup', 'tedatagroup', 'element', 'name')]),
        ),
        migrations.AlterUniqueTogether(
            name='cconditionfieldvalue',
            unique_together=set([('cdatagroup', 'tcondition', 'tfield')]),
        ),
        migrations.AlterUniqueTogether(
            name='capability',
            unique_together=set([('tenant', 'group', 'code')]),
        ),
        migrations.AlterUniqueTogether(
            name='agent',
            unique_together=set([('tenant', 'name')]),
        ),
        migrations.AlterUniqueTogether(
            name='linkelement',
            unique_together=set([('link', 'iface')]),
        ),
    ]
