# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

from django.conf import settings 

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

# Questa costante serve per codificare un colore sufficientemente "strano" e 
# "distinguibile" dagli altri colori che che un utente potrebbe specificare
# da configurazione
_INVALID_STATE_COLOR ="ff33ff"

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

def get_outcome_color(val):
	"""
	Questa funzione restituisce il colore in base allo stato *val*.
	
	Lo stato *val* deve essere uno stato valido per i DataSource.
	"""
	return settings.OUTCOME_COLOR_MAPPING[val]
	#try:
	#	return settings.OUTCOME_COLOR_MAPPING[val]
	#except KeyError, e:
	#	return _INVALID_STATE_COLOR

def get_state_color(val):
	"""
	Questa funzione calcola il colore in base allo stato in input
	
	Per il momento usiamo un mero mapping tra codice dello stato e colore
	in modo da renderlo simile al mapping CSS usato in passato.
	
	Il mapping 1:1 tra stato e colore non e' piu' valido poiche'
	il colore di un elemento dell'interfaccia non e' "equivalente"
	allo stato di una condition.
	"""
	
	return settings.STATE_COLOR_MAPPING[val]
	#try:
	#	return settings.STATE_COLOR_MAPPING[val]
	#except KeyError, e:
	#	return _INVALID_STATE_COLOR

def get_tag_state_color(val):
	"""
	Questa funzione calcola il colore in base allo stato in input
	
	Per il momento usiamo un mero mapping tra codice dello stato e colore
	in modo da renderlo simile al mapping CSS usato in passato.
	
	Il mapping 1:1 tra stato e colore non e' piu' valido poiche'
	il colore di un elemento dell'interfaccia non e' "equivalente"
	allo stato di una condition.
	"""
	
	return settings.TAG_STATE_COLOR_MAPPING[val]
	#try:
	#	return settings.TAG_STATE_COLOR_MAPPING[val]
	#except KeyError, e:
	#	return _INVALID_STATE_COLOR
