# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

import traceback

import logging    
from logging import NullHandler


from sanet_common.formatutils import calc_num_prefix

from django import template

register = template.Library()

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

"""

Questi sono filtri di formattazione utilizzabili per formattare i template
nei messaggi di allarme.

"""

@register.filter
def kibi(value):
	try:
		(num, base, e, prefix) = calc_num_prefix(value, base=1024)
		return "%3.1f%s" % (num, prefix)
	except Exception, e:
		return value

@register.filter
def kilo(value):
	try:
		(num, base, e, prefix) = calc_num_prefix(value)
		return "%3.1f%s" % (num, prefix)
	except Exception, e:
		return value

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

#
# FIX: feature disabled.
#
#@register.tag(name="sanetexpr")
#def _sanetexpr(parser, token):
#	
#	"""
#	datagroup-template testexpr
#	    title test
#	    condition c
#	        expr "int(readFile('/tmp/test.txt')) == 1"
#	        max-tries 1
#	        msg-downbody "DOWN   {% sanetexpr '1.3.6.1.2.1.1.1.0.clusterInstance():clusterCommunity()@$clusterNode()' %} {% sanetexpr '1.3.6.1.2.1.1.1.0@' %}"
#	        msg-downsubj "[DOWN] {% sanetexpr '1.3.6.1.2.1.1.1.0.clusterInstance():clusterCommunity()@$clusterNode()' %} {% sanetexpr '1.3.6.1.2.1.1.1.0@' %}"
#	        msg-upbody   "UP     {% sanetexpr '1.3.6.1.2.1.1.1.0.clusterInstance():clusterCommunity()@$clusterNode()' %} {% sanetexpr '1.3.6.1.2.1.1.1.0@' %}"
#	        msg-upsubj   "[UP]   {% sanetexpr '1.3.6.1.2.1.1.1.0.clusterInstance():clusterCommunity()@$clusterNode()' %} {% sanetexpr '1.3.6.1.2.1.1.1.0@' %}"
#	        title check
#	    exit
#	exit
#	"""
#	
#	class _sanet_expr_class(template.Node):
#		
#		def __init__(self, expr_str):
#			self.expr_str = expr_str
#		
#		def render(self, context):
#			
#			from core.management.commands.exec_expr import text_expression
#			
#			logger = context['__logger__']
#			node   = context['node']
#			
#			try:
#				fake_logger = logging.getLogger('__null_logger__')
#				fake_logger.addHandler(NullHandler())
#				
#				value, info = text_expression(fake_logger, node.tenant, node.name, self.expr_str, {}, no_defaults=False)
#				return value
#			except template.VariableDoesNotExist:
#				#msg = 'ERRORE ESPANSIONE: %s %s %s' % (type(e), str(e), traceback.format_exc(e))
#				#logger.error(msg)
#				return "{{%s}}" % (self.expr_str)
#			except Exception, e:
#				#msg = 'ERRORE ESPANSIONE: %s %s %s' % (type(e), str(e), traceback.format_exc(e))
#				#logger.error(msg)
#				return "{{%s}}" % (self.expr_str)
#	
#	
#	expr_str = None
#	
#	try:
#		tag_name, expr_str = token.split_contents()
#	except ValueError:
#		raise template.TemplateSyntaxError("Invalid sintax")
#		
#	if not (expr_str[0] == expr_str[-1] and expr_str[0] in ('"', "'")):
#		raise template.TemplateSyntaxError("Invalid sintax")
#	
#	expr_str = expr_str[1:-1]
#	
#	if not expr_str:
#		raise template.TemplateSyntaxError("Invalid sintax")
#	
#	try:
#		return _sanet_expr_class(expr_str)
#	except Exception, e:
#		return "{{%s}}" % (expr_str)
#
