#!/bin/bash

BASE=$1
INSTALL_DIR=$2

echo "Updating install directory value '$INSTALL_DIR' in files inside $BASE"

#
# Edit shell scripts:
#
#        SANET_INSTALL_DIR=
# to
#        SANET_INSTALL_DIR='....'
#
MUST_EDIT_FILES=$(rgrep -l -e '^SANET_INSTALL_DIR=$' $BASE | grep -v .svn | grep -v Binary)

echo "Patching scripts..."
for file in $MUST_EDIT_FILES
do
	echo "Fixing file" $file

	sed -i -e "s|^SANET_INSTALL_DIR=$|SANET_INSTALL_DIR='$INSTALL_DIR'|" $file
done


#
# Edit python modules
#
#        SANET_INSTALL_DIR=None
# to
#        SANET_INSTALL_DIR='....'
#
echo "Patching python files..."

MUST_EDIT_FILES=$(rgrep -l -e '^SANET_INSTALL_DIR=None$' $BASE | grep -v .svn | grep -v Binary)

for file in $MUST_EDIT_FILES
do
	echo "Fixing file" $file

	sed -i -e "s|^SANET_INSTALL_DIR=None$|SANET_INSTALL_DIR='$INSTALL_DIR'|" $file
done
