#!/usr/bin/env python

# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

import os
import sys

#==============================================================================#
SANET_INSTALL_DIR=None

SANET_INSTALL_DIR = os.environ.get("SANET_HOME", SANET_INSTALL_DIR)
from os.path import dirname, abspath
if not SANET_INSTALL_DIR:
	SANET_INSTALL_DIR = os.path.dirname(abspath(__file__))

sys.path.append( SANET_INSTALL_DIR )
#==============================================================================#


if __name__ == "__main__":

	os.environ.setdefault("DJANGO_SETTINGS_MODULE", "conf.settings")

	from django.core.management import execute_from_command_line

	#
	# HACK: Django 'help' option shows all django commands. 
	#
	#       Use Sanet's command 'helpme' instead of 'help'.
	#
	argv = [ a for a in sys.argv if a != '-h']

	if len(argv) > 1:
		if argv[1]   == 'help'      : argv[1] = 'helpme'
		elif argv[1] == 'djangohelp': argv[1] = 'help'
	else:
		argv = [ sys.argv[0], 'helpme' ]

	execute_from_command_line(argv)




