# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

from cli.prompts import cli_register_menu, cli_register_hook

from notes.cli.prompts.config import menu_config_note
from notes.cli.prompts.config import *
from notes.cli.prompts.show   import menu_show_note
from notes.cli.prompts.show   import notes_show_resource_notes

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

def register_cli_hooks():
	
	#
	# Configuration hooks
	#
	
	#
	# 
	# tenant ...
	#   note ...
	# exit
	#
	cli_register_menu('configuration:tenant'    , 'note'   , menu_config_note)

	# no note ...
	cli_register_menu('configuration:tenant:no' , 'note'   , menu_config_note_remove)

	cli_register_menu('configuration:node'      , 'note'   , menu_config_note)
	cli_register_menu('configuration:interface' , 'note'   , menu_config_note)
	cli_register_menu('configuration:storage'   , 'note'   , menu_config_note)
	cli_register_menu('configuration:service'   , 'note'   , menu_config_note)
	cli_register_menu('configuration:device'    , 'note'   , menu_config_note)
	
	#cli_register_menu('configuration:condition' , 'note'   , menu_config_note) FIX: non funziona

	#
	# Show hooks
	#
	
	# show configuration tenant ...
	cli_register_hook('show:tenant:configuration'    , 'note'   , notes_show_conf_tenant_notes)
	cli_register_hook('show:node:configuration'      , 'note'   , notes_show_conf_node_notes)
	cli_register_hook('show:interface:configuration' , 'note'   , notes_show_conf_interface_notes)
	cli_register_hook('show:storage:configuration'   , 'note'   , notes_show_conf_storage_notes)
	cli_register_hook('show:service:configuration'   , 'note'   , notes_show_conf_service_notes)
	cli_register_hook('show:device:configuration'    , 'note'   , notes_show_conf_device_notes)
	
	#cli_register_hook('show:condition:configuration' , 'note'   , notes_show_conf_condition_notes)  FIX: non funziona

	# show notes
	cli_register_menu('show' , 'note'   , menu_show_note)

	# show node ...
	cli_register_hook('show:node'      , 'note'   , notes_show_resource_notes, priority=9999) #show notes after every other plugin
	cli_register_hook('show:interface' , 'note'   , notes_show_resource_notes, priority=9999)
	cli_register_hook('show:storage'   , 'note'   , notes_show_resource_notes, priority=9999)
	cli_register_hook('show:service'   , 'note'   , notes_show_resource_notes, priority=9999)
	cli_register_hook('show:device'    , 'note'   , notes_show_resource_notes, priority=9999)
	
	#cli_register_hook('show:condition' , 'note'   , notes_show_resource_notes, priority=9999) FIX: non funziona


	return
