# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

from core.models import Tenant

from webui.api.Data import BaseDataSet

from notes.views import _get_notes

#-------------------------------------------------------------------------------#
#                                                                               #
#-------------------------------------------------------------------------------#

class DataSet(BaseDataSet):

	def __init__(self, id):
		super(DataSet, self).__init__(id)

	def get_data(self, options): 

		user   = options['user']
		tenant = options.get('tenant')

		element = self.fetch_entity(options)

		# Get notes
		data = _get_notes(tenant, user, element)

		#
		# Check permissions
		#
		#can_edit = True
		#can_edit = can_edit and 'notes.note.element.edit' in user.get_capabilities(tenant)
                #
		#if not isinstance(element, Tenant):
		#	can_edit = can_edit and element.can_write(user) 
                #
		#data['meta']['can_edit'] = can_edit

		return {
			'dataset': data
		} 
