# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

import logging

from django.dispatch import receiver

from core.models import sanet_init_subapp
from core.models import sanet_check_tenant
from core.models import sanet_cleanup_tenant
from core.models import sanet_post_check

#------------------------------------------------------------------------------#
# SANET SIGNALS                                                                #
#------------------------------------------------------------------------------#

@receiver(sanet_init_subapp)
def _sanet_init_subapp_rest_api(sender, **kwargs):
	
	logger = logging.getLogger('sanet.global')
	
	logger.info(  "[rest_api] Init" )

@receiver(sanet_check_tenant)
def _sanet_check_tenant_rest_api(sender, **kwargs):
	
	logger = logging.getLogger('sanet.global')
	
	t = kwargs['instance']
	logger.info(  "[rest_api] Check tenant %s" % (t) )

@receiver(sanet_cleanup_tenant)
def _sanet_cleanup_tenant_rest_api(sender, **kwargs):
	
	logger = logging.getLogger('sanet.global')
	
	t = kwargs['instance']
	logger.info(  "[rest_api] Cleanup tenant %s" % (t) )

@receiver(sanet_post_check)
def _sanet_post_check_rest_api(sender, **kwargs):
	
	logger = logging.getLogger('sanet.global')
	
	logger.info(  "[rest_api] Post check" )

