# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

from django.conf.urls import patterns, url

urlpatterns = patterns('',

	#
	# URL GENERICHE
	#
	url(r'^(?P<resource_type>\w+)$'                                            , 'rest_api.views.resource_list'),

	#
	# NODI
	#
	url(r'^node/(?P<uuid_or_path>(?!/).+)/$'                                   , 'rest_api.views.get_node_info'),
	url(r'^node/(?P<uuid_or_path>(?!/).+)/get_node_info$'                      , 'rest_api.views.get_node_info'),
	url(r'^node/(?P<uuid_or_path>(?!/).+)/get_primary_condition_status_change$', 'rest_api.views.get_primary_condition_status_change'),

	#
	# Interfacce
	#
	url(r'^interface/(?P<uuid_or_path>[a-zA-Z0-9:;]+)/$'                       , 'rest_api.views.get_interface_info'),
	url(r'^interface/(?P<uuid_or_path>[a-zA-Z0-9:;]+)/get_interface_info$'     , 'rest_api.views.get_interface_info'),
	url(r'^interface/(?P<uuid_or_path>[a-zA-Z0-9:;]+)/get_traffic$'            , 'rest_api.views.get_traffic'),

	#
	# Datasource
	#
	url(r'^datasource/(?P<uuid_or_path>[a-zA-Z0-9:;]+)/get_avg_value$'         , 'rest_api.views.get_avg_value'),
	url(r'^datasource/(?P<uuid_or_path>[a-zA-Z0-9:;]+)/get_max_value$'         , 'rest_api.views.get_max_value'),
	url(r'^datasource/(?P<uuid_or_path>[a-zA-Z0-9:;]+)/get_min_value$'         , 'rest_api.views.get_min_value'),
	
	#
	# TAG
	#
	url(r'^tag/(?P<uuid_or_path>.+)/datasources/get_last_value$'               , 'rest_api.views.tag_datasources_get_last_value'),
	url(r'^tag/(?P<uuid_or_path>.+)/datasources/get_last_year_values$'         , 'rest_api.views.tag_datasources_get_last_year_values'),

	#
	# Alarms (Conditions)
	#
	url(r'^alarm/current/$'                                                    , 'rest_api.views.alarms.alarm_current'),

)
