#!/bin/bash

set -e

DATE=$(date +%Y-%m-%d_%H-%M-%S)

VAR_DIR=$(sanet-manage get_config DATA_DIR)
if [ ! "$?" -eq "0" ]; then
	echo "error"
	exit -1
fi


DEST_DIR="$VAR_DIR/current-config"
mkdir -p $DEST_DIR

#
# CLI 
#
cli_filename="$DEST_DIR/current-cli-config.$DATE"

echo "Dumping CLI configuration in" $cli_filename
echo 'show configuration' | sanet-cli > $cli_filename

ln -fs  $cli_filename  $DEST_DIR/current-cli-config

#
# ENTABLES
#
entables_filename="$DEST_DIR/current-entables-config.$DATE"

echo "Dumping ENTABLES configuration in" $entables_filename
entables --save > $entables_filename

ln -fs  $entables_filename  $DEST_DIR/current-entables-config
