#!/bin/bash

set -e

DATE=$(date +%Y-%m-%d_%H-%M-%S)

VAR_DIR=$(sanet-manage get_config DATA_DIR)
if [ ! "$?" -eq "0" ]; then
	echo "error"
	exit -1
fi


DEST_DIR="$VAR_DIR/current-config"
mkdir -p $DEST_DIR

#
# CLI 
#
DB_NAME=$(sanet-manage get_config DATABASE_NAME)

db_filename="$DEST_DIR/db.dump.$DATE"

echo "Dumping databse in in" $db_filename
pg_dump  -T '*.alarm' -T '*.event' -T '*.entables_alarm*'  -U postgres $DB_NAME > $db_filename

echo "Linkding $db_filename to $DEST_DIR/current-db-dump"
ln -fs  $db_filename  $DEST_DIR/current-db-dump
