import os
import sys

def png_file_replace_color(in_file_name, out_file_name, old_color, new_color):

	from PIL import Image

	img = Image.open(in_file_name)
	img = img.convert("RGBA")
	
	count = 0

	datas = img.getdata()
	new_data = []
	for rgba in datas:
		if rgba == old_color:
			rgba = new_color
			count += 1

		new_data.append(rgba)

	img.putdata(new_data)
	img.save(out_file_name, "PNG")
		
	return True

def STR_TO_RGBA(color_str):
	return (int(color_str[0:2],16), int(color_str[2:4],16), int(color_str[4:6],16), 255)	
	
if __name__ == "__main__":
	
	if len(sys.argv) < 4:
		print "usage: <input png file> <output file> <old RGB color> <new RGB color>"
		sys.exit(-1)
	
	file_name = sys.argv[1]
	file_out  = sys.argv[2]
	old_color = STR_TO_RGBA(sys.argv[3])
	new_color = STR_TO_RGBA(sys.argv[4])
	
	print file_name	, file_out, old_color, new_color

	png_file_replace_color(file_name, file_out, old_color, new_color)
