# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET3
# SANET3 is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.


if __name__ == "__main__":
	
	import os
	import sys
	
	reload(sys)
	sys.setdefaultencoding('UTF8')

	from sanet_poller.main import poller_main
	
	def _debug(*args):
		if os.environ.get('DEBUG', None) == "on":
			sys.stderr.write(' '.join([str(a) for a in args]))
	

	if len(sys.argv) < 3:
		print "usage: <sanet install dir> <options>"
		sys.exit(-1)

	sanet_install_dir = sys.argv[1]
	
	if not os.path.exists(sanet_install_dir):
		print "Invalid directory: %s" % (sanet_install_dir)
		sys.exit(-1)
	
	argv = sys.argv[2:]

	_debug("*** ATTENTION ***\n")
	_debug("*** ATTENTION ***\n")
	_debug("*** ATTENTION ***\n")
	_debug("You are launching the agent within the internal server wrapper.\n")
	_debug("*** ATTENTION ***\n")
	_debug("*** ATTENTION ***\n")
	_debug("*** ATTENTION ***\n")


	#
	# FIX: remove this switch
	#
	from sanet_poller.agent import BaseAgent
	from sanet_poller.agent_new_scheduler import BaseAgentAdvancedScheduling
	
	SANET_NO_SCHEDULINGGROUPS = os.environ.get('SANET_NO_SCHEDULINGGROUPS', False)
	if SANET_NO_SCHEDULINGGROUPS:
		Sanet3Agent = BaseAgent
	else:
		Sanet3Agent = BaseAgentAdvancedScheduling

	agent = Sanet3Agent()

	# FIX: disabled, buffering not working yet.
	#from sanet_poller.agent_new_buffered  import BufferedAgent
	#agent = BufferedAgent()

	_debug("SANET_INSTALL_DIR =", sanet_install_dir)
	_debug("Launching supervised poller with arguments", argv)

	poller_main(agent, argv)




