# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

import os
import time
import sys
import getopt
import logging
import threading
import json

from sanet_common.ipc import IPCConnection

#-----------------------------------------------------------------------------#
#                                                                             #
#-----------------------------------------------------------------------------#

def print_help():
	print 'program -B "<user>/<password>@<host>"  <queue name>  [ <json string>  ]'

def agent_ctl():

	opt_broker         = None
	opt_wait_ack       = False
	opt_wait_resp      = False
	argv = sys.argv

	try:
		opts, args = getopt.getopt(sys.argv[1:], "hB:I:wW")
		for o, a in opts:
			if   o in ("-h"):
				print_help()
				sys.exit(0)
			elif o in ("-B"):
				opt_broker = a
			elif o in ("-w"):
				print "pippo"
				opt_wait_ack = True
			elif o in ("-W"):
				opt_wait_resp = True
			else:
				print_help()
				sys.exit(0)

	except getopt.error, msg:
		print "Error while parsing options: %s" % msg
		print_help()
		sys.exit()
	except ValueError, ex:
		print "Invalid value for input parameter: %s" % ex
		print_help()
		sys.exit()

	queue_name = args[0]

	if len(args) > 1:

		data = args[1]
	
	else:
		data = sys.stdin.read()
		
	print "'%s'" % (data)
	
	
	host = None
	port = None
	user = None
	password = None
	
	auth, addr = opt_broker.split('@')
	user,password = auth.split('/')
	addr = addr.split(':')
	host = addr[0]
	if len(addr) > 1:
		port = int(addr[1])
	
	connect_options = {}
	if port     != None: connect_options['port']     = port
	if user     != None: connect_options['username'] = user
	if password != None: connect_options['password'] = password
	
	t0 = time.time()
	c = IPCConnection( host, **connect_options)
	
	c.open()
	
	c.bind("temp-sanettestclient-pid-%s" % (os.getpid()), persistent=False)
	
	
	request         = json.loads(data)
	
	t1 = time.time()
	
	request2        = json.dumps(request)
	
	#request = data
	c.send_msg( queue_name, request2, blocking=opt_wait_ack)
	
	if opt_wait_resp:
		addr, data = c.receive_msg(ack_msg=True)
		if addr != None:
			print "######################## RECEIVED FROM %s #######################" % (addr,)
			print data

	t2 = time.time()
	print "execution time", t2-t1

	c.close()


if __name__ == "__main__":

	agent_ctl()
