# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

if __name__ == "__main__":

	import os
	import sys

	#
	# Be sure django will find modules with the right path
	#
	sanet_install_dir = sys.argv[1]
	if not sanet_install_dir in sys.path:
		sys.path.insert(0, sanet_install_dir)

	os.environ.setdefault("DJANGO_SETTINGS_MODULE", "conf.settings")

	# Added for django 1.11
	import django
	django.setup()

	from django.conf import settings

	#
	# Be sure to load all signals from all APP's models.py file
	#
	for app in settings.INSTALLED_APPS:
		try:
			__import__('%s.models' % (app), {},{})
		except ImportError, e:
			pass


	#
	# INIT
	#

	from server.statusd.statusdserver import init_logger
	from server.statusd.statusdserver import StatusDServer

	log_level = settings.STATUSD_LOG_LEVEL
	log_file  = os.sep.join( [settings.LOG_DIR, 'statusd_log'])

	logger = init_logger(log_level, log_file)

	#
	# START
	#
	
	if sanet_install_dir != settings.SANET_INSTALL_DIR:
		msg = "Install dir %s is different from configuration install dir %s" % (sanet_install_dir, settings.SANET_INSTALL_DIR)
		print msg 
		logger.critical(msg)

	s = StatusDServer(logger)
	s.start()

	# never returns
