/**
 * Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
 * Created: 7/12/13, 5:31 PM
 * Author: Antonio Vaccarino
 */

// support (aux) components

lwpa= {};

// LWP TOOLBAR subwidget - not a widget in the actual sense but a generic component for other widgets

lwpa.Toolbar = function lwptb (destdiv, context)
{
    // will be passed as "this.context" on all bindings callbacks
    this.context = context;
    this.div = destdiv;
    this.reset();
};

lwpa.Toolbar.prototype.reset = function ()
{
    // remove controls:
    this.div.empty();
    this.controls = [];
};

lwpa.Toolbar.prototype.setControls = function (list)
{
    this.reset();
    for (var i = 0; i < list.length; i++)
    {

    }
};

lwpa.Toolbar.prototype.render = function ()
{

};

lwpa.Toolbar.prototype.makeControl = function (defdict, context)
{
    var srctype = typeof(defdict);
    var src = "("+srctype+") "+JSON.stringify(defdict);

    var allowed = ["string", "object"];
    if (allowed.indexOf(srctype)==-1)
    {
        throw ("Non valid datatype "+srctype+", need object");
    }
    if (srctype == "string")
    {
        try
        {
            defdict = JSON.parse(defdict);
        }
        catch (err)
        {
            console.trace();
            console.error("JSON parse error on "+src);
        }
    }

    var control = {};

    if (!defdict.hasOwnProperty('icon'))
    {
        throw ("Missing tool icon in definition "+src);
    }
    else
    {
        control.icon = defdict.icon;
    }

    if (!defdict['action'])
    {
        control.action = defdict['action'];
    }
    else
    {
        return null;
    }

    control.tip = defdict['tip'] ? defdict['tip'] : null;
    control.modal = defdict['modal'] === true;
    control.alwayson = defdict['alwayson'] === true;

    // todo: add check that it's a dictlike javascript object
    control.ctx = context;

    // all requirements use ctx as context
    if (defdict['reqs'] && defdict['reqs']['values'])
    {

    }






    return control;

};

lwpa.Toolbar.prototype.addControl = function (defdict)
{
    var control = this.makeControl(defdict);

};

