/**
 * Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
 * Created: 3/18/14, 2:26 PM
 * Author: Antonio Vaccarino
 */


alarmslist = {};

alarmslist.validate = function validate (data)
{
	// todo: placeholder, implement
};

alarmslist.emerge = function emerge ()
{
	var data = wcore.read.call(this, 'data');

	var mode = data['data']['type'];

	var wstate = wcore.getWstate.call(this);
	

	if (typeof(wstate) == 'undefined' || wstate == null || wstate['selected_mode'] != mode)
	{
		wcore.write.call(this, {}, 'retrieved');
		wcore.write.call(this, {}, 'vis_details');
		
		var WIDGET = $(this);

		$(document).on("alarmslist:change_priority_filter", { widget: WIDGET }, function(e, priority_level_name) {
			var widget_obj = e.data.widget;
			console.log("TRIGGERED " + priority_level_name);
			alarmslist.setLevelFilter.call(widget_obj, priority_level_name);
		});


	}

	//
	// Prepariamo i dati da mostrare nel rendering del widget
	//
	var model = {
		'base_url': data['resource_url'],
		'modes'   : data['modes'],
		'blocks'  : [],
		
		'show_all': data['show_all'],
		'priority_level': data['priority_level'],
		
		'enable_filters': (data['enable_filters']),
		'tag_filters': data['tag_filters'],
		'tag_filters_count': data['tag_filters_count']
	};

	var tot_rows = 0;
	for (var i = 0; i < data['data']['blocks'].length; i++)
	{
		var cblock = data['data']['blocks'][i];
		
		//console.log("Block "+i+": ",cblock);
		
		var tblock = {
			'title'   : cblock['title'],
			'rows'    : [],
			'is_last' : (i >= (data['data']['blocks'].length-1)),
			'has_rows': (cblock['rows'].length != 0)
		};
		
		
		for (var r = 0; r < cblock['rows'].length; r++)
		{
			tot_rows++;
			
			var crow = cblock['rows'][r];
			var trow = {};
			
			trow.condition_id = crow[0];
			trow.condition_title = crow[1];

			var alarmdate = alarmslist.extractDateTime(crow[2], true);
			trow.date = alarmdate['date'];
			trow.time = alarmdate['time'];

			trow.node_id = crow[3];
			trow.node_icon = crow[4];
			trow.node_name = crow[5];
			
			if (crow[3] != crow[6]) {
				trow.sub_id   = crow[6];
				trow.sub_icon = crow[7];
				trow.sub_name = crow[8];
			}
			else {
				trow.sub_id   = undefined;
				trow.sub_icon = undefined;
				trow.sub_name = undefined;
			}
			
			trow.has_notes = crow[9] ? alarmslist.CLASS_HASNOTE : "";
			trow.type      = crow[10];
			
			trow.current_state = crow[11]
			trow.priority      = crow[12]
			
			tblock['rows'].push(trow);
		}
		model['blocks'].push(tblock);
	}

	//
	// Salviamo lo stato corrente del widget
	//
	var short_view     = data['short_view_limit'] >= tot_rows;
	var show_all       = data['show_all'];
	var priority_level = data['priority_level'];
	wcore.setWstate.call(this, {
		"selected_mode" : mode, 
		"short_view"    : short_view,
		"show_all"      : show_all,
		"priority_level": priority_level,
	});


	model['can_expand'] = data['tot_alarms'] > tot_rows;
	model['can_shrink'] = data['short_view_limit'] < tot_rows;

	can_edit = (data['get_tag_filters_url'] != undefined && data['get_tag_filters_url'] != null && data['get_tag_filters_url'] != '');

	console.log("CAN EDIT " + can_edit);

	model['can_edit_filters'] = can_edit;

	wcore.write.call(this, model, 'model');
};

alarmslist.extractDateTime = function (timestamp, convertSecStamp)
{
	if (convertSecStamp===true) {
		timestamp = wcore.aux.sec2msec(timestamp);
	}

	var date = typeof(timestamp) == 'number' ? new Date(timestamp) : timestamp;

//	var tz = date.getTimezoneOffset();
//	var timezonemod = tz > 0 ? "-" : "+";
//	var timezonehours = Math.abs(Math.round(tz / 60));
//	timezonehours = timezonehours < 10 ? "0"+timezonehours : timezonehours;
//	var timezonemins = tz % 60 == 0 ? "00" : "30";
//	var timezonestring = ""+timezonemod+""+timezonehours+""+timezonemins;

	var time_monthday = date.getDate();
	//console.log(typeof time_date);
	if (time_monthday < 10) { time_monthday = "0"+time_monthday; }
	var time_month = date.getMonth()+1;
	if (time_month < 10) { time_month = "0"+time_month; }
	
	var time_hours = date.getHours();
	if (time_hours<10) { time_hours = "0"+time_hours; }
	
	var time_mins = date.getMinutes();
	if (time_mins<10) { time_mins = "0"+time_mins; }
	
//	var time_secs = date.getSeconds();
//	if (time_secs<10) { time_secs = "0"+time_secs; }

	var datestring = date.getFullYear()+"-"+time_month+"-"+time_monthday;
	var timestring = time_hours+":"+time_mins;

	return {
		date: datestring,
		time: timestring
	}

};

alarmslist.CLASS_MODE_BUTTONS = "jswlib2_al_modebuttons";
alarmslist.CLASS_MODE_BUTTON  = "jswlib2_al_modebutton";

alarmslist.CLASS_ALARMTABLE   = "jswlib2_al_altable";
alarmslist.CLASS_ALARMROW     = "jswlib2_al_alrow";
alarmslist.CLASS_ALARMCELL     = "jswlib2_al_alcell";
alarmslist.CLASS_ALARMDETAILS = "jswlib2_al_aldetails";

// cells that need to take as much space as possible
alarmslist.CLASS_WIDE         = "jswlib2_al_widecell";
// other cells need to take as little as possible WITHOUT wrapping on two lines
alarmslist.CLASS_NOWRAP       = "jswlib2_al_unbreakable";

alarmslist.CLASS_FOLDBUTTON   = "jswlib2_al_foldbutton";
alarmslist.PREFIX_FOLDBUTTON  = "jswlib2_al_btn_";
alarmslist.CLASS_SUBFOLD      = "jswlib2_al_subfold";
alarmslist.PREFIX_SUBFOLD     = "jswlib2_al_sub_";
alarmslist.CLASS_HASNOTE      = "jswlib2_al_hasnote";

alarmslist.FOLDBUTTON_OPEN    = "chevron-down";
alarmslist.FOLDBUTTON_CLOSE   = "chevron-up";

alarmslist.ICON_NOTE = "file-text-o";

alarmslist.wrender = function wrender()
{
	var WIDGET = this;
	
	wcore.async.unlock.call(WIDGET);

	//
	// Cancelliamo il contenuto precedente
	//
	var display = wcore.getDisplay.call(WIDGET);
	display.empty();
	
	//
	// Carichiamo i dati
	//
	var model = wcore.read.call(WIDGET, 'model');

	// NOTE: some colspan are forced to keep the col number consistent with future versions

	var template = '\
	<div> \
		\
		<br />\
		\
		{{#enable_filters}}\
		<div class="alarm_tag_filters"> \
			<table class="jswlib2_al_altable" style="border: 1px solid #aaaaaa" > \
				<tr  class="jswlib2_al_alrow"> \
					<th width="100%"> \
						' + "Filters " + '(<span class="tag_filters_count">{{tag_filters_count}}</span>)\
					</th> \
					<th> \
						<span class="alarm_tag_filter_close_button"> \
							<i class="fa fa-chevron-down"></i> \
						</span> \
					</th> \
				</tr> \
				<tr name="alarm_tag_filters_body"> \
					<td colspan="2"> \
						<table cellpadding=0 cellspacing=0 border=0 width="100%"> \
							<tr> \
								{{#can_edit_filters}} \
								<td align="center" valign="middle" width=1> \
									<div style="display: inline-block; width: 40px"> \
										<button class="gui-button gui-gradient   add_tag_filter_button" title="' + 'Add new filter' + '" style=""> \
											<span class="icon-plus"></span> \
										</button> \
									</div> \
								</td> \
								{{/can_edit_filters}} \
								<td> \
									<table class="filterd_tags_table" style="font-size: 10px;" border="0" cellpadding=0 cellspacing=0  width="100%"> \
										{{#tag_filters}} \
											<tr id="tagfilter_{{uuid}}" class="tag_filter_row"> \
												<td class="gui-row" align="left"> \
													<span title="Tree: {{tree}}"> \
														{{path}} {{#owner}}( {{owner}} ){{/owner}}\
													</span> \
												</td> \
												{{#can_edit_filters}} \
												<td width="1"> \
													<button class="gui-button gui-gradient remove_tag_filter_button" title="' + 'Remove' + '" filter_id="{{uuid}}"> \
														<span style="font-size: 8px" class="icon-minus"></span> \
													</button> \
												</td> \
												{{/can_edit_filters}} \
											</tr> \
											\
										{{/tag_filters}} \
									</table> \
								</td> \
							</tr> \
						</table> \
					</td> \
				</tr> \
			</table> \
		</div> \
		\
		<br /> \
		{{/enable_filters}}\
		\
		<div id="alarm_list_buttons" class="'+alarmslist.CLASS_MODE_BUTTONS+'"> \
			<table width="100%"> \
				<tr> \
				{{#modes}} \
					<td> \
						<div data-type="{{type}}" title="{{descr}}" class="'+alarmslist.CLASS_MODE_BUTTON+'"> \
							<i class="fa fa-fw fa-{{icon}}"/> \
						</div> \
					</td> \
				{{/modes}} \
					<td valign="middle" align="center"> \
						\
						<div title="Show alarms below the minimum priority level" style="display: inline-block; width: 16px; height:16px; border-radius: 10px; background-color: yellow; border: 1px solid yellow; color: black; font-weight:bold; text-align:center; text-valign:middle"> \
							<i class="icon-eye-close"></i> \
						</div> \
						\
						{{#priority_level}} \
							<input name="show_all_button" type="checkbox" {{#show_all}}checked="checked"{{/show_all}} disabled="disabled" /> \
						{{/priority_level}} \
						\
						{{^priority_level}} \
							<input name="show_all_button" type="checkbox" {{#show_all}}checked="checked"{{/show_all}} /> \
						{{/priority_level}} \
					</td> \
				</tr> \
				<tr> \
				{{#modes}} \
					<td> \
						<span style="font-size: x-small">{{descr}}</span> \
					</td> \
				{{/modes}} \
					<td> \
						<span style="font-size: x-small">Show ignored alarms</span>\
					</td> \
				</tr> \
			</table> \
		</div> \
		\
		<table class="'+alarmslist.CLASS_ALARMTABLE+'" width="100%">\
			{{#blocks}}\
				<tr>\
					<th colspan=8>{{title}}</th>\
				</tr>\
				{{#has_rows}} \
					<tr class="'+alarmslist.CLASS_ALARMROW+'"> \
						<th> Status  </th> \
						<th> Priority</th> \
						<th colspan=2> Time    </th> \
						<th> Element </th> \
						<th> Title   </th> \
						<th> </th> \
						<th> </th> \
					<tr> \
				{{/has_rows}} \
				{{#rows}}\
					<tr class="'+alarmslist.CLASS_ALARMROW+'">\
						<td width="1" class="'+alarmslist.CLASS_ALARMCELL+' '+'jswlib2_al_border' + ' '+alarmslist.CLASS_NOWRAP+'"> \
							<span class="state-box bg-{{current_state}}" dataref="{{condition_id}}">{{current_state}}</span> \
						</td>\
						<td width="1" class="'+alarmslist.CLASS_ALARMCELL+' '+'jswlib2_al_border' + ' '+alarmslist.CLASS_NOWRAP+'"> {{priority}} </td> \
						<td width="1" class="'+alarmslist.CLASS_ALARMCELL+' '+'jswlib2_al_border' + ' '+alarmslist.CLASS_NOWRAP+'"> {{date}} </td>\
						<td width="1" class="'+alarmslist.CLASS_ALARMCELL+' '                          +alarmslist.CLASS_NOWRAP+'"> {{time}} </td> \
						<td width="1" class="'+alarmslist.CLASS_ALARMCELL+' '+'jswlib2_al_border' + ' '+alarmslist.CLASS_NOWRAP+'"> <a href="{{base_url}}/node/{{node_id}}" target="_blank">{{node_name}}</a>{{#sub_name}}:<a href="{{base_url}}/{{type}}/{{sub_id}}" target="_blank">{{sub_name}}</a>{{/sub_name}} </td> \
						<td width=""  class="'+alarmslist.CLASS_ALARMCELL+' '+'jswlib2_al_border'+'"                              > <a href="{{base_url}}/node/{{node_id}}" target="_blank"> {{condition_title}} </a>  </td>\
						<td width=""  class="{{has_notes}} '+alarmslist.CLASS_NOWRAP+'"                                           > </td>\
						<td width="1" data-ref="{{condition_id}}" id="'+alarmslist.PREFIX_FOLDBUTTON+'{{condition_id}}" class="'+alarmslist.CLASS_ALARMCELL+' '+'jswlib2_al_border' + ' '+alarmslist.CLASS_FOLDBUTTON+' '+alarmslist.CLASS_NOWRAP+'"> </td>\
					</tr>\
					<tr data-ref="{{condition_id}}" class="'+alarmslist.CLASS_SUBFOLD+" "+'jswlib2_al_alrow_details'+'"   {{#last}}{{/last}}    >\
						<td data-ref="{{condition_id}}" class="'+alarmslist.CLASS_ALARMDETAILS+'" id="'+alarmslist.PREFIX_SUBFOLD+'{{condition_id}}" colspan=8> \
						</td>\
					</tr>\
				{{/rows}}\
				{{^rows}}\
					<tr class="'+alarmslist.CLASS_ALARMROW+'  jswlib2_al_alrow_no_alarms">\
						<td colspan=8 align="center"> no alarms </td>\
					</tr>\
				{{/rows}}\
				 \
				{{^is_last}} \
					<tr>\
						<td class="jswlib2_al_alrow_last" colspan=8 align="center"> &nbsp; </td>\
					</tr>\
				{{/is_last}} \
			{{/blocks}}\
			{{^blocks}}\
				<tr>\
					<td colspan=8 align="center"> \
						No data to show.  \
						<br> \
						(check your custom filters) \
					</td> \
				</tr>\
			{{/blocks}}\
		</table>\
	</div>\
	';
	
	var html = Mustache.to_html(template, model);
	var div = $(html);

	var WIDGET = this;


	//
	// PANNELLO (TABELLA) FILTRI TAG
	//
	
	// Pulsante dropdown
	btn = div.find('.alarm_tag_filter_close_button');
	btn.bind('click', { div: div }, function(e) {

		panel = e.data.div.find('[name=alarm_tag_filters_body]');
		
		console.log(WIDGET.alarm_tag_filters);

		var alarm_tag_filters = wcore.read.call(WIDGET, 'alarm_tag_filters');
		
		if (alarm_tag_filters == false) {
			panel.show();
			wcore.write.call(WIDGET, true, 'alarm_tag_filters');
		}
		else {
			panel.hide();
			wcore.write.call(WIDGET, false, 'alarm_tag_filters');
		}
	});	
	
	var alarm_tag_filters = wcore.read.call(WIDGET, 'alarm_tag_filters');
	if (alarm_tag_filters == undefined) {
		 wcore.write.call(WIDGET, false, 'alarm_tag_filters');
	}
	if (wcore.read.call(WIDGET, 'alarm_tag_filters') == false) {
		div.find('[name=alarm_tag_filters_body]').hide();
	}
	
	
	
	
	
	
	
	function add_events(WIDGET, element) {

		var widget_config = wcore.read.call(WIDGET)['data'];
		var url = widget_config['remove_tag_filter_url'];

		element.bind('click', { widget: WIDGET, filter_id: element.attr('filter_id') }, function(e) {

			var params = {
				lock  : true,
				silent: false,
				success_callback: function() {
					console.log("SUCCESS. Deleting " + e.data.filter_id);
					$('#tagfilter_' + e.data.filter_id).remove();
					
					var display = wcore.getDisplay.call(WIDGET);
					
					var count = $('.tag_filter_row', display).length;
					console.log( count );
					$('.tag_filters_count', display).empty().append( count );

					alarmslist.refresh.call(WIDGET);
				},
				error_callback  : function() {
					console.log("ERROR");
				}
			};

			wcore.async.ajax_json.call(WIDGET, url, { uuid: e.data.filter_id } , params);
		})
	}
	
	btn = div.find('.add_tag_filter_button');
	btn.bind('click', { widget: this, div: div}, function(e) {
		
		var widget = e.data.widget;
		var div    = e.data.div;
		var btn = $(this);
		var data = wcore.read.call(widget)['data'];
		var url = data['get_tag_filters_url'];
		
		var add_tag_filter_url = data['add_tag_filter_url'];
		
		var params = {
			lock  : false,
			silent: false,
			success_callback: function(data) {
				console.log("SUCCESS" + data);
				
				filters_list_div = $('<div>');

				var TEMPLATE = " \
				<table width='100%'>  \
				{{#data}} \
					<tr> \
						<td> \
							<input id='tagtree_{{uuid}}' type='checkbox' name='uuid' value='{{uuid}}'  {{#filtered}}checked='checked'{{/filtered}} />  \
						</td> \
						<td class='tagtreelabel'  ref='tagtree_{{uuid}}'> \
							<span title='Tree: {{tree}}'> \
							{{path}} {{#owner}}( {{owner}} ){{/owner}}\
							</span> \
						<td> \
					</tr> \
				{{/data}} \
				</table> \
				";

				var selectable_tags = Mustache.to_html(TEMPLATE, data);
				var selectable_tags = $(selectable_tags);
				
				$('.tagtreelabel', selectable_tags).bind('click', function(e) {
					var l = $(this);
					var b = $( '#' + l.attr('ref') );
					if (b.attr('checked') != 'checked')
						b.attr('checked', 'checked');
					else
						b.removeAttr('checked');
				});
				
				
				filters_list_div.append(selectable_tags);

				filters_list_div.dialog({
					title: 'Exclude tags',
					buttons : {
						Ok: function() {

							var url = add_tag_filter_url;
							
							var uuids = new Array();
							selectable_tags.find('input:checked').each(function(i,e){ 
								uuids.push($(e).attr('value'));
							});

							$(this).dialog("close");

							if (uuids.length == 0)
								return;
							
							console.log("SELECTED: " + uuids);

							request_data = {
								'uuid': uuids.join("|") 
							}							
							settings  = {
								lock  : true,
								silent: false,
								success_callback: function(response_data) {
									
									filters_list_div.dialog('close');
									
									console.log(response_data['data'].length);
									for (var i=0; i < response_data['data'].length; i++) {
										
										var filter_id = response_data['data'][i]['uuid'];
										var label     = response_data['data'][i]['path'];
										var created   = response_data['data'][i]['created'];
										
										if (created == false)
											continue;
											
										
										console.log("OK" + response_data);
										
										filter_entry_div = $('\
											<tr id="tagfilter_'+ filter_id + '"   class="tag_filter_row"> \
												<td>' + label + '</td> \
												<td width="1"> \
													<button class="gui-button gui-gradient remove_tag_filter_button" title="Remove" filter_id="'+filter_id+'" > \
														<span style="font-size: 8px"  class="icon-minus"></span> \
													</button> \
												</td> \
											</tr> \
										');
										
										console.log("3");
										element = filter_entry_div.find('.remove_tag_filter_button').each(function(i, element){
											add_events(widget, $(element));
										});
										
										console.log("4");
										
										table_div = div.find('.filterd_tags_table');
										table_div.append(filter_entry_div);
										
										
										var count = $('.tag_filter_row', display).length;
										console.log( count );
										$('.tag_filters_count', display).empty().append( count );
										
										
										alarmslist.refresh.call(WIDGET);
									}

									NS.ShowFadeMessage("Done");
									
								},
								error_callback: function(data) {
									console.log("ERROR" + data);
								}								
							}		
							wcore.async.ajax_json.call(widget, url, request_data, settings);
						}
					}
				});
				filters_list_div.show();
				
			},
			error_callback  : function() {
				console.log("ERROR");
			}
		};

		wcore.async.ajax_json.call(widget, url, {}, params);
	});

	div.find('.remove_tag_filter_button').each(function(i, element) {
		add_events(WIDGET, $(element));
	});
	


	//
	// TABELLA ALLARMI
	//

	//foldbutton = bottone dentro la tabella per vedere le info dell'elemento
	var foldbutton = wcore.aux.renderFA(alarmslist.FOLDBUTTON_OPEN);
	var notesicon = wcore.aux.renderFA(alarmslist.ICON_NOTE);
	div.find("."+alarmslist.CLASS_FOLDBUTTON).append(foldbutton);
	div.find("."+alarmslist.CLASS_HASNOTE).append(notesicon);

	var details_url = wcore.read.call(this, 'data')['details_url'];

	var i, cond_id, cbutton, cmode;

	var all_foldbuttons = div.find("."+alarmslist.CLASS_FOLDBUTTON+">i");
	all_foldbuttons.bind('click', {widget: this, url: details_url}, alarmslist.openAlarmsDetails);

	var all_modebuttons = div.find("."+alarmslist.CLASS_MODE_BUTTON);
	all_modebuttons.bind('click', {widget: this}, alarmslist.switchMode);
	var current_mode = wcore.getWstate.call(this)['selected_mode'];
	
	

	for (i = 0; i < all_modebuttons.length; i++)
	{
		cbutton = $(all_modebuttons[i]);
		cmode = cbutton.data("type");
		if (current_mode == cmode)
		{
			cbutton.addClass(alarmslist.CLASS_MODE_BUTTON+"_selected");
		}
	}

	/*
	var all_sub = div.find("."+alarmslist.CLASS_SUBFOLD);
	all_sub.hide();
	// pre-retrieved stuff: note that fills but not reopens for now
	var retrieved       = wcore.read.call(this, 'retrieved');
	
	var visible_details = wcore.read.call(this, 'vis_details');

//	console.log("Pre-retrieved: ",retrieved," pre-visible: ",visible_details);

	
	for (i = 0; i < all_sub.length; i++) {
		var csub = $(all_sub[i]);
		var cond_id = csub.data("ref");
		
		if (retrieved.hasOwnProperty(cond_id)) {
			csub.find('td').empty().append(retrieved[cond_id]);
		}
	}
	
	for (i = 0; i < all_foldbuttons.length; i++) {
		cbutton = $(all_foldbuttons[i]);
		
		var ctd     = cbutton.closest('td');
		var cond_id = ctd.data("ref");
		
		if (visible_details[cond_id] === true) {
			cbutton.click();
		}
	}
	*/

	var show_all_button = div.find('input[name="show_all_button"]');
	show_all_button.bind('click', {widget: this}, alarmslist.toggleShowAllConditions ); 
	
	
	var refresh_buttons = div.find('.state-box');
	refresh_buttons.bind('click', {widget: this}, function(e) {


		e.preventDefault();

		var widget = e.data.widget;

		var button = $(e.target)

		var widget_config = wcore.read.call(widget)['data'];

		
		var condition_id = button.attr('dataref'); 
		
		var url = widget_config['check_condition_url'];
		if (url != null  && url != undefined)  {
				console.log(condition_id);
				console.log(widget_config);
				
				var params = {
					lock  : false,
					silent: false,
					success_callback: function(data) {
						console.log("SUCCESS. Deleting " + data);
						//$('#tagfilter_' + e.data.filter_id).remove();
						//
						//var display = wcore.getDisplay.call(WIDGET);
						//
						//var count = $('.tag_filter_row', display).length;
						//console.log( count );
						//$('.tag_filters_count', display).empty().append( count );
                                                //
						//alarmslist.refresh.call(WIDGET);
						
						var parent = button.parent();
						
						parent.empty();
						parent.append('<div><i class="icon-spinner icon-spin icon-large"></i><div>');
					},
					error_callback  : function(data) {
						alert("An error occcurred: " + data['info']);
					}
				};

				wcore.async.ajax_json.call(WIDGET, url, { uuid: condition_id } , params);			
			
		
		}
		return false;
	}); 
	
	//function(ev) {
	//	("ok");
	//	alarmslist.toggleShowAllConditions(ev);
	//});



	// setting expanders
	var expander;
	
	if (model['can_expand']) {
//		console.log("Widget can expand to more lines");
		expander = wcore.aux.renderExpander.call(this, wcore.CONST.EXPANDER_SIDE_CENTER, alarmslist.getLongView, null, null, "Show more alarms", "jsw2_expander_btn_red");
	}
	else if (model['can_shrink']) {
//		console.log("Widget can shrink to less lines");
		expander = wcore.aux.renderExpander.call(this, wcore.CONST.EXPANDER_SIDE_CENTER, null, alarmslist.getShortView, true);
	}
	
	if (expander) {
		div.append(expander);
	}


	display.append(div);
	
	
	

	

};

alarmslist.getLongView = function (button)
{
	var widget = this;
	var current_state = wcore.getWstate.call(widget);
	
	var req_mode       = current_state['selected_mode'];
	var short_view     = false
	var show_all       = current_state['show_all'];
	var priority_level = current_state['priority_level'];


	wcore.async.lock.call(this);
	wcore.update.call(this, {"short_view": short_view, "selected_mode": req_mode, "show_all": show_all, 'priority_level': priority_level}, true);
};

alarmslist.getShortView = function (button)
{
	var widget = this;
	var wstate = wcore.getWstate.call(widget);

	var current_state   = wstate['show_all'];

	var req_mode       = current_state['selected_mode'];
	var short_view     = true
	var show_all       = current_state['show_all'];
	var priority_level = current_state['priority_level'];
	
	wcore.async.lock.call(this);
	wcore.update.call(widget, {"short_view": short_view, "selected_mode": req_mode, "show_all": show_all, 'priority_level': priority_level}, true);
};

alarmslist.switchMode = function (ev)
{
	var req_mode = $(this).data('type');
	var widget = ev.data.widget;

	var current_state = wcore.getWstate.call(widget);
	
	var short_view     = current_state['short_view'];
	var show_all       = current_state['show_all'];
	var priority_level = current_state['priority_level'];

	wcore.async.lock.call(widget);
	wcore.update.call(widget, {"short_view": short_view, "selected_mode": req_mode, "show_all": show_all, 'priority_level': priority_level}, true);
};

alarmslist.setLevelFilter = function (priority_level)
{
	var widget = $(this);

	var current_state = wcore.getWstate.call(widget);
	
	var short_view = current_state['short_view'];
	var show_all   = current_state['show_all'];
	var req_mode   = current_state['selected_mode'];

	wcore.async.lock.call(widget);
	wcore.update.call(widget, {"short_view": short_view, "selected_mode": req_mode, "show_all": show_all, 'priority_level': priority_level}, true);
};

alarmslist.refresh = function ()
{
	var widget = $(this);

	var current_state = wcore.getWstate.call(widget);
	
	var short_view     = current_state['short_view'];
	var req_mode       = current_state['selected_mode'];
	var show_all       = current_state['show_all'];
	var priority_level = current_state['priority_level'];

	wcore.async.lock.call(widget);
	wcore.update.call(widget, {"short_view": short_view, "selected_mode": req_mode, "show_all": show_all, 'priority_level': priority_level}, true);
};


alarmslist.toggleShowAllConditions = function (ev)
{
	var req_mode = $(this).data('type');
	var widget = ev.data.widget;

	var current_state = wcore.getWstate.call(widget);

	var short_view     = current_state['short_view'];
	var req_mode       = current_state['selected_mode'];
	var show_all       = current_state['show_all'];
	var priority_level = current_state['priority_level'];
	
	if (show_all != true)
		show_all = true;
	else
		show_all = false;
	
	//show_all = $(ev.target).is(':checked');
		
	
	wcore.async.lock.call(widget);
	wcore.update.call(widget, {"short_view": short_view, "selected_mode": req_mode, "show_all": show_all, 'priority_level': priority_level}, true);
};



alarmslist.openAlarmsDetails = function (ev)
{
	var caller = $(this);

	var widget = ev.data.widget;

	console.log("alarmslist.openAlarmsDetails");
	
	wcore.blockAutorefresh.call(widget);

	var target = caller.closest('tr').next('tr');
	var cond_id = caller.closest('td').attr('id').substr(alarmslist.PREFIX_FOLDBUTTON.length);


	// Abbiamo gia' scaricato i dettagli? 
	var retrieved = wcore.read.call(widget, 'retrieved');
	if (!retrieved.hasOwnProperty(cond_id))	{

		var url = ev.data.url;
		var ajaxparams = {
			custom: true,
			silent: true,
			lock: false,
			//content: "text/html",
			content: "application/x-www-form-urlencoded", //content: "text/html",  do not work anymore with django 1.11
			callback: alarmslist.showAlarmDetails
		};
		
		data = { 
			"uuid": cond_id 
		};
		wcore.async.ajax.call(widget, url, data, ajaxparams);
	}
	else {
		// already retrieved
		var subfold = $(widget).find("#"+alarmslist.PREFIX_FOLDBUTTON+cond_id);
		subfold.empty();
		
		var foldbutton = wcore.aux.renderFA(alarmslist.FOLDBUTTON_CLOSE);
		foldbutton.bind('click', {widget: widget, subdiv: target}, alarmslist.closeAlarmDetails);
		
		subfold.append(foldbutton);
		target.show();

		var visible_details = wcore.read.call(widget, 'vis_details');
		visible_details[cond_id] = true;
	}
};

alarmslist.showAlarmDetails = function (data, req_data)
{
	var cond_id = req_data['uuid'];
	var rawhtml = data;
	
	//console.log("Retrieved alarm details ",rawhtml," from ",req_data," in w ",this);

	var subdiv = $(this).find("#"+alarmslist.PREFIX_SUBFOLD+cond_id);
	
	//console.log("Rendering to subdiv ",subdiv);
	
	// changing button
	var subfold = $(this).find("#"+alarmslist.PREFIX_FOLDBUTTON+cond_id);
	subfold.empty();
	
	var foldbutton = wcore.aux.renderFA(alarmslist.FOLDBUTTON_CLOSE);
	foldbutton.bind('click', {widget: this, subdiv: subdiv}, alarmslist.closeAlarmDetails);
	subfold.append(foldbutton);

	subdiv.append(rawhtml);
	subdiv.closest('tr').show();

	var retrieved = wcore.read.call(this, 'retrieved');
	retrieved[cond_id] = rawhtml;
	
	var visible_details = wcore.read.call(this, 'vis_details');
	visible_details[cond_id] = true;
};

alarmslist.closeAlarmDetails = function (ev)
{
	var widget = ev.data.widget;
	var subdiv = ev.data.subdiv;

	var cond_id = subdiv.data('ref');

	$(subdiv).closest('tr').hide();

	var foldbutton = wcore.aux.renderFA(alarmslist.FOLDBUTTON_OPEN);
	var details_url = wcore.read.call(widget, 'data')['details_url'];
	var subfold = $(this).closest('td');
	
	subfold.empty().append(foldbutton);

//	console.log("Rebinding opener w params ",widget," and ",details_url);
	foldbutton.bind('click', { widget: widget, url: details_url }, alarmslist.openAlarmsDetails);

	var visible_details = wcore.read.call(widget, 'vis_details');
	visible_details[cond_id] = false;
};


// saving all widgets to library for finalization and use

WDS.wlib['alarmslist'] = alarmslist;





				/*
				for (var i=0; i < data['data'].length; i++) {

	

					var entry = $("""\
					<div uuid='"""+data['data'][i]['uuid']+"' class='gui-button gui-gradient' style='width: 100%' >"+ data['data'][i]['path'] + "
					</div>
					""");
					
					entry.bind('click', { entry: entry }, function(e) {

						var url = add_tag_filter_url;

						request_data = {
							'uuid': e.data.entry.attr('uuid')
						}

						settings  = {
							lock  : false,
							silent: false,
							success_callback: function(response_data) {
								
								filters_list_div.dialog('close');
								
								NS.ShowFadeMessage("Added");
								
								var filter_id = response_data['data']['uuid'];
								var label     = response_data['data']['path'];
								var created   = response_data['data']['created'];
								
								if (created == false)
									return;
									
								
								console.log("OK" + response_data);
								
								filter_entry_div = $('\
									<tr id="tagfilter_'+ filter_id + '"   class="tag_filter_row"> \
										<td>' + label + '</td> \
										<td width="1"> \
											<button class="gui-button gui-gradient remove_tag_filter_button" title="Remove" filter_id="'+filter_id+'" > \
												<span style="font-size: 8px"  class="icon-minus"></span> \
											</button> \
										</td> \
									</tr> \
								');
								
								console.log("3");
								element = filter_entry_div.find('.remove_tag_filter_button').each(function(i, element){
									add_events(widget, $(element));
								});
								
								console.log("4");
								
								table_div = div.find('.filterd_tags_table');
								table_div.append(filter_entry_div);
								
								
								var count = $('.tag_filter_row', display).length;
								console.log( count );
								$('.tag_filters_count', display).empty().append( count );
							},
							error_callback: function(data) {
								console.log("ERROR" + data);
							}
						}

						wcore.async.ajax_json.call(widget, url, request_data, settings);
					});

					filters_list_div.append(entry);
				}
				*/
