var badgeview = {};

var OPEN_TEMPLATE = '\
	<div id="{{id}}" \
	     sid="{{sid}}" \
	     class="badge open-badge {{type}} {{#droppable}}data-droppable{{/droppable}} {{#events_enabled}}badge-active{{/events_enabled}}" \
	     style="width: 100%" \
	     json_state="{{json_state}}" \
	     \
	     parent_tag_id="{{parent_tag_id}}" \
	> \
		<table class="border-{{status}}" \
		       style="width: 100%; border-width: 4px; border-style: solid; border-radius: 10px; padding: 4px; cursor: pointer" \
		> \
			<tr> \
				<td valign="top"> \
					<img style="width:24px; height:24px;" src="{{icon}}"> \
					<span style="font-weight:bold; font-size:24px"> {{name}} </span> \
					\
					<button class="gui-button jswlib2_badge_link" href="{{url}}" target="_blank"> \
						<i class="icon-share" /> \
					</button> \
				</td>  \
				<td valign="top" width=1>  \
					<table width="100%" style="background-color: white; border-collapse:collapse; border-top: 1px solid black; border-bottom: 1px solid black; border-left: 1px solid black; border-right: 1px solid black; "> \
						<tbody> \
							<tr> \
								{{#levels}} \
								<th align="center" width="20,0%" style="border-bottom: 1px solid gray;"> \
										{{title}} \
								</th> \
								{{/levels}} \
							</tr> \
							<tr> \
								{{#levels}} \
								<td align="center" style="border-left: 1px solid gray; {{#count}}color:red; font-weight:bold;{{/count}} "   > \
										{{count}} \
								</td> \
								{{/levels}} \
							</tr> \
						</tbody> \
					</table> \
				</td>  \
			<tr>  \
			<tr>  \
				<td colspan=2>  \
					##SUB## \
				</td>  \
			<tr>  \
		</table>  \
	</div> \
';


var BADGE_TEMPLATE = '\
		<div id="{{id}}" \
		     sid="{{sid}}" \
		     \
		     json_state="{{json_state}}" \
		     \
		     parent_tag_id="{{parent_tag_id}}" \
		     url="{{url}}" \
		     \
		     element_tag="{{element_tag}}"\
		     \
		     class="badge closed-badge  {{type}} {{#droppable}}data-droppable{{/droppable}}  {{#events_enabled}}badge-active{{/events_enabled}}  jswlib2_badge_badge w-4 h-2 " \
		     style="margin: 2px; {{#events_enabled}}cursor:pointer;{{/events_enabled}}" \
		> \
			<div class="jswlib2_badge_sub jswlib2_badge_quickview" style=""> \
			\
				<img title="{{ status_info }}"class="jswlib2_badge_icon" src="{{icon}}"> \
				\
				{{#alarms}} \
					<div class="jswlib2_badge_issues" title="There are {{alarms}} alarm(s) inside this element">  \
						{{alarms}}  \
					</div> \
				{{/alarms}} \
			</div> \
			\
			<div class="jswlib2_badge_spacer jswlib2_badge_sub"> \
			</div> \
			\
			<div class="jswlib2_badge_sub jswlib2_badge_details"> \
				\
				<div class="jswlib2_badge_nametag"> \
					\
					<span class="jswlib2_badge_name_title jswlib2_badge_name_text"> \
						{{name}} \
						<wbr></wbr> \
					</span> \
					<br> \
					<span class="jswlib2_badge_name_description jswlib2_badge_name_text"> \
						{{description}} \
					</span> \
					\
					<button class="gui-button jswlib2_badge_link" href="{{url}}" target="_blank"> \
						<i class="fa fa-external-link "></i> \
					</button> \
					\
					<!-- \
					<button class="gui-button jswlib2_badge_link " href="{{url}}#map" target="_blank"> \
						<i class="fa fa-code-fork"> </i> \
					</button> \
					\
					<button class="gui-button jswlib2_badge_link " href="{{url}}#geo" target="_blank"> \
						<i class="fa fa-globe"></i> \
					</button> \
					--> \
					\
					{{#section_urls}} \
						<button class="gui-button jswlib2_badge_link " href="{{url}}" target="_blank"> \
							<i class="fa {{icon}}"> </i> \
						</button> \
					{{/section_urls}} \
					\
					\
					{{#can_force_reload}} \
					<button class="gui-button refresh_state" url="{{reload_state_url}}?elementtype={{type}}&elementid={{id}}"> \
						<i class="icon-refresh"></i> \
					</button> \
					{{/can_force_reload}} \
					\
					\
				</div> \
				\
				{{#tag}} \
					<div class="gui-button jswlib2_delete_link icon-wrench" data-jq-dropdown="#jq-dropdown-tag" tag_uuid = "{{sid}}"> \
					</div> \
					<div id="can_edit-{{id}}"        style="display:none;">{{can_edit}}</div> \
					<div id="user_can_rename-{{id}}" style="display:none;">{{user_can_rename}}</div> \
					<div id="user_can_delete-{{id}}" style="display:none;">{{user_can_delete}}</div> \
				{{/tag}} \
				{{^tag}} \
					{{#can_untag}} \
						<div class="gui-button jswlib2_delete_link" title="Untag this element"> \
							<i class="fa fa-times "></i> \
						</div> \
					{{/can_untag}} \
					{{^can_untag}} \
						<div class="gui-button jswlib2_delete_link gui-disabled" title="You are not allowed to change tagging for this element"> \
							<i class="fa fa-times "></i> \
						</div> \
					{{/can_untag}} \
				{{/tag}} \
				\
			</div> \
			\
			{{#icon_overlay}} \
				<img class="jswlib2_badge_warn " \
				     src="{{icon_overlay}}" \
				     style="{{#events_enabled}}cursor:pointer;{{/events_enabled}}" \
				     title="{{ status_info }}"> \
			{{/icon_overlay}} \
		</div> \
';



function add_badge_actions(current_element, widget) 
{
	current_element.find('.jswlib2_badge_link').each( function(i) { 
		$(this).click ( {widget: widget}, function(ev) {
			
			ev.stopPropagation();
			
			var url = $(this).attr('href');

			window.open(url, '_blank');
		} );
	});

	//NS._bonf_counter = 0;

	current_element.find('.refresh_state').each(function(i) {

		$(this).click ( {widget: widget}, function(ev) {

			var button = $(this);

			ev.preventDefault();

			if (button.hasClass('gui-disabled'))
				return;


			var url = button.attr('url');

			console.log(url);

			button.addClass('gui-disabled');

			button.find('.icon-refresh').addClass('icon-spinner').addClass('icon-spin');

			$.ajax({
				url: url,

				success: function ( data, textStatus, jqXHR ) {

					data = $.parseJSON(data);

					if (data['status'] == 'success') {
						NS.ShowFadeMessage("Wait");


						//NS._bonf_counter += 1;
						//if (NS._bonf_counter > 3)
						//	alert("Bonf sei tu?");

						setTimeout(function() {

							button.find('.icon-spin').addClass('icon-refresh').removeClass('icon-spinner').removeClass('icon-spin');

							button.removeClass('gui-disabled');

							wcore.update.call(widget);
						}, 3000);
						
					}
					else {
						NS.ShowErrorMessage("Server error: " + data["info"] );
						
						button.removeClass('gui-disabled');
						button.find('.icon-spin').addClass('icon-refresh').removeClass('icon-spinner').removeClass('icon-spin');
						
						NS._counter = 0;

					}
					

				}

			});


			return false;
		});
	});

	/*current_element.find('.jswlib2_delete_link').each( function(i) { 
		
		$(this).click ( {widget: widget, button: $(this) }, function(ev) {

			if ($(ev.data.button).hasClass('gui-disabled')) {
				return false;
			}

			var caller = $(ev.target); //$(this);
			
			var badge_div = caller.closest('.badge');
			
			var id = badge_div.attr('id');
			
			if (badge_div.hasClass('tag')) {
				if (confirm('Confirm to delete this Tag?'))
					delete_tag(id, function() {
						badge_div.remove();
						NS.ShowFadeMessage('Tag deleted');
					});
			}
			else {
				var tagid = badge_div.attr('parent_tag_id');
				
				if (confirm('Confirm to untag this element?'))
					untag_elementid(id, tagid, function() {
						badge_div.remove();
						NS.ShowFadeMessage('Element untagged');
					});
			}
			return false;
		});
	});*/
	
	current_element.find('.jswlib2_delete_link').each( function(i) {
		
		$(this).click ( {widget: widget, button: $(this) }, function(ev) {

			var badge_div = $(ev.target).closest('.badge');
			
			if (badge_div.hasClass('tag')) {

				var uuid = $(this).attr("tag_uuid")
				
				var trigger = dropdown_show(ev, badge_div, {"uuid": uuid, "type": "tag"});
		
				var trigger_rename = trigger.find('#tag_rename_menu');
				var trigger_delete = trigger.find('#tag_delete_menu');
				
				var can_edit        = $("#can_edit-"       + uuid).text();
				var user_can_rename = $("#user_can_rename-"+ uuid).text();
				var user_can_delete = $("#user_can_delete-"+ uuid).text();
				
				//rename
				if ((can_edit == "1") && (user_can_rename == "1")){
					trigger_rename.removeClass("gui-disabled");
					
					trigger_rename.attr('href', '#');
					trigger_rename.attr('onclick', "open_rename_dialog('tag')");
					
					trigger_rename.attr('title', "Rename this tag.");
				}
				else {
					trigger_rename.removeAttr('href');
					trigger_rename.removeAttr('onclick');
					
					trigger_rename.addClass("gui-disabled");
					
					trigger_rename.attr('title', 'You are not allowed to rename this tag.');
				}
				
				//delete
				if ((can_edit == "1") && (user_can_delete == "1")){
					trigger_delete.removeClass("gui-disabled");
					
					trigger_delete.attr('href', '#');
					trigger_delete.attr('onclick', "delete_tag_dynatree_title(this);");

					trigger_delete.attr('title', "Delete this tag.");
				}
				else {
					trigger_delete.removeAttr('href');
					trigger_delete.removeAttr('onclick');
					
					trigger_delete.addClass("gui-disabled");
					
					trigger_delete.attr('title', 'You are not allowed to delete this tag.');
				}
			}
			else {
				
				if ($(ev.data.button).hasClass('gui-disabled')) {
					return false;
				}
				
				var id = badge_div.attr('id');
				var tagid = badge_div.attr('parent_tag_id');
				var element_tag_id = badge_div.attr('element_tag');
				
				if (confirm('Confirm to untag this element?'))
					untag_elementid(id, tagid, function() {
						badge_div.remove();
						
						$('[element_tag_id="'+ element_tag_id +'"]').parent().remove();
						NS.ShowFadeMessage('Element untagged');
					});
			}
			
			return false;
		});
		
	});
	
	

	current_element.find('.data-droppable').each(function(i) { 
		NS.set_droppable($(this));
	});

	if (current_element.hasClass('.data-droppable'))
		NS.set_droppable(current_element);
}

badgeview.validate = function (data)
{
};

badgeview.onClick = function(ev)
{
	// Questo handler viene impostato piu' volte a causa delle aperture/chiusure dei badge
	// Deve essere triggherato da un solo badge e una volta sola.
	if (ev.isDefaultPrevented())
		return;
		
	var widget  = ev.data.widget;

	var caller = $(ev.target); 
	
	console.log( "CLICK ON HTML TARGET", $(ev.target) );

	
	var badge_div = caller.closest('.badge');
	if (badge_div == undefined)
		return;

	// Ok, triggeriamo l'evento una volta sola.
	ev.preventDefault();

	if (! badge_div.hasClass('tag')) {
		
		var url = $(badge_div).attr('url');

		window.open(url, '_blank');
		
		return;
	}
		
	//console.log("CLICCKEND ON BADGE", badge_div.attr('id'));

	var is_opening = ! badge_div.hasClass('open-badge');

	if (is_opening) {

		//console.log("NEED TO OPEN", badge_div.attr('id'));
		
		badge_div.empty().append($('<table style="width:100%; height:100%;"><tr><td align="center" valign="middle"> <li class="icon-spinner icon-spin" style="font-size: 32px"></li> <br> Loading...</td></tr></table>'));

		var widget_state = wcore.getWstate.call(widget);
		if (widget_state == undefined)
			widget_state = new Object();
			
		var open_tree_structure = widget_state['open_badges'];
		if (open_tree_structure == undefined)
			open_tree_structure = new Object()

		var tree_path = badge_div.parents('.badge');
		
		var current_tree = open_tree_structure;
		console.log("PATH LENGTH", tree_path.length);
		
		for (var i=tree_path.length-1; i >= 0; i--) {
			var t = $(tree_path[i]);
			var subtree = current_tree[  t.attr('id')  ];
			current_tree = subtree;
		}

		if (is_opening) {
			//console.log("OPENING");
			current_tree[ badge_div.attr('id') ] = new Object();
		}
		else {
			//console.log("CLOSING");
			delete current_tree[ badge_div.attr('id') ];
		}

		widget_state['open_badges'] = open_tree_structure;

		//console.log(open_tree_structure);
		wcore.setWstate.call(widget, widget_state);

		if (is_opening) {
			widget_state['opening'] = badge_div.attr('id')
		}

		//console.log("WIDGET UPDATE")

		wcore.update.call(widget, widget_state, true);

	}
	else {
		//console.log("CLOSING", badge_div.attr('id'));

		var json_data = $.parseJSON( badge_div.attr('json_state') );

		
		var html = Mustache.to_html(BADGE_TEMPLATE, json_data);

		var current_element = $(html);

		badge_div.replaceWith(current_element);

		// Eventi
		current_element.click ( {widget: widget}, badgeview.onClick );
		
		add_badge_actions(current_element, widget);
		
		NS.set_droppable(current_element);



		//
		// Refresh widget
		//
		//var widget_state = wcore.getWstate.call(widget);
		//wcore.update.call(widget, widget_state, true);
	}

	return false;

}

badgeview.wrender = function ()
{
	var WIDGET = this;

	// INIT Tutti i widget vengono renderizzati per finta e non hanno dati quindi 
	var data    = wcore.read.call(WIDGET, 'data');
	if (typeof(data) == 'undefined')
		return;

	// Il widget al primo giro deve renderizzare il badge in modo diverso (non cliccabili)
	// quindi segnamoci se siamo al primo gior o meno.
	if (WIDGET[0].first_render == undefined) {
		WIDGET[0].first_render = true;
		
	} else {
		WIDGET[0].first_render = false;
	}

	//
	// Carichiamo lo stato corrente
	//
	var widget_state = undefined;
	
	widget_state =	wcore.getWstate.call(WIDGET);
	if (widget_state == undefined)
		widget_state = data['options'];
		
	if (widget_state == undefined)
		widget_state = new Object();


	//
	// Se il server ha mandato il flag "opening" allora stiamo "aprendo" un badge
	// e dobbiamo gestire la rendere in modo diverso.
	//
	var is_opening = false;
	if ( data['opening'] != null && data['opening'] != undefined )  {
		is_opening = true;
	}

	//
	// Se non sto aprendo un badge, lo stato (aggiornato con i dati del server)
	// deve essere aggiornato.
	//
	if (! is_opening)
		wcore.setWstate.call(WIDGET, widget_state);
	
	
	// Funzione ricorsiva per rendereizzare i badge
	function _render_elements(config, elements, parent_tag_id) 
	{
		var html_content = '';
		
		for (var i=0; i < elements.length; i++) {
			
				var d = elements[i];

				d['events_enabled'  ] = config['events_enabled'];
				d['sid'             ] = d['id'];
				d['parent_tag_id'   ] = parent_tag_id;
				d['can_untag'       ] = config['can_untag'];
				d['can_force_reload'] = config['can_force_reload'];
				d['droppable'       ] = (d['type'] == 'tag');
				d['reload_state_url'] = data['urls'] != undefined ? data['urls']['reload_state'] : null;

				// Questa deve essere sempre l'ultima chiave da salvare!
				d['json_state']       = JSON.stringify(d);

				console.log(data);

				if (d['sections'].length == 0) {
					var html = Mustache.to_html(BADGE_TEMPLATE, d);
				}
				else {
					var html = Mustache.to_html(OPEN_TEMPLATE, d);

					if (d['type'] == 'tag')
						parent_tag_id = d['id'];

					var sub_html = '';
					for (var s=0; s < d['sections'].length; s++) {
						var section = d['sections'][s];

						if (section['objects'].length == 0) continue;

						sub_html += '<h2>'+section['name']+'</h2>';

						sub_html += _render_elements(data, section['objects'], parent_tag_id)
					}

					html = html.replace('##SUB##', sub_html);
				}
				html_content += html;
		}
		return html_content;
	}

	var display = wcore.getDisplay.call(WIDGET);

	var current_element = null;

	// Se sto renderizzando tutto il widget (e non sto aprendo solo un badge particolare)
	if ( !(data['opening'] != null && data['opening'] != undefined) ) {

		// Puliamo tutto
		display.empty();
		display.append($("<blink>Loading...</blink>"));

		// Al primo giro i badge non gestiscono il click ed altri eventi
		var events_enabled = WIDGET[0].first_render == false ? 1 : 0;
		data['events_enabled'] =  events_enabled;

		// Renderizziamo tutte le sezioni
		var full_html_content = '<div>';
		for (var s=0; s< data['sections'].length; s++) {
			var section = data['sections'][s];

			if (section['objects'].length == 0) continue;

			full_html_content += '<h2>'+section['name']+'</h2>';

			full_html_content += _render_elements(data, section['objects'], data['uuid'])
		}
		full_html_content += '</div>';

		// Visualizziamo tutti i contenuti
		display.empty();
		display.append( $(full_html_content) );

		current_element = display;

		if (events_enabled == 1) {
			current_element.find('.badge').each( function(i) {
 
				$(this).click ( {widget: WIDGET}, badgeview.onClick );

			});
		}

	}
	else {
		//console.log("OPENING--------------", data['opening']);

		data['events_enabled'] = 1;

		var id = data['opening'];
		var old_element = $('#'+id);

		var html_content = '';

		var html_content = _render_elements(data, data['objects']);

		var new_element = $(html_content);

		old_element.replaceWith(new_element);

		current_element = new_element;

		current_element.click ( {widget: WIDGET}, badgeview.onClick );

	}
	
	// Se non siamo al primo rendere (veloce) gli eventi sono tutti abilitati
	if (WIDGET[0].first_render == false)
		add_badge_actions(current_element, WIDGET);

	// Se abbiamo fatto un render veloce triggeriamo l'update del widget subito
	if (WIDGET[0].first_render == true){
		wcore.update.call(WIDGET);
		WIDGET[0].first_render = false;
	}




};

WDS.wlib['badgeview'] = badgeview;
