/**
 * Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
 * Author: Mirko Mucaria
 */

var configelement = {};

configelement.wrender = function ()
{
	var WIDGET = this;

	var data    = wcore.read.call(WIDGET, 'data');
	if (typeof(data) == 'undefined' || data == null)
	{
		var display = wcore.getDisplay.call(this);
		display.empty();
		display.append('<div style="width: 100%; text-align: center;"><i class="fa icon-spinner icon-spin icon-4x"></i></div>');
		return;
	}

	configelement.rendering_conf.call(this);
};

configelement.rendering_conf = function ()
{
	var WIDGET = this;
	
	var data = wcore.read.call(this, 'data');
	if(typeof data === 'undefined' || data == null)
	{
		return;
	}

	var display = wcore.getDisplay.call(this);
	display.empty();

	var base = '<div class="jsw2_config_base_element_holder jswlib2_wconf_center"></div>';
	display.append(base);

	var CONTENT_TEMPLATE = '\
	<form id="wconf" method="post">\
		\
		<input id="wconf_mtime" class="wconf_mtime" type="text" hidden>\
		\
		<div class="jswlib2_wconf">\
			<br>\
			<div> \
				<h3>Base <i class="fa fa-chevron-up jswlib2_wconf_button" data-divid="conf_base"></i></h3> \
			</div> \
			<div class="jswlib2_wconf_border conf_base" id="conf_base"> \
				<div class="jswlib2_wconf_box">\
					<div class="jswlib2_wconf_row">\
						<div class="jswlib2_wconf_col-left">\
							Icon\
						</div>\
						<div class="jswlib2_wconf_icon jswlib2_wconf_col-right">\
							<div id="wconf_icon">\
							</div>\
						</div>\
					</div>\
					<div class="jswlib2_wconf_row">\
						<div class="jswlib2_wconf_col-left">Description</div>\
						<div class="jswlib2_wconf_col-right">\
							<textarea class="jswlib2_wconf_text" name="conf-description" id="wconf_description"></textarea>\
						</div>\
					</div>\
					<div class="jswlib2_wconf_row">\
						<div class="jswlib2_wconf_col-left">\
							Priorita\'\
						</div>\
						<div class="jswlib2_wconf_col-right">\
							<select name="conf-prio" id="wconf_priority">\
								{{#numbers}}\
								<option value="{{.}}">{{.}}</option>\
								{{/numbers}}\
							</select>\
						</div>\
					</div>\
				</div>\
			</div>\
		</div>\
	';

	//
	// Preparo la select per la priorita'
	//
	var prio_array = [];

	for(var i=0; i < 101; i++)
	{
		prio_array.push(i);
	}

	var params = {'numbers' : prio_array};

	var html_content = Mustache.to_html(CONTENT_TEMPLATE, params);

	var element = $(html_content);

	//
	// Appendo le sezioni del nodo di monitoraggio e dei customfield
	//
	element.append(TEMPLATE_DICT[data.elemtype]);

	element.append('<br><input class="jswlib2_wconf_submit wconf_submit" id="wconf_submit" type="button" value="Save"></form>');

	$('.jsw2_config_base_element_holder', display).append(element);

	$(".wconf_submit", element).click( function ()
	{
		var postData = {};
		var id = '';
		postData['custom_fields'] = {};

		//
		// Prendo il valore di ogni campo
		//
		//$( "#wconf :input" ,element).each( function ()
		$( ":input" ,element).each( function ()
		{
			id = $(this).attr('id');

			if(id != 'undefined' && id != null)
			{
				id = id.slice(6);

				//console.log(id);

				if( $(this).attr('type') == 'checkbox')
				{
					postData[id] = $(this).is(':checked');
				}
				else if( $(this).attr('id') == 'wconf_icon')
				{
					postData[id] = $('.dd-selected-text', element).html();
				}
				else if( $(this).attr('id') == 'wconf_xform' || $(this).attr('id') == 'wconf_cluster_xform')
				{
					postData[id] = encodeURIComponent( $(this).val() );
				}
				else
				{
					var val = $(this).val();

					if( val == '' )
					{
						val = null;
					}

					postData[id] = val;
				}
			}
		});

		$.ajax(
		{
			type     : "POST",
			url      : data.submit_url,
			dataType : "json",
			data     : { 
				'd' : JSON.stringify(postData) 
			},
			success  : function(data) {
				configelement.check_response.call(WIDGET, data);
			}, 
			error    : function(data)
			{
				console.log("Errore ajax", data);
			}
		});
	});

	configelement.iconselect    .call(this, data.autocomplete, data.data.icon.value);

	configelement.selectcomplete.call(this, data.autocomplete);

	configelement.show_current_config.call(this, data.data);

	//
	// Jquery datepicker
	//
	
	$('input[type=text_date]', element).datepicker({
		dateFormat: "yy-mm-dd"
	});

	//
	// Bind per nascondere/mostrare i vari blocchi
	//
	$(".fa", element).click(function(){

		var div_id = $(this).attr('data-divid');

		if($(this).hasClass('fa-chevron-down'))
		{
			$(this).removeClass('fa-chevron-down');
			$(this).addClass('fa-chevron-up');
		}
		else
		{
			$(this).removeClass('fa-chevron-up');
			$(this).addClass('fa-chevron-down');
		}
		
		//$('#'+div_id).toggle();
		$('.'+div_id).toggle();
	});

	$('.icon-info-sign', display).click(function(){
		var div_id = $(this).attr('data-divid');

		$( '#'+div_id ).toggle();
	});

	return base;
};

//
// Callback richiesta ajax
//
configelement.check_response = function(data)
{
	var display = wcore.getDisplay.call(this);
	//display.empty();


	if(data.status == "success")
	{
		NS.ShowFadeMessage('Saved');
		
		$('#wconf_'+name, display).parent().prev().attr('style', '');
		
		//$('#wconf_mtime', display).val(data.mtime);
		$('.wconf_mtime', display).val(data.mtime);
		
		$('.jswlib2_wconf_error', display).remove();
	}
	else
	{
		NS.ShowErrorMessage('Error saving configuration: ' + data.error_msg);
		//$('#wconf_mtime'        , display).val(data.mtime);
		$('.wconf_mtime'        , display).val(data.mtime);
		$('.jswlib2_wconf_error', display).remove();
		
		//
		// Mostro gli errori accanto i relativi campi
		//
		for(key in data.wrong_fields)
		{
				name = key;
				msg = data.wrong_fields[name];

				$('#wconf_'+name, display).parent().prev().attr('style', 'color: red;');
				$('<tr class="jswlib2_wconf_error"><td align="left" class="jswlib2_wconf_error">'+msg+'</td></tr>').insertBefore($('#wconf_'+name, display).parent().parent());
		}
	}
};

//
// Inserisco nei campi i valori attuali
//
configelement.show_current_config = function(config)
{
	var display = wcore.getDisplay.call(this);
	//display.empty();


	console.log(config)

	if(typeof config === "undefined" || config == null)
	{
		return;
	}


	for(field in config)
	{
		var name  = config[field].name;
		var value = config[field].value;

		var elem = $("#wconf_"+name, display);
		//var elem = $($(".wconf_"+name, display)[0]);

		console.log(elem);

		if(elem.attr('type') == 'checkbox') {
			elem.prop('checked', value);
		}
		else {
			console.log(name); console.log(value);

			elem.val(value);

			elem.attr("value", value);
		}

	}


	if($('.wconf_use_ipv4', display).is(':checked'))
	{
		$(".wconf_ip6_mgt"  , display).attr("disabled", true);
		$(".wconf_dns6_name", display).attr("disabled", true);
	}
	else
	{
		$(".wconf_ip4_mgt" , display).attr("disabled", true);
		$(".wconf_dns_name", display).attr("disabled", true);
	}


	$('.wconf_use_ipv4', display).click( function()
	{
		var value = $(this).prop("checked");
		//console.log(value);

		$('.wconf_ip6_mgt'  , display).attr('disabled', value);
		$('.wconf_dns6_name', display).attr('disabled', value);
		
		$('.wconf_ip4_mgt' , display).attr('disabled', ! value);
		$('.wconf_dns_name', display).attr('disabled', ! value);
	});
};

//
// Inserisco i campi option per le varie select e gli autocomplete
//
configelement.selectcomplete = function(autocomplete_data)
{
	var display = wcore.getDisplay.call(this);
	//display.empty();

	if(typeof autocomplete_data === "undefined")
		return;


	for(field in autocomplete_data)
	{
		var name = autocomplete_data[field].name;

		for(option in autocomplete_data[field].values)
		{
			if(name == 'icon')
				continue;

			if(name == 'snmp_version') {
				$("#wconf_"+name, display).append('<option value="'+ autocomplete_data[field].values[option] +'">' + autocomplete_data[field].values[option] + '</option>');
				//$(".wconf_"+name, display).append('<option value="'+ autocomplete_data[field].values[option] +'">' + autocomplete_data[field].values[option] + '</option>');
			}
			else {
				$("#wconf_"+name, display).append('<option value="'+ option +'">' + autocomplete_data[field].values[option] + '</option>');
				//$(".wconf_"+name, display).append('<option value="'+ option +'">' + autocomplete_data[field].values[option] + '</option>');
			}
		}
	}

	if('xform' in autocomplete_data)
	{
		$("#wconf_xform", display).autocomplete({
		//$(".wconf_xform", display).autocomplete({
			source: autocomplete_data['xform']['value']
		});
	}
};

configelement.iconselect = function(autocomplete, icon_name)
{
	var display = wcore.getDisplay.call(this);
	//display.empty();

	if(typeof autocomplete === 'undefined')
		return;

	var ddData = [];

	var setIconIndex = null;

	// Preparo i dati per il plugin
	for(icon in autocomplete.icon.values)
	{
		if(autocomplete.icon.values[icon].name == icon_name)
		{
			setIconIndex = icon;
		}

		ddData[icon] = {
			text    : autocomplete.icon.values[icon].name,
			selected: false,
			value   : icon,
			imageSrc: autocomplete.icon.values[icon].url
		}
	}

	// Configuro il plugin
	$('#wconf_icon', display).ddslick({
		data: ddData,
		height: 300,
		selectText: "Select the icon of your choice",
		imagePosition:"left",
		defaultSelectedIndex: setIconIndex,
		onSelected: function(selectedData){

			//console.log("cambio attributi callback");

			$('.dd-selected-text' , display).attr('style' , 'line-height: 30px');
			$('.dd-selected-image', display).attr('height', '30px');
			$('.dd-selected-value', display).attr('id'    , 'wconf_icon');
		}
	});

	$('.dd-option-image'  , display).attr('height', '30px');
	$('.dd-selected-image', display).attr('height', '30px');
	$('.dd-selected-text' , display).attr('style' , 'line-height: 30px');
	$('.dd-selected-value', display).attr('id'    , 'wconf_icon');
}

DEV_TEMPLATE = '\
<div class="jsw2_config_dev_element_holder jswlib2_wconf"> \
	<br>\
	<div> \
		<h3>Advanced <i class="fa fa-chevron-down jswlib2_wconf_button" data-divid="conf_device"></i></h3> \
	</div> \
	<div class="jswlib2_wconf_border conf_device" id="conf_device" style="display: none;">\
		<div class="jswlib2_wconf_box">\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					Distinguisher\
				</div>\
				<div class="jswlib2_wconf_col-right">\
					<input class="jswlib2_wconf_input" type="text" name="conf-distinguisher" id="wconf_distinguisher" id="wconf_distinguisher"> \
				</div>\
			</div>\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					Devindex\
				</div>\
				<div class="jswlib2_wconf_col-right">\
					<input class="jswlib2_wconf_input" type="number" name="conf-devindex" id="wconf_devindex">\
				</div>\
			</div>\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					Xform\
				</div>\
				<div class="jswlib2_wconf_col-right">\
					<input class="jswlib2_wconf_input" type="text" name="conf-xform" id="wconf_xform">\
				</div>\
			</div>\
		</div>\
	</div>\
</div>';

SERV_TEMPLATE = '\
<div class="jsw2_config_serv_element_holder jswlib2_wconf"> \
	<br>\
	<div> \
		<h3>Advanced <i class="fa fa-chevron-down jswlib2_wconf_button" data-divid="conf_service"></i></h3> \
	</div> \
	<div class="jswlib2_wconf_border conf_service" id="conf_service" style="display: none;">\
		<div class="jswlib2_wconf_box">\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					Distinguisher\
				</div>\
				<div class="jswlib2_wconf_col-right">\
					<input class="jswlib2_wconf_input" type="text" name="conf-distinguisher" id="wconf_distinguisher"> \
				</div>\
			</div> \
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					Swrunindex\
				</div>\
				<div class="jswlib2_wconf_col-right">\
					<input class="jswlib2_wconf_input" type="number" name="conf-swrunindex" id="wconf_swrunindex">\
				</div>\
			</div>\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					Xform\
				</div>\
				<div class="jswlib2_wconf_col-right">\
					<input class="jswlib2_wconf_input" type="text" name="conf-xform" id="wconf_xform">\
				</div>\
			</div>\
		</div>\
	</div>\
</div>';

STOR_TEMPLATE = '\
<div class="jsw2_config_stor_element_holder jswlib2_wconf"> \
	<br>\
	<div> \
		<h3>Advanced <i class="fa fa-chevron-down jswlib2_wconf_button" data-divid="conf_storage"></i></h3> \
	</div> \
	<div class="jswlib2_wconf_border conf_storage" id="conf_storage" style="display: none;">\
		<div class="jswlib2_wconf_box">\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					Distinguisher\
				</div>\
				<div class="jswlib2_wconf_col-right">\
					<input class="jswlib2_wconf_input" type="text" name="conf-distinguisher" id="wconf_distinguisher"> \
				</div> \
			</div>\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					Stindex\
				</div>\
				<div class="jswlib2_wconf_col-right">\
					<input class="jswlib2_wconf_input" type="number" name="conf-stindex" id="wconf_stindex">\
				</div>\
			</div>\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					Xform\
				</div>\
				<div class="jswlib2_wconf_col-right">\
					<input class="jswlib2_wconf_input" type="text" name="conf-xform" id="wconf_xform">\
				</div>\
			</div>\
		</div>\
	</div>\
</div>';

IFACE_TEMPLATE = '\
<div class="jsw2_config_iface_element_holder jswlib2_wconf"> \
	<br>\
	<div> \
		<h3>Advanced <i class="fa fa-chevron-down jswlib2_wconf_button" data-divid="conf_iface"></i></h3> \
	</div> \
	<div class="jswlib2_wconf_border conf_iface" id="conf_iface" style="display: none;">\
		<div class="jswlib2_wconf_box">\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					Distinguisher\
				</div>\
				<div class="jswlib2_wconf_col-right">\
					<input class="jswlib2_wconf_input" type="text" name="conf-distinguisher" id="wconf_distinguisher"> \
				</div> \
			</div>\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					Ifindex\
				</div>\
				<div class="jswlib2_wconf_col-right">\
					<input class="jswlib2_wconf_input" type="number" name="conf-ifindex" id="wconf_ifindex">\
				</div>\
			</div>\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
						Backbone\
				</div>\
				<div class="jswlib2_wconf_col-right">\
					<input type="checkbox" name="conf-backbone" id="wconf_backbone">\
				</div>\
			</div>\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					Xform\
				</div>\
				<div class="jswlib2_wconf_col-right">\
					<input class="jswlib2_wconf_input" type="text" name="conf-xform" id="wconf_xform">\
				</div>\
			</div>\
		</div>\
	</div>\
</div>';

NODE_TEMPLATE = '\
<div class="jsw2_config_node_element_holder jswlib2_wconf"> \
	<br>\
	<div> \
		<h3>Advanced <i class="fa fa-chevron-down jswlib2_wconf_button" data-divid="conf_node"></i></h3>\
	</div> \
	<div class="jswlib2_wconf_border conf_node" id="conf_node" style="display: none;">\
		<div class="jswlib2_wconf_box">\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					Use IPv4\
				</div>\
				<div class="jswlib2_wconf_col-right">\
					<input type="checkbox" name="conf_use_ipv4" id="wconf_use_ipv4"> \
				</div>\
			</div>\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					DNS Name\
				</div>\
				<div class="jswlib2_wconf_col-right4">\
					<input class="jswlib2_wconf_input" type="text" name="conf_dns" id="wconf_dns_name" >\
				</div>\
				<div class="jswlib2_wconf_col-left">\
					DNS IPv6 Name\
				</div>\
				<div class="jswlib2_wconf_col-right4">\
					<input class="jswlib2_wconf_input" type="text" name="conf_dns6" id="wconf_dns6_name">\
				</div>\
			</div>\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					IPv4\
				</div>\
				<div class="jswlib2_wconf_col-right4">\
					<input class="jswlib2_wconf_input" type="text" name="conf_ip4_mgt" id="wconf_ip4_mgt">\
				</div>\
				<div class="jswlib2_wconf_col-left">\
					IPv6\
				</div>\
				<div class="jswlib2_wconf_col-right4">\
					<input class="jswlib2_wconf_input" type="text" name="conf_ip6_mgt" id="wconf_ip6_mgt">\
				</div>\
			</div>\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					Is Switch\
				</div>\
				<div class="jswlib2_wconf_col-right">\
					<input type="checkbox" name="conf_is_switch" id="wconf_is_switch">\
				</div>\
			</div>\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					Is Router\
				</div>\
				<div class="jswlib2_wconf_col-right4">\
					<input type="checkbox" name="conf_is_router" id="wconf_is_router">\
				</div>\
			</div>\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					Default Timeout\
				</div>\
				<div class="jswlib2_wconf_col-right">\
					<input type="number" name="conf-timeout" id="wconf_dft_timeout">\
				</div>\
			</div>\
		</div>\
	</div>\
	<br>\
</div>\
<div class="jsw2_config_node_element_holder jswlib2_wconf"> \
	<div> \
		<h3>SNMP <i class="fa fa-chevron-down jswlib2_wconf_button" data-divid="c_snmp"></i></h3>\
	</div> \
	<div class="jswlib2_wconf_border c_snmp" id="c_snmp" style="display: none;">\
		<div class="jswlib2_wconf_box">\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					Version\
				</div>\
				<div class="jswlib2_wconf_col-right">\
					<select name="config_snmp_version" id="wconf_snmp_version"></select>\
				</div>\
			</div>\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
						Port\
				</div>\
				<div class="jswlib2_wconf_col-right">\
					<input type="number" name="conf_snmp_port" id="wconf_snmp_port">\
				</div>\
			</div>\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					Community\
				</div>\
				<div class="jswlib2_wconf_col-right">\
					<input class="jswlib2_wconf_input" type="text" name="conf_snmp_community" id="wconf_snmp_community">\
				</div>\
			</div>\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					v3 Auth Data\
				</div>\
				<div class="jswlib2_wconf_col-right">\
					<input class="jswlib2_wconf_input" type="text" name="conf_snmp_v3_authdata" id="wconf_snmp_v3_authdata">\
				</div>\
			</div>\
		</div>\
	</div>\
</div>\
<br>\
<div class="jsw2_config_node_element_holder jswlib2_wconf"> \
	<div> \
		<h3>Cluster <i class="fa fa-chevron-down jswlib2_wconf_button" data-divid="c_cluster"></i></h3>\
	</div> \
	<div class="jswlib2_wconf_border c_cluster" id="c_cluster" style="display: none;">\
		<div class="jswlib2_wconf_box"> \
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					Cluster\
				</div>\
				<div class="jswlib2_wconf_col-right">\
					<select name="conf_cluster" id="wconf_cluster"> </select>\
				</div> \
			</div>\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					Role\
				</div>\
				<div class="jswlib2_wconf_col-right" style="width: 30%;">\
					<select class="jswlib2_wconf_input" type="text" name="conf_cluster_role" id="wconf_cluster_role">\
					</select>\
				</div>\
				<div class="jswlib2_wconf_col-left">\
					Distinguisher\
				</div>\
				<div class="jswlib2_wconf_col-right" style="width: 30%;">\
					<input class="jswlib2_wconf_input" type="text" name="conf_cluster_distinguisher" id="wconf_cluster_distinguisher">\
				</div>\
			</div>\
			<div class="jswlib2_wconf_row">\
				<div class="jswlib2_wconf_col-left">\
					Xform\
				</div>\
				<div class="jswlib2_wconf_col-right" style="width: 30%;">\
					<input class="jswlib2_wconf_input" type="text" name="conf_cluster_xform" id="wconf_cluster_xform">\
				</div>\
				<div class="jswlib2_wconf_col-left">\
					Instance\
				</div>\
				<div class="jswlib2_wconf_col-right" style="width: 30%;">\
					<input class="jswlib2_wconf_input" type="text" name="conf_cluster_instance" id="wconf_cluster_instance">\
				</div>\
			</div>\
		</div>\
	</div>\
</div>\
';


var TEMPLATE_DICT = {
	node     : NODE_TEMPLATE,
	interface: IFACE_TEMPLATE,
	storage  : STOR_TEMPLATE,
	service  : SERV_TEMPLATE,
	device   : DEV_TEMPLATE
};
// saving all widgets to library for finalization and use

WDS.wlib['configelement'] = configelement;
