
var log = {};

//************************************************************************************
//*                              WIDGET STATUS                                       *
//************************************************************************************
	
log.state_filter       = null;    // state transition bar status
log.isExpanded         = false;   // true if it is expanded with state bar and false if not
log.search_bar_filters = ['Type', 'Time', 'Priority', 'Element', 'Logged entity']


//************************************************************************************
//*                              WIDGET FUNCTIONS                                    *
//************************************************************************************

function prepareOptions(widget)
{
	var div = $(widget);

	var options = {};

	var options = wcore.getWstate.call(widget);

	var pagesize = parseInt(div.find("select[name=pagesize]").val());
	if (options['pagesize'] != pagesize) {		
		options['pagesize'] = parseInt(div.find("select[name=pagesize]").val());
		options['page']     = 1;
	}
	
	options['priority']   = div.find("[name=priority]").val();
	options['freetext']   = div.find("[name=freetext]").val();
	options['date_start'] = div.find("[name=date_start]").val();
	options['date_end']   = div.find("[name=date_end]").val();
	options['hour_start'] = div.find("[name=hour_start]").val();
	options['hour_end']   = div.find("[name=hour_end]").val();

	wcore.setWstate.call(widget, options);
	
	return options;
}

log.refreshLog = function(ev) 
{
	ev.stopPropagation();

	var widget  = ev.data.widget;

	options = prepareOptions(widget);

	wcore.async.lock.call(widget);
	
	wcore.update.call(widget, options, true);
	
};

log.exportLog = function(ev) 
{
	var url      = ev.data.url;
	var etype    = ev.data.etype;
	var uuid     = ev.data.uuid;

	ev.stopPropagation();

	var widget  = ev.data.widget;

	options = prepareOptions(widget);

	$.ajax({
		url: url, 
		type: 'POST',
		data: {
			'etype'  : etype,
			'uuid'   : uuid,
			'options': JSON.stringify(options)
		},
		success: function(data) {
		}
	});
};

log.changeSort = function(ev)
{
	ev.stopPropagation();
	
	var widget  = ev.data.widget;
	
	var caller = $(this)

	options = prepareOptions(widget);

	var sortfield  = caller.attr('sortfield').trim();
	
	if (sortfield == options['sort_field']) {
		options['sort_type'] = options['sort_type'] * -1;
	}
	else {
		options['sort_field'] = sortfield;
		options['sort_type' ] = 1;
	}
	
	wcore.setWstate.call(widget, options);
	
	wcore.update.call(widget, options, true);
}


log.changePage = function(ev)
{
	ev.stopPropagation();
	
	var widget  = ev.data.widget;
	
	var caller = $(this)

	options = prepareOptions(widget);
	
	
	var selected_page = caller.text().trim();
	
	if      (selected_page == '<<') {
		selected_page = 1;
	}
	else if (selected_page == '<') {
		selected_page = options['page'] - 1;
	}
	else if (selected_page == '>') {
		selected_page = options['page'] + 1;
	}
	else if (selected_page == '>>') {
		selected_page = -1;
	}
	else {
		selected_page = parseInt(selected_page);
	}

	options['page'] = selected_page;


	wcore.setWstate.call(widget, options);

	wcore.update.call(widget, options, true);

	return false;
}

log.expandLog = function(ev)
{
	var widget = ev.data.widget;
	var url    = ev.data.url;
	var logid  = ev.data.logid;
	var type   = ev.data.type;


	//
	// We need to "expand" blocks. It's better to block any updates.
	//
	wcore.blockAutorefresh.call(widget);

	//
	// If the data are already on the page we show them, otherwise we will have to download them.
	//
	
	var row_id         = logid;
	var row_details_id = logid + '_' + type;
	
	var row = $('#'+row_details_id);
	if (row.length != 0) {
		row.toggle();
		return;
	}


	url = url + '?uuid='+logid;
	
	$.ajax({
		type: 'POST',
		url: url,
		async: false,
		success: function(data){

			data = $.parseJSON(data)

			data['msg'] = data['msg'].replace(/\n/g, '<br>')

			var html_content = '<tr id="' + row_details_id +'"><td colspan="6"><tt>'+data['msg']+'</tt></td></tr>';
						
			var row = $(html_content);
			row.insertAfter('#'+row_id);
		}
	});
}

//************************************************************************************
//*                         state transition panel functions                         *
//************************************************************************************

function expandStateTransitionPanel()
{
	if($('#state_transition_panel').is(":visible"))
	{
		$('#state_transition_panel').hide();
		$('#expand_log_bar').html('<i class="fa fa-chevron-down"></i>');
	}
	else
	{
		$('#state_transition_panel').show();
		
		$('#expand_log_bar').html('<i class="fa fa-chevron-up"></i>');
		
		log.isExpanded = true;
	}
}

function stateFilterBarStatus()
{

	var new_bar_state = '';
	
	if(log.state_filter != 'cleaned'){
		$('#cancel-transitions').removeClass('icon-disabled');
		$('#cancel-transitions').addClass('icon-abled');
	}
	else{
		$('#cancel-transitions').removeClass('icon-abled');
		$('#cancel-transitions').addClass('icon-disabled');
		new_bar_state = null;
	}
			
	if(log.state_filter == null){
		new_bar_state = 'from';
	}
	if(log.state_filter == 'initial_transaction'){
		new_bar_state = 'to';
	}
	if(log.state_filter == 'from'){
		new_bar_state = 'initial_transaction';
	}
	if(log.state_filter == 'to'){
		new_bar_state = 'finish_condition';
	}
	if(log.state_filter == 'finish_condition'){
		new_bar_state = null;
	}

	log.state_filter = new_bar_state;
	
}

function stateFilterCompleterOptions()
{
	
	if(log.state_filter == null){
		
		var from_completer = "<div id='from_autocompleter' style='padding-left:15px;' class='autocompleter'>\
					from:\
				    </div>\
				   ";
		
		$('#state_transition_options').html(from_completer);

		$('#from_autocompleter').bind('click', {}, function(ev) {
			//get previous value in search bar
			var search_str = $('#state_filters').val();
			
			//concatenate new value
			search_str += 'from: ';  

			//set complete value in search bar
			$('#state_filters').val(search_str);
			
			stateFilterBarStatus();
			stateFilterCompleterOptions();
		});
	}
	
	if(log.state_filter == 'initial_transaction'){		   
		var to_completer = "<div id='to_autocompleter' style='padding-left:15px;' class='autocompleter'>\
					to:\
				    </div>\
				   ";
		$('#state_transition_options').html(to_completer);
		
		$('#to_autocompleter').bind('click', {}, function(ev) {
			//get previous value in search bar
			var search_str = $('#state_filters').val();
			
			//concatenate new value
			search_str += 'to: ';  

			//set complete value in search bar
			$('#state_filters').val(search_str);
			
			stateFilterBarStatus();
			stateFilterCompleterOptions(); 
		});
	}
	
	if(log.state_filter == 'from'){
		var initial_transaction = "<div id='initial_transaction_autocompleter' style='padding-left:15px;' class='autocompleter'>\
					     <table id='select_initial_state' style='width: 100%;'>\
					        <tr class='state' id='UP'><td>UP</td></tr>\
					        <tr class='state' id='DN'><td>DN</td></tr>\
					     </table>\
					   </div>\
					  ";
		$('#state_transition_options').html(initial_transaction);
		$('.state').bind('click', function(ev) {
			//get previous value in search bar
			var search_str = $('#state_filters').val();

			//concatenate new value
			search_str += $(this).attr('id')+' ';  

			//set complete value in search bar
			$('#state_filters').val(search_str);
			
			stateFilterBarStatus();
			stateFilterCompleterOptions(); 
		});
					  
	}

	if(log.state_filter == 'to'){			          
		var final_transaction = "<div id='final_transaction_autocompleter' style='padding-left:15px;' class='autocompleter'>\
						<input type='checkbox' name='state_sel' value='DN'> Down<br>\
						<input type='checkbox' name='state_sel' value='UP'> UP<br>\
						<center><button id='final_transaction_ok' class='btn-log btn-save'> OK </button></center>\
					</div>\
					";
		$('#state_transition_options').html(final_transaction);
		
		$('#final_transaction_ok').bind('click', function(ev){
			
			var values = $('input[name="state_sel"]:checked').map(function(){return $(this).val();}).get();
				
			var search_str = $('#state_filters').val();
				
			for(var i = 0; i < values.length; i++ ){
				//concatenate new value
				search_str += values[i]+",";  
			}
				
			if(values.length > 0){
				search_str = search_str.slice(0, -1);
				search_str += '; ';
				
				$('#state_filters').val(search_str); 
			}
			
			stateFilterBarStatus();
			stateFilterCompleterOptions(); 	
		});
	}
	
	if(log.state_filter == 'finish_condition'){
		$('#state_transition_options').empty();
	}
	
}


//************************************************************************************
//*                         search bar functions                                     *
//************************************************************************************

function search_bar_filters(filters_list)
{
	var html_content = "<div id='search_bar_filters_panel' style='padding-left:15px;' class='autocompleter'>\
					     <table id='search_bar_filters' style='width: 100%;'>\
			   ";
			   
	for(var i = 0; i < filters_list.length; i++){
		html_content += "<tr class='state' id='"+filters_list[i]+"'><td>"+filters_list[i]+"</td></tr>";
	}
	
	html_content += "</table>";
	html_content += "</div>";
	
	$('#search_bar_options').html(html_content);
	
}

function save_query_panel()
{
	if($('#save-query').hasClass('icon-abled'))
	{
		if($('#save_query_panel').length)
		{
			$('#search_bar_options').empty();
		}
		else
		{
			var html_content = "<div id='save_query_panel' style='padding-left:15px; font-weight: bold;' align='right'>\
						<center>Query name: <input type='text' id='query-name'><br/>\
						Save for:  <input type='radio' name='saved_for' value='user' checked> User <input type='radio' name='saved_for' value='group'> Group</center>\
						<br />\
						<div id='save_query_error_message' class='error-log-message'></div>\
						<center><a class='btn-log btn-save' id='save-query-button'>Save</a><a class='btn-log btn-cancel' id='cancel-save-query'>Cancel</a></center>\
					    </div>\
					   ";
			
			$('#search_bar_options').html(html_content);
			
			$('#cancel-save-query').bind('click', function (ev) {
				$('#search_bar_options').empty();
			});
			
			$('#save-query-button').bind('click', function (ev) {
				if($('#query-name').val().length == 0){
					error_message = '<center>Insert a query name to continue ...</center>';
					$('#save_query_error_message').empty();
					$('#save_query_error_message').html(error_message);
				}
				else{
					//CHIAMATA AJAX
				}
			});
			
		}
	}
}

function saved_query_panel_selection()
{
	if($('#saved_query_panel_selection').length)
	{
		$('#search_bar_options').empty();
	}
	else
	{
		$.ajax({
			url: NS.base_prefix+'web/saved_queries',
			type: 'GET',
			data: {
			},
			dataType: 'text',
			
			success: function (r,s) {

				var saved_queries = JSON.parse(r);

				if (saved_queries["saved_queries"].length == 0){
					var html_content = "<div id='saved_query_panel_selection' style='padding-left:15px; font-weight: bold;' align='center'>\
							        <br/>Non ci sono query salvate<br/><br/>\
							    </div>\
							    ";
					$('#search_bar_options').html(html_content);
					$('#saved_query_panel_selection').width($('#search_bar').width());
				}
	
			}
		});
	}
}

function search_bar()
{
	var html_content = "<!--<input type='search' id='query_parameters' placeholder='Log search bar' style='font-size: x-small; width: 80%; float: left; margin: 5px; margin-left: 15px; border: none; background-color: white;' valign=center/>-->\
			        <div id='query-search'></div>\
			        <div id='icon-bar' align='right'>\
			            <span class='glyphicon glyphicon-remove-sign icon-disabled' id='empty-search-bar'></span>\
			            <span class='glyphicon glyphicon-floppy-disk icon-disabled' id='save-query'></span>\
			            <span class='glyphicon glyphicon-pushpin icon-disabled'></span>\
			            <span class='glyphicon glyphicon-menu-down icon-abled' id='saved-query'></span>\
			        </div>\
			   ";
	
	$('#search_bar').html(html_content);
	
	$('#query-search').height($('#icon-bar').height());
	
	$('#search_bar').bind('click', function(ev) {
		
		if($("#query-filters").length == 0){
			var html_content = "<div class='ui-widget'>\
				<input id='query-filters'>\
			</div>";
			$('#query-search').html(html_content);
			
			$('.ui-widget').height($('#query-search').height());
			
			$( "#query-filters" ).autocomplete({
				source: log.search_bar_filters
			});
		}
	});
}

function search_bar_event_handlers()
{
	$('#save-query').bind('click', this, function(ev) { 
		save_query_panel();
	} );
	$('#saved-query').bind('click', this, function(ev) { 
		saved_query_panel_selection();
	} );
	
	$('#search').bind('click', function(ev) {

	});
	
	$('#state_filters').bind('change', function(ev) {
		if($('#state_filters').val() != ''){
			$('#search').removeClass('btn-log-disabled');
		}else{
			$('#search').addClass('btn-log-disabled');
		}
		$('#state_filters').val('CIAONE');
	});
}


//************************************************************************************
//*                          widget render                                           *
//************************************************************************************

log.wrender = function ()
{
	var widget = this;

	var display = wcore.getDisplay.call(widget);
	display.empty();

	var data    = wcore.read.call(this, 'data');
	
	console.log("DATA" + data);
	
	if (typeof(data) == 'undefined') {
		console.log('loading data from server...');
		display.append("<p>Loading logs from server...</p>");
		return;
	}

	var options = undefined;
	
	options =	wcore.getWstate.call(widget);
	if (options == undefined)
		options = data['options'];
	if (options == undefined)
		options = new Object();
	
	wcore.setWstate.call(widget, options);
	
	//************************************************************************************
	//*                              Handle options                                      *
	//************************************************************************************


	var WIDGET = this;

	data['timestamp_sort'] = 'icon-sort';
	data['priority_sort' ] = 'icon-sort';
	data['element_sort'  ] = 'icon-sort';
	data['condition_sort'] = 'icon-sort';
	
	var s = (options['sort_type'] == 1) ? 'up': 'down';
	if (options['sort_field'] == 'timestamp'     ) { data['timestamp_sort'] = 'icon-caret-'+ s; data['timestamp_sort_on'] = 1; }
	if (options['sort_field'] == 'priority'      ) { data['priority_sort' ] = 'icon-caret-'+ s; data['priority_sort_on' ] = 1; }
	if (options['sort_field'] == 'element_path'  ) { data['element_sort'  ] = 'icon-caret-'+ s; data['element_sort_on'  ] = 1; }
	if (options['sort_field'] == 'condition_path') { data['condition_sort'] = 'icon-caret-'+ s; data['condition_sort_on'] = 1; }


	//************************************************************************************
	//*                                 Render                                           *
	//************************************************************************************

	var pagesizes = [5, 10, 25, 50, 100];
	data['pagesizes'] = new Array();
	for (var i=0; i< pagesizes.length; i++) {
		data['pagesizes'][i] = {'val':pagesizes[i], 'selected': pagesizes[i] == options['pagesize'] };
	}

	var num_pages = 16;

	data['pages'] = new Array();
	for (var p=1; p <= num_pages; p++) 
		data['pages'][p-1] = {'num':p, 'selected': options['page'] == p };

	EVENT_CONDITION    = 1
	EVENT_SYSLOG       = 2
	EVENT_SNMPTRAP     = 3
	EVENT_CUSTOM       = 4

	if (data['logs'] != undefined) {

		for (var i=0; i < data['logs'].length; i++) {
			l = data['logs'][i];
			
			if (l['k'] == EVENT_CONDITION) {
				l['is_condition'] = 1;
			}
			else {
				l['is_condition'] = 0;
				l['cur']  = '';
				l['prev'] = '';
			}
			
			console.log(l['msg']);
		}
	}
	
	
	if (options['selected_kinds'] != undefined) {
		if (options['selected_kinds'][EVENT_CONDITION] == true) data['selected_conditions'   ]  = 1;
		if (options['selected_kinds'][EVENT_SNMPTRAP]  == true) data['selected_snmptraps'    ]  = 1;
		if (options['selected_kinds'][EVENT_CUSTOM]    == true) data['selected_customevents' ]  = 1;
	}

	var CONTENT_TEMPLATE = '\
	<div> \
		<span style="font-size: 1.5em; font-weight:bold">Log:</span>  \
		<img class="icon16x16" src="{{ icon_url }}">\
		{{ element_path }} \
	<div> \
	<table border=0 style="border-collapse:collapse" width=100%> \
		<tr>\
			<td align=left> \
				<div id="search_bar" width=100%> \
				</div>\
				<div id="search_bar_options" width=100%> \
				</div>\
			</td> \
			<td width=1 align=right valign="top"> \
				<a class="btn-log btn-log-disabled" id="search"><span class="glyphicon glyphicon-search"></span> Search</a> \
			</td> \
			<td width=1 align=right valign="top"> \
				<a class="btn-log btn-log-abled" id="exportbutton"><span class="glyphicon glyphicon-export"></span> Export</a> \
			</td> \
			<td width=1 align=right valign="top"> \
				<a class="btn-log btn-log-abled" id="refreshbutton" name="refreshbutton"><span class="glyphicon glyphicon-refresh"></span></a> \
			</td> \
		</tr> \
	</table> \
	<div class="jsw2_expander jsw2_flag_notextsel"> \
		<div id="expand_log_bar" class="jsw2_expander_btn jsw2_flag_notextsel jsw2_expander_side_left"><i class="fa fa-chevron-down"></i></div>\
	</div>\
	<br />\
	<div id="state_transition_panel" style="display: none;">\
		<table border=0 style="border-collapse:collapse" width=100%> \
			<tr>\
				<td align="left" width=90%>\
					<div id="state_transition_bar">\
						<input type="search" id="state_filters" placeholder="State transition filter ..." style="font-size: x-small; width: 80%; float: left; margin: 5px; margin-left: 15px; border: none; background-color: white;" valign=center/>\
						<span id="cancel-transitions" class="glyphicon glyphicon-remove-sign icon-disabled" align="right"></span>\
					</div>\
					<div id="state_transition_options">\
					</div>\
				</td>\
				<td align="right">\
					<button id="default_transitions" name="default_transitions" class="btn-log btn-log-abled"> \
						<span style="font-weight: bold; color: green">UP</span> \
						>  \
						<span style="font-weight: bold; color: #ffdd00">FA</span> \
						>  \
						<span style="font-weight: bold; color: red">DN</span>  \
					</button> \
				</td>\
			</tr>\
		</table>\
	</div>\
	<table style="border-collapse:collapse" width=100%>\
	<tr> \
		<td> \
			<button class="selectpage" href=""> \
				&lt;&lt; \
			</button> \
			\
			<button class="selectpage"  href=""> \
				&lt; \
			</button> \
			 \
			<!-- {{#pages}} \
				{{#selected}} \
					<button class="selectpage"  style="background-color:#3333ff; ">{{num}}</button>  \
				{{/selected}} \
				{{^selected}} \
					<button class="selectpage"  href="" ">{{num}}</button>  \
				{{/selected}} \
			{{/pages}} -->\
			 \
			<button class="selectpage"  href=""> \
				&gt; \
			</button> \
			\
			<!-- <button class="selectpage"  href=""> \
				&gt;&gt; \
			</button> --> \
		</td> \
		<td align=right valign=top id="pagesize_column_top"> \
		Visualizza\
		<select id="pagesize" name="pagesize"> \
			{{#pagesizes}} \
				<option value="{{val}}"  {{#selected}}selected="selected"{{/selected}}> {{val}} </option>  \
			{{/pagesizes}} \
		</select> \
		elementi\
		</td> \
	</tr> \
	</table> \
	<table width="100%" id="log_table">\
		<tr class="gui-tr gui-tr-log"> \
			<th class="gui-th-log" width=1> \
				Type \
			</th> \
			<th class="gui-th-log sortcolumn" sortfield="timestamp" width=1> \
						<span>  \
							<nobr> Time      <li class="{{timestamp_sort}}" style=" font-size: 12px; {{#timestamp_sort_on}}color:black;{{/timestamp_sort_on}}" /> </nobr>\
						</span> \
			</th> \
			<th class="gui-th-log" width=1>  \
									Change      \
			</th>                        \
			<th class="gui-th-log sortcolumn" sortfield="priority"" width=1>  \
						<span> \
							<nobr> Prio         <li class="{{priority_sort}}"     style="font-size: 12px; {{#priority_sort_on}}color:black;{{/priority_sort_on}}" /> </nobr>          \
						</span>\
			</th> \
			<th class="gui-th-log sortcolumn" sortfield="element_path" width=1>  \
						<span> \
							<nobr> Element   <li class="{{element_sort}}"      style="font-size: 12px; {{#element_sort_on}}color:black;{{/element_sort_on}}" /> </nobr>           \
						</span>\
			</th> \
			<th class="gui-th-log sortcolumn" sortfield="condition_path">  \
						<span align="right"> \
							<nobr> Logged entity <li class="{{condition_sort}}"    style="font-size: 12px; {{#condition_sort_on}}color:black;{{/condition_sort_on}}" /> </nobr>          \
						</span>\
			</th> \
			<th class="gui-th-log" width=1>  \
			</th> \
		</tr> \
		{{#init}} \
		<tr> \
			<td align="center" colspan="7"> \
				<p> \
					Loading data from server....  \
				</p> \
			</td>\
		</tr> \
		{{/init}} \
		{{^init}} \
			\
			{{#logs}} \
			<tr id="{{id}}"    class="gui-tr logrow"  val="{{id}}" style="padding:0px; spacing:0px;"> \
				<td align="center"> \
					{{#logkind2str}}{{k}}{{/logkind2str}} \
				</td> \
				<td> \
					<nobr style="font-size:.8em">{{ts}}</nobr> \
				</td> \
				<td class="bg-{{cur}}" align="center"> \
					{{^is_condition}} \
						n/a \
					{{/is_condition}} \
					{{#is_condition}} \
						{{prev}}-{{cur}} \
					{{/is_condition}} \
				</td> \
				<td align="right">\
					{{#p}}{{p}}{{/p}}\
				</td> \
				<td> \
					<nobr> \
					<a href="{{url_path}}?path={{element}}">{{element}}</a> \
				</td> \
				<td> \
					<nobr> \
					{{#is_condition}} \
					<a href="{{url_path}}?path={{cpath}}"> \
						{{cpath}} \
					</a> \
					{{/is_condition}} \
					{{^is_condition}} \
						{{cpath}} \
					{{/is_condition}} \
				</td> \
				<td> \
					<nobr> \
					<!--<i class="fa fa-external-link" aria-hidden="true"></i>-->\
					<div class="gui-button gui-gradient expandlog"      val="{{id}}" style="cursor:pointer; padding: 0px; padding-right: 4px; padding-left : 4px;" > <i class="icon-chevron-sign-down   icon16x16" > </i> </div>\
					{{#is_condition}} \
					<div class="gui-button gui-gradient expandentables" val="{{id}}" style="cursor:pointer; padding: 0px; padding-right: 4px; padding-left : 4px;" > <i class="icon-comment   icon16x16" ></i> </div> \
					{{/is_condition}} \
				</td> \
			</tr> \
			{{/logs}}	 \
			{{^logs}}	 \
			<tr> \
				<td colspan="6"> \
					<center style="font-size: 24px; color: orange"> \
						No data \
					</center> \
				</td> \
			</tr> \
			{{/logs}} \
		\
		{{/init}} \
		\
	</table> \
	<table style="border-collapse:collapse" width=100%>\
	<tr> \
		<td> \
			<button class="selectpage" href=""> \
				&lt;&lt; \
			</button> \
			\
			<button class="selectpage"  href=""> \
				&lt; \
			</button> \
			 \
			<!-- {{#pages}} \
				{{#selected}} \
					<button class="selectpage"  style="background-color:#3333ff; ">{{num}}</button>  \
				{{/selected}} \
				{{^selected}} \
					<button class="selectpage"  href="" ">{{num}}</button>  \
				{{/selected}} \
			{{/pages}} -->\
			 \
			<button class="selectpage"  href=""> \
				&gt; \
			</button> \
			\
			<!-- <button class="selectpage"  href=""> \
				&gt;&gt; \
			</button> --> \
		</td> \
		<td align=right valign=top id="pagesize_column"> \
		Visualizza\
		<select id="pagesize" name="pagesize"> \
			{{#pagesizes}} \
				<option value="{{val}}"  {{#selected}}selected="selected"{{/selected}}> {{val}} </option>  \
			{{/pagesizes}} \
		</select> \
		elementi\
		</td> \
	</tr> \
	</table> \
	';

	data['logkind2str'] = function () {
		return function (text, render) {
			var k = parseInt(render(text));
			if      (k == 1) return "C";
			else if (k == 3) return "T";
			else if (k == 4) return "E";
			else             return text;
		}
	};

	var html_content = Mustache.to_html(CONTENT_TEMPLATE, data)	
	display.append( $(html_content) );
	
	search_bar();
	search_bar_event_handlers();
	
	if(log.isExpanded == true){
		$('#state_transition_panel').show();
	}
	
	if (data['init'] != undefined) {
		wcore.async.lock.call(widget);
	}

	//************************************************************************************
	//*                              Bind events                                         *
	//************************************************************************************
	
	display.find('.selectpage').each( function(i) { 
		$(this).bind('click', {widget:WIDGET}, log.changePage);
	});

	display.find('.sortcolumn').each( function(i) { 
		$(this).bind('click', {widget:WIDGET}, log.changeSort);
	});

	display.find('.expandlog').each( function(i) { 
		$(this).bind('click', {widget:WIDGET, url: data['url'], logid:$(this).attr('val'), type:"details"}, log.expandLog );  
	});

	display.find('.expandentables').each( function(i) { 
		$(this).bind('click', {widget:WIDGET, url: data['url_entables'], logid:$(this).attr('val'), type:"entables"}, log.expandLog );  
	});


	var button = display.find('[name=refreshbutton]');
	button.bind('click', {widget: WIDGET}, log.refreshLog);


	var exportbutton = display.find('[id=exportbutton]');
	exportbutton.bind('click', {widget: WIDGET, url: data['exporturl'], etype: data['etype'], uuid: data['uuid'] }, function (ev) {
		//
		// FIX: facciamo una GET con tutti i parametri perche' non ho trovato un modo per fare una POST in un'altra finestra del browser
		//
		var base_url = data['exporturl'] + '?' + 'uuid='+data['uuid'] + '&' + 'etype='+data['etype']+ '&' + 'options=' + JSON.stringify(options);
		window.location = base_url;
	})

	var option_panel = display.find('[name=log_search_options]');

	display.find('[name=button_show_search]').each( function(i) { 
		$(this).bind('click', {widget:WIDGET}, function(ev) { 

			display.find('[name=log_search_options]').toggle();

			var widget  = ev.data.widget;
			options = prepareOptions(widget);
			
			
			options['show_options'] = display.find('[name=log_search_options]').is(":visible");

			wcore.setWstate.call(widget, options);
		} );
	});	

	//************************************************************************************
	//*                              Fil transitions                                     *
	//************************************************************************************
	
	var widget_expander = display.find('.jsw2_expander');
	widget_expander.bind('click', {widget: WIDGET}, expandStateTransitionPanel);

	display.find('[name=transition]').each( function(i) { 
		$(this).bind('click', {widget:WIDGET}, function(ev) { 

			var t_from = $(this).attr("row");
			var t_to   = $(this).attr("col");
			
			var widget  = ev.data.widget;
			options = prepareOptions(widget);
			
			if (options['transitions'] == undefined)
				options['transitions'] = new Object();
			
			if (options['transitions'][t_from] == undefined)
				options['transitions'][t_from] = new Object();
				
			options['transitions'][t_from][t_to] =  $(this).is(':checked') ? 1 : 0;

			wcore.setWstate.call(widget, options);
		});
	});
	
	display.find('[name=default_transitions]').each( function(i) { 
		$(this).bind('click', {widget:WIDGET}, function(ev) { 
			var widget  = ev.data.widget;
			options = prepareOptions(widget);
			options['transitions'] = { UP: { FA: 1, DN: 1} , FA: { UP:1, DN: 1 }, DN: { UP: 1 } };
			wcore.setWstate.call(widget, options);
			
			$('#default_transitions').removeClass('btn-log-abled');
			$('#default_transitions').addClass('btn-log-disabled');
			
			var search_str = 'from: UP to: Failure,Down; from: Down to: UP;';
			$('#state_filters').val(search_str); 
			$('#state_transition_options').empty();
			stateFilterBarStatus();
			
			$('#search').removeClass('btn-log-disabled');
			$('#search').addClass('btn-log-abled');
		});
	});


	display.find('.colselector').each(function(i){
		
		$(this).bind('click', {widget:WIDGET}, function(ev) { 
			
			var widget  = ev.data.widget;
			options = prepareOptions(widget);
			
			var col = $(this).attr('val');

			display.find('[col='+col+']').each( function(i) {
				$(this).attr('checked', ! $(this).attr('checked'));
				
				var v = $(this).attr('checked');
				
				var t_from = $(this).attr("row");
				var t_to   = $(this).attr("col");
				
				if (options['transitions'] == undefined)
					options['transitions'] = new Object();
				
				if (options['transitions'][t_from] == undefined)
					options['transitions'][t_from] = new Object();
					
				options['transitions'][t_from][t_to] =  v ? 1:0 ;
			});
			
			wcore.setWstate.call(widget, options);
		});
	});

	display.find('input').focus({widget:WIDGET}, function(e) {
		
		var widget = e.data.widget;
		wcore.blockAutorefresh.call(widget);
	});


	display.find('.rowselector').each(function(i){
		
		$(this).bind('click', {widget:WIDGET}, function(ev) { 
			
			var widget  = ev.data.widget;
			options = prepareOptions(widget);
			
			var row = $(this).attr('val');

			display.find('[row='+row+']').each( function(i) {
				$(this).attr('checked', ! $(this).attr('checked'));
				
				var v = $(this).attr('checked');
				
				var t_from = $(this).attr("row");
				var t_to   = $(this).attr("col");
				
				if (options['transitions'] == undefined)
					options['transitions'] = new Object();
				
				if (options['transitions'][t_from] == undefined)
					options['transitions'][t_from] = new Object();
					
				options['transitions'][t_from][t_to] =  v ? 1:0 ;
			});
			
			wcore.setWstate.call(widget, options);
			
		});
	});	

	//************************************************************************************
	//*                 state transition bar events bind and handlers                    *
	//************************************************************************************
	
	$('#state_transition_bar').bind('click', {widget: WIDGET}, function(ev) {
 			
			if(log.state_filter != 'cleaned'){
				stateFilterCompleterOptions(); 	
			}
			else{
				stateFilterBarStatus();
			}
			
		});
	
	$('#state_filters').keypress(function(e) {
		if (e.which === 32) {
			stateFilterCompleterOptions();
			stateFilterBarStatus();
		}
	});
	
	$('#cancel-transitions').bind('click', function(ev) {
		if($(this).hasClass('icon-abled')){
			
			if($('#default_transitions').hasClass('btn-log-disabled')){
				$('#default_transitions').removeClass('btn-log-disabled');
				$('#default_transitions').addClass('btn-log-abled');
			}
			
			$('#state_filters').val('');
			$(this).removeClass('icon-abled');
			$(this).addClass('icon-disabled');
			$('#state_transition_options').empty();
			log.state_filter = 'cleaned';
		}
	});
};


WDS.wlib['log'] = log;
