/**
 * Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
 * Author: Mirko Mucaria
 */

var shownodes      = {};
var data           = {};
var hidden_columns = [];
var columns        = [];
var url_column     = [];
var tag_filter     = '';
var div_width      = 0;
var display        = '';

var last_search    = {'search': '', 'tag': ''};
var tmp_search     = {'search': '', 'tag': ''};

//
// Colonna su cui applicare l'ordinamento
//
var t_cell_order   = [];

var last_filtered  = 0;

var TRUTH_SIGNS = {
	true: '<i class="icon-circle" style="color: green;"></i>',
	false: '<i class="icon-circle" style="color: red;"></i>'
};

//
// Passa da modalita' desktop a modalita' mobile (migliorabile)
//


var resizer = function()
{
	var control  = $( '#table_control' );
	var info     = $( '#table_info' );
	var exporter = $( '#table_exporter' );
	var pager    = $( '.table_pages' );
		
	
	if( $( window ).width() < 700 )
	{
		$( '#mobile_conf' ).removeAttr('hidden');
		$( '#desktop_conf' ).attr('hidden', '');
		
		control.removeClass('table_control');
		control.addClass('table_control-mobile');
		
		info.removeClass('table_info');
		info.addClass('table_info-mobile');
		
		pager.removeClass('table_pages');
		pager.addClass('table_pages-mobile');
		
		exporter.removeClass('table_exporter');
		exporter.addClass('table_exporter-mobile');
	}
	else
	{
		$( '#mobile_conf' ).attr('hidden', '');
		$( '#desktop_conf' ).removeAttr('hidden');
		
		control.removeClass('table_control-mobile');
		control.addClass('table_control');
		
		info.removeClass('table_info-mobile');
		info.addClass('table_info');
		
		pager.removeClass('table_pages-mobile');
		pager.addClass('table_pages');
		
		exporter.removeClass('table_exporter-mobile');
		exporter.addClass('table_exporter');
	}
}

shownodes.wrender = function ()
{
	var WIDGET = this;
	
	WIDGET.last_resize_ts = 0;
	
	
	display = wcore.getDisplay.call(this);
	
	data = wcore.read.call(WIDGET, 'data');
	
	//
	// Primo giro di rendreing (init del widget). Niente da fare.
	//
	if (typeof(data) == 'undefined' || data == null)
		return;


	//
	// Chiedo i dati per disegnare la tabella
	//
	$.ajax({
		'url'    : data.url.table_data,
		'type'   : 'POST',
		'success': function(d){
			var params = JSON.parse(d);
			shownodes.create_table(params);
		}
	});
}

shownodes.create_table = function(params)
{
	var WIDGET = this;
	
	var table_conf    = params['table_conf'];
	var tag_list      = params['tag_list'];
	var custom_fields = [];
	
	columns           = [];
	hidden_columns    = [];
	url_column        = [];
	tag_filter        = '';
	t_cell_order      = table_conf['cell_order'];
	
	display.empty();
	
	div_width = $(display).width();
	
	//
	// Fix per una gestione discutibile del plugin di jquery
	// migliorabile
	//
	$('#csv_dialog').remove();
	
	display.append(data.structure.template);
	
	var buttons_list = [];
	
	var i = 0;
	
	for(column in table_conf['columns'])
	{
		if( table_conf['columns'][column]['name'] == 'url' )
		{
			url_column = table_conf['columns'][column];
		}
		else{
			columns.push(table_conf['columns'][column]);
		}
		
		if(table_conf['columns'][column]['group'] != 'Base fields')
		{
			custom_fields.push(table_conf['columns'][column]);
		}
	}
	
	hidden_columns = table_conf['hidden_columns'];
	
	console.log(custom_fields)
	console.log(columns)
	var t_template = Mustache.render(TEMPLATE, {'columns': columns});
	$('#table_div').append(DESKTOP_CONF);
	$('#table_div').append(MOBILE_CONF);
	$('#table_div').append(t_template);
	
	var conf_height = $( '#Col_reorder' ).height();
	$( '#tag_selector_div' ).css('height', conf_height);
	
	//
	// Inizializzo datatables
	//
	var table = $("#configtenant_shownodes").DataTable( {
		"colReorder"  : true,
		"deferRender" : true,
		"paging"      : true,
		"autoWidth"   : false,
		"lengthChange": true,
		"paginType"   : "simple_numbers",
		"lengthMenu"  : [[10, 25, 50], [10, 25, 50]],
		"pageLength"  : table_conf['length'],
		"scrollX"     : true,
		"processing"  : true,
		"serverSide"  : true,
		"order"       : t_cell_order,
		"language"    : {
			"info"         : "_TOTAL_ entrie(s) found",
			"infoFiltered" : "out of _MAX_",
			"paginate"     : {
				"previous": "<i class='icon-arrow-left icon-large'></i>",
				"next"    : "<i class='icon-arrow-right icon-large'></i>"
			},
			"aria"         : {
				"previous": "Previous",
				"next"    : "Next"
			}
		},
		"ajax": {
			"url"    : data.url.data_request,
			"type"   : 'POST',
			"error"  : function (jqXHR, textStatus, errorThrown){
					$('#table_error').empty();
					$('#table_error').append(errorThrown);
					$('#table_error').removeAttr('hidden');
			},
			"data"   : function (d){
					
					var data_columns = [url_column];
					var order_name   = d['columns'][ d['order'][0]['column'] ]['name'];
					
					d['order'][0]['column'] = $.grep(columns, function(e){ return e.name == order_name; })[0];
					
					var response = {
						'd'            : JSON.stringify( d ),
						'hidden'       : JSON.stringify( hidden_columns ),
						'col_conf'     : JSON.stringify( columns.concat(data_columns) ),
						'custom_fields': JSON.stringify( custom_fields ),
						'tag'          : JSON.stringify( tag_filter ),
						'last_search'  : JSON.stringify( last_search ),
						'last_filtered': JSON.stringify( last_filtered )
					};
					
					tmp_search = {'search' : d['search'], 'tag' : tag_filter}
					
					return response;
				},
			"dataSrc": function (json) {
						for( var i=0; i<json.data.length; i++ ){
						
							if( json.data[i]['Switch'] in TRUTH_SIGNS )
							{
								json.data[i]['Switch'] = TRUTH_SIGNS[ json.data[i]['Switch'] ];
							}
							
							if( json.data[i]['Router'] in TRUTH_SIGNS )
							{
								json.data[i]['Router'] = TRUTH_SIGNS[ json.data[i]['Router'] ];
							}
							
							json.data[i]['Name']   = '<a href="' + json.data[i]['url'] + '">' + json.data[i]['Name'] + '</a>';
							delete json.data[i]['url'];
						}
						
						last_search   = tmp_search;
						last_filtered = json['recordsFiltered'];
						$('#table_error').attr('hidden', '');
						
				        return json.data;
			           }
		},
		"columns": columns,
		"dom": '<"#table_control"<"#table_info"i><"table_length"l><"table_pages"p>><<t>><p>'
	});
	
	$('#configtenant_shownodes_wrapper > div:nth-child(2)').append(EMPTY_TABLE);
	
	$.fn.dataTableExt.sErrMode = 'throw';
	
	//
	// Nascondo le colonne salvate in configurazione come nascoste
	for(column in hidden_columns)
	{
		table.column(hidden_columns[column]+':name').visible(false);
	}
	for(column in custom_fields)
	{
		if( hidden_columns.indexOf(custom_fields[column]['group']+'/'+custom_fields[column]['title']) != -1 )
		{
			table.column(custom_fields[column]['name']+':name').visible(false);
		}
	}
	
	//
	// Inserisco il pulsante di esportazione in csv e faccio bind delle 
	// varie callback
	//
	$( '#table_control' ).prepend( '<div class="table_exporter" id="table_exporter">\
										<a id="configtenant_shownodes_export_csv" class="gui-button">\
											<i class="fa icon-file" style="padding-left: 5px;"></i>\
											Export to CSV\
										</a>\
									</div>');
	
	$('#configtenant_shownodes_export_csv').on('click', function(){
		$('#csv_dialog').dialog();
	});
	
	$('.csv_form').attr('action', data.url.export_csv);
	
	$('#csv_dialog_yes').on('click', function(){
		var last_request = table.ajax.params();
		var col_order    = table.order();
		var order        = table.columns().dataSrc();
		params           = JSON.parse(last_request['d']);
		tag              = JSON.parse(last_request['tag']);
		
		console.log(tag);
		console.log(params);
		
		var cell_order = []
		
		for( var i=0; i<order.length; i++ )
		{
			var label = order[i];
			cell_order.push( label );
		}
		
		var request = {
			"cell_order"   : cell_order,
			"col_order"    : col_order,
			"order"        : params['order'],
			"search"       : params['search'],
			"columns"      : params['columns'],
			"length"       : params['length'],
			"start"        : params['start'],
			"hidden"       : hidden_columns,
			"custom_fields": JSON.parse(last_request['custom_fields']),
			"tag"          : tag
		};
		
		$('#csv_input_yes').val(JSON.stringify(request) );
		
		$('#csv_dialog').dialog("close");
	});
	
	$('#csv_dialog_no').on('click', function(){
		var last_request = table.ajax.params();
		var col_order    = table.order();
		var order        = table.columns().dataSrc();
		params           = JSON.parse(last_request['d']);
		tag              = JSON.parse(last_request['tag']);
		
		var cell_order = []
		
		for( var i=0; i<order.length; i++ )
		{
			var label = order[i];
			cell_order.push( label );
		}
		
		var request = {
			"cell_order"   : cell_order,
			"col_order"    : col_order,
			"order"        : params['order'],
			"search"       : params['search'],
			"columns"      : params['columns'],
			"hidden"       : hidden_columns,
			"custom_fields": JSON.parse(last_request['custom_fields']),
			"tag"          : tag
		};
		
		$('#csv_input_no').val(JSON.stringify(request) );
		
		$('#csv_dialog').dialog("close");
	});
	
	//
	// Bind per mostrare/nascondere i blocchi associati ai pulsanti
	//
	$(".toggler").click(function(){
		
		var div_id = $( this ).attr( 'data-div' );
		div_id = '#' + div_id;
		
		var icon = $(this).find( 'i' )[0];
		
		if( $( this ).hasClass( 'conf_tab_inactive' ) )
		{
			$( this ).removeClass( 'conf_tab_inactive');
			$( this ).addClass( 'conf_tab_active');
		}
		else
		{
			$( this ).removeClass( 'conf_tab_active');
			$( this ).addClass( 'conf_tab_inactive');
		}
		
		if( $( icon ).hasClass('fa-chevron-down') )
		{
			$( icon ).removeClass('fa-chevron-down');
			$( icon ).addClass('fa-chevron-up');
		}
		else
		{
			$( icon ).removeClass('fa-chevron-up');
			$( icon ).addClass('fa-chevron-down');
		}
		
		$( div_id ).toggle();
	});
	
	$( $('#configtenant_shownodes_length').children()[0] ).replaceWith( $( $('#configtenant_shownodes_length').children()[0] ).children() );
	
	$('#configtenant_shownodes_wrapper').attr('style', 'max-width: '+div_width+'px;');
	
	//$(window).resize({ widget: WIDGET}, function(e){
	//	
	//	var WIDGET = e.data.widget;
	//	
	//	console.log(WIDGET.last_resize_ts - now);
	//	var now = Date.now();
	//	if ((WIDGET.last_resize_ts - now) < 1000)
	//		return;
	//	WIDGET.last_risize_ts = now;
	//	
	//			
	//	
	//	div_width = $('.jsw2_display').width();
	//	
	//	$('#configtenant_shownodes_wrapper').attr('style', 'max-width: '+div_width+'px;');
	//	
	//	table.columns.adjust();
	//});
	
	//
	// Salvo la configurazione quando viene cambiato l'ordinamento di una colonna
	//
	$("#configtenant_shownodes").on('order.dt', function( e, settings )
	{
		var api = new $.fn.dataTable.Api( settings );
		t_cell_order = api.order();
		
		save_conf();
	});
	
	shownodes.selector(table_conf);
	shownodes.search(tag_list);
	resizer();
	
	//
	// Quando la finestra viene ridimensionata ridisegna la tabella
	//
	//$( window ).resize({ widget: WIDGET}, function(e){
	//	
	//	var WIDGET = e.data.widget;
	//	
	//	console.log(WIDGET.last_resize_ts - now);
	//	var now = Date.now();
	//	if ((WIDGET.last_resize_ts - now) < 1000)
	//		return;
	//	WIDGET.last_risize_ts = now;
	//	
	//	
	//	var table    = $( '#configtenant_shownodes' ).DataTable();
	//	table.draw( 'page' );
	//	
	//	resizer();
	//});
};

shownodes.search = function(tag_list)
{
	var table = $('#configtenant_shownodes').DataTable();
	
	//
	// Appendo gli option alla select relativa ai tag
	// Quando viene selezionato un tag viene fatta una ricerca
	//
	for( tag in tag_list )
	{
		$( '.tag_selector' ).append( '<option value="'+tag_list[tag]+'">'+tag_list[tag]+'</option>' );
	}
	
	$( '.tag_selector' ).on('change', function(){
		tag_filter = $( this ).val();
		table.ajax.reload();
	});
	
	//
	// Se la lunghezza della chiave di ricerca e' > 2 e viene premuto invio
	// o il pulsante di ricerca, questa viene avviata
	//
	$(".table_search").keyup(function(e){
		if (e.keyCode == 13){
			if(this.value.length >=2) {
				table.search(this.value).draw();
			}
			else if(this.value.length == 0){
				table.search(this.value).draw();
			}
		}
	});
	
	$( '.apply_tag_filter' ).on('click', function(){
		var input = $( this ).attr( 'data-div' );
		table.search( $( '#'+input ).val() );
		table.ajax.reload();
	})
}

//
// Costruisco il box per la configurazione della tabella e associo ai vari
// pulsanti le azioni di riordinamento delle colonne
//
shownodes.selector = function(table_conf)
{
	var table       = $('#configtenant_shownodes').DataTable();
	var t_mover     = $('#configtenant_shownodes').dataTable();
	var tab_columns     = table.columns();
	
	var visible     = 0;
	var availeable  = 0;
	
	for(var i=0; i<tab_columns[0].length; i++)
	{
		var name = table.settings()[0].aoColumns[i].name;
		name = name.split('_');
		name[ name.length-1 ] = table.settings()[0].aoColumns[i].sTitle
		name = name.join('/');
		
		if(tab_columns.column(i).settings()[0].aoColumns[i].name == "url")
		{
			continue;
		}
		if(tab_columns.column(i).visible())
		{
			$('.selected_columns').append('<option value="'+visible+'" col="'+tab_columns[0][i]+'" title="'+name+'">'+name+'</option>');
			visible = visible+1;
		}
		else
		{
			$('.available_columns').append('<option value="'+availeable+'" col="'+tab_columns[0][i]+'" title="'+name+'">'+name+'</option>');
			availeable = availeable+1;
		}
	}
	
	$('.colShow').on('click', function() {
		
		var select_av = $( '#'+$( this ).attr( 'data-div_av' ) );
		var select_se = $( '#'+$( this ).attr( 'data-div_se' ) );
		
		var new_selected  = {};
		var select_list   = [];
		var select_values = select_av.val();
		
		if(select_values != null)
		{
			var children     = select_av.children();
			var opt_columns  = [];
			
			$('#empty_table').hide();
			
			for( child in select_values )
			{
				elem = children[ parseInt( select_values[child] ) ];
				select_list.push(elem);
			}
			
			for( child in select_list )
			{
				var se_children = select_se.children();
				var opt = $( select_list[child] );
				
				new_selected = opt.val();
				
				t_mover.fnColReorder(parseInt(opt.attr('col')), se_children.length);
				
				//for(var i=opt.attr('value'); i>=0; i--)
				//{
				//	var tmp = $( children[i] );
				//	tmp.attr('col', parseInt( tmp.attr('col') )+1);
				//}
				
				//for(var i=opt.attr('value'); i<children.length; i++)
				//{
				//	var tmp = $( children[i] );
				//	var val = tmp.attr('value');
				//	tmp.attr('value', val-1);
				//}
				
				opt.remove();
				children.splice( children.index(opt), 1);
				opt.attr('value', select_se.children().length);
				select_se.append(opt);
				
				opt.attr('col', se_children.length);
				
				opt_columns.push( opt.attr('col') );
				
				//t_mover.fnSetColumnVis( opt.attr('col'), true, false );
				
				//table.columns(opt.attr('col')).visible(true);
				//table.columns.adjust();
				
				hidden_columns.splice( hidden_columns.indexOf( opt.text() ), 1 );
			}
			
			table.columns( opt_columns ).visible(true);
			table.columns.adjust();
			
			// TODO: sistemare gli indici rivedendo l'intera lista e sistemandoli dal primo all'ultimo
			for(var i = children.length - 1; i>=0; i--)
			{
				var tmp1 = $( children[i] );
				var tmp2 = $( children[i-1] );
				tmp2.attr('col', parseInt( tmp1.attr('col') ) - 1);
			}
			
			// TODO: come sopra
			for(var i = 0; i<children.length; i++)
			{
				var tmp1 = $( children[i] );
				tmp1.attr('value', i );
			}
			
			if( t_cell_order[0][0] >= select_se.children().length )
			{
				table.order( [0, 'asc'] );
			}
			
			console.log(hidden_columns);
			select_av.val(new_selected);
		}
	});

	$('.colHide').on('click', function(){
		var select_av = $( '#'+$( this ).attr( 'data-div_av' ) );
		var select_se = $( '#'+$( this ).attr( 'data-div_se' ) );
		var t_mover   = $('#configtenant_shownodes').dataTable();
		
		var new_selected  = {};
		var select_list   = [];
		var select_values = select_se.val();
		
		if(select_values != null)
		{
			var children    = select_se.children();
			var opt_columns = [];
			
			for( child in select_values )
			{
				elem = children[ parseInt( select_values[child] ) ];
				select_list.push(elem);
			}
			
			for( child in select_list )
			{
				var opt         = $( select_list[child] );
				
				new_selected = opt.val();
				
				//for(var i=opt.attr('value'); i<children.length; i++)
				//{
				//	var tmp = $( children[i] );
				//	var val = tmp.attr('value');
				//	tmp.attr('value', val-1);
				//}
				
				opt.remove();
				children.splice( children.index(opt), 1);
				//opt.attr('value', select_av.children().length);
				//select_av.prepend(opt);
				
				hidden_columns.push( opt.text() );
				//table.columns(parseInt(opt.attr('col'))).visible(false);
				
				console.log(hidden_columns);
				
				//for(var i=parseInt(opt.attr('col')); i+1<table.columns()[0].length; i++){
				//	var opt2 = $(children[i]);
				//	t_mover.fnColReorder(i, i+1);
				//	opt2.attr('col', opt.attr('col'));
				//	opt.attr('col', i+1);
				//}
				
				//for(var i=parseInt(av_children.length)-1; i>=0; i--)
				//{
				//	var tmp = $( av_children[i] );
				//	tmp.attr('col', parseInt( tmp.attr('col') )-1);
				//}
				
				//if( table.order()[0][0] == parseInt( opt.attr('col') ) )
				//{
				//	table.order([0, 'asc']);
				//}
				
				table.columns(parseInt(opt.attr('col'))).visible(false);
			}
			
			for( var child = select_list.length-1; child>=0; child-- )
			{
				var opt1 = $( select_list[child] );
				
				for( var i = parseInt( opt1.attr('col') ) - child; i < children.length; i++ )
				{
					var opt2 = $( children[i] );
					t_mover.fnColReorder( parseInt( opt1.attr('col') ), parseInt( opt2.attr('col') ) );
					opt2.attr('col', opt1.attr('col'));
					opt1.attr('col', parseInt(opt1.attr('col')) + 1);
				}
				
				select_av.prepend(opt1);
			}
			
			//for( var i = av_children.length - select_list.length-2; i >= 0; i-- )
			//{
			//	var tmp = $( av_children[i] );
			//	tmp.attr('col', parseInt( tmp.attr('col') ) - select_list.length);
			//}
			
			//for( var i = av_children.length - 1; i > av_children.length - select_list.length; i-- )
			//{
			//	var tmp = $( av_children[i-1] );
			//	var tmp1 = $( av_children[i] );
			//	tmp.attr('col', parseInt(tmp1.attr('col'))-1);
			//}
			
			for(var i = 0; i<children.length; i++)
			{
				var tmp1 = $( children[i] );
				tmp1.attr('value', i );
			}
			
			var av_children = select_av.children();
			
			for(var i = 0; i<av_children.length; i++)
			{
				var tmp1 = $( av_children[i] );
				tmp1.attr('value', i );
			}
			
			if( table.order()[0][0] > select_se.length )
			{
				table.order([0, 'asc']).draw();
			}
			
			table.columns.adjust();
			
			select_se.val(new_selected);
			
			if ( table.columns().indexes().length == hidden_columns.length )
				$('#empty_table').show();
		}
	});
	
	$('.colMoveUP').on('click', function(){
		var select_se = $( '#'+$( this ).attr( 'data-div_se' ) );
		var children = select_se.children();
		var t_mover = $('#configtenant_shownodes').dataTable();
		
		var select_values = select_se.val();
		var select_list   = [];
		
		if(select_values != null && select_values[0] != 0)
		{
			for( child in select_values )
			{
				elem = children[ parseInt( select_values[child] ) ];
				select_list.push(elem);
			}
			
			for( child in select_list )
			{
				var opt1 = $( select_list[child] );
				
				var opt2 = $( select_se.children()[ opt1.attr('value')-1 ] );
				
				var tmp = opt1.attr('value');
				
				opt1.attr('value', opt2.attr('value'));
				opt2.attr('value', tmp);
				
				opt1.remove();
				opt2.before(opt1);
				
				tmp = opt1.attr('col');
				t_mover.fnColReorder(parseInt(opt1.attr('col')), parseInt(opt2.attr('col')));
				opt1.attr('col', opt2.attr('col'));
				opt2.attr('col', tmp);
			}
			table.columns.adjust();
		}
	});
	
	$('.colMoveDOWN').on('click', function(){
		var select_se = $( '#'+$( this ).attr( 'data-div_se' ) );
		var children = select_se.children();
		var t_mover = $('#configtenant_shownodes').dataTable();
		
		var select_values = select_se.val();
		var select_list   = [];
		
		if(select_values != null && select_values[select_values.length-1] != children.length-1)
		{
			for( child in select_values )
			{
				elem = children[ parseInt( select_values[child] ) ];
				select_list.push(elem);
			}
			
			for( var i = select_list.length-1; i>= 0; i-- )
			{
				var opt1 = $( select_list[i] );
				
				var opt2 = $( select_se.children()[ parseInt( opt1.attr('value') )+1 ] );
				
				var tmp = opt1.attr('value');
				
				opt1.attr('value', opt2.attr('value'));
				opt2.attr('value', tmp);
				
				opt1.remove();
				opt2.after(opt1);
				
				tmp = opt1.attr('col');
				t_mover.fnColReorder(parseInt(opt1.attr('col')), parseInt(opt2.attr('col')));
				opt1.attr('col', opt2.attr('col'));
				opt2.attr('col', tmp);
			}
			table.columns.adjust();
		}
	});
	
	$('.colMover').on('click', function(){
		save_conf();
	});
}

//
// Salvataggio della configurazione della tabella sul server
//
var save_conf = function()
{
	var table      = $('#configtenant_shownodes').DataTable();
	var order      = table.columns().dataSrc();
	var cell_order = table.order();
	var col_order  = [];
	
	for( var i=0; i<order.length; i++ )
	{
		var label = order[i];
		col_order.push( label );
	}
	
	$.ajax({
		'url' : data.url.conf_save,
		'type': 'POST',
		'data': {
				'cell_order': JSON.stringify( cell_order ),
				'col_order' : JSON.stringify( col_order ),
				'columns'   : JSON.stringify( columns.concat([url_column]) ),
				'hidden'    : JSON.stringify( hidden_columns ),
				'length'    : table.page.len()
			}
	});
}

var TEMPLATE = '\
<table id="configtenant_shownodes" width="100%" class="gui-table tablesorter">\
	<thead>\
		<tr class="gui-tr">\
			{{#columns}}\
				<th class="gui-th header {{group}} {{data}}" style="cursor: pointer;">{{data}}</th>\
			{{/columns}}\
		</tr>\
	</thead>\
</table>\
'

var DESKTOP_CONF = '\
<div id="desktop_conf">\
	<table class="conf_table">\
		<body>\
			<tr>\
				<th style="text-align: left;">\
					<div class="conf_left_tab conf_tab conf_tab_inactive toggler" data-div="Col_reorder">\
						Config\
						<i class="fa fa-chevron-down"></i>\
					</div>\
				</th>\
				<th style="text-align: left;">\
					<div class="conf_right_tab conf_tab conf_tab_inactive toggler" data-div="tag_selector_div">\
						Search\
						<i class="fa fa-chevron-down"></i>\
					</div>\
				</th>\
			</tr>\
			<tr>\
				<td>\
					<div id="Col_reorder" style="display: none;" class="block Col_reorder">\
								<table style="padding-bottom: 5px;">\
									<tbody>\
										<tr>\
											<td>\
												Available Columns\
											</td>\
											<td>\
											</td>\
											<td>\
												Selected Columns\
											</td>\
											<td>\
											</td>\
										</tr>\
										<tr>\
											<td>\
												<select id="available_columns" class="col_selector available_columns" multiple="multiple">\
												</select>\
											</td>\
											<td>\
												<button id="" class="gui-button colMover colShow" data-div_av="available_columns" data-div_se="selected_columns"><i class="fa icon-arrow-right"></i></button><br>\
												<button id="" class="gui-button colMover colHide" data-div_av="available_columns" data-div_se="selected_columns"><i class="fa icon-arrow-left"></i></button><br>\
											</td>\
											<td>\
												<select id="selected_columns" class="col_selector selected_columns" multiple="multiple">\
												</select>\
											</td>\
											<td>\
												<button id="" class="gui-button colMover colMoveUP" data-div_se="selected_columns"><i class="fa icon-arrow-up"></i></button><br>\
												<button id="" class="gui-button colMover colMoveDOWN" data-div_se="selected_columns"><i class="fa icon-arrow-down"></i></button><br>\
											</td>\
										</tr>\
									</tbody>\
								</table>\
					</div>\
				</td>\
				<td>\
					<div id="tag_selector_div" style="display: none; width: 100%;" class="block tag_selector_div">\
						<div style="padding-top: 5px; display: table; width: 100%">\
							<i class="fa icon-filter" style="display: table-cell"></i>\
							<select class="tag_selector" value="None" style="width: 100%;">\
								<option value="None">None</option>\
							</select>\
						</div>\
						<div style="display: table; width: 100%; padding-top: 5px;">\
							<label style="display: table-cell;">\
								Search:	\
							</label>\
							<span style="display: table-cell; width: 100%; padding: 0px 10px;">\
								<input id="table_search" class="table_search" style="display: table-cell; width: 100%;">\
							</span>\
							<button class="apply_tag_filter" style="display: table-cell;" data-div="table_search">\
								<i class="icon-search"></i>\
							</button>\
						</div>\
					</div>\
				</td>\
			</tr>\
		</body>\
	</table>\
</div>\
'

var MOBILE_CONF = '\
<div id="mobile_conf" hidden>\
	<table class="conf_table">\
		<body>\
			<tr>\
			<table>\
				<body>\
					<tr>\
						<th style="text-align: left;">\
							<div class="conf_right_tab conf_tab conf_tab_inactive toggler" data-div="Col_reorder-mobile">\
								Config\
								<i class="fa fa-chevron-down"></i>\
							</div>\
						</th>\
					</tr>\
					<tr>\
						<td>\
							<div id="Col_reorder-mobile" style="display: none; height: 105%;" class="block Col_reorder">\
								<table style="padding-bottom: 5px;">\
									<tbody>\
										<tr>\
											<td>\
												Available Columns\
											</td>\
											<td>\
											</td>\
											<td>\
												Selected Columns\
											</td>\
											<td>\
											</td>\
										</tr>\
										<tr>\
											<td>\
												<select id="available_columns-mobile" class="col_selector available_columns" multiple="multiple">\
												</select>\
											</td>\
											<td>\
												<button id="" class="gui-button colMover colShow" data-div_av="available_columns-mobile" data-div_se="selected_columns-mobile"><i class="fa icon-arrow-right"></i></button><br>\
												<button id="" class="gui-button colMover colHide" data-div_av="available_columns-mobile" data-div_se="selected_columns-mobile"><i class="fa icon-arrow-left"></i></button><br>\
											</td>\
											<td>\
												<select id="selected_columns-mobile" class="col_selector selected_columns" multiple="multiple">\
												</select>\
											</td>\
											<td>\
												<button id="" class="gui-button colMover colMoveUP" data-div_se="selected_columns-mobile"><i class="fa icon-arrow-up"></i></button><br>\
												<button id="" class="gui-button colMover colMoveDOWN" data-div_se="selected_columns-mobile"><i class="fa icon-arrow-down"></i></button><br>\
											</td>\
										</tr>\
									</tbody>\
								</table>\
							</div>\
						</td>\
					</tr>\
				</body>\
			</table>\
			</tr>\
			<tr>\
				<table width="100%">\
					<body>\
						<tr>\
						<th style="text-align: left;">\
							<div class="conf_right_tab conf_tab conf_tab_inactive toggler" data-div="tag_selector_div-mobile">\
								Search\
								<i class="fa fa-chevron-down"></i>\
							</div>\
						</th>\
						</tr>\
						<tr>\
							<td>\
								<div id="tag_selector_div-mobile" style="display: none; height: 105%;" class="block tag_selector_div">\
									<div style="padding-top: 5px; display: table; width: 100%">\
										<i class="fa icon-filter" style="display: table-cell"></i>\
										<select class="tag_selector" value="None" style="width: 100%;">\
											<option value="None">None</option>\
										</select>\
									</div>\
									<div style="display: table; width: 100%; padding-top: 5px;">\
										<label style="display: table-cell;">\
											Search:	\
										</label>\
										<span style="display: table-cell; width: 100%; padding: 0px 10px;">\
											<input id="table_search-mobile" class="table_search" style="display: table-cell; width: 100%;">\
										</span>\
										<button class="apply_tag_filter" style="display: table-cell;" data-div="table_search-mobile">\
											<i class="icon-search"></i>\
										</button>\
									</div>\
								</div>\
							</td>\
						</tr>\
					</body>\
				</table>\
			</tr>\
		</body>\
	</table>\
</div>\
'

var EMPTY_TABLE = '\
<div id="empty_table" style="text-align: center; display: none;">\
All columns are hidden, please select at least one in order to display any data\
</div>\
'

WDS.wlib['shownodes'] = shownodes;
