/**
 * Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
 * Created: 10/31/14, 11:31 AM
 * Author: Antonio Vaccarino
 */

timegraph4 = {};

timegraph4.PADDING = 5;
timegraph4.GRAPH_RIGHT_PADDING = 8;

timegraph4.DEFAULTS = {};

timegraph4.CONST = {};
timegraph4.CONST.DIV_CHART        = "jswlib_tg3_chart";
timegraph4.CONST.DIV_CHART_CANVAS = "jswlib_tg3_chart_canvas";

timegraph4.FONTSIZE = 11;

timegraph4.SQUARE_SIZE = timegraph4.FONTSIZE + 2;
timegraph4.LINE_GAP    = 2;

timegraph4.RENDER_SQUARED  = 1;
timegraph4.RENDER_LINE     = 2;
timegraph4.OPACITY         = 0.4
timegraph4.AREA_STROKE_WIDTH = 1.25;

timegraph4.ONE_MINUTE = 60;
timegraph4.ONE_HOUR   = timegraph4.ONE_MINUTE * 60;
timegraph4.ONE_DAY    = timegraph4.ONE_HOUR   * 24;
timegraph4.ONE_WEEK   = timegraph4.ONE_DAY    * 7;
timegraph4.ONE_MOUNTH = timegraph4.ONE_DAY    * 31;
timegraph4.ONE_YEAR   = timegraph4.ONE_DAY    * 365;


function guid() 
{
	function s4() {
		return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
	}
	return s4() + s4() + '-' + s4() + '-' + s4() + '-' + s4() + '-' + s4() + s4() + s4();
}

function TRUNC(v)
{
	if (v > 0)
		return Math.floor(v);
	else
		return Math.ceil(v);
}

timegraph4.LINE_GREY = { 
	stroke           : '#d0d0d0', 
	strokeWidth      : 1, 
	"shape-rendering":"crispEdges" 
};

timegraph4.LINE_BLUE = { 
	stroke           : '#0000ff', 
	strokeWidth      : 1, 
	"shape-rendering":"crispEdges" 
};

timegraph4.LINE_RED = { 
	stroke           : '#ff0000', 
	strokeWidth      : 2, 
	"shape-rendering":"crispEdges" ,
	"stroke-dasharray": "5,5"
};

var ATTRIB_BLACK_LINE = { 
	stroke           : 'black', 
	strokeWidth      : 1, 
	"shape-rendering": "crispEdges", 
	"z-index"        : 8000 
};

// IE9 does not support Math.log10
function log10(val) 
{
	return Math.log(val) / Math.LN10;
}

function pad(i) 
{
	if (i<10) return "0"+i;
	return i;
}

function padspace(i) 
{
	if (i<10) return " "+i;
	return i;
}

function IS_INSIDE( gui_object, x, y)
{
	return (gui_object.x <= x && x <= (gui_object.x + gui_object.width) && gui_object.y <= y && y <= (gui_object.y + gui_object.height));
}

function guid() 
{
	function s4() {
		return Math.floor((1 + Math.random()) * 0x10000)
			.toString(16)
			.substring(1);
	}
	return s4() + s4() + '-' + s4() + '-' + s4() + '-' + s4() + '-' + s4() + s4() + s4();
}

var TIME_RANGES = {
	"1y" : 60 * 60 * 24 * 365 ,
	"6m" : 60 * 60 * 24 * 180 ,
	"3m" : 60 * 60 * 24 * 90  ,
	"1m" : 60 * 60 * 24 * 30  ,
	"7d" : 60 * 60 * 24 * 7   ,
	"3d" : 60 * 60 * 24 * 3   ,
	"24h": 60 * 60 * 24       ,
	"8h" : 60 * 60 * 8        ,
	"4h" : 60 * 60 * 4        ,
	"1h" : 60 * 60
};

function addTimestamp(date, ts) {
	var result = new Date(date);
	result.setTime(result.getTime() + ts);//*1000);
	return result;
}

Date.prototype.addSeconds = function (num) {
    return addTimestamp(this, num * 1000);
}

Date.prototype.addMinutes = function (num) {
    return this.addSeconds(num * 60);
}

Date.prototype.addHours = function (num) {
	return this.addMinutes(num * 60)
}

Date.prototype.addMonths = function (num) {
    var value = new Date(this.valueOf());

    var mo = this.getMonth();
    var yr = this.getYear();

    mo = (mo + num) % 12;
    if (0 > mo) {
        yr += (this.getMonth() + num - mo - 12) / 12;
        mo += 12;
    }
    else
        yr += ((this.getMonth() + num - mo) / 12);

    value.setMonth(mo);
    value.setYear(yr);
    return value;
}

Date.prototype.cloneDate = function() {
	return new Date(this.valueOf())	
}

Date.prototype.gotoNextDay = function () {
	next_date = this.cloneDate();
	next_date.setDate(next_date.getDate() + days);
	return next_date;
}

Date.prototype.gotoNextWeek = function () {
	next_date = this.cloneDate();
	next_date.setDate(next_date.getDate() + 7);
	next_date = next_date.cloneDate();
	
	while (next_date.getDay() != 1) {
		next_date.setDate( next_date.getDate() - 1 );
	}
		
	return next_date;
}

Date.prototype.addDays = function (days) { 
	var dat = new Date(this.valueOf());
	dat.setDate(dat.getDate() + days);

	return dat;
}

/******************************************************************************/
/******************************************************************************/
/******************************************************************************/

function get_data_index_by_ts(series, ts)
{
	serie = series[0];

	var values = serie['values'];

	if (serie['format'] == 'changesequence') {
		// formato: < ts_start, ts_end, duration, state >

		for (var i=0; i < values.length; i++)
			if (values[i][0] <= ts && ts <= values[i][1])
				return i;
			;
		return null;
	}
	else {
		// format: <ts, value>
		
		for (var i=0; values[i][0] < ts && i < values.length; i++)
			;
			
		if (i < values.length)
			return i - 1;
		else
			return null;
	}
}

/******************************************************************************/
/******************************************************************************/
/******************************************************************************/

timegraph4.GraphArea = function GraphArea(id, graph, x,y, width, height, attributes)
{
	this.id = id;

	this.graph = graph;

	this.x      = x;
	this.y      = y;
	this.width  = width;
	this.height = height;

	this.attributes = attributes;

	this.visible = true;

	this.main_graph = null;

	this.svg_group = null;

	this.start_ts = null;
	this.end_ts   = null;
	this.step     = null;

	this.on_mouse_move = null;

	this.selecting_start_ts  = null;
	this.svg_selection_cover = null;

	this.on_selection_change = null;  

	// CLIPPING AREA
	var defs = this.graph.svg.defs();
	this.svg_clippath = this.graph.svg.clipPath(defs, guid());
	this.graph.svg.rect(this.svg_clippath, this.x+1, this.y+1, this.width-2, this.height-2, {'fill':'black', strokeWidth: 0});
};

timegraph4.GraphArea.prototype.getRequiredHeight = function()
{
	if (this.visible) 
		height = this.height;
	else
		height = 0;
		
	return height;
};

timegraph4.GraphArea.prototype.getSVGGroup = function()
{
	if (this.svg_group == null)
		this.svg_group = this.graph.svg.group(null, guid());

	return this.svg_group;
};


timegraph4.GraphArea.prototype.destroy = function()
{
        if (!this.visible) return;

        if (this.svg_group != null) {
                $("#" + this.svg_group.id, this.graph.svg.root()).remove();
                this.svg_group = null;
        }

        this.graph = null;
};


timegraph4.GraphArea.prototype.clean = function()
{
	if (!this.visible) return;

	if (this.svg_group != null) {
		$("#" + this.svg_group.id, this.graph.svg.root()).remove();
		this.svg_group = null;
	}
};

timegraph4.GraphArea.prototype.setVisibility = function (bool)
{
	if (bool == false) {
		if (this.svg_group != null && this.svg_group != undefined) 
			$(this.svg_group).css('display', 'none'); // set
	}
	else
		if (this.svg_group != null && this.svg_group != undefined) 
			$(this.svg_group).css('display', ''); /* unset (works with ie11 too */		
		
	this.visible = bool;
};

timegraph4.GraphArea.prototype.setTimeRange = function(ts_s, ts_e)
{
	this.start_ts = ts_s;
	this.end_ts   = ts_e;
};

timegraph4.GraphArea.prototype.line = function line(parent, x1, y1, x2, y2, attributes)
{
	if (!this.visible) return;
	
	var attributes = jQuery.extend({}, attributes);
	
	attributes['clipPath'] = 'url(#' + this.svg_clippath.id + ')'

	//this.graph.svg.line(parent, this.x + x1, this.y+this.height-y1, this.x + x2, this.y+this.height-y2, attributes);
	this.graph.svg.line(parent, this.x + x1, this.y+y1, this.x + x2, this.y+y2, attributes);
};


timegraph4.GraphArea.prototype.render = function render()
{
	this.renderBorder();
};

timegraph4.GraphArea.prototype.renderBorder = function renderBorder()
{
	if (!this.visible) 
		return;

	g = this.getSVGGroup();

	this.svg_rect = this.graph.svg.rect(g, this.x, this.y, this.width, this.height, //this.attributes
		{fill: 'none', stroke: '#000000', strokeWidth: 1, "shape-rendering":"crispEdges" }
	
	); 
};

timegraph4.GraphArea.prototype.renderMouseLines = function renderMouseLines(mouse_x, mouse_y)
{
	var svg = this.graph.svg; //canvas.svg('get');
	
	if (!this.visible) return;

	// Cancelliamo le righe precedenti
	if (this.mouse_h_line != undefined) {
		$("#" + this.mouse_h_line.id, this.graph.svg.root()).remove();
		$("#" + this.mouse_v_line.id, this.graph.svg.root()).remove();
	}

	if (! IS_INSIDE(this, mouse_x, mouse_y))
		return;

	this.mouse_h_line = svg.line(null, this.x , mouse_y, this.x + this.width, mouse_y                    , {id: guid(), stroke: 'black', strokeWidth: 1, "shape-rendering":"crispEdges", "z-index": 8000} );
	this.mouse_v_line = svg.line(null, mouse_x, this.y , mouse_x            , this.y + this.height       , {id: guid(), stroke: 'black', strokeWidth: 1, "shape-rendering":"crispEdges", "z-index": 8000} );
};

timegraph4.GraphArea.prototype.renderSeries = function renderSeries (series, start_ts, end_ts)
{
	if (!this.visible) 
		return;

	//console.log(this.id + ".GraphArea.renderSeries("+start_ts+","+end_ts+")");
	//console.log("\tstart_ts " + start_ts);
	//console.log("\tend_ts   " + end_ts  );

	if (start_ts == undefined) start_ts = this.start_ts;
	if (end_ts   == undefined) end_ts   = this.end_ts;
	
	//console.log("\tstart_ts " + start_ts);
	//console.log("\tend_ts   " + end_ts  );

	this.clean();
	
	g = this.getSVGGroup();

	this.renderBorder();

	var value_ranges = get_min_max_in_range(series, start_ts, end_ts);
	this.min_value = value_ranges['min'];
	this.max_value = value_ranges['max'];

	//
	// Ordiniamo le serie in ordine di rendering
	//
	var ordered_series = new Array();
	for (var i=0; i < series.length; i++)  {
		ordered_series.push(series[i]);
	}
	FORMAT_FACTOR = {
		'area': 1,
		'line': 100,
		'tick': 1000
	};
	ordered_series.sort(function(s1, s2){ 
		var v1 = FORMAT_FACTOR[s1['format']] + s1['order'];
		if (v1 == undefined || isNaN(v1)) v1 = 0;
		var v2 = FORMAT_FACTOR[s2['format']] + s2['order'];
		if (v2 == undefined || isNaN(v2)) v2 = 0;
		return ( v1 - v2 ) 
	});
	
	//
	// Render vero e proprio
	//
	for (var i=0; i < ordered_series.length; i++) {
		
		this.renderSerie( ordered_series[i], start_ts, end_ts );
	}

	if (this.max_value != null && this.graph.gui_settings['virtual-max-value'] != null && this.graph.gui_settings['virtual-max-value'] < this.max_value) {

		var svg = this.graph.svg;
		
		var value = this.graph.gui_settings['virtual-max-value'];
		var max_value = this.max_value;
		var min_value = this.min_value;
		this.x_origin = this.x;
		this.y_origin = this.y + this.height-1;
		// Normalmente l'asse Y (y=0) e' attaccato alla parte bassa del grafico.
		// Se abbiamo valori negativi, l'assy Y deve essere "centrato" sul grafico.
		var real_y_origin = this.y_origin;
		if (min_value < 0) {
			real_y_origin = real_y_origin - ((this.height / (max_value - min_value)) * (-min_value));
		}		
		var y_rel = ((this.height / (max_value - min_value)) * value)
		var y  = real_y_origin - y_rel;
		svg.line(this.svg_group, this.x,  y, this.x+this.width, y, timegraph4.LINE_RED );
	}
};

timegraph4.GraphArea.prototype.renderSerie = function renderSerie(serie, start_ts, end_ts)
{
	if (!this.visible) return;

	var svg = this.graph.svg;
	
	if (start_ts == undefined && end_ts == undefined) {
		var start_ts = this.start_ts;
		var end_ts   = this.end_ts;
	}
	
	var max_value = this.max_value;
	var min_value = this.min_value;
	
	this.x_origin = this.x;
	this.y_origin = this.y + this.height-1;
	
	
	//if      ((end_ts - start_ts) > (timegraph4.ONE_DAY  * 20))  max_steps =  500;
	//else if ((end_ts - start_ts) > (timegraph4.ONE_WEEK * 20))	 max_steps =  100;
	//else if ((end_ts - start_ts) > (timegraph4.ONE_DAY  * 24))  max_steps =   20;
	//else                                             max_steps =    1;
	function mytrunc(val)
	{
		if (val > 0)
		{
			return Math.floor(val);
		}
		else
		{
			return Math.ceil(val)
		}
	}
	//console.log("Errore-------------------------------------------------------------------------------------_");
	//var c = cals/0;
	var min_visible_time_slice = (end_ts - start_ts) / this.width;
	if (min_visible_time_slice >= serie.timescale.step)
		//max_steps = Math.trunc(min_visible_time_slice / serie.timescale.step);
		max_steps = mytrunc(min_visible_time_slice / serie.timescale.step);
	else
		max_steps = 1;
	
	step = serie.timescale.step * max_steps;

	console.log("SERIE FORMAT       : " + serie['format']);
	console.log("VIS STEP LENGTH    : " + min_visible_time_slice + " seconds");
	console.log("GRAPH STEP         : " + serie.timescale.step   + " seconds");
	console.log("MAX STEPS PER PIXEL: " + max_steps);
	console.log("STEP               : " + step);


	
	var data = serie['values'];
	
	// Normalmente l'asse Y (y=0) e' attaccato alla parte bassa del grafico.
	// Se abbiamo valori negativi, l'assy Y deve essere "centrato" sul grafico.
	var real_y_origin = this.y_origin;
	if (min_value != null && min_value < 0) {
		real_y_origin = real_y_origin - ((this.height / (max_value - min_value)) * (-min_value));
	}
	
	
	
	var render_mode = timegraph4.RENDER_LINE;
	//var render_mode = timegraph4.RENDER_SQUARED;
	
	if (serie['format'] == 'line' || serie['format'] == "area") {

		var color = serie['color'];
		
		var polyline = new Array();
		
		// variabili per aggregare i dati del grafico
		var step_count = 0;
		var step_ts    = null;
		var step_max_v = null;

		
		for (var v=0; v < data.length; v++)  {

			var ts    = data[v][0];
			var value = data[v][1];

			// Punto fuori grafico a destra?
			if (ts > end_ts)
			{
				var p_value = data[v-1][1];
				var p_ts    = data[v-1][0];
				
				var y2_rel  = ((this.height / (max_value - min_value)) * value  );
				var y1_rel  = ((this.height / (max_value - min_value)) * p_value);
				
				var x2      = ts_to_x_axis_pos(0, this.width, start_ts, end_ts, ts  );
				var p_x1    = ts_to_x_axis_pos(0, this.width, start_ts, end_ts, p_ts);
				
				var k       = (y2_rel - y1_rel) / (x2 - p_x1);
				var c       = y2_rel - (k * x2);
				
				var x_edge  = this.x_origin + this.width;
				
				var y       = real_y_origin - ( (k * x_edge) + c );
				
				polyline.push([x_edge, y]);
				
				break;
			}
			
			// Punto fuori grafico a sinistra?
			if (ts < start_ts) {
				
				//ts = null;
				//if (v < (data.length - 1)) {
				//	if (data[v+1][0] >= start_ts) {
				//		ts = Math.max(ts, start_ts)
				//	}
				//}
				//
				//if (ts == null)
					continue;
			}
			
			//
			// Aggreghiamo i valori
			//
			
			// Prendiamo il valore del picco (positivo o negativo) massimo
			if (value != null) {
				if (value >= 0) {
					if (step_max_v < value) {
						step_max_v = value; 
					}
				}
				else {
					if (step_max_v > value) {
						step_max_v = value;
					}
				}
			}

			// Come timestamp dei valori aggregati usiamo il primo della serie
			if (step_count == 0)
				step_ts    = ts;

			step_count += 1
			
			if (step_count < max_steps) {
				continue
			}
			
			// Prendamo il valore scelto
			value = step_max_v;
			ts    = step_ts;
			
			step_max_v = null;
			step_ts    = null;
			step_count = 0
			
			
			//
			//            (B)--------C
			//             |
			//             |
			//             |
			//   *---------A
			//             x1        x2
			//
			//  last      current    next    
			//  value     value      value

			var x1 = ts_to_x_axis_pos(0, this.width, start_ts, end_ts, ts     );

			if (render_mode == timegraph4.RENDER_SQUARED) {
				// prossimo punto (per la visualizzaizone a scalini)
				var next_ts = (v < data.length - 1) ? data[v+1][0] : ts + step;
				next_ts = Math.min(next_ts, end_ts);
				var x2 = ts_to_x_axis_pos(0, this.width, start_ts, end_ts, next_ts);
			}
			
			if (value != null) {

				//
				// Linea verticale A-B
				//
				
				// Il punto A e' gia' nella polyline a meno che non la polyline non sia vuota (quindi prima c'e' un buco)
				// Se prima c'era un buco dobbiamo tirare una riga verticale dal punto (A)
				if (polyline.length == 0){
					
					if (v > 0 && data[v-1][0] < start_ts)
					{
						var p_value = data[v-1][1];
						var p_ts    = data[v-1][0];
						
						var y2_rel  = ((this.height / (max_value - min_value)) * value  );
						var y1_rel  = ((this.height / (max_value - min_value)) * p_value);
						
						var x2      = x1;
						var p_x1    = ts_to_x_axis_pos(0, this.width, start_ts, end_ts, p_ts);
						
						var k       = (y2_rel - y1_rel) / (x2 - p_x1);
						
						var c       = y2_rel - (k * x2);
						
						var y       = real_y_origin - c;
						
						polyline.push([this.x_origin, real_y_origin]);
						polyline.push([this.x_origin, y]);
					}
					else
					{
						polyline.push([this.x_origin+x1, real_y_origin]);
					}
				}
				
				//
				// Linea orizzontale B-C
				//
				var y_rel = ((this.height / (max_value - min_value)) * value);
				var y  = real_y_origin - y_rel;

				polyline.push([this.x_origin + x1, y]);
				
				if (render_mode == timegraph4.RENDER_SQUARED) {
					polyline.push([this.x_origin + x2, y]);
					last_x = x2;
				}
				else
					last_x = x1;
			}
			else {
				// C'e' un buco, ma se qualcosa avevamo disegnato allora dobbiamo "chiudere" il grafico con una linea verticale A-B
				if (polyline.length > 0) {

					// Linea verticale A-B  fino all'asse y=0
					polyline.push([this.x_origin + last_x    , real_y_origin]);

					// Disegnamo quanto fatto fino ad ora
					if (serie['format'] == "line")
						svg.polyline(this.svg_group, polyline, {fill: "none", stroke: color, strokeWidth: 1, "shape-rendering":"crispEdges", clipPath: 'url(#' + this.svg_clippath.id + ')' });
					else
						svg.polygon(this.svg_group, polyline, { 
							stroke: color, 
							strokeWidth: timegraph4.AREA_STROKE_WIDTH, 
							fill: color, 
							"fill-opacity": timegraph4.OPACITY,  
							//"shape-rendering":"crispEdges", 
							clipPath: 'url(#' + this.svg_clippath.id + ')' 
						});
						
					// Azzeriamo la polyline perche' da qui comincia il "buco".
					polyline = new Array();
				}

				last_x = null;
			}
		}
		
		// E' rimasto qualcosa da disegnare
		if (polyline.length > 0) {
			if (serie['format'] == "line") {
				svg.polyline(this.svg_group, polyline, {fill: "none", stroke: color, strokeWidth: 1, "shape-rendering":"crispEdges", clipPath: 'url(#' + this.svg_clippath.id + ')' });
			}
			else {
				// chiudiamo il poligono con una ultima linea verticale in corrispondenza dell'ultimo punto.
				last_x = polyline[ polyline.length -1 ][0];
				polyline.push([last_x, real_y_origin]); 
				
				svg.polygon(this.svg_group, polyline, { 
					stroke: color, 
					strokeWidth: timegraph4.AREA_STROKE_WIDTH, 
					fill: color, 
					"fill-opacity": timegraph4.OPACITY,  
					//"shape-rendering":"crispEdges", 
					clipPath: 'url(#' + this.svg_clippath.id + ')' 
				});
			}
		}
		
	}
	
	//
	// Aggrego i dati delle serie dei tick
	//
	else if (serie['format'] == 'tick') {
		
		var color = serie['color'];
		
		var step_count       = 0;
		var step_ts_start    = null;
		var step_ts_end      = null;
		var step_start_x     = null;
		
		var empty_step_count = 0;
		var empty_start_x    = null;
		
		var last_value       = null;
		
		var x                = 0;
		
		var first            = true;
		
		
		//console.log("DRAWING TICK SERIE");

		for (var v=0; v < data.length; v++)  {

			var ts    = data[v][0];
			var value = data[v][1];
			
			if (ts > end_ts || v == data.length - 1)
			{
				var p_value = data[v-1][1];
				var p_ts    = data[v-1][0];
				
				if ( p_value > 0 || (empty_step_count < max_steps && step_count > 0) )
				{
					var x1 = step_start_x; //ts_to_x_axis_pos(0, this.width, this.start_ts, this.end_ts, p_ts);
					var x2 = this.x_origin + this.width;
					svg.rect(this.svg_group, this.x_origin+x1, this.y, x2 - x1, this.height, {fill: color, stroke: color, strokeWidth: 1, "shape-rendering":"crispEdges", clipPath: 'url(#' + this.svg_clippath.id + ')' });
				}
				break;
			}

			if (ts < start_ts)
				continue;
			
			//// se minore a zero salto il ciclo
			//if (value < 0)
			//	continue;
			if ( first  && data[v-1] != undefined && data[v-1][1] > 0)
			{
				var p_value = data[v-1][1];
				var p_ts    = data[v-1][0];
				
				step_count   += 1;
				step_ts_start = p_ts;
				step_start_x  = ts_to_x_axis_pos(0, this.width, this.start_ts, this.end_ts, step_ts_start);
				
				last_value    = p_value;
				
				first         = false;
			}
			
			if (value > 0)
			{
				// se e' il primo step prendo il ts di inizio dell'aggregazione
				if (step_count == 0)
				{
					step_ts_start = ts;
				}
				
				step_count +=1;
				last_value = value;
				
				// x di inizio aggregazione
				if (step_start_x == null)
					step_start_x = ts_to_x_axis_pos(0, this.width, this.start_ts, this.end_ts, step_ts_start);
			
				// salto il valore da aggregare
				if (empty_step_count < max_steps)
					continue;
			}
			
			if (value <= 0 && step_count > 0)
			{
				if(last_value != 0)
				{
					empty_step_count = 0;
					empty_start_x    = ts_to_x_axis_pos(0, this.width, this.start_ts, this.end_ts, ts);
				}
				
				empty_step_count += 1;
				last_value        = 0;
				
				if (empty_step_count < max_steps)
				{
					continue;
				}
				
				else
				{
					x = empty_start_x;
				}
			}
			
			// se il valore della serie e' 0 o e' stato raggiunto il numero massimo di step finisco di aggregare e disegno
			if ( empty_step_count >= max_steps && step_count > 0 )
			{
				
				//var x = ts_to_x_axis_pos(0, this.width, this.start_ts, this.end_ts, ts);
				
				//sconsole.log("STEP START X: ", step_start_x);
				//sconsole.log("END X       : ", x);
				//sconsole.log("HEIGHT      : ", this.y + this.height);
				
				// se la granularita' e' del pixel disegna una linea
				if (step_start_x == x)
				{
					svg.line(this.svg_group, this.x_origin+x, this.y, this.x_origin+x, this.height + this.y, {fill: color, stroke: color, strokeWidth: 1, "shape-rendering":"crispEdges", clipPath: 'url(#' + this.svg_clippath.id + ')' });
					
					//step_count    = 0;
					//step_start_x  = null;
					//step_ts_start = null;
				}
				
				// se la granularita' e' maggiore del pixel disegna un rettangolo
				else
				{
					svg.rect(this.svg_group, this.x_origin+step_start_x, this.y, x-step_start_x, this.height, {fill: color, stroke: color, strokeWidth: 1, "shape-rendering":"crispEdges", clipPath: 'url(#' + this.svg_clippath.id + ')' });
					
					//step_count    = 0;
					//step_start_x  = null;
					//step_ts_start = null;
					
					//if ( value > 0 )
					//	step_start_x = x;
				}
				
				if ( step_count > 0 )
				{
					step_count       = 0;
					step_start_x     = null;
					step_ts_start    = null;
					empty_step_count = 0;
				}
			}
			
		}
	}
	
	else if (serie['format'] == 'changesequence') {

		colors_palette = serie['color'];

		for (var v=0; v < data.length; v++)  {
			
			//color = '#00ff00';
			color = colors_palette[data[v][3]];
			
			var ts_s    = data[v][0];
			var ts_e    = data[v][1];
			
			if (ts_s < this.start_ts) ts_s = this.start_ts;
			if (ts_e > this.end_ts  ) ts_e = this.end_ts;

			var x1 = ts_to_x_axis_pos(0, this.width, this.start_ts, this.end_ts, ts_s );
			var x2 = ts_to_x_axis_pos(0, this.width, this.start_ts, this.end_ts, ts_e );

			svg.rect(this.svg_group, this.x_origin+x1, this.y, x2-x1, this.height, {fill: color, stroke: color, strokeWidth: 1, "shape-rendering":"crispEdges", clipPath: 'url(#' + this.svg_clippath.id + ')' });
		}

	}
}

timegraph4.GraphArea.prototype.removeSelection = function removeSelection()
{
	if (!this.visible) return;

	var svg = this.graph.svg;

	$("#" + this.id+'_selection', svg.root()).remove();
	this.svg_selection_cover = null;
}

timegraph4.GraphArea.prototype.renderSelection = function renderSelection(selection_start_ts, selection_end_ts, attach_to_main_graph)
{
	if (!this.visible) return;

	var svg = this.graph.svg;
	
	var x_start = ts_to_x_axis_pos(0, this.width, this.start_ts, this.end_ts, selection_start_ts);
	var x_end   = ts_to_x_axis_pos(0, this.width, this.start_ts, this.end_ts, selection_end_ts);


	if (this.main_graph == null) {

		if (this.svg_selection_cover == undefined) {

			this.svg_selection_cover = svg.rect(
					this.svg_group,
					0, 
					this.y, 
					0, 
					this.height, 
					{ 
						id               : this.id+'_selection',
						fill             : '#00aaff', 
						stroke           : 'blue', 
						"stroke-opacity" : 0.3,
						"fill-opacity"   : 0.3,
						strokeWidth      : 3, 
						"shape-rendering":"crispEdges"
					}
			); 
		}
		
		this.svg_selection_cover.setAttribute('x'    , x_start + this.x);
		this.svg_selection_cover.setAttribute('width', x_end - x_start);
	}

	else {
		if (this.svg_selection_cover != undefined) {
			$("#"+this.id+'_selection', svg.root()).remove();//this.svg_selection_cover.
			this.svg_selection_cover = null;
		}

		var add_dimension = 0;
		
		if(this.main_graph.graph.hasOwnProperty('highlight_times_data'))
		{
			add_dimension = HIGHLIGHT_TIMES_SHIFT;
		}

		this.svg_selection_cover = svg.polygon(
			this.svg_group,
			[
				[this.x + x_start                          , this.y],
				[this.main_graph.x                         , this.main_graph.y + this.main_graph.height+1],
				[this.main_graph.x + this.main_graph.width , this.main_graph.y + this.main_graph.height+1],
				[this.x + x_end                            , this.y],
				[this.x + x_end                            , this.y + this.height],
				[this.x + x_start                          , this.y + this.height], 
			],  
			{ 
				id               : this.id+'_selection',
				fill             : '#00aaff', 
				stroke           : 'blue', 
				"stroke-opacity" : 1.0,
				"fill-opacity"   : 0.3,
				strokeWidth      : 1.1, 
				"stroke-linecap" : "back",
				//"shape-rendering": "crispEdges"
			}
		);
	}
};

timegraph4.GraphArea.prototype.mousedown = function (mouse_x, mouse_y)
{
	if (!this.visible) return;

	if (!IS_INSIDE(this, mouse_x, mouse_y))
		return
		
	var ts = x_pos_to_ts(mouse_x - this.x, 0, this.width, this.start_ts, this.end_ts);

	this.selecting_start_ts = ts;
};

timegraph4.GraphArea.prototype.mousemove = function (mouse_x, mouse_y)
{
	if (!IS_INSIDE(this, mouse_x, mouse_y))
		return

	var xpos    = mouse_x - this.x;
	var ts = x_pos_to_ts(xpos, 0, this.width, this.start_ts, this.end_ts);

	if (this.on_mouse_over != null) {
		this.on_mouse_over(this.graph, mouse_x, mouse_y, ts);
	}

	if (this.selecting_start_ts == null) 
		return;

	if (this.selecting_start_ts < ts) {
		var ts_s = this.selecting_start_ts;
		var ts_e = ts;
	}
	else if (this.selecting_start_ts > ts) {
		var ts_s = ts;
		var ts_e = this.selecting_start_ts;
	}

	this.renderSelection(ts_s, ts_e, false);
};

timegraph4.GraphArea.prototype.mouseup = function mouseup(mouse_x, mouse_y)
{
	if (!this.visible) return;

	if (!IS_INSIDE(this, mouse_x, mouse_y))
		return

	var current_ts = x_pos_to_ts(mouse_x - this.x, 0, this.width, this.start_ts, this.end_ts);

	if (current_ts != this.selecting_start_ts) {
		

		if (this.selecting_start_ts < current_ts) {
			var ts_s = this.selecting_start_ts;
			var ts_e = current_ts;
		}
		else if (this.selecting_start_ts > current_ts) {
			var ts_s = current_ts;
			var ts_e = this.selecting_start_ts;
		}

		this.selecting_start_ts = null;

		if (this.on_selection_change != null) {
			this.on_selection_change(this.graph, ts_s, ts_e);
		}
	}
	else {
		this.selecting_start_ts = null;
		
		if (this.on_selection_change != null) {
			this.on_selection_change(this.graph, null, null);
		}
	}
};

timegraph4.GraphArea.prototype.click = function click(mouse_x, mouse_y)
{
	if (!this.visible) return;

	if (!IS_INSIDE(this, mouse_x, mouse_y))
		return

	var ts = x_pos_to_ts(mouse_x - this.x, 0, this.width, this.start_ts, this.end_ts);
};


/******************************************************************************/
/******************************************************************************/
/******************************************************************************/


timegraph4.XAxis = function XAxis(graph, graph_area, x,y, width, height, attributes)
{
	this.graph = graph;
	
	this.graph_area = graph_area;
	
	this.visible = true;

	this.x      = x;
	this.y      = y;
	this.width  = width;
	this.height = height;

	this.svg_group = null;

	this.svg_rect = null;

	this.start_ts = null;
	this.end_ts   = null;
	
	this.attributes = attributes;
	
	this.highlight_times_data = graph.highlight_times_data;
};

timegraph4.XAxis.prototype.getRequiredHeight = function()
{
	if (this.visible)
		height = this.height;
	else
		height = 0;
		
	return height;
}



timegraph4.XAxis.prototype.clean = function()
{
	if (!this.visible) return;

	if (this.svg_group != null) {
		$("#" + this.svg_group.id, this.graph.svg.root()).remove();
		$('.dday_rect'+this.svg_clippath.id).remove(); //remove ddays rects

	}
}

timegraph4.XAxis.prototype.setVisibility = function (bool)
{
		if (bool == false) {
			//this.clean();
			if (this.svg_group != null && this.svg_group != undefined) 
				$(this.svg_group).css('display', 'none');
		}
		else
			if (this.svg_group != null && this.svg_group != undefined) 
				$(this.svg_group).css('display', ''); /* unset (works with ie11 too */		
				
			
		this.visible = bool;
}

timegraph4.XAxis.prototype.setRange = function setRange(start_ts, end_ts)
{
	if (!this.visible) return;

	this.start_ts = start_ts;
	this.end_ts   = end_ts;
}



timegraph4.XAxis.prototype.render = function render()
{
	if (!this.visible) return;

	this.clean();
	
	this.svg_group = this.graph.svg.group(null, guid() );

	var defs = this.graph.svg.defs();
	this.svg_clippath = this.graph.svg.clipPath(defs, this.svg_group.id, 'objectBoundingBox');
		this.graph.svg.rect(this.svg_clippath, this.x+50, this.y, this.width-100, this.height, {'fill':'black', strokeWidth: 0, stroke:'none'});
		
	var months_short_names  = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'June', 'July', 'Aug', 'Sept', 'Oct', 'Nov', 'Dec'];
	var months_full_names   = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
	var days_of_week_short  = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
	var days_of_week_letter = ['S.', 'M.', 'T.', 'W.', 'T.', 'F.', 'S.'];
	
	this.svg_rect = this.graph.svg.rect(this.svg_group, this.x, this.y, this.width, this.height, this.attributes); //{fill: '#ff0000', stroke: 'black', strokeWidth: 0});
	
	var X_AXIS_LABEL_SPACE = 0;

	var tick_number        = 10;
	var total_visible_time = this.end_ts - this.start_ts;
	var start_date  = new Date(this.start_ts * 1000);
	var minutes     = start_date.getMinutes();
	minutes         = minutes - (minutes % 10);
	var start_date2 = new Date(start_date.getFullYear(), start_date.getMonth(), start_date.getDate(), start_date.getHours(), minutes, 0, 0);
	var end_date    = new Date(this.end_ts   * 1000);
	minutes         = end_date.getMinutes();
	minutes         = minutes - (minutes % 10);
	end_date.setMinutes(minutes);
	end_date.setSeconds(0);
	end_date.setMilliseconds(0);

	var tick_step   = (end_date - start_date)/tick_number;

	this.graph.next_date_function = null;
	var bold_function      = null;
	this.graph.label_time_format  = null;
	
	function label_time_format_hhmm(current_d) {
		return padspace(current_d.getHours()) + ":" + pad(current_d.getMinutes());
	}

	function label_time_format_ddMM(current_d) {
		if (current_d.getMonth() == 0 && current_d.getDate() == 1 && current_d.getHours() == 0 && current_d.getMinutes() == 0) {
			return current_d.getFullYear() + "";
		}
		else if (current_d.getHours() == 0 && current_d.getMinutes() == 0) {
			return current_d.getDate() + "/" + pad(current_d.getMonth()+1);
		}	
		else
			return label_time_format_hhmm(current_d);
	}

	function label_time_format_year(currend_d) {

		if (current_d.getMonth() == 0 && current_d.getDate() == 1)
			return String(current_d.getFullYear());

		else if (current_d.getDate() == 1)
			return months_short_names[current_d.getMonth()];

		return '';
	}

	function label_time_format_six_months(currend_d) {

		if (current_d.getMonth() == 0 && current_d.getDate() == 1)
			return String(current_d.getFullYear());

		else if (current_d.getDate() == 1)
			return months_short_names[current_d.getMonth()];

		else if(current_d.getDate() == 1 || current_d.getDate() == 15)
			return String(current_d.getDate());

		return '';
	}

	function label_time_format_three_months(currend_d) {

		if (current_d.getMonth() == 0 && current_d.getDate() == 1)
			return String(current_d.getFullYear());

		else if (current_d.getDate() == 1)
			return months_short_names[current_d.getMonth()];

		else if ((current_d.getDate() % 10) == 0)
			return String(current_d.getDate());

		return '';
	}

	function label_time_format_month(currend_d) {

		if (current_d.getDate() == 1)
			return months_full_names[current_d.getMonth()];

		else if ((current_d.getDate() % 2) == 0)
			return String(current_d.getDate());

		return '';
	}

	function label_time_format_2w(currend_d) {

		if (current_d.getDate() == 1 && current_d.getHours() == 0 && current_d.getMinutes() == 0)
			return months_short_names[current_d.getMonth()];

		else if (current_d.getHours() == 0 && current_d.getMinutes() == 0)
			return days_of_week_short[current_d.getDay()] + ' ' + current_d.getDate();

		else if ((current_d.getDate % 2) == 0)
			return label_time_format_hhmm(current_d);

		return '';
	}

	function label_time_format_week(currend_d) {

		if (current_d.getDate() == 1 && current_d.getHours() == 0 && current_d.getMinutes() == 0)
			return months_short_names[current_d.getMonth()];

		if (current_d.getHours() == 0 && current_d.getMinutes() == 0)
			return days_of_week_short[current_d.getDay()] + ' ' + current_d.getDate();

		if ((current_d.getHours() % 12) == 0)
			return label_time_format_hhmm(current_d);

		return '';
	}

	function label_time_format_3d(currend_d) {

		if (current_d.getDate() == 1 && current_d.getHours() == 0 && current_d.getMinutes() == 0)
			return months_short_names[current_d.getMonth()];

		if (current_d.getHours() == 0 && current_d.getMinutes() == 0)
			return days_of_week_letter[current_d.getDay()] + current_d.getDate();

		if ((current_d.getHours() % 6) == 0)
			return label_time_format_hhmm(current_d);

		return '';
	}

	function label_time_format_24h(currend_d) {

		if (current_d.getDate() == 1 && current_d.getHours() == 0 && current_d.getMinutes() == 0)
			return months_short_names[current_d.getMonth()];

		if (current_d.getHours() == 0 && current_d.getMinutes() == 0)
			return days_of_week_short[current_d.getDay()] + ' ' + current_d.getDate();

		if ((current_d.getHours() % 2) == 0)
			return label_time_format_hhmm(current_d);

		return '';
	}

	function label_time_format_8h(currend_d) {

		if (current_d.getDate() == 1 && current_d.getHours() == 0 && current_d.getMinutes() == 0)
			return months_short_names[current_d.getMonth()];

		if (current_d.getHours() == 0 && current_d.getMinutes() == 0)
			return days_of_week_short[current_d.getDay()] + ' ' + current_d.getDate();

		if (current_d.getMinutes() == 0)
			return label_time_format_hhmm(current_d);

		return '';
	}

	function label_time_format_4h(currend_d) {

		if (current_d.getDate() == 1 && current_d.getHours() == 0 && current_d.getMinutes() == 0)
			return months_short_names[current_d.getMonth()];

		if (current_d.getHours() == 0 && current_d.getMinutes() == 0)
			return days_of_week_short[current_d.getDay()] + ' ' + current_d.getDate();

		if (current_d.getMinutes() == 0 || current_d.getMinutes() == 30)
			return label_time_format_hhmm(current_d);

		return '';
	}

	function label_time_format_1h(currend_d) {

		if (current_d.getDate() == 1 && current_d.getHours() == 0 && current_d.getMinutes() == 0)
			return months_short_names[current_d.getMonth()];

		if (current_d.getHours() == 0 && current_d.getMinutes() == 0)
			return days_of_week_short[current_d.getDay()] + ' ' + current_d.getDate();

		if ((current_d.getMinutes() % 5) == 0)
			return label_time_format_hhmm(current_d);

		return '';
	}

	function addDays(date, days) {
		var result = new Date(date);
		result.setDate(result.getDate() + days);
		return result;
	}

	// 1 year
	if (total_visible_time      > timegraph4.ONE_MOUNTH * 6)      { 
		start_date         = new Date(start_date.getFullYear(), 1, 1, 0,0,0,0);
		
		this.graph.next_date_function = function(start_date) {

			if(start_date.getDate() == 1)
				var ret = addDays(start_date, 14);
			else
			{
				var ret  = addDays(start_date, 15);
				var next = addDays(ret, 15);
				if (ret.getMonth() != next.getMonth() && ret.getMonth() != 1)
				{
					next.setDate(1);
					ret = next;
				}
			}

			if(start_date.getMonth() != ret.getMonth())
				ret.setDate(1);

			return ret;
		}
		bold_function      = function(start_date) { return start_date.getMonth() == 0 }
		this.graph.label_time_format  = label_time_format_year;
	}
	// 6 months
	else if (total_visible_time      > timegraph4.ONE_MOUNTH * 3)      { 
		start_date         = new Date(start_date.getFullYear(), start_date.getMonth()+1, 1, 0,0,0,0);
		start_date         = addDays(start_date, -30);
		
		this.graph.next_date_function = function(start_date) {

			if(start_date.getDate() == 1)
				var ret = addDays(start_date, 6.5);
			else
			{
				var ret  = addDays(start_date, 7.5);
				var next = addDays(ret, 7.5);
				if (ret.getMonth() != next.getMonth() && ret.getMonth() != 1)
				{
					next.setDate(1);
					ret = next;
				}
			}

			if(start_date.getMonth() != ret.getMonth())
				ret.setDate(1);
			return ret;
		}
		//this.graph.next_date_function = function(start_date) { return addTimestamp(start_date, tick_step) ; }
		bold_function      = function(start_date) { return start_date.getDate() == 1 }
		this.graph.label_time_format  = label_time_format_six_months;
	}
	// 3 months
	else if (total_visible_time > timegraph4.ONE_MOUNTH)      {
		start_date         = new Date(start_date.getFullYear(), start_date.getMonth()+1, 1, 0,0,0,0);
		start_date         = addDays(start_date, -30);
		var c              = start_date.getDate() % 10;
		start_date.setDate(start_date < c ? c : start_date.getDate() - c);

		this.graph.next_date_function = function(start_date) {

			if(start_date.getDate() == 1)
				var ret = addDays(start_date, 4);
			else
			{
				var ret  = addDays(start_date, 5);
				var next = addDays(ret, 5);
				if (ret.getMonth() != next.getMonth() && ret.getMonth() != 1)
				{
					next.setDate(1);
					ret = next;
				}
			}

			if(start_date.getMonth() != ret.getMonth())
				ret.setDate(1);
			return ret;
		}
		bold_function      = function(start_date) { return (start_date.getDate() == 1) }
		this.graph.label_time_format  = label_time_format_three_months;
	}
	// 1 month
	else if (total_visible_time > timegraph4.ONE_WEEK * 3)        {
		// per far partire il timegraph con un numero di giorni che faccia ricadere il bold sul primo del mese
		start_date         = new Date(start_date.getFullYear(), start_date.getMonth()+1, 1, 0,0,0,0);
		start_date         = addDays(start_date, -30);

		this.graph.next_date_function = function(start_date) { return addDays(start_date, 1); }
		bold_function      = function(start_date) { return (start_date.getDate() == 1) }
		this.graph.label_time_format  = label_time_format_month;
	}
	// 2 weeks
	else if (total_visible_time > timegraph4.ONE_WEEK * 2)        { 
		start_date         = new Date(start_date.getFullYear(), start_date.getMonth()+1, 1, 0,0,0,0);
		start_date         = addDays(start_date, -30);

		this.graph.next_date_function = function(start_date) { return addDays(start_date, 1); }
		bold_function      = function(start_date) { return (start_date.getDate() % 2) != 0 }

		this.graph.label_time_format  = label_time_format_2w;
	}
	// > 1 week
	else if (total_visible_time > timegraph4.ONE_WEEK)        {
		start_date         = new Date(start_date.getFullYear(), start_date.getMonth(), 1, 0,0,0,0);

		this.graph.next_date_function = function(start_date) { return addDays(start_date, 1); }
		bold_function      = function(start_date) { return (start_date.getDate() % 2) != 0 }
		this.graph.label_time_format  = label_time_format_week;
	}
	// 7d
	else if (total_visible_time > (timegraph4.ONE_DAY * 3))        {
		start_date         = new Date(start_date.getFullYear(), start_date.getMonth(), 1, 0,0,0,0);

		this.graph.next_date_function = function(start_date) {
			var result = start_date.addHours(6);

			if (result.getHours() != 0 && (result.getHours() % 6) != 0)
			 	result = result.addHours(-1);

			 return result;
		}

		bold_function      = function(start_date) { return (start_date.getHours() == 0 && start_date.getMinutes() == 0) }
		this.graph.label_time_format  = label_time_format_week;
	}
	// 3d
	else if (total_visible_time > timegraph4.ONE_DAY)         {
		start_date         = new Date(start_date.getFullYear(), start_date.getMonth(), start_date.getDate(), 0,0,0,0);

		this.graph.next_date_function = function(start_date) {

			var result = start_date.addHours(3);

			if (result.getHours() != 0 && (result.getHours() % 3) != 0)
			 	result = result.addHours(-1);

			 return result;
		}

		bold_function      = function(start_date) { return (start_date.getHours() == 0 && start_date.getMinutes() == 0) }
		this.graph.label_time_format  = label_time_format_3d;
	}
	// 24h
	else if (total_visible_time > (timegraph4.ONE_HOUR*12))   {
		start_date         = new Date(start_date.getFullYear(), start_date.getMonth(), 0, 0,0,0,0);
		var c = (timegraph4.ONE_HOUR * 1000);
		tick_step   = c;

		this.graph.next_date_function = function(start_date) {

			var result = addTimestamp(start_date, tick_step);
			return result;
		}
		bold_function      = function(start_date) { return ((start_date.getHours() % 12)==0) }
		this.graph.label_time_format  = label_time_format_24h;
	}
	// 8h
	else if (total_visible_time > 4 * timegraph4.ONE_HOUR)        { 
		start_date         = new Date(start_date.getFullYear(), start_date.getMonth(), start_date.getDate(), 0,0,0,0);
		var c = (timegraph4.ONE_MINUTE * 20 * 1000);
		tick_step   = c;

		this.graph.next_date_function = function(start_date) {
			var result = addTimestamp(start_date, tick_step);
			return result;
		}
		bold_function      = function(start_date) { return ((start_date.getHours() % 2)==0) }
		this.graph.label_time_format  = label_time_format_8h;
	}
	// 4h
	else if (total_visible_time > timegraph4.ONE_HOUR * 3)        {
		start_date         = new Date(start_date.getFullYear(), start_date.getMonth(), start_date.getDate(), 0,0,0,0);
		var c = (timegraph4.ONE_MINUTE * 10 * 1000);
		tick_step   = c;

		this.graph.next_date_function = function(start_date) {
			var result = addTimestamp(start_date, tick_step);
			return result;
		}
		bold_function      = function(start_date) { return ((start_date.getMinutes() % 60)==0) }
		this.graph.label_time_format  = label_time_format_4h;
	}
	// 2 H
	else if (total_visible_time > timegraph4.ONE_HOUR) {
		start_date         = new Date(start_date.getFullYear(), start_date.getMonth(), start_date.getDate(), start_date.getHours(), 0 , 0,0);
		var c = (timegraph4.ONE_MINUTE * 5 * 1000)
		tick_step   = tick_step < c ? c : tick_step - (tick_step % c);

		this.graph.next_date_function = function(start_date) { return start_date.addMinutes(15); }
		bold_function      = function(start_date) { return ((start_date.getMinutes() % 10)==0) }
		this.graph.label_time_format  = label_time_format_1h;
	}
	// 1 H
	else if (total_visible_time > timegraph4.ONE_MINUTE * 50) {
		start_date         = new Date(start_date.getFullYear(), start_date.getMonth(), start_date.getDate(), start_date.getHours(), 0 , 0,0);
		var c = (timegraph4.ONE_MINUTE * 5 * 1000)
		tick_step   = tick_step < c ? c : tick_step - (tick_step % c);

		this.graph.next_date_function = function(start_date) {

			var result = addTimestamp(start_date, tick_step);

			return result;
		}
		bold_function      = function(start_date) { return ((start_date.getMinutes() % 15)==0) }
		this.graph.label_time_format  = label_time_format_1h;
	}
	// minore di 1 H
	else {
		start_date         = new Date(start_date.getFullYear(), start_date.getMonth(), start_date.getDate(), start_date.getHours(), 0 , 0,0);
		this.graph.next_date_function = function(start_date) { return start_date.addMinutes(2); }
		bold_function      = function(start_date) { return ((start_date.getMinutes() % 10)==0) }
		this.graph.label_time_format  = label_time_format_hhmm;
	}
	
	var y = this.y;

	var current_date = start_date;
	var current_ts   = start_date.getTime() / 1000;;
	// this.graph.timestep_value_labels = [];

	var y_increment = 0;
	
	if(this.highlight_times_data != null)
	{
		y_increment = HIGHLIGHT_TIMES_SHIFT;
		
		var start_graph = ts_to_x_axis_pos(0, this.width, this.start_ts, this.end_ts, this.start_ts);
		var end_graph = ts_to_x_axis_pos(0, this.width, this.start_ts, this.end_ts, this.end_ts);
		
		var label = this.graph.svg.rect(this.x + start_graph, y, end_graph-start_graph, y_increment, {
				stroke           : 'black',
				"fill"           : "none",
				"shape-rendering": "crispEdges",
				"clip-path"      : "#"+this.svg_clippath.id
			});
								
	}

	var ddays_in_graph = [];
	
	while (current_ts < this.end_ts) {

			if (current_ts < this.start_ts) {
				current_date = this.graph.next_date_function(current_date);
				current_ts   = current_date.getTime() / 1000;

				continue;
			}

			current_d = current_date;

			fontsize = timegraph4.FONTSIZE - 1;
			bold     = 0;
			if (bold_function(current_d) == true) {
				bold     = 0.5;
				fontsize = timegraph4.FONTSIZE
			}

			var date_label = this.graph.label_time_format(current_d);

			var x_pos = ts_to_x_axis_pos(0, this.width, this.start_ts, this.end_ts, current_ts);
			if (x_pos >= 0) {

				this.graph_area.line(this.svg_group, x_pos, 0, x_pos, this.graph_area.height, timegraph4.LINE_GREY);

				var label  = this.graph.svg.text(this.svg_group, this.x + x_pos, y, date_label, {
					"fontSize"       : fontsize+"px",
					fill             : 'black',
					stroke           : 'black',
					textRendering    : "geometricPrecision",
					strokeWidth      : bold,
					"shape-rendering": "crispEdges",
					"clip-path"      : "#"+this.svg_clippath.id
				});
				var width  = label.getBBox().width;
				var height = label.getBBox().height;

				label.setAttribute('y', this.y + height + y_increment);

				var x = label.getBBox().x - (width/2);
				label.setAttribute('x', x);

				if ((x < this.x) || ((x + width) > (this.x + this.width))) {
					//label.remove();
				}

				var label  = this.graph.svg.line(this.svg_group, this.x + x_pos, this.y + y_increment, this.x + x_pos, this.y + 3 + y_increment, {
					stroke           : 'black',
					strokeWidth      : 1,
					"shape-rendering": "crispEdges",
					"clip-path"      : "#"+this.svg_clippath.id
				});
							
				if(this.highlight_times_data != null)
				{
					keys = Object.keys(this.highlight_times_data);

					for (var index = 0; index < keys.length; index++)
					{
						if($.inArray(index, ddays_in_graph) == -1)
						{
							if(this.highlight_times_data[keys[index]]['ts_start'] <= current_ts && this.highlight_times_data[keys[index]]['ts_end'] >= current_ts)
							{
								var x_dday_pos = ts_to_x_axis_pos(0, this.width, this.start_ts, this.end_ts, this.highlight_times_data[keys[index]]['ts_start']);
								var x_dday_end = ts_to_x_axis_pos(0, this.width, this.start_ts, this.end_ts, this.highlight_times_data[keys[index]]['ts_end']);
								
								if(x_dday_pos < 0)
								{
									x_dday_pos = 0;
								}
								
								if(x_dday_end > ts_to_x_axis_pos(0, this.width, this.start_ts, this.end_ts, this.end_ts))
								{
									x_dday_end = ts_to_x_axis_pos(0, this.width, this.start_ts, this.end_ts, this.end_ts);
								}
								
								//draw correspondent rectangle
								var label = this.graph.svg.rect(this.x + x_dday_pos, y, x_dday_end-x_dday_pos, y_increment, {
									"class"             : "dday_rect"+this.svg_clippath.id,
									"fill"           : this.highlight_times_data[keys[index]]['color'],
									"fill-opacity"   : 0.3,
									"shape-rendering": "crispEdges",
									"clip-path"      : "#"+this.svg_clippath.id
								});
								
								ddays_in_graph.push(index)
							}
						}
					}
					
					/*var label  = this.graph.svg.line(this.svg_group, this.x, this.y + y_increment, this.x+x_pos, this.y + y_increment, {
						stroke           : 'black',
						strokeWidth      : 1,
						"shape-rendering": "crispEdges",
						"clip-path"      : "#"+this.svg_clippath.id
					});*/
				}
			}
			
			current_date = this.graph.next_date_function(current_date);
			current_ts   = current_date.getTime() / 1000;
	}
};

/******************************************************************************/
/******************************************************************************/
/******************************************************************************/

timegraph4.YAxis = function YAxis(graph, graph_area, x, y, width, height, attributes)
{
	this.graph = graph;

	this.graph_area = graph_area;
	
	this.visible = true;

	this.x      = x;
	this.y      = y;
	
	this.width  = width;
	this.height = height;


	this.svg_rect   = null;
	
	this.min_value = null;
	this.max_value = null;
	this.ylegend   = "";
	
	this.attributes = attributes;
	
	this.single_step = false;
	this.step_anchor = 'left';
	
	this.percentual_scale = false;

	this.virtual_max_value = null;
};

timegraph4.YAxis.prototype.getRequiredHeight = function()
{
	if (this.visible) 
		height = this.height;
	else
		height = 0;
		
	return height;
}

timegraph4.YAxis.prototype.clean = function()
{
	if (!this.visible) return;

	if (this.svg_group != null) {
		$("#" + this.svg_group.id, this.graph.svg.root()).remove();
	}
}

timegraph4.YAxis.prototype.setVisibility = function (bool)
{
	if (bool == false) {
		if (this.svg_group != null && this.svg_group != undefined) 
			$(this.svg_group).css('display', 'none'); // set
	}
	else
		if (this.svg_group != null && this.svg_group != undefined) 
			$(this.svg_group).css('display', ''); /* unset (works with ie11 too */
		
	this.visible = bool;
}

timegraph4.YAxis.prototype.setRange = function setRange(min_value, max_value)
{
	this.min_value = min_value;
	this.max_value = max_value;
}



var SCALES = [
	[ "P",  15],
	[ "T",  12],
	[ "G",   9],
	[ "M",   6],
	[ "k",   3],
	[ "" ,   0],
	[ "m",  -3],
	[ "u",  -6],
	[ "n",  -9],
	[ "f", -12],
];

function calculate_scale(v)
{
	if (v == 0) return "";
		
	var e = log10(Math.abs(v));
	
	for (var i=0; i < SCALES.length; i++) {
		if (e > SCALES[i][1])
			return SCALES[i][0];
	}
	return '*';
}

function scale_factor(e)
{
	for (var i=0; i < SCALES.length; i++) {
		if (e == SCALES[i][0]) return SCALES[i][1];
	}
	return 1;	
}

function ROUNDED(v, precision) 
{
	if (precision == undefined)
		precision = Math.pow(10,3);
	else
		precision = Math.pow(10, precision);
		
	return Math.round(v * precision)/precision;
	
}

function fixDecimalZero(n) 
{
	if ((n - TRUNC(n)) > 0.01 )
		return n.toFixed(2)
	else
		return n.toFixed(0)
}


timegraph4.YAxis.prototype.render = function render()
{
	if (!this.visible) return;
	
	//console.log("YAxis render:  max " + this.max_value + " min " + this.min_value );

	this.clean();
	this.svg_group = this.graph.svg.group(null, guid(), {});

	//
	// BACKGROUND
	//
	this.svg_rect = this.graph.svg.rect(this.svg_group, this.x, this.y, this.width, this.height, this.attributes);
	
	//
	// VERTICAL LABEL
	//
	if (this.max_value == null && this.min_value == null)
		return;

	if (this.max_value == 0 && this.min_value == 0) {
		this.min_value = 0;
		this.max_value = 1;
	}

	if (this.max_value < this.min_value)
		return;

	//
	// SCALE LABELS
	//
	var MAX_VALUE = Math.max( Math.abs(this.max_value), Math.abs(this.min_value));

	//
	// Spezziamo il range in step piu' piccoli (di un ordine di grandezza inferiore)
	//
	var step             = Math.pow(10, Math.ceil( log10( MAX_VALUE )  - 1)   );

	var scale_label      = calculate_scale(this.max_value - this.min_value);
	var scale_multiplier = Math.pow(10, (scale_factor(scale_label) * -1))   ;

	if ( ((this.max_value - this.min_value) / step) > 5 ) {
		step = step * 2;
	}

	if (this.single_step) {
		single_step = step;
		while (single_step < MAX_VALUE) 
			single_step += step;
		step = single_step - step;
	}

	// Fall back di sicurezza
	if (step == 0)
		step = 1;

	//
	// Disegnamo il grafico
	//
	var y_pos_perc = (this.height / (this.max_value - this.min_value));


	var real_y_origin = this.height;

	if (min_value < 0) {
		real_y_origin = real_y_origin - ((this.height / (this.max_value - this.min_value)) * (-this.min_value));
	}

	// Draw other values
	for (var v = 0; v <= MAX_VALUE; v += step)
	{
		if (v == 0 || this.max_value > 0) {
			
			if (this.percentual_scale == false) {
				var v_rounded = ROUNDED(v, log10(scale_multiplier) );
				var v_visible = v_rounded * scale_multiplier;
				var ticktext  = fixDecimalZero(ROUNDED(v_visible)) + " " + scale_label + this.ylegend;
			}
			else {
				top_val = (this.virtual_max_value != null) ? this.virtual_max_value : this.max_value;
				
				var ticktext  = ROUNDED( (100 / top_val) * v, 0) + "%";
			}
			
			var y_rel = v * y_pos_perc;
			var y     = real_y_origin - y_rel;

			var label = this.graph.svg.text(this.svg_group, 0 , this.y + y, ticktext, {
				  "fontSize"         : timegraph4.FONTSIZE+"px"
				, fill               : 'black'
				, stroke             : 'black'
				, textRendering      : "geometricPrecision"
				, strokeWidth        : 0
				, "shape-rendering"  : "crispEdges"
			});
			var l_height = label.getBBox().height;
			var l_width  = label.getBBox().width;
			label.setAttribute('x', this.x + this.width - l_width - 5);
			label.setAttribute('y', this.y + y + (timegraph4.FONTSIZE/2));
			
			this.graph_area.line(this.svg_group, 0, y, this.graph_area.width, y, (v != 0 ? timegraph4.LINE_GREY : timegraph4.LINE_BLUE ));

			if (this.step_anchor == 'left') 
				x_anchor = this.x+this.width-3
			else
				x_anchor = this.x;
				
			var label = this.graph.svg.line(this.svg_group, x_anchor, this.y+y, x_anchor+3, this.y+y, {
				  stroke             : 'black'
				, strokeWidth        : 1
				, "shape-rendering"  : "crispEdges"
			});
		}

		if (v != 0 && this.min_value < 0) {
			v2 = -v;

			var y_rel = v2 * y_pos_perc;
			var y  = real_y_origin - y_rel;

			// Non disegnamo la leggenda se esce dall'area visibile
			if ( y > this.height) 
				continue;
			
			if (this.percentual_scale == false) {
				var v_rounded = ROUNDED(v2, log10(scale_multiplier));
				var v_visible = v_rounded * scale_multiplier;
				var ticktext  = fixDecimalZero(v_visible) + " " + scale_label + this.ylegend;
			}
			else {
				top_val = (this.virtual_max_value != null) ? this.virtual_max_value : this.max_value;
				
				var ticktext  = ROUNDED( (100 / -top_val) * v, 0) + "%";
			}
			

			var label = this.graph.svg.text(this.svg_group, 0 , this.y + y, ticktext, {
				  "fontSize"         : timegraph4.FONTSIZE+"px"
				, fill               : 'black'
				, stroke             : 'black'
				, textRendering      : "geometricPrecision"
				, strokeWidth        : 0
				, "shape-rendering"  : "crispEdges"
			});
			var l_height = label.getBBox().height;
			var l_width  = label.getBBox().width;
			label.setAttribute('x', this.x + this.width - l_width  - 5);
			label.setAttribute('y', this.y + y + (timegraph4.FONTSIZE/2));
			
			this.graph_area.line(this.svg_group, 0, y, this.graph_area.width, y,  (v != 0 ? timegraph4.LINE_GREY : timegraph4.LINE_BLUE ));
			
			
			if (this.step_anchor == 'left') 
				x_anchor = this.x+this.width-3;
			else
				x_anchor = this.x;
				
			var label = this.graph.svg.line(this.svg_group, x_anchor, this.y+y, x_anchor+3, this.y+y, {
				stroke             : 'black'
				, strokeWidth        : 1
				, "shape-rendering"  : "crispEdges"
			});
			
		}
	}
};

/******************************************************************************/
/******************************************************************************/
/******************************************************************************/

timegraph4.Legend = function Legend(id, graph,  graph_area, x,y, width, height, attributes)
{
	this.graph = graph;
	this.graph_area = graph_area;
	
	this.visible = true;

	this.x      = x;
	this.y      = y;
	this.width  = width;
	this.height = height;
	
	this.show_reduced = false;

	this.text_max_value = "Maximum";
	this.text_min_value = "Minimum";
	this.text_avg_value = "Average";

	if (graph.gui_settings['labels'] != undefined && graph.gui_settings['labels'] != null) {
		this.text_min_value = graph.gui_settings['labels']['text_min_value'];
		this.text_max_value = graph.gui_settings['labels']['text_max_value'];
		this.text_avg_value = graph.gui_settings['labels']['text_avg_value'];
	}

	this.attributes = attributes;

	this.svg_group = null;

	// CLIP AREA
	this.svg_clippath_id = guid();
	this.svg_clippath = this.graph.svg.clipPath(null, this.svg_clippath_id);
	this.graph.svg.rect(this.svg_clippath, this.x, this.y, this.width, this.height+20, {'fill':'black', strokeWidth: 0});
};

timegraph4.Legend.prototype.setReduced = function(bool)
{
	this.show_reduced = bool;
}

timegraph4.Legend.prototype.getRequiredHeight = function()
{
	if (! this.visible) 
		return 0;

	if (this.show_reduced)
		height = timegraph4.SQUARE_SIZE;
	else 
		height = (this.graph.data['series'].length * timegraph4.SQUARE_SIZE) + ((this.graph.data['series'].length - 1) * timegraph4.LINE_GAP);
		
	return height;
}

timegraph4.Legend.prototype.getSVGGroup = function()
{
	if (this.svg_group == null)
		this.svg_group = this.graph.svg.group(null, guid());
	return this.svg_group;
}

timegraph4.Legend.prototype.clean = function()
{
	if (!this.visible) return;

	if (this.svg_group != null) {
		$("#" + this.svg_group.id, this.graph.svg.root()).remove();
		this.svg_group = null;
	}
};



timegraph4.Legend.prototype.setVisibility = function (bool)
{
		if (bool == false) {
			//this.clean();
			if (this.svg_group != null && this.svg_group != undefined) 
				$(this.svg_group).css('display', 'none');
		}
		else
			if (this.svg_group != null && this.svg_group != undefined) 
				$(this.svg_group).css('display', ''); // unset, works with ie11 too.

		this.visible = bool;
}


timegraph4.Legend.prototype.render = function render(series)
{
	if (! this.visible) 
		return ;
		
	if (this.show_reduced)
		this.renderShort(series);
	else
		this.renderExtended(series);
}

timegraph4.Legend.prototype.renderShort = function renderShort(series)
{

	this.clean();

	if (! this.visible) 
		return ;


	var start_x = 0;
	var max_label_length = 0;
	
	g = this.getSVGGroup();

	var x_pos = this.x;
	var y_pos = this.y;
	for (var s=0; s < series.length; s++) {

		if (series[s]['format'] == 'changesequence'){
			var labels = series[s]['label'];
			var colors = series[s]['color'];
			
			for (l in labels){
				var label = labels[l];
				var color = colors[l];
				
				var square  = this.graph.svg.rect(g, x_pos , y_pos              , timegraph4.SQUARE_SIZE , timegraph4.SQUARE_SIZE, {
					"fontSize": timegraph4.FONTSIZE+"px", 
					fill: color  , 
					stroke: null, 
					textRendering: "geometricPrecision", 
					strokeWidth: 0, 
					"shape-rendering":"crispEdges", 
					//clipPath: 'url(#' + this.svg_clippath_id + ')' 
				});
				x_pos += timegraph4.SQUARE_SIZE + timegraph4.LINE_GAP;
				
				var label   = this.graph.svg.text(g, x_pos , y_pos + timegraph4.SQUARE_SIZE, label                    , {
					"fontSize": timegraph4.FONTSIZE+"px", 
					fill: 'black', 
					stroke: 'black', 
					textRendering: "geometricPrecision", 
					strokeWidth: 0, 
					"shape-rendering":"crispEdges", 
					//clipPath: 'url(#' + this.svg_clippath_id + ')' 
				});
				x_pos += label.getBBox().width + 10;
			}
		}
		else {
			var label = series[s]['label'];
			var color = series[s]['color'];
	
			var square  = this.graph.svg.rect(g, x_pos , y_pos              , timegraph4.SQUARE_SIZE , timegraph4.SQUARE_SIZE, {
				"fontSize": timegraph4.FONTSIZE+"px", 
				fill: color  , 
				stroke: null, 
				textRendering: "geometricPrecision", 
				strokeWidth: 0, 
				"shape-rendering":"crispEdges", 
				//clipPath: 'url(#' + this.svg_clippath_id + ')' 
			});
			x_pos += timegraph4.SQUARE_SIZE + timegraph4.LINE_GAP;
			
			
			var label   = this.graph.svg.text(g, x_pos , y_pos + timegraph4.SQUARE_SIZE, label                    , {
				"fontSize": timegraph4.FONTSIZE+"px", 
				fill: 'black', 
				stroke: 'black', 
				textRendering: "geometricPrecision", 
				strokeWidth: 0, 
				"shape-rendering":"crispEdges", 
				//clipPath: 'url(#' + this.svg_clippath_id + ')' 
			});
			x_pos += label.getBBox().width + 10;
	
			//y_pos += timegraph4.SQUARE_SIZE + timegraph4.LINE_GAP;
		}
	}
	
}

timegraph4.Legend.prototype.renderExtended = function renderExtended(series)
{

	this.clean();

	if (! this.visible) 
		return ;

	this.getSVGGroup();
	
	//
	// BACKGROUND
	//
	this.svg_rect = this.graph.svg.rect(this.svg_group, this.x, this.y, this.width, this.height, this.attributes);
	
	//
	// Entries
	//
	var y_pos = this.y;
	
	for (var s=0; s < series.length; s++) {

		var min_val = null;
		var max_val = null;
		var avg_val = 0;
		var avg_n   = 0;
		
		if (series[s]['format'] != 'tick') {

			var values = series[s]['values'];
			
			for (var i=0; i < values.length; i++)  {
				var v = values[i][1];

				if (v == null) continue;

				min_val = ((min_val == null) ? v : Math.min(min_val, v));
				max_val = ((max_val == null) ? v : Math.max(max_val, v));

				avg_val += v;
				avg_n   += 1;
			}

			if (avg_n != 0)
				avg_val = avg_val / avg_n;
			else
				avg_val = null;
		}

		series[s]['max_val'] = ( max_val != null ? max_val : null );
		series[s]['min_val'] = ( min_val != null ? min_val : null );
		series[s]['avg_val'] = ( avg_val != null ? avg_val : null );
	}

	var start_x = 0;
	var max_label_length = 0;

	var y_pos = this.y;
	for (var s=0; s < series.length; s++) {

		if (series[s]['format'] == 'changesequence'){
			var labels = series[s]['label'];
			var colors = series[s]['color'];
	
			for (l in labels){
				var square  = this.graph.svg.rect(this.svg_group, this.x                          , y_pos              , timegraph4.SQUARE_SIZE , timegraph4.SQUARE_SIZE, {"fontSize": timegraph4.FONTSIZE+"px", fill: colors[l]  , stroke: 'black', textRendering: "geometricPrecision", strokeWidth: 0, "shape-rendering":"crispEdges", clipPath: 'url(#' + this.svg_clippath_id + ')' });
				var label   = this.graph.svg.text(this.svg_group, this.x + timegraph4.SQUARE_SIZE + timegraph4.LINE_GAP , y_pos + timegraph4.SQUARE_SIZE, labels[l]                    , {"fontSize": timegraph4.FONTSIZE+"px", fill: 'black', stroke: 'black', textRendering: "geometricPrecision", strokeWidth: 0, "shape-rendering":"crispEdges", clipPath: 'url(#' + this.svg_clippath.id + ')' });
		
				w = label.getBBox().width;
				
				max_label_length  = Math.max(max_label_length, w);
		
				y_pos += timegraph4.SQUARE_SIZE + timegraph4.LINE_GAP;
			}
		}
		else{
			var label = series[s]['label'];
			var color = series[s]['color'];
	
			var square  = this.graph.svg.rect(this.svg_group, this.x                          , y_pos              , timegraph4.SQUARE_SIZE , timegraph4.SQUARE_SIZE, {"fontSize": timegraph4.FONTSIZE+"px", fill: color  , stroke: 'black', textRendering: "geometricPrecision", strokeWidth: 0, "shape-rendering":"crispEdges", clipPath: 'url(#' + this.svg_clippath_id + ')' });
			var label   = this.graph.svg.text(this.svg_group, this.x + timegraph4.SQUARE_SIZE + timegraph4.LINE_GAP , y_pos + timegraph4.SQUARE_SIZE, label                    , {"fontSize": timegraph4.FONTSIZE+"px", fill: 'black', stroke: 'black', textRendering: "geometricPrecision", strokeWidth: 0, "shape-rendering":"crispEdges", clipPath: 'url(#' + this.svg_clippath.id + ')' });
	
			w = label.getBBox().width;
			
			max_label_length  = Math.max(max_label_length, w);
	
			y_pos += timegraph4.SQUARE_SIZE + timegraph4.LINE_GAP;
		}
	}

	start_x += max_label_length + 20;

	if (this.text_max_value != null) {
		
		var y_pos = this.y;
		for (var s=0; s < series.length; s++) {

			var v = series[s]['max_val'];
			if (v != null) {
				var scale_label      = calculate_scale(v);
				var scale_multiplier = Math.pow(10, (scale_factor(scale_label) * -1))   ;
				var v_visible = v * scale_multiplier;
				var ticktext  = fixDecimalZero(v_visible) + " " + scale_label + this.graph.ylegend;
				if (this.graph.gui_settings['virtual-max-value'] != null) {
					var p = ROUNDED((100.0 / this.graph.gui_settings['virtual-max-value'] * v),0);					
					ticktext += " (" + p + "%)"
				}
			}
			else {
				var ticktext  = "null";
			}
			

			var text = '';
			if (series[s]['format'] != 'tick') 
				text = " " + this.text_max_value + ": " + ticktext;

			var label = this.graph.svg.text(this.svg_group, timegraph4.SQUARE_SIZE + timegraph4.LINE_GAP + start_x, y_pos + timegraph4.SQUARE_SIZE, text       , {"fontSize": timegraph4.FONTSIZE+"px", fill: 'black', stroke: 'black', textRendering: "geometricPrecision", strokeWidth: 0, "shape-rendering":"crispEdges", clipPath: 'url(#' + this.svg_clippath_id + ')' });

			y_pos += timegraph4.SQUARE_SIZE + timegraph4.LINE_GAP;

			max_label_length  = Math.max(max_label_length, label.getBBox().width);
		}
		start_x += max_label_length + 20;
	}

	if (this.text_min_value != null) {
		
		var y_pos = this.y;
		for (var s=0; s < series.length; s++) {
			
			var v = series[s]['min_val'];
			if (v != null) {
				var scale_label      = calculate_scale(v);
				var scale_multiplier = Math.pow(10, (scale_factor(scale_label) * -1))   ;
				var v_visible = v * scale_multiplier;
				var ticktext  = fixDecimalZero(v_visible) + " " + scale_label + this.graph.ylegend;
				if (this.graph.gui_settings['virtual-max-value'] != null) {
					var p = ROUNDED((100.0 / this.graph.gui_settings['virtual-max-value'] * v),0)
					ticktext += " (" + p + "%)"
				}
			}
			else {
				var ticktext  = "null";
			}
			
			
			var text = '';
			if (series[s]['format'] != 'tick') 
				text = " " + this.text_min_value + ": " + ticktext;
			
			var label = this.graph.svg.text(this.svg_group, timegraph4.SQUARE_SIZE + timegraph4.LINE_GAP + start_x, y_pos + timegraph4.SQUARE_SIZE, text       , {"fontSize": timegraph4.FONTSIZE+"px", fill: 'black', stroke: 'black', textRendering: "geometricPrecision", strokeWidth: 0, "shape-rendering":"crispEdges", clipPath: 'url(#' + this.svg_clippath_id + ')' });

			y_pos += timegraph4.SQUARE_SIZE + timegraph4.LINE_GAP;

			max_label_length  = Math.max(max_label_length, label.getBBox().width);
		}
		start_x += max_label_length + 20;
	}

	if (this.text_avg_value != null) {
		
		var y_pos = this.y;
		for (var s=0; s < series.length; s++) {
			var v = series[s]['avg_val'];
			if (v != null) {
				var scale_label      = calculate_scale(v);
				var scale_multiplier = Math.pow(10, (scale_factor(scale_label) * -1))   ;
				var v_visible = v * scale_multiplier;
				var ticktext  = fixDecimalZero(v_visible) + " " + scale_label + this.graph.ylegend;

				if (this.graph.gui_settings['virtual-max-value'] != null) {
					var p = ROUNDED((100.0 / this.graph.gui_settings['virtual-max-value'] * v),0)
					ticktext += " (" + p + "%)"
				}
			}
			else {
				var ticktext  = "null";
			}

			var text = '';
			if (series[s]['format'] != 'tick') 
				text = " " + this.text_avg_value + ": " + ticktext;

			var label = this.graph.svg.text(this.svg_group, timegraph4.SQUARE_SIZE + timegraph4.LINE_GAP + start_x, y_pos + timegraph4.SQUARE_SIZE, text       , {"fontSize": timegraph4.FONTSIZE+"px", fill: 'black', stroke: 'black', textRendering: "geometricPrecision", strokeWidth: 0, "shape-rendering":"crispEdges", clipPath: 'url(#' + this.svg_clippath_id + ')' });

			y_pos += timegraph4.SQUARE_SIZE + timegraph4.LINE_GAP;

			max_label_length  = Math.max(max_label_length, label.getBBox().width);
		}
	}
}

/******************************************************************************/
/******************************************************************************/
/******************************************************************************/

var TITLE_MAX_HEIGHT   = 20;
var X_AXIS_HEIGHT      = 20;
var MAIN_GRAPH_HEIGHT  = 90;
var TIMELINE_HEIGHT    = 30;
var LEGEND_LINE_HEIGHT = timegraph4.SQUARE_SIZE;

var HIGHLIGHT_TIMES_SHIFT = 12;
var HIGHLIGHT_TIMES_HEIGHT = 15;

timegraph4.Chart = function Chart (id, widget, canvas)
{
	this.id = id;
	
	this.widget = widget;
	this.canvas = canvas;
	
	this.svg = null;
	
	
	this.selected_ts_start = null;
	this.selected_ts_end   = null;
	

	this.isChrome = window.hasOwnProperty('chrome');
};

function ts_to_x_axis_pos(min, max, start_ts, end_ts, ts)
{
	return ((max - min) / (end_ts - start_ts)) * (ts-start_ts);
}

function x_pos_to_ts(x, x_start, x_end, start_ts, end_ts)
{
	return (   (((end_ts - start_ts) / (x_end-x_start)) * x) + start_ts );
}


timegraph4.Chart.prototype.drawTimestepValues = function ()
{
	var start_date  = new Date(this.start_ts * 1000);
	var x_axis = this.main_graph;
	var graph = this.main_x_axis.graph;

	current_date = start_date;
	current_ts   = start_date.getTime() / 1000;
	var index = 0;
	var i = 0;


	var find_index_from_ts = function(array, ts, start){
		if (start == undefined)
			start = 0;
		for(var i = start; i < array.length; i++) {
			if(array[i][0] > ts) {
				return i-1;
			}
		}
	}

	if('show-periodic-values' in this.gui_settings){
		if(!this.gui_settings['show-periodic-values'])
			return
	}
	else{
		return
	}

	while (current_ts < x_axis.end_ts){
		if (current_ts < x_axis.start_ts) {
			current_date = graph.next_date_function(current_date);
			current_ts   = current_date.getTime() / 1000;

			continue;
		}

		current_d = current_date;

		index = find_index_from_ts(graph['data']['series'][1]['values'], current_ts, index);

		var x_pos = ts_to_x_axis_pos(0, x_axis.width, x_axis.start_ts, x_axis.end_ts, current_ts);
		var date_label = graph.label_time_format(current_d);

		if(date_label != '' && graph.gui_settings['show-periodic-values']){
			for (serie in graph['data']['series']){

				var v = graph['data']['series'][serie]['values'][index][1];
				var scale_label      = calculate_scale(v);
				var scale_multiplier = Math.pow(10, (scale_factor(scale_label) * -1))   ;
				var v_rounded        = ROUNDED(v, log10(scale_multiplier)+2);
				var v_visible        = v_rounded * scale_multiplier;
				var ticktext         = fixDecimalZero(v_visible) + " " + scale_label + graph.ylegend[0];
				var value_label = graph['data']['series'][serie]['label'][0]+': '+ticktext;

				var y_local = 10 + parseInt(serie)*10;
				if(i%2){
					y_local = y_local + 30;
				}

				var label  = this.svg.text(null, x_axis.x + x_pos, y_local, value_label, {
					"fontSize"       : fontsize+"px",
					fill             : 'black',
					stroke           : 'black',
					textRendering    : "geometricPrecision",
					strokeWidth      : 0.3,
					"shape-rendering": "crispEdges",
					"clip-path"      : "#"+x_axis.svg_clippath.id
				});

				var width  = label.getBBox().width;
				// var height = label.getBBox().height;
				label.setAttribute('y', y_local);
				var x = label.getBBox().x - (width/2);
				label.setAttribute('x', x);

				var label  = this.svg.line(null, x_axis.x + x_pos, y_local+10, x_axis.x+x_pos, x_axis.height+60, {
					stroke           : '#535f72',
					strokeWidth      : 1,
					"shape-rendering": "crispEdges"
				});
			}
			i += 1;
		}

		current_date = graph.next_date_function(current_date);
		current_ts   = current_date.getTime() / 1000;
	}

}


timegraph4.Chart.prototype.calculateTimeRange = function calculateTimeRange(series)
{
	var min_ts = null;
	var max_ts = null;

	for (var i=0; i < series.length; i++) {

		var data = series[i]['values'];
		
		if (series[i]['format'] != 'tick' && series[i]['format'] != 'changesequence') {
		
			for (var v=0; v <data.length; v++)  {
				var value = data[v][0];
				if (value != null) {
					max_ts = max_ts == null ? value : Math.max(max_ts, value);
					min_ts = min_ts == null ? value : Math.min(min_ts, value);
				}
			}
		}
		else {

			for (var v=0; v <data.length; v++)  {
				min_ts = min_ts == null ? data[v][0] : Math.min(min_ts, data[v][0]);
				max_ts = max_ts == null ? data[v][1] : Math.max(max_ts, data[v][1]);
			}
		}
	}

	this.start_ts = min_ts; 
	this.end_ts   = max_ts; 
}

timegraph4.Chart.prototype.calculateGraphHeight = function  calculateGraphHeight()
{
	console.log('calculateGraphHeight');
	height = (this.gui_settings['show-title'] ? TITLE_MAX_HEIGHT : 0) +
		this.main_graph     .getRequiredHeight() +
		this.main_x_axis    .getRequiredHeight() +
		(this.gui_settings['show-timeline'] ? this.timeline_graph .getRequiredHeight() + this.timeline_x_axis.getRequiredHeight() : 0 ) +
		(this.gui_settings['show-legend']   ? this.legend         .getRequiredHeight() + 10                                       : 0 )
	;
	
	return height;
}


timegraph4.Chart.prototype.initHeight = function (dataset)//, max_chart_height)
{
	var canvas = this.canvas;

	var data = dataset;
	var series = data['series'];
	
	var add = 0;
	if(data.hasOwnProperty('highlight_times'))
	{
		add = HIGHLIGHT_TIMES_SHIFT;
	}
	
	this.graph_height = (this.gui_settings['main-graph-height'] == undefined ? MAIN_GRAPH_HEIGHT : this.gui_settings['main-graph-height']+add)
	
	//
	// Set chart height before everything
	//
	var LEGEND_HEIGHT = (LEGEND_LINE_HEIGHT * series.length) + (timegraph4.LINE_GAP * (series.length - 1));

	var max_chart_height = 
		  (this.gui_settings['show-title'] ? TITLE_MAX_HEIGHT  : 0 )
		+ (this.graph_height) 
		+ X_AXIS_HEIGHT
		+ add
		+ (this.gui_settings['show-timeline'] ? TIMELINE_HEIGHT + X_AXIS_HEIGHT + add : 0 )
		+ (this.gui_settings['show-legend']   ? LEGEND_HEIGHT                   : 0 )
	;
	
	canvas.attr('thisiscanvas','1');
	canvas.css('height', max_chart_height);
}


timegraph4.Chart.prototype.updateRanges = function(dataset)
{
	var data = dataset;
	var series = data['series'];
	var highlight_times_data = data["highlight_times"];
	
	this.data = data;

	min_value = data['min_value'];
	max_value = data['max_value'];
	
	this.min_value = min_value;
	this.max_value = max_value;

	this.calculateTimeRange(series);

	//
	// Graph
	//
	this.main_graph.setTimeRange(this.start_ts, this.end_ts);

	this.main_x_axis.setRange(this.start_ts, this.end_ts);
	
	//DDAYS update
	this.main_x_axis.highlight_times_data = highlight_times_data;

	this.main_y_axis.setRange(this.min_value, this.max_value);
	this.main_y_axis.ylegend = data['ylegend'];
	this.main_y_axis.virtual_max_value  = this.gui_settings['virtual-max-value'];

	this.main_y_axis2.setRange(this.min_value, this.max_value);
	this.main_y_axis2.virtual_max_value = this.gui_settings['virtual-max-value'];

	this.ylegend = data['ylegend'];


	//
	// Timeline
	//
	this.timeline_graph.setTimeRange(this.start_ts, this.end_ts);
	this.timeline_graph.main_graph = this.main_graph;

	this.timeline_x_axis.setRange(this.start_ts, this.end_ts);
	
	//DDAYS update
	this.timeline_x_axis.highlight_times_data = highlight_times_data;
	
	this.timeline_y_axis.setRange(this.min_value, this.max_value);
	this.timeline_y_axis.ylegend = data['ylegend'];
}

timegraph4.Chart.prototype.init = function init (dataset)//, max_chart_height)
{

	if (this.svg != undefined)
		return;

	//
	// INIT SVG AREA
	//
	var canvas = this.canvas;
	canvas.svg();

	var svg = canvas.svg("get");
	
	this.svg = svg;
	
	svg.configure(
		svg.root(), 
		{
			"preserveAspectRatio": "none slice", 
			"textRendering"      : "geometricPrecision", 
			"shapeRendering"     : "crispEdges"
		}, 
		false
	);
	

	var data = dataset;
	var series = data['series'];
	
	//
	// DDAYS DATA (highlight_times)
	//

	var add_dimension = 0;

	if (data.hasOwnProperty("highlight_times"))
	{
		this.highlight_times_data = data["highlight_times"];
		add_dimension = HIGHLIGHT_TIMES_HEIGHT;
	}
	else
	{
		this.highlight_times_data = null;
	}
	
	var offx, offy, maxx, maxy;
	var yoffset = 0; //TITLE_MAX_HEIGHT;


	var HEIGHT = (this.gui_settings['main-graph-height'] == undefined ? MAIN_GRAPH_HEIGHT : this.gui_settings['main-graph-height'] )

	//
	// Calculate y-axies max size (BADDDD)
	//
	var yaxis_max_text = '9999.999 G' + data['ylegend'];
	
	var l  = svg.text(null, 0, 0, yaxis_max_text, {
		"fontSize"       : timegraph4.FONTSIZE + "px", 
		"fill"           : 'black', 
		"stroke"         : 'black', 
		"stroke-opacity" : 1, 
		"textRendering"  : "geometricPrecision", 
		"strokeWidth"    : 0, 
		"shape-rendering": "crispEdges"
	});

	this.y_axis_width = l.getBBox().width;

	l.remove();

	//this.y_axis_width = yaxis_max_text.length * 8;

	//
	// TITLE
	//
	if (this.gui_settings['show-title']) {
		
		var label  = svg.text(null, 0, 0, data['title'], {
			"fontSize"       : timegraph4.FONTSIZE + "px", 
			"fill"           : 'black', 
			"stroke"         : 'black', 
			"stroke-width"   : 3, 
			"stroke-opacity" : 1, 
			"textRendering"  : "geometricPrecision", 
			"strokeWidth"    : 0, 
			"shape-rendering": "crispEdges"
		});
		var width  = label.getBBox().width;
		var height = label.getBBox().height;
		
		//var width  = data['title'].length * 8;
		//var height = 8;
		label.setAttribute('y', (TITLE_MAX_HEIGHT + height) / 2);
		label.setAttribute('x', (canvas.width()/2) - (width / 2));

		yoffset = TITLE_MAX_HEIGHT;
	}
	else {
		yoffset = 0;
	}

	// TIMESTEP VALUE LABELS
	if('show-periodic-values' in this.gui_settings){
		if(this.gui_settings['show-periodic-values'])
			yoffset += 60;
	}

	
	//
	// GRAPHS DIMENSIONS
	//

	//this.y_axis_width  = 100;
	this.y_axis_width2 = 40;

	this.x_origin      = (this.gui_settings['show-yaxis']? this.y_axis_width : 0);
	
	this.graph_width   = canvas.width() - timegraph4.PADDING * 2 - timegraph4.GRAPH_RIGHT_PADDING - (this.gui_settings['show-yaxis']? this.y_axis_width : 0) - ( this.gui_settings['show-perc-yaxis'] == true ?  this.y_axis_width2 : 0 );
	this.graph_height  = HEIGHT;
	
	this.x_axis_width  = this.graph_width;
	this.x_axis_height = X_AXIS_HEIGHT+add_dimension;

	this.y_axis_height = this.graph_height;


	this.y_origin      = yoffset + this.y_axis_height;


	//
	// MAIN GRAPH
	//
	this.main_graph  = new timegraph4.GraphArea(
		"main_graph", 
		this,                  
		0.5 + timegraph4.PADDING + this.x_origin    ,
		0.5 +           yoffset              ,
		this.graph_width , 
		this.graph_height,
		{fill: 'white', stroke: 'black', strokeWidth: 1, "shape-rendering": "crispEdges"}
	);

	this.main_x_axis = new timegraph4.XAxis    (this, this.main_graph, 
		0.5 + timegraph4.PADDING + this.x_origin,         
		0.5           + this.y_origin, 
		this.x_axis_width  , 
		this.x_axis_height, 
		{fill: 'none' , stroke: null, strokeWidth: 0, "shape-rendering": "crispEdges"}

	);

	this.main_y_axis = new timegraph4.YAxis    (this, this.main_graph,                 
		0.5 + timegraph4.PADDING, 
		this.main_graph.y,
		this.y_axis_width, 
		this.y_axis_height, 
		{fill: 'none' , stroke: null, strokeWidth: 0, "shape-rendering": "crispEdges"}
	);
	this.main_y_axis.setVisibility(this.gui_settings['show-yaxis']);
	
	this.main_y_axis2 = new timegraph4.YAxis    (this, this.main_graph,                 
		0.5 + timegraph4.PADDING + this.y_axis_width + this.graph_width, 
		this.main_graph.y,
		this.y_axis_width2, 
		this.y_axis_height, 
		{fill: 'none' , stroke: null, strokeWidth: 1, "shape-rendering": "crispEdges"}
	);
	this.main_y_axis2.percentual_scale = true;
	this.main_y_axis2.step_anchor = 'right';

	this.main_y_axis2.setVisibility(this.gui_settings['show-yaxis']);

	//
	// TIMELINE GRAPH
	//
	var timeline_y_start = this.main_x_axis.y + this.main_x_axis.height;
	var timeline_height  = TIMELINE_HEIGHT;

	this.timeline_graph  = new timegraph4.GraphArea("timeline_graph", this,                      
		this.x_origin                                +0.5+timegraph4.PADDING, 
		timeline_y_start                             +0.5, 
		this.graph_width     ,
		timeline_height     ,
		{fill: 'white', stroke: 'black', strokeWidth: 1, "shape-rendering": "crispEdges"}
	);
	
	this.timeline_x_axis = new timegraph4.XAxis    (this, this.timeline_graph, 
		0.5 + timegraph4.PADDING + this.x_origin, 
		0.5 + timeline_y_start + this.timeline_graph.height, 
		this.graph_width  , 
		this.x_axis_height, 
		{fill: 'none' , stroke: 'white', strokeWidth: 0, "shape-rendering": "crispEdges"}
	); 
	
	this.timeline_y_axis = new timegraph4.YAxis    (this, this.timeline_graph,                 
		0.5 + timegraph4.PADDING , 
		0.5 + timeline_y_start                             , 
		this.y_axis_width-1, 
		timeline_height    , 
		{fill: 'none' , stroke: 'white', strokeWidth: 0, "shape-rendering": "crispEdges"}
	);
	
	this.timeline_y_axis.single_step = true;
	this.timeline_y_axis.setVisibility(this.gui_settings['show-yaxis']);
	
	//
	// LEGEND
	//
	var LEGEND_HEIGHT = 0;
	if (this.gui_settings['show-legend']) 
		LEGEND_HEIGHT = (LEGEND_LINE_HEIGHT * series.length + 2 * (series.length-1));
		

	var legend_y = 0;
	
	if (this.gui_settings['show-timeline']) {
		legend_y = this.timeline_x_axis.y + this.timeline_x_axis.height;
	}
	else {
		legend_y = this.main_x_axis.y + this.main_x_axis.height;
	}

	//legend_height = LEGEND_HEIGHT;

	this.legend = new timegraph4.Legend("legend", this, this.main_graph,  
		10, 
		legend_y, 
		this.main_graph.x + this.main_graph.width  ,  
		LEGEND_HEIGHT          , 
		{fill: 'none' , stroke: 'black', strokeWidth: 0, "shape-rendering": "crispEdges"}
	);

	this.legend.setVisibility(this.gui_settings['show-legend'] == true);

	//
	// MOUSE LINES
	//
	
	//
	canvas
	.mousemove({ div: this.canvas, graph: this }, function(ev) {
		ev.preventDefault();
		ev.stopPropagation();

		var div = ev.data.div;
		var mouse_x = ev.pageX - div.offset().left;
		var mouse_y = ev.pageY - div.offset().top;

		ev.data.graph.main_graph.renderMouseLines(mouse_x, mouse_y);
		if (ev.data.graph.gui_settings['show-timeline']) {
			ev.data.graph.timeline_graph.renderMouseLines(mouse_x, mouse_y);
		}
		return false;
	});

	//
	// EVENT HANDLING
	//
	canvas
	.mousedown( { widget: this, div: this.canvas , graph:this  }, function (ev) {
		var w     = ev.data.widget;
		var div   = ev.data.div;
		var graph = ev.data.graph;
		
		var mouse_x = ev.pageX - div.offset().left;
		var mouse_y = ev.pageY - div.offset().top;
		
		ev.data.graph.main_graph.mousedown(mouse_x, mouse_y);
		
		if (ev.data.graph.gui_settings['show-timeline']) {
			ev.data.graph.timeline_graph.mousedown(mouse_x, mouse_y);
		}
		return true;
	});
	canvas
	.mousemove({ widget: this, div:this.canvas, graph:this }, function(ev) {
		var div   = ev.data.div;
		var w     = ev.data.widget;
		var graph = ev.data.graph;
		
		var mouse_x = ev.pageX - div.offset().left;
		var mouse_y = ev.pageY - div.offset().top;
		
		ev.data.graph.main_graph.mousemove(mouse_x, mouse_y);
		
		if (ev.data.graph.gui_settings['show-timeline']) {
			ev.data.graph.timeline_graph.mousemove(mouse_x, mouse_y);
		}
	});
	
	canvas
	.mouseup( { div: this.canvas, graph:this  }, function (ev) {
		var div     = ev.data.div;
		var mouse_x = ev.pageX - div.offset().left;
		var mouse_y = ev.pageY - div.offset().top;
		
		ev.data.graph.main_graph.mouseup(mouse_x, mouse_y);
		
		if (ev.data.graph.gui_settings['show-timeline']) {
			ev.data.graph.timeline_graph.mouseup(mouse_x, mouse_y);
		}
		return true; 
	});
	
	canvas
	.on('click', { div: this.canvas, graph:this  }, function (ev) {
		var div   = ev.data.div;
		
		var mouse_x = ev.pageX - div.offset().left;
		var mouse_y = ev.pageY - div.offset().top;
		
		ev.data.graph.main_graph.click(mouse_x, mouse_y);
		
		if (ev.data.graph.gui_settings['show-timeline']) {
			ev.data.graph.timeline_graph.click(mouse_x, mouse_y);
		}
		return true; 
	});
};

timegraph4.Chart.prototype.drawSeriesGraphs = function drawSeriesGraphs (dataset, start_ts, end_ts)
{
	//console.log("drawSeriesGraphs("+ start_ts+","+end_ts+")");
	
	var series = dataset['series'];

	this.main_graph.renderSeries(series, start_ts, end_ts);
	
	if (this.gui_settings['show-timeline']) {
		this.timeline_graph.renderSeries(series, start_ts, end_ts);
	}
}

timegraph4.Chart.prototype.renderAll = function renderAll(dataset)
{
	console.log('main graph rendering');
	this.main_graph.render();
	console.log('x axis rendering');
	this.main_x_axis.render();

	console.log('y axis rendering');
	this.main_y_axis.render();
	this.main_y_axis2.render();

	if (this.gui_settings['show-timeline']) {
		console.log('timeline rendering');
		this.timeline_graph.render();
		this.timeline_x_axis.render();
		this.timeline_y_axis.render();
	}
	this.legend.render(dataset['series']);
};

timegraph4.Chart.prototype.toggleExpandedView = function toggleExpandedView(forced)
{
	var canvas = this.canvas;
	var graph  = this;
	
	//console.log("toggleExpandedView()");
	
	var svg_element = $(graph.svg.root());


	var full_height = svg_element.attr('fullheight');
	
	if (full_height == null || full_height == undefined) {
		full_height = this.calculateGraphHeight();
		svg_element.attr('fullheight', full_height );
	}

	if (svg_element.attr('height') == svg_element.attr('fullheight'))  
		show = false;
	else 
		show  = true;

	if (forced != undefined) {
		show = forced;
	}

	//console.log("\t show = " + show);
	
	if (show == true) {
		height = parseInt(svg_element.attr('fullheight'));
		
		this.main_graph     .setVisibility(true);
		this.main_x_axis    .setVisibility(true);
		this.main_y_axis    .setVisibility(true);
		this.main_y_axis2   .setVisibility(this.gui_settings['show-perc-yaxis']);

		if (this.gui_settings['show-timeline']) {
			this.timeline_graph .setVisibility(true);


			this.timeline_x_axis.setVisibility(true);
			this.timeline_x_axis.start_ts = this.main_graph.start_ts;
			this.timeline_x_axis.end_ts   = this.main_graph.end_ts;
			this.timeline_x_axis.render();
			this.timeline_y_axis.setVisibility(true);


			// C'e' un'area selezionata?
			start_ts = this.selected_ts_start;
			end_ts   = this.selected_ts_end;
			//console.log("\t selection=" + start_ts + "  end_ts="+end_ts);
			if (start_ts != undefined && start_ts != null)
				this.timeline_graph.renderSelection(start_ts, end_ts);
		}

		this.legend         .setVisibility(true);
		this.legend         .setReduced(false);
		this.legend.clean();

		if (this.gui_settings['show-timeline']) {
			this.legend.y = this.timeline_x_axis.y + this.timeline_x_axis.height;
		}
		else {
			this.legend.y = this.main_x_axis.y + this.main_x_axis.height;
		}
		this.legend.render(this.data['series']);
	}
	else {
		this.main_graph     .setVisibility(true);
		this.main_x_axis    .setVisibility(true);
		this.main_y_axis    .setVisibility(true);
		this.main_y_axis2   .setVisibility(this.gui_settings['show-perc-yaxis']);
		
		if (this.gui_settings['show-timeline']) {
			this.timeline_graph .setVisibility(false);
			this.timeline_x_axis.setVisibility(false);
			this.timeline_y_axis.setVisibility(false);
		}

		this.legend         .setVisibility(true);
		this.legend         .setReduced(true);
		this.legend.clean();
		this.legend.y = this.main_x_axis.y + this.main_x_axis.height;
		this.legend.render(this.data['series']);

		height = parseInt(this.calculateGraphHeight());
	}
	if('show-periodic-values' in this.gui_settings){
		if(this.gui_settings['show-periodic-values'])
			height += 60;
	}

	svg_element.attr('height', height);
	canvas.css('height', height);

	return show;
};

/******************************************************************************/
/******************************************************************************/
/******************************************************************************/


timegraph4.setExpandedView = function setExpandedView(bool)
{
	var widget = $(this);
	
	//console.log("Expaing timegraph: " + bool);

	current_state = wcore.getWstate.call(widget);
	current_state['expanded'] = bool;
	wcore.setWstate.call(widget, current_state );
	
	this.graph.drawSeriesGraphs(this.graph.data);

	// Se la timeline e' visibile assicuriamoci che sia visibile anche l'area selezionata.
	if (bool == true) {

		// Nel dubbio cancelliamo la selezione corrente (al massimo non facciamo nulla)
		this.graph.timeline_graph.removeSelection();
		
		// C'e' un'area selezionata?
		current_state = wcore.getWstate.call(widget);
		start_ts = current_state['render_state']['selected_ts_start'];
		end_ts   = current_state['render_state']['selected_ts_end'];

		//console.log("\tstart = " + start_ts);
		//console.log("\tend   = " + end_ts  );

		if (start_ts != undefined && start_ts != null && end_ts != undefined && end_ts != null)
		
			this.graph.timeline_graph.renderSelection(start_ts, end_ts);
	}	
}

timegraph4.changeSelectedTimeRange = function changeSelectedTimeRange(selected_ts_start, selected_ts_end)
{
	var widget = $(this);
	
	//console.log("changeSelectedTimeRange(" + selected_ts_start + "," + selected_ts_end + ")");

	current_state = wcore.getWstate.call(widget);
	current_state['render_state']['selected_ts_start'] = selected_ts_start;
	current_state['render_state']['selected_ts_end']   = selected_ts_end;
	
	wcore.setWstate.call(widget, current_state );

}


timegraph4.changeTimeRange = function changeTimeRange(range_length)
{
	var widget = $(this);

	//console.log("changeTimeRange(" + range_length + ")");

	current_state = wcore.getWstate.call(widget);
	current_state['render_state']['ts_start'] = - range_length
	current_state['render_state']['ts_end']   = null;
	var update_params = {
		render_state: current_state['render_state']
	};
	
	wcore.async.lock.call(widget);
	
	wcore.update.call(widget, update_params, true);
};

timegraph4.toggleTimeRangeSelectionLock = function toggleTimeRangeSelectionLock()
{
	alert("LOCK");
}

var DEFAULT_PALETTE = [
	'#00ff00',
	'#0000ff',
	'#ffff00',
	'#ff0000',
	'#ff00ff',
	'#00ffff'
];


function adjust_max_value(v) 
{
	if (v == 0)
		return 0;

	
	var v2 = Math.abs(v);

	if (v2 < 1) {
		var e   = Math.floor(log10(v2)) - 1
	}
	else {
		var e   = TRUNC(log10(v2))
	}
	var f   = Math.pow( 10, e);

	var max = Math.floor(v2 / f) * f;

	while (max < v2)
		max += f;

	max = max * 1.1;

	if (v < 0)
		max = -max;

	return max;
}

function get_min_max_in_range(series, selected_ts_start, selected_ts_end)
{
	var global_min_value = 0;
	var global_max_value = -1;
	
	var valid_series_count = 0;
	var min_val = null;
	var max_val = null;

	for (var s=0; s < series.length; s++) {


		if (series[s]['format'] == 'tick' || series[s]['format'] == 'changesequence')
			continue;

		valid_series_count += 1;

		var values = series[s]['values'];
		
		for (var i=0; i < values.length; i++)  {
			
			
			var ts = values[i][0];
			var v  = values[i][1];

			if (selected_ts_start != undefined && selected_ts_start != null)
				if ( !(selected_ts_start <= ts && ts <= selected_ts_end))
					continue
	
			if (v != null) {
				min_val = ((min_val == null) ? v : Math.min(min_val, v));
				max_val = ((max_val == null) ? v : Math.max(max_val, v));
			}
		}

		global_max_value = (max_val != null) ? Math.max(global_max_value, max_val) : 0.06;
		global_min_value = (max_val != null) ? Math.min(global_min_value, min_val) : global_min_value;
	}

	if (valid_series_count > 0) {
		d = { 'min': adjust_max_value(global_min_value), 'max': adjust_max_value(global_max_value) }; // Per visualizzare meglio il grafico l'estremo superiore e' un po' piu' alto dei dati veri
	}
	else {
		d = { 'min': null, 'max': null }; // Per visualizzare meglio il grafico l'estremo superiore e' un po' piu' alto dei dati veri
	}

	return d;
}

timegraph4.format_value_with_scale = function format_value_with_scale(v)
{
	var scale_label      = calculate_scale(v);
	var scale_multiplier = Math.pow(10, (scale_factor(scale_label) * -1))   ;
	var v_rounded = ROUNDED(v, scale_multiplier);
	var v_visible = v_rounded * scale_multiplier;
	var ticktext  = fixDecimalZero(v_visible) + " " + scale_label;
	return ticktext;
};





timegraph4.analyze_data = function(data)
{
	var series = data['series'];
	
	var analized_series_count = 0;  

	var global_min_value = 0;
	var global_max_value = 0;
	
	var palette_pos = 0;

	data['max_value_raw'] = null;
	data['min_value_raw'] = null;
	data['max_value']     = null;
	data['min_value']     = null;

	for (var s=0; s < series.length; s++) {

		if (series[s]['format'] == 'changesequence')
			continue;
			
	
		analized_series_count += 1;
		
		if (series[s]['color'] == null) {
			
			c = DEFAULT_PALETTE[palette_pos];
			if (palette_pos < (DEFAULT_PALETTE.length-1))
				palette_pos++;
				
			series[s]['color'] = c;
		}

		var to   = series[s]["timescale"]["to"];
		var from = series[s]["timescale"]["from"];
		var step = series[s]["timescale"]["step"];
		
		var min_val = null;
		var max_val = null;
		
		var val_s = series[s]['values'];
		
		try {
			if (val_s[0].length == 2)
			{
				for (var i=0; i < val_s.length; i++)  {
				
					var ts = val_s[i][0];
					var v  = val_s[i][1];
				
					if (series[s]['format'] != 'tick'){
						if (v != null) {
							min_val = ((min_val == null) ? v : Math.min(min_val, v));
							max_val = ((max_val == null) ? v : Math.max(max_val, v));
						}
					}
				}
				global_max_value = (max_val != null) ? Math.max(global_max_value, max_val) : global_max_value;
				global_min_value = (min_val != null) ? Math.min(global_min_value, min_val) : global_min_value;
				continue;
			}
		} catch(err) {
			console.log("analyze_data() error: " + err);
		}
		
		avg_val = 0;
		avg_n   = 0;

		var ts = from;
		var data2 = [];
		for (var i=0; i < val_s.length; i++)  {

			var v = val_s[i];

			if (series[s]['format'] != 'tick')
				if (v != null) {
					min_val = ((min_val == null) ? v : Math.min(min_val, v));
					max_val = ((max_val == null) ? v : Math.max(max_val, v));
					avg_val += v;
					avg_n   += 1;
				}
			
			data2.push([ts, v]);
			ts += step;
		}
		series[s]['values'] = data2;

		if (series[s]['format'] != 'tick') {
			if (avg_n != 0)
				avg_val = avg_val / avg_n;
			else
				avg_val = null;
		}

		series[s]['max_val'] = max_val;
		series[s]['min_val'] = min_val;
		series[s]['avg_val'] = avg_val;		

		global_max_value = (max_val != null) ? Math.max(global_max_value, max_val) : global_max_value;
		global_min_value = (min_val != null) ? Math.min(global_min_value, min_val) : global_min_value;
	}

	if (analized_series_count > 0) {
		data['max_value_raw'] = global_max_value;
		data['min_value_raw'] = global_min_value;
		data['max_value']     = adjust_max_value(global_max_value);
		data['min_value']     = adjust_max_value(global_min_value);
		
		//console.log("raw max:" + data['max_value_raw'] );
		//console.log("raw min:" + data['min_value_raw'] );
		//console.log("    man:" + data['max_value']     );
		//console.log("    mix:" + data['min_value']     );
	}
}


timegraph4.destroy = function destroy()
{
	console.log('destroy timegraph4');
	var WIDGET = $(this);
	
	$('#timegraph_wvis').empty().remove();
	
	WIDGET.data().wdata.series = null;
	WIDGET.data().wdata = null;
	WIDGET.data().graph = null;
	
	WIDGET.removeData();
};




timegraph4.wrender = function wrender()
{
	var WIDGET = $(this);
	
	
	
	// Non ci sono dati dal server? INIT
	var data    = wcore.read.call(this, 'data');
	if (typeof(data) == 'undefined') {
		//console.log("NO DATA");
		return;
	}

	//console.log("DATA");
	//console.log(data);

	// Se non abbiamo info sul rendering usciamo
	var render_state_from_server = data['render_state'];
	
	//console.log("Render state from server " + render_state_from_server);
	if (render_state_from_server == null) {
		return ;
	}

	// Carichiamo lo stao corrente
	var current_render_state = null;
	var current_wstate = wcore.getWstate.call(WIDGET);
	if (! (current_wstate == null)) {
		current_render_state = current_wstate['render_state'];
	}
	else
		current_wstate = {};
	
	
	
	//
	// Salviamo lo stato del rendering
	//
	current_render_state = render_state_from_server;
	current_wstate['render_state'] = render_state_from_server;
	wcore.setWstate.call(WIDGET, current_wstate );


	//
	// Processiamo i dati ricevuti per calcolare valori massimi, minimi, ecc.
	//
	// IMPORTANTE: NON SO PERCHE' NON FUNZIONA SE NON DUPLICO I DATI
	//
	//data = jQuery.extend(true, {}, data);
	
	timegraph4.analyze_data(data);


	//
	// INIT WIDGET AREA
	//

	var display = wcore.getDisplay.call(this);
	
	
	/*
	if (display.is(':visible') == false) {
		return;
	}
	*/

	if (WIDGET.data('graph') == undefined || (display == null || display == undefined) || (display.is(':empty') == true)) {

		display.empty();
		display.css({ 
			"background-color": "#fafffa",
		});
		
		//
		// GRAPH DIV
		//
		var graphdiv = $("<div/>");

		graphdiv.css({ 
			"top"   : "10px",
			"bottom": "10px",
			"right" : "10px",
			"left"  : "10px", 
			
			'-webkit-touch-callout': "none",
			'-webkit-user-select'  : "none",
			'-khtml-user-select'   : "none",
			'-moz-user-select'     : "none",
			'-ms-user-select'      : "none",
			'user-select'          : "none",
		});
		display.append(graphdiv);

		//
		// CANVAS
		//
		var canvas = $("<div/>");
		canvas.css({
			"width" : "100%",
		}); 
		graphdiv.append(canvas);

		//
		// CREATE CHART
		//
		graph = new timegraph4.Chart(guid(), WIDGET, canvas);
		WIDGET.data('graph', graph);
		

		graph = WIDGET.data('graph');

		//
		// Init
		//
		graph.gui_settings      = data['gui-settings'];

		graph.initHeight(data);

		graph.init(data);

		graph.updateRanges(data);


		
		//
		// Gestione della leggenda pop-up
		//
		
		if (WIDGET.over_div == undefined) {
			over_div = $('<div />');
			over_div.css({
				'position'        : 'absolute',
				'background-color': 'white',
				'border'          : '1px solid black',
				'z-indez'         : 8000,
			});
			display.append(over_div);
			WIDGET.over_div = over_div;
		}

		function render_over_legend(graph, ts, pos, mouse_x, mouse_y)
		{
			var series = graph.data['series'];
			
			// Prelevo i dati relativi all'asse sottostante
			if (graph.data.hasOwnProperty('highlight_times'))
			{
				var highlight_times_data = graph.data['highlight_times'];
			}
			else
			{
				highlight_times_data = {};
			}
			
			// Facciamo il calcolo a partire dal timestamp ts per risolvere problemi di ora legale
			var x = new Date(ts * 1000);
			var UTCseconds = x.getTimezoneOffset() * 60 * 1000;

			var d = new Date(ts * 1000 - UTCseconds);

			var time_str = d.getUTCFullYear()+"-"+pad(d.getUTCMonth()+1)+"-"+pad(d.getUTCDate())+ " " +pad(d.getUTCHours()) + ":" + pad(d.getUTCMinutes()) + ":" + pad(d.getUTCSeconds());

			// Calcolo i dati dell'asse sottostante da inserire nella legenda
			var highlight_times_data_keys = Object.keys(highlight_times_data)
			
			var add_to_legend = "";
			
			for(var highlight_times_data_index=0; highlight_times_data_index < highlight_times_data_keys.length; highlight_times_data_index++)
			{
				if(highlight_times_data[highlight_times_data_keys[highlight_times_data_index]]['ts_start'] <= ts && highlight_times_data[highlight_times_data_keys[highlight_times_data_index]]['ts_end'] >= ts)
				{
					var subj = '';
					if(highlight_times_data[highlight_times_data_keys[highlight_times_data_index]]['subject'] != '')
					{
						subj = highlight_times_data[highlight_times_data_keys[highlight_times_data_index]]['subject'];
					}
					else
					{
						subj = highlight_times_data_keys[highlight_times_data_index];
					}
					
					add_to_legend += "<tr> \
								<td> \
									<div style='width:10px; height:10px; border: 0px; background-color:" + highlight_times_data[highlight_times_data_keys[highlight_times_data_index]]['color'] + "'/> \
								</td> \
								<td style='font-size: "+ timegraph4.FONTSIZE +"px'>"+subj+"</td> \
							</tr>";
				}
			}
			
			var info_title = " \
				<tr> \
					<td align='center' colspan=3 style='font-size: "+ timegraph4.FONTSIZE +"px; font-weight: bold;'> \
					Informazioni\
					</td> \
				</tr> \
			";
			
			if(add_to_legend != "")
			{
				var complete_added = info_title + add_to_legend;
				add_to_legend = complete_added;
			}
			
			var over_div = WIDGET.over_div;
			over_div .empty();
			
			str = '';
			str += '<table width="100%" cellspacing=3 cellpadding=0>';
			str += " \
				<tr> \
					<td align='center' colspan=3> \
					" + time_str + "\
					</td> \
				</tr> \
			";

			if (graph.gui_settings['virtual-max-value'] != null) {
				v = graph.gui_settings['virtual-max-value'];
						var scale_label      = calculate_scale(v);
						var scale_multiplier = Math.pow(10, (scale_factor(scale_label) * -1))   ;
						var v_rounded = ROUNDED(v, log10(scale_multiplier)+2);
						var v_visible = v_rounded * scale_multiplier;
						var ticktext  = fixDecimalZero(v_visible) + " " + scale_label + graph.ylegend;
				str += " \
					<tr> \
						<td> \
							<div style='width:10px; height:10px; border: 1px dashed red;'/> \
						</td> \
						<td style='font-size: "+ timegraph4.FONTSIZE +"px'> \
							<span style='color:red'>LIMIT</span>\
						</td> \
						<td style='font-size: "+ timegraph4.FONTSIZE +"px'> \
							" + ticktext + " \
						</td> \
					</tr> \
				";
			}

			for (var s=0; s < series.length; s++) {

				serie = series[s];

				label = '';
				color = '';

				var v;

				if (serie['format'] == 'changesequence') {

					if (pos != null)
						if (serie['values'] != undefined && serie['values'].length != 0 && (0 <= pos && pos < serie['values'].length)) 
							v = serie['values'][pos];

					color = serie['color'][v[3]];

					var tot_time = v[2];

					var num_d = Math.floor(tot_time / timegraph4.ONE_DAY ); tot_time = tot_time % timegraph4.ONE_DAY;
					var num_h = Math.floor(tot_time / timegraph4.ONE_HOUR); tot_time = tot_time % timegraph4.ONE_HOUR;
					var num_m = Math.floor(tot_time / 60      ); tot_time = tot_time % 60;

					var ticktext = 'Duration: ' + num_d + " days " + num_h + " hours " + num_m + " minutes" + tot_time + " seconds";
				}
				else {
						if (pos != null)
							if (serie['values'] != undefined  && serie['values'].length != 0 && (0 <= pos && pos < serie['values'].length) ) 
								v = serie['values'][pos][1];

						label = serie['label'];
						color = serie['color'];

						if (serie['format'] == 'tick') {
							var ticktext = (v>0) ? 'yes': '';
						}
						else {
							if (v != null) {
								var scale_label      = calculate_scale(v);
								var scale_multiplier = Math.pow(10, (scale_factor(scale_label) * -1))   ;
								var v_rounded        = ROUNDED(v, log10(scale_multiplier)+2);
								var v_visible        = v_rounded * scale_multiplier;
								var ticktext         = fixDecimalZero(v_visible) + " " + scale_label + graph.ylegend;
							}
							else {
								var ticktext  = "null";
							}
						}
				}

				str += " \
					<tr> \
						<td> \
							<div style='width:10px; height:10px; border: 0px; background-color:" + color + "'/> \
						</td> \
						<td style='font-size: "+ timegraph4.FONTSIZE +"px'> \
							" + label + "\
						</td> \
						<td style='font-size: "+ timegraph4.FONTSIZE +"px'> \
							" + ticktext + " \
						</td> \
					</tr> \
				";
			}

			str += add_to_legend;
			
			str += '<table>';

			over_div.append(str);
			
			mouse_x = mouse_x + 10;
			if ( (mouse_x + over_div.width()) >  WIDGET.over_div.parent().width())
				mouse_x = mouse_x - over_div.css('width');

			over_div.css('left', mouse_x);
			over_div.css('top' , mouse_y + 10);
			over_div.show();
		}

		// La leggenda deve essere ridisegnata in base alla posizione del mouse sul grafico (o sulla timeline
		graph.main_graph.on_mouse_over     = function (graph, mouse_x, mouse_y, ts) {
			pos = get_data_index_by_ts(graph.data['series'], ts);
			render_over_legend(graph, ts, pos, mouse_x, mouse_y);
		};

		if (graph.gui_settings['show-timeline']) {
			graph.timeline_graph.on_mouse_over = function (graph, mouse_x, mouse_y, ts) {
				pos = get_data_index_by_ts(graph.data['series'], ts);
				render_over_legend(graph, ts, pos, mouse_x, mouse_y);
			};
		}

		// Se il mouse esce dall'area DISPLAY del widget, la leggeda deve sparire
		display.mouseleave( { widget: WIDGET }, function(ev) {
			var widget = ev.data.widget;
			WIDGET.over_div.hide();
		});



		//
		// Gestione della selezione. 
		//
		// NOTA: Le azioni da compiere sulla selezione sono leggermente diverse tra quando seleziono un intervallo
		//       sul grafico principale o sulla timeline.
		//

		function timeline_local_on_selection_change(WIDGET, graph, start_ts, end_ts) {
			
			// Ricordiamoci questa selezione cosi' in caso di refresh la ripristiniamo
			timegraph4.changeSelectedTimeRange.call(WIDGET, start_ts, end_ts);

			graph.main_graph.removeSelection();
			graph.main_graph.clean();

			if ( ( end_ts - start_ts ) > graph.data['series'][0]['timescale']['step'] ) {
				values_range = get_min_max_in_range(graph.data['series'], start_ts, end_ts);

				graph.main_x_axis.setRange(start_ts, end_ts);
				graph.main_x_axis.render();

				graph.main_y_axis.setRange(values_range['min'], values_range['max']);
				graph.main_y_axis.render();

				graph.main_y_axis2.setRange(values_range['min'], values_range['max']);
				graph.main_y_axis2.render();

				graph.main_graph.setTimeRange(start_ts, end_ts);
				graph.main_graph.renderSeries(graph.data['series'], start_ts, end_ts);

				if (graph.gui_settings['show-timeline'])
					graph.timeline_graph.renderSelection(start_ts, end_ts);
			}
			else {
				
				if ( start_ts == null || end_ts == null )
				{
					graph.selected_ts_start = null;
					graph.selected_ts_end   = null;
	
					values_range = get_min_max_in_range(graph.data['series'], graph.timeline_graph.start_ts, graph.timeline_graph.end_ts);

					graph.main_x_axis.setRange(graph.timeline_graph.start_ts, graph.timeline_graph.end_ts);
					graph.main_x_axis.render();

					graph.main_y_axis.setRange(values_range['min'], values_range['max']);
					graph.main_y_axis.render();

					graph.main_y_axis2.setRange(values_range['min'], values_range['max']);
					graph.main_y_axis2.render();

					graph.main_graph.setTimeRange(graph.timeline_graph.start_ts, graph.timeline_graph.end_ts);
					graph.main_graph.renderSeries(graph.data['series']);
					graph.main_graph.removeSelection();

					graph.timeline_graph.removeSelection();
				}
				else
				{
					alert("Lo zoom richiesto e' maggiore della granularita' dei dati");
					return;
				}
			}
			
			if (start_ts != null) {
				$("button[name='btn_clean']" , WIDGET).css('opacity', 1);
				$("button[name='btn_clean']" , WIDGET).addClass('gui-button-selected');
			}
			else {
				$("button[name='btn_clean']" , WIDGET).css('opacity', 0.2);
				$("button[name='btn_clean']" , WIDGET).removeClass('gui-button-selected');
			}
			
		};

		function main_graph_local_on_selection_change(WIDGET, graph, start_ts, end_ts) {
		
			timegraph4.changeSelectedTimeRange.call(WIDGET, start_ts, end_ts);

			if ( ( end_ts - start_ts ) > graph.data['series'][0]['timescale']['step'] ) {

				values_range = get_min_max_in_range(graph.data['series'], start_ts, end_ts);
				
				graph.main_graph.removeSelection();
				graph.main_graph.setTimeRange(start_ts, end_ts);

				graph.main_x_axis.setRange(start_ts, end_ts);
				graph.main_x_axis.render();

				graph.main_y_axis.setRange(values_range['min'], values_range['max']);
				graph.main_y_axis.render();

				graph.main_y_axis2.setRange(values_range['min'], values_range['max']);
				graph.main_y_axis2.render();

				graph.main_graph.clean();
				graph.main_graph.renderSeries(graph.data['series'], start_ts, end_ts);

				if (graph.gui_settings['show-timeline'])
					graph.timeline_graph.renderSelection(start_ts, end_ts);
			}
			else {
				
				if ( start_ts == null || end_ts == null )
				{
					graph.selected_ts_start = null;
					graph.selected_ts_end   = null;
	
	
					values_range = get_min_max_in_range(graph.data['series'], graph.timeline_graph.start_ts, graph.timeline_graph.end_ts);
					
					graph.main_graph.removeSelection();
					graph.main_graph.clean();

					graph.main_x_axis.setRange(graph.timeline_graph.start_ts, graph.timeline_graph.end_ts);
					graph.main_x_axis.render();

					graph.main_y_axis.setRange(values_range['min'], values_range['max']);
					graph.main_y_axis.render();

					graph.main_y_axis2.setRange(values_range['min'], values_range['max']);
					graph.main_y_axis2.render();

					graph.main_graph.setTimeRange(graph.timeline_graph.start_ts, graph.timeline_graph.end_ts);
					graph.main_graph.renderSeries(graph.data['series']);

					graph.main_graph.removeSelection();

					if (graph.gui_settings['show-timeline'])
						graph.timeline_graph.removeSelection();
				}
				else
				{
					alert("Lo zoom richiesto e' maggiore della granularita' dei dati");
					return;
				}
			}
			
			if (start_ts != null) {
				$("button[name='btn_clean']" , WIDGET).css('opacity', 1);
				$("button[name='btn_clean']" , WIDGET).addClass('gui-button-selected');
			}
			else {
				$("button[name='btn_clean']" , WIDGET).css('opacity', 0.2);
				$("button[name='btn_clean']" , WIDGET).removeClass('gui-button-selected');
			}			
		};

		//
		// Callback per gestire il cambio di selezione col mouse dal grafico principale o 
		//
		graph.main_graph.on_selection_change = function (graph, start_ts, end_ts) {
			// Poiche' dobbiamo gestire il "collegamento" di piu' timegraph triggheriamo un evento a livello di pagina
			// per segnalare il cambio di selezione a tutti i grafici in ascolto (in stato locked)
			$( document ).trigger( "timegraph:change_selection", [graph.widget, start_ts, end_ts, false] );
		};

		if (graph.gui_settings['show-timeline']) {
			graph.timeline_graph.on_selection_change = function (graph, start_ts, end_ts) {
				// Poiche' dobbiamo gestire il "collegamento" di piu' timegraph triggheriamo un evento a livello di pagina
				// per segnalare il cambio di selezione a tutti i grafici in ascolto (in stato locked)
				$( document ).trigger( "timegraph:change_selection", [graph.widget, start_ts, end_ts, true] );
			};
		}
		
		
		// Callback vera e priopria per gestire un cambio di selezione.
		// - event_source_widget: widget dove l'utente sta fisicamente operando
		// - start_ts + end_ts :  timestamp del range temporale scelto. (se sono nulli vuol dire che l'utente ha annullato la selezione)
		// - from_timeline: per sapere se l'utente sta cambiando selezione nel grafico principale o dalla timeline.
		$(document).on("timegraph:change_selection", { widget: WIDGET }, function(e, event_source_widget, start_ts, end_ts, from_timeline) {
			var widget_obj = e.data.widget;
			
			// Se l'evento e' stato generato da un widget diverso bisogna vedere se sono entrambi "lockati"
			if ( event_source_widget != widget_obj) {
				var locked_event = $(event_source_widget).attr('locked') == 'true';
				var am_i_locked  = $(widget_obj).attr('locked')          == 'true';
				
				if (! am_i_locked ) return;
				if (! locked_event) return;
			}
			
			if (from_timeline == false)
				main_graph_local_on_selection_change(widget_obj, widget_obj.graph, start_ts, end_ts);
			else
				timeline_local_on_selection_change(widget_obj, widget_obj.graph, start_ts, end_ts);
		});


		$(document).on("timegraph:change_timerange", { widget: WIDGET}, function(e, event_source_widget, range_key) {

			var widget_obj = e.data.widget;
			
			// Se l'evento e' stato generato da un widget diverso bisogna vedere se sono entrambi "lockati"
			if ( event_source_widget != widget_obj) {
				var locked_event = $(event_source_widget).attr('locked') == 'true';
				var am_i_locked  = $(widget_obj).attr('locked')          == 'true';
				
				if (! am_i_locked ) return;
				if (! locked_event) return;
			}

			//console.log("timegraph:change_timerange  to " + $(widget_obj).attr('id') + ": " + range_key);

			// Se la timeline non e' visibile, quando clicchiamo su un pulsante [-1d], [-3d], ecc. bisogna
			// azzerare qualunque selezione temporale, in modo da non "incasinare" il grafico con cio'
			// che dovrebbe fare vedere e cosa inviece e' selezionato.
			if (widget_obj.graph.timeline_graph.visible == false) {
				timeline_local_on_selection_change(widget_obj, widget_obj.graph, null, null)
			}
			
			timegraph4.changeTimeRange.call(widget_obj, range_key );  
		});





		//
		// CREATE CONTROLS
		//
		if (graph.gui_settings['show-controls']) {
		
			var controls_div = $('<div name="controls"/>');
			
			controls_div.append(' \
				<table border="0" width="100%"> \
						<tr> \
							<td width="1%"> \
								<nobr> \
								<button name="btn_lock"         title="Link/Unlink chart with other charts"       class="gui-button" >  <i class="icon-unlink"             >  </i> </button> \
								<button name="btn_timeline"     title="Expand"                                    class="gui-button" >  <i class="icon-chevron-sign-down"  >  </i> </button> \
							</td> \
							\
							<td width="100%" align="center"> \
								\
								<button name="btn_1y"       title="1y"       class="gui-button" > 1y  </button> \
								<button name="btn_6m"       title="6m"       class="gui-button" > 6m  </button> \
								<button name="btn_3m"       title="3m"       class="gui-button" > 3m  </button> \
								<button name="btn_1m"       title="1m"       class="gui-button" > 1m  </button> \
								<button name="btn_7d"       title="7d"       class="gui-button" > 7d  </button> \
								<button name="btn_3d"       title="3d"       class="gui-button" > 3d  </button> \
								<button name="btn_24h"      title="24h"      class="gui-button" > 24h </button> \
								<button name="btn_8h"       title="8h"       class="gui-button" > 8h  </button> \
								<button name="btn_4h"       title="4h"       class="gui-button" > 4h  </button> \
								<button name="btn_1h"       title="1h"       class="gui-button" > 1h  </button> \
								\
								<button name="btn_clean"    title="Remove current selection"       class="gui-button" style="opacity: 0.2;" > Remove Selection </button> \
								\
							</td> \
							\
							<td width="1%"> \
								<nobr> \
									<button name="btn_export"       title="PNG"       class="gui-button" >  <i class="icon-bar-chart"          >  </i> </button> \
									<!--<button name="btn_csv"          title="CSV"       class="gui-button" >  <i class="icon-table"              >  </i> </button> --> \
							</td> \
						</tr> \
				</table> \
			');

			controls_div.css({
				"width":"100%",
			});
			display.append(controls_div);

			//
			// Set control events
			//

			$("button[name='btn_lock']"  , controls_div).on('click', { widget:WIDGET }, function(ev) {  

				var button = $(ev.target);
				var widget = $(ev.data.widget);

				// Cambiamo l'icona del pulsante
				if (widget.attr('locked') != "true") {
					widget.attr('locked', "true");

					$('i', button).attr('class', 'icon-unlink');
					button.addClass('gui-button-selected');
				} 
				else {
					widget.attr('locked', "false");

					$('i', button).attr('class', 'icon-link');
					button.removeClass('gui-button-selected');
				}
			});

			$("button[name='btn_timeline']"  , controls_div).on('click', { val:val  , widget:WIDGET, canvas:canvas, graph: graph }, function(ev) { 

				expanded = ev.data.graph.toggleExpandedView();
				
				timegraph4.setExpandedView.call(ev.data.widget, expanded); 
			});
			
			for (var key in TIME_RANGES ) {
				
				var val = TIME_RANGES[key];
				
				$("button[name='btn_"+key+"']"  , controls_div).on('click', { val:val  , widget:WIDGET }, function(ev) {  
					/*
					var widget_obj = ev.data.widget;
					
					// Se la timeline non e' visibile, quando clicchiamo su un pulsante -1d, -3d, ecc. bisogna
					// Azzerare qualunque selezione temporale in modo da non "incasinare" il grafico con cio'
					// che dovrebbe fare vedere e cosa inviece e' selezionato.
					// console.log("Timeline graph is visible?: " + widget_obj.graph.timeline_graph.visible);
					if (widget_obj.graph.timeline_graph.visible == false) {
						widget_obj.graph.main_graph.on_selection_change(widget_obj.graph, null, null);
					}
					
					timegraph4.changeTimeRange.call(widget_obj, ev.data.val );  
					*/
					
					$( document ).trigger( "timegraph:change_timerange", [ ev.data.widget, ev.data.val ] );
				});
			}

			$("button[name='btn_clean']"  , controls_div).on('click', { widget:WIDGET }, function(ev) {  
				var widget = ev.data.widget;
				//$( document ).trigger( "timegraph:timeline_change_selection", [widget, null, null] );
				$( document ).trigger( "timegraph:change_selection", [widget, null, null, false] );
			});

			$("button[name='btn_export']"  , controls_div).on('click', { val:val  , widget:WIDGET, canvas:canvas, graph: graph }, function(ev) {  

				var svg_code = ev.data.graph.svg.toSVG();
				
				var postdata = {
					'svgdata': svg_code
				};

				var ajaxurl = data['svg_url'];
				
				$.ajax({
					url        : ajaxurl,
					contentType: 'application/json',
					cache      : false,
					type       : 'POST',
					data       : postdata,
					
					context: {
					},
					success: function (data, status, request) {
						
						function isIE(userAgent) {
						  userAgent = userAgent || navigator.userAgent;
						  return userAgent.indexOf("MSIE ") > -1 || userAgent.indexOf("Trident/") > -1;
						}
						
						if (isIE()) {
							exchange = $("<div/>");
							exchange.dialog({
								autoOpen : false,
								title    : "Immagine PNG",
								resizable: true,
								closeText: "Close",
								width    : "auto",
							});
							var savelink = $("<img />");
							savelink.attr('src', data);
							savelink.attr('width', 640);
							exchange.append(savelink);
							exchange.dialog('open');
							exchange.dialog( "moveToTop" );
							exchange.css('z-index', 10000000);
						}
						else {
							var savelink = $("<a />")
								.attr('href', data)
								.attr('download', "image.png")
								.appendTo("body");
							savelink[0].click();
							savelink.remove();
						}
					},
					error: function (request, status, error) {
						alert("Impossibile creare l'immagine richiesta. Errore con il server.");
					}
				});
			});
		}
	}

	WIDGET.graph = WIDGET.data('graph');

	WIDGET.graph.gui_settings      = data['gui-settings'];

	//
	// FORCE AREA RAPPRESENTATION
	//
	
	/*
	for (var s=0; s< data['series'].length; s++) {
		if (data['series'][s]['format'] == 'tick' || data['series'][s]['format'] == 'changesequence')
			continue;
		data['series'][s]['format'] = 'area';
	}
	*/

	if (WIDGET.graph.gui_settings['show-perc-yaxis'] == false) {
		WIDGET.graph.main_y_axis2.setVisibility(false);
	}

	//
	// RENDER
	//
	WIDGET.graph.updateRanges(data);

	WIDGET.graph.renderAll(data);

	WIDGET.graph.drawSeriesGraphs(data);

	WIDGET.graph.drawTimestepValues(data);

	//
	// Posizioniamoci sulla zona selezionata
	//
	WIDGET.graph.selected_ts_start = null;
	WIDGET.graph.selected_ts_end   = null;
	
	if (current_wstate['render_state']['selected_ts_start'] != undefined && current_wstate['render_state']['selected_ts_start'] != null) {

		start_ts = current_wstate['render_state']['selected_ts_start'];
		end_ts   = current_wstate['render_state']['selected_ts_end'];
		
		WIDGET.graph.selected_ts_start = start_ts;
		WIDGET.graph.selected_ts_end   = end_ts;
		
		// Se l'area seleziona non e' visibile, e' inutile anche solo tentantare di far vedere l'area selezionata nel grafico
		if (WIDGET.graph.selected_ts_end  < WIDGET.graph.timeline_graph.start_ts )
			return;

		values_range = get_min_max_in_range(data['series'], start_ts, end_ts);
		
		WIDGET.graph.main_graph.setTimeRange(start_ts, end_ts);
		WIDGET.graph.main_x_axis.setRange(start_ts, end_ts);
		WIDGET.graph.main_x_axis.render();

		WIDGET.graph.main_y_axis.setRange(values_range['min'], values_range['max']);
		WIDGET.graph.main_y_axis.render();

		WIDGET.graph.main_graph.clean();
		WIDGET.graph.main_graph.renderSeries(data['series'], start_ts, end_ts);

		//console.log("Show timeline? " + WIDGET.graph.gui_settings['show-timeline']);

		if (WIDGET.graph.gui_settings['show-timeline']) {
			WIDGET.graph.timeline_graph.renderSelection(start_ts, end_ts);
		}
	}

	//
	// Show controls / legend
	//

	// Show selected button range
	if (current_render_state['ts_end'] == null) {
		var controls_div = $('[name="controls"]', display);
		var time_range = current_render_state['ts_start'] * -1;		
		for (var key in TIME_RANGES ) {
			var range = TIME_RANGES[key];
			if (range == time_range) $("button[name='btn_"+key+"']"      , controls_div).addClass("gui-button-selected");
			else                     $("button[name='btn_"+key+"']"      , controls_div).removeClass("gui-button-selected");
		}
	}

	if (current_wstate['expanded'] == undefined)
	{
		current_wstate['expanded'] = data['gui-settings']['expanded'];
	}
	
	// Di default il grafico non e' espanso
	if (current_wstate['expanded'] == undefined)
	{
		current_wstate['expanded'] = false;
	}
	
	WIDGET.graph.toggleExpandedView(current_wstate['expanded']);
	
	console.log("Timegraph fine");
	
	// Segnalazione di fine rendering
	$( document ).trigger( "timegraph.renderFinished", [] );
};

// saving all widgets to library for finalization and use
WDS.wlib['timegraph3'] = timegraph4;




