/**
 * Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
 * Created: 3/20/14, 3:07 PM
 * Author: Antonio Vaccarino
 */

/*

FORMAT
{
	sections: [ SECTION ]
}

SECTION
{
	title: string
	entries: [ ENTRY ],
	tot_entries: number, // total entries available for section
	page: number, // current page in the pager list
	tot_pages: number, // amount of pages available for this section
}

ENTRY
{
	id: entry id, // for remote
	type: string, // condition|timegraph, mandatory
	grouptitle: string,
	title: string,
	views: [ VIEW ]
}

// VIEWS are created dynamically by the troubleshoot widget itself according to entry type
VIEW (widget + meta)
//{
//	icon: string, // fontawesome icon code,
//	name: string, // description
//	wtype: string, // type of the widget
//	remote: string, // remote of the widget
//	rtimer: int, // secodns for refresh
//	rdata: object, // data for the widget, non mandatory
//}

*/


troubleshoot = {};

//troubleshoot.emergeOLD = function ()
//{
//	var data = $(this).data('wdata');
//
//	// widget list for quicker generation when clickling on a wloader button
//	var wlist = {};
//	for (var i = 0; i < data['sections'].length; i++)
//	{
//		var section = data['sections'][i];
//		for (var j = 0; j < section['entries'].length; j++)
//		{
//			var entry = section['entries'][j];
//			for (var k = 0; k < entry['views'].length; k++)
//			{
//				var view = entry['views'][k];
//				var wloader = {
//					wid: view['wid'],
//					wtype: view['wtype']
//				};
//
//				// todo: see if can be optimized with checks
//				wloader['rdata'] = view['rdata'];
//				wloader['premote'] = view['remote'];
//				wloader['rtimer'] = typeof (view['rtimer']) == 'number' ? view['rtimer'] : 0;
//
//				wlist[wloader['wid']] = wloader;
//			}
//		}
//	}
//
//	wcore.write.call(this, wlist, 'wlist');
//
//
//};

troubleshoot.CLASS_SECTION_TABLE              = "jswlib2_ts_table";
troubleshoot.CLASS_SECTION_HEAD               = "jswlib2_ts_section_head";
troubleshoot.CLASS_SECTION_ENTRY              = "jswlib2_ts_section_entry";
troubleshoot.CLASS_SECTION_ENTRY_TITLE        = "jswlib2_ts_section_title";
troubleshoot.CLASS_SECTION_ENTRY_ELEMENT      = "jswlib2_ts_section_title_element";
troubleshoot.CLASS_SECTION_ENTRY_TITLE_ITALIC = "jswlib2_ts_section_title_italic";
troubleshoot.CLASS_SECTION_ENTRY_ROW          = "jswlib2_ts_section_row";
troubleshoot.CLASS_SECTION_ENTRY_SUBROW       = "jswlib2_ts_section_sub";
troubleshoot.CLASS_SECTION_ENTRY_SUBCELL      = "jswlib2_ts_section_subcell";
troubleshoot.CLASS_SECTION_PAGER              = "jswlib2_ts_section_pager";
troubleshoot.CLASS_SECTION_ENTRY_SELECTOR     = "jswlib2_ts_section_itemsel";
troubleshoot.CLASS_WLOADER                    = "jswlib2_ts_widget_loader";
troubleshoot.CLASS_WLOADER_GEN                = "jswlib2_ts_widget_loader_gen";
troubleshoot.CLASS_SECTION_HIGHLIGHT          = "jswlib2_ts_highlights";

troubleshoot.CLASS_PADDING_ROWS               = "jswlib2_ts_paddingrows";

troubleshoot.VIEWS = {
	"condition":
	[
		{
			title: "Graph",
			icon : "barcode",
			//wlib : "lwp",
			//wtype: "bandgraph",
			//wop  : "dash_condgraph"
			wlib : "wcore",
			wtype: "timegraph3",
			wop  : "timegraph3condition"
		},
		{
			title: "Info",
			icon : "info-circle",
			wlib : "lwp",
			wtype: "valuelist",
			wop  : "resourceinfo"
		},
		{
			title: "Logs",
			icon : "file-text",
			wtype: "ajaxtable",
			wlib : "lwp",
			wop  : "event_log"
		}
	],
	"timegraph":
	[
		{
			title: "Graph",
			icon : "bar-chart-o",
			wlib : "wcore",
			wtype: "timegraph3",
			wop  : "timegraph3"
		},
		{
			title: "Info",
			icon : "info-circle",
			wlib : "lwp",
			wtype: "valuelist",
			wop  : "resourceinfo"
		}
	]
};

troubleshoot.CLASS_CTRL_CONT         = "jswlib2_ts_ctrl_container";
troubleshoot.CLASS_CTRL_BTN          = "jswlib2_ts_ctrl_button";
troubleshoot.CLASS_RESET_BTN         = "jswlib2_ts_reset_button";
troubleshoot.CLASS_CTRL_COMP         = "jswlib2_ts_ctrl_component";
troubleshoot.CLASS_CTRL_CHECK        = "jswlib2_ts_ctrl_itemsel";
troubleshoot.CLASS_PAGER_PAGELINK    = "jswlib2_ts_pager_pagelink";
troubleshoot.CLASS_PAGER_CURRENTPAGE = "jswlib2_ts_pager_pagelink_current";
troubleshoot.CLASS_PAGER_CELL        = "jswlib2_ts_pager_cell";
troubleshoot.CLASS_SECTION_HEADGROUP = "jswlib2_ts_section_headergroup";
troubleshoot.CLASS_SECTION_TITLEGROUP = "jswlib2_ts_section_titlegroup";

troubleshoot.GLYPH_CHECKBOX_UNSEL    = "square-o";
troubleshoot.GLYPH_CHECKBOX_SEL      = "check-square-o";


troubleshoot.assemble = function ()
{
};

troubleshoot.wrender = function wrender ()
{
	var WIDGET = this;
	
	var display = wcore.getDisplay.call(this);
	display.empty();


	var struct = wcore.read.call(this, 'data');
	if (struct == undefined) {
		display.append("<center>Loading data from server...</center>");
		return;
	}

	var oldtemplate = '\
	<div class="'+troubleshoot.CLASS_CTRL_CONT+'">\
		<span class="'+troubleshoot.CLASS_CTRL_COMP+' jswlib2_ts_filter_bykind"> \
			Section \
			<select> \
				<option value="">Conditions</option>\
				<option value="">Timegraphs</option>\
			</select> \
		</span>\
		<span class="'+troubleshoot.CLASS_CTRL_COMP+' jswlib2_ts_filter_byel"> \
			Kind \
			<select>\
				<option value="">All</option>\
				<option value="">Nodes</option>\
				<option value="">Interfaces</option>\
				<option value="">Storages</option>\
				<option value="">Services</option>\
			</select>\
		</span>\
		<span class="'+troubleshoot.CLASS_CTRL_COMP+' jswlib2_ts_filter_filter"> \
			Filter <input type="text"> \
		</span>\
		<span class="'+troubleshoot.CLASS_CTRL_COMP+' jswlib2_ts_filter_oncol"> \
			Column \
			<select>\
				<option value="">Any</option>\
				<option value="">Status</option>\
				<option value="">Element</option>\
				<option value="">Name</option>\
				<option value="">Description</option>\
				<option value="">Classification</option>\
				<option value="">Last update</option>\
			</select>\
		</span>\
	</div>\
	';

	var template = '\
					<div class="'+troubleshoot.CLASS_CTRL_CONT+'"> \
						<input  id="troublesearch"  type="text"  value="{{search}}" /> \
						<span class="jswlib2_ts_filter_byname"></span> \
					</div> \
	';

	var search_controller = Mustache.to_html(template, struct);
	
	var controller = $(search_controller)
	
	controller.find('#troublesearch').bind('keypress', function(e) {
		if(e.keyCode == 13) {
			 e.data = { widget: WIDGET };
			 troubleshoot.searchLoader(e);
		}
	});
    
	// todo: properly set bound functions
	wcore.aux.setButton(controller.find(".jswlib2_ts_button_showcontrols"), {widget: this}, null);
	wcore.aux.setButton(controller.find(".jswlib2_ts_button_showmeasures"), {widget: this}, null);

	var filterbutton = wcore.aux.renderFA("search");
	filterbutton.addClass(troubleshoot.CLASS_CTRL_BTN);
    
	wcore.aux.setButton(filterbutton, {widget: this}, troubleshoot.searchLoader);
	controller.find(".jswlib2_ts_filter_byname").append(filterbutton);

	var resetbutton = wcore.aux.renderFA("times");
	resetbutton.addClass(troubleshoot.CLASS_RESET_BTN);
    
	wcore.aux.setButton(resetbutton, {widget: this}, troubleshoot.resetSearch);
	controller.find(".jswlib2_ts_filter_byname").append(resetbutton);

	display.append( controller );

	// we create the tbody for each section as a placeholder to inject the actual section

	template = '\
		<table class="'+troubleshoot.CLASS_SECTION_TABLE+'" cellpadding=0 cellspacing=0 border=0 style="border-collapse:collapse">\
			{{#sections}}\
			<tbody class="'+troubleshoot.CLASS_SECTION_HEADGROUP+'" data-esection={{title}}>\
			</tbody>\
			{{/sections}}\
		</table>\
	';

	var html_content = Mustache.to_html(template, struct);

	var table = $(html_content);
	display.append( table );

	for (var i = 0; i < struct['sections'].length; i++)
	{
		var csection = struct['sections'][i];
		troubleshoot.renderSection.call(this, csection);
	}

};


troubleshoot.pagerloader = function (ev) {

	var widget    = ev.data.widget;
	
	var html_control = $(ev.target);
	
	if (html_control.hasClass('pagersize')) {
		var section   = html_control.closest('[data-esection]');
		var sectionid = $(section).attr('data-esection');
		var pagenum   = 0;
	}
	else {
		var sectionid = html_control.attr("data-sectionid");
		var section   = $('[data-esection="'+sectionid+'"]', widget);
		var pagenum   = html_control.attr("data-pagenum");
	}

	var pagesize  = section.find('.pagersize').val();

	var baseurl = NS.urls.get_data;

	var premote = widget.data('premote');

	var premote_prefix = premote.split(".")[0].split("_");


	var search_string = $("#troublesearch").val();

	var payload = {
		rid: premote_prefix[1],
		rt : premote_prefix[0],
		d  : {}
	};
	payload["d"][premote] = {
		section      : sectionid,
		page         : pagenum,
		pagesize     : pagesize,
		search_string: search_string,
	};
	payload.d = JSON.stringify(payload.d);

	var params = {
		hasfile: false,
		locking: false,
		custom	: true,
		callback: function (data) {
			data = typeof(data) == 'str' ? JSON.parse(data) : data;

			var sections = data[premote]["dataset"]["sections"];
			var foundrequested = false;
			
			for (var i = 0; i < sections.length; i++) {
				var csection = sections[i];
				
				if (csection['sectionid'] == sectionid) {
					troubleshoot.renderSection.call(widget, csection);
					foundrequested=true;
				}
			}
			
			if (!foundrequested) {
				wcore.aux.feedbackDialog.call(widget, "Could not find the requested page.");
			}
		}
	};

	wcore.async.ajax(baseurl, payload, params);

};

troubleshoot.resetSearch = function (ev) 
{
	$("#troublesearch").val('');
	wcore.setWstate.call(ev.data.widget, {'search_string': ''});

	troubleshoot.searchLoader(ev);
}

troubleshoot.searchLoader = function (ev) {

	var display = $(wcore.getDisplay.call(ev.data.widget).find('table'));

	var baseurl = NS.urls.get_data;

	var widget = ev.data["widget"];
	var premote = widget.data('premote');

	var premote_prefix = premote.split(".")[0].split("_");

	var search_string = $("#troublesearch").val();
	
	var payload = {
		rid: premote_prefix[1],
		rt : premote_prefix[0],
		d  : {}
	};
	payload["d"][premote] = {
		search_string: search_string,
	};
	payload.d = JSON.stringify(payload.d);

	wcore.setWstate.call(ev.data.widget, {'search_string': search_string});

	var params = {
		hasfile: false,
		locking: false,
		custom: true,
		callback: function (data)
		{
			display.empty();

			data = typeof(data) == 'str' ? JSON.parse(data) : data;

			var sections = data[premote]["dataset"]["sections"];
			var foundrequested = false;
			
			for (var i = 0; i < sections.length; i++)
			{
				var csection = sections[i];
				
				troubleshoot.renderSection.call(widget, csection);
				foundrequested=true;
			}

			if (!foundrequested)
			{
				wcore.aux.feedbackDialog.call(widget, "Could not find the requested page.");
			}
		}
	};

	wcore.async.ajax(baseurl, payload, params);
};

troubleshoot.renderSection = function (data)
{
	var section = WSTAT.clone(data);
	var sectionid = data['sectionid'];

	var pager_table = $('<table border=0 width="100%" cellspacing=0 cellpadding=0>');
	var pager_row = $("<tr>");
	pager_table.append(pager_row);
	
	pager_row.append($('<td width="33%">'));

	var sectionpager = $("<td align='center' width='33%'>");
	if (section['tot_pages'] > 1)
	{
		var pager_range = 2;
		
		var maxpage  = section['tot_pages'] - 1;
		var currpage = section['page'];

		var rangesize = pager_range*2+1;

		var page_from = Math.max (0, currpage-pager_range);
		var page_to = Math.min (currpage+pager_range, maxpage);

		var range_exceeds = Math.abs(page_to - page_from - rangesize);
		if (range_exceeds > 0)
		{
			page_from = Math.max (0, page_from - range_exceeds);
			range_exceeds = Math.abs(page_to - page_from - rangesize);
			if (range_exceeds > 0)
			{
				page_to = Math.min (page_to + range_exceeds, maxpage);
			}
		}

		var maxout = page_to == maxpage;
		var minout = page_from == 0;

		var link_page;

		if (!minout)
		{
			link_page = $("<span/>");
			link_page.addClass(troubleshoot.CLASS_PAGER_PAGELINK);
			
			icon = wcore.aux.renderFA("fast-backward", null, ["fw"]);
			icon.attr("data-pagenum", 0);
			icon.attr("data-sectionid", sectionid);
			
			link_page.append(icon);
			sectionpager.append(link_page);
		}

		if (currpage > 0)
		{
			link_page = $("<span/>");
			link_page.attr("data-pagenum", currpage-1);
			link_page.attr("data-sectionid", sectionid);
			link_page.addClass(troubleshoot.CLASS_PAGER_PAGELINK);

			icon = wcore.aux.renderFA("step-backward", null, ["fw"])
			icon.attr("data-pagenum", currpage-1);
			icon.attr("data-sectionid", sectionid);

			link_page.append(icon);
			
			sectionpager.append(link_page);
		}

		for (var p = page_from; p <= page_to; p++)
		{
			link_page = $("<span/>");
			link_page.addClass(troubleshoot.CLASS_PAGER_PAGELINK);
			if (p == currpage)
			{
				link_page.addClass(troubleshoot.CLASS_PAGER_CURRENTPAGE);
			}
			link_page.append (p+1);
			link_page.attr("data-pagenum", p);
			link_page.attr("data-sectionid", sectionid);
			sectionpager.append(link_page);
		}

		if (currpage < maxpage)
		{
			link_page = $("<span/>");
			link_page.addClass(troubleshoot.CLASS_PAGER_PAGELINK);
			
			icon = wcore.aux.renderFA("step-forward", null, ["fw"]);
			icon.attr("data-pagenum", currpage+1);
			icon.attr("data-sectionid", sectionid);
			
			link_page.append(icon);
			
			sectionpager.append(link_page);
		}

		if (!maxout)
		{
			link_page = $("<span/>");
			link_page.addClass(troubleshoot.CLASS_PAGER_PAGELINK);

			icon = wcore.aux.renderFA("fast-forward", null, ["fw"]);
			icon.attr("data-pagenum", maxpage);
			icon.attr("data-sectionid", sectionid);
			
			link_page.append(icon);
			
			sectionpager.append(link_page);
		}

	}
	pager_row.append(sectionpager);


	var pagersize = $("<td align='right' width='33%'>");
	var select = $("<select class='pagersize'>");
	var SIZES = [5, 10, 20, 50, 100];
	for (i=0; i < SIZES.length; i++) {
		var v = SIZES[i];
		var obj = $('<option value="'+v+'">'+v+'</option>');
		if (v == section['pagesize'])
			obj.attr('selected','selected');
		select.append(obj);
	}
	
	pagersize.append(select);
	pager_row.append(pagersize);


	var pager_table2 = $('<tr>').append( $('<td colspan="9">').append(pager_table));

	html = pager_table2.html();
	
	section['pager_el'] = html;


	for (var i = 0; i < section['entries'].length; i++)
	{
		section["entries"][i]["title_section"] = sectionid;
	}

	var template = '\
		<tbody class="'+troubleshoot.CLASS_SECTION_HEADGROUP+'" data-esection={{sectionid}}>\
			<tr> \
				<td colspan=9>&nbsp;</td> \
			</tr>\
			<tr>\
				<th class="'+troubleshoot.CLASS_SECTION_HEAD+'" colspan=9> \
					<span class="'+troubleshoot.CLASS_SECTION_HEAD+'">{{sectionid}}</span> \
				</th>\
			</tr>\
			{{{ pager_el }}}\
			<tr> \
				<td colspan=9>\
					<hr \>\
				</tr>\
			</tr>\
		</tbody>\
		<tbody class="'+troubleshoot.CLASS_SECTION_TITLEGROUP+'" data-esection={{sectionid}}>\
			<tr class="'+troubleshoot.CLASS_SECTION_ENTRY_ROW+'" style="border-bottom: 1px solid #aaaaaa">\
{{^istimegraph}}\
				<th width=1 colspan=3>\
					<span class="'+troubleshoot.CLASS_SECTION_ENTRY_TITLE+' '+troubleshoot.CLASS_PADDING_ROWS+'" style="width:100%;">State</span>\
				</th>\
				<th width=1 >\
					<span class="'+troubleshoot.CLASS_SECTION_ENTRY_TITLE+' '+troubleshoot.CLASS_PADDING_ROWS+'" style="width:100%;">Element</span>\
				</th>\
				<th colspan=2>\
					<span class="'+troubleshoot.CLASS_SECTION_ENTRY_TITLE+' '+troubleshoot.CLASS_PADDING_ROWS+'" style="width:100%;">Title</span>\
				</th>\
				<th width=1 >\
					<span class="'+troubleshoot.CLASS_SECTION_ENTRY_TITLE+' '+troubleshoot.CLASS_PADDING_ROWS+'" style="width:100%;">Priority</span>\
				</th>\
				<th width=1 >\
					<span class="'+troubleshoot.CLASS_SECTION_ENTRY_TITLE+'" style="width:100%;">Last Notable Change</span>\
				</th>\
				<th width=1 >\
					<span class="'+troubleshoot.CLASS_SECTION_ENTRY_TITLE+'" style="width:100%;">Last Done</span>\
				</th>\
				<!--<th width=1 >\
					<span class="'+troubleshoot.CLASS_SECTION_ENTRY_TITLE+'" style="width:100%;">Last Change</span>\
				</th>-->\
{{/istimegraph}}\
{{#istimegraph}}\
				<th colspan=3>\
					<span class="'+troubleshoot.CLASS_SECTION_ENTRY_TITLE+' '+troubleshoot.CLASS_PADDING_ROWS+'" style="width:100%;">&nbsp;</span>\
				</th>\
				<th>\
					<span class="'+troubleshoot.CLASS_SECTION_ENTRY_TITLE+' '+troubleshoot.CLASS_PADDING_ROWS+'" style="width:100%;">Element</span>\
				</th>\
				<th>\
					<span class="'+troubleshoot.CLASS_SECTION_ENTRY_TITLE+' '+troubleshoot.CLASS_PADDING_ROWS+'" style="width:100%;">Description</span>\
				</th>\
				<th>\
					<span class="'+troubleshoot.CLASS_SECTION_ENTRY_TITLE+'" style="width:100%;"></span>\
				</th>\
				<th>\
					<span class="'+troubleshoot.CLASS_SECTION_ENTRY_TITLE+'" style="width:100%;"></span>\
				</th>\
{{/istimegraph}}\
			</tr>\
		</tbody>\
		{{#entries}}\
		<tbody data-esection="{{title_section}}" data-eid="{{id}}" data-rowident="source">\
			<tr class="'+troubleshoot.CLASS_SECTION_ENTRY_ROW+'">\
				\
				<td style="width: 5px; border-bottom: 1px solid #aaaaaa">\
				</td>\
				\
				<td style="width: 30px; border-bottom: 1px solid #aaaaaa"> \
					{{#state}}<span class="state-box bg-{{state}}">{{state}}</span>{{/state}}\
				</td>\
				\
				<td data-eid="{{id}}" data-etype="{{type}}" class="'+troubleshoot.CLASS_WLOADER_GEN+'"  style="border-bottom: 1px solid #aaaaaa">\
				</td>\
				\
				<td style="width: 30px;border-bottom: 1px solid #aaaaaa"> \
					<nobr> \
					<span class="'+troubleshoot.CLASS_SECTION_ENTRY_TITLE+' '+troubleshoot.CLASS_SECTION_ENTRY_ELEMENT+'"> \
						<a href="{{element_kind_url}}">{{element_kind}}</a> \
					</span> \
				</td> \
				<td style="border-bottom: 1px solid #aaaaaa;width:30%;"> \
					<span class="'+troubleshoot.CLASS_SECTION_ENTRY_TITLE+' '+troubleshoot.CLASS_PADDING_ROWS+'"> \
						<a href="{{url}}"> \
							{{title}} \
						</a> \
					</span> \
					\
					{{#primary}} \
										<div class="icon_primary"> P </div> \
					{{/primary}} \
					\
					{{#ignored}} \
										<div class="icon_ignored" title="priority level under minimum prioririty level"> i </div> \
					{{/ignored}} \
				</td> \
				<td style="border-bottom: 1px solid #aaaaaa; width:1%;"> \
					{{#linked}} \
						<nobr> \
						<a href="{{node_url}}" >{{ node_name}}</a>:<a href="{{iface_url}}">{{iface_name}}</a> \
						&nbsp; \
					{{/linked}} \
				</td> \
		{{^istimegraph}}\
				<td width=1 style="border-bottom: 1px solid #aaaaaa"> \
					<span class="'+troubleshoot.CLASS_SECTION_ENTRY_TITLE+'" title="{{#priority}}{{priority}}{{/priority}}"> \
						<nobr>{{plabel}}</nobr> \
					</span> \
				</td> \
				<td width=1 style="border-bottom: 1px solid #aaaaaa"> \
					<span class="'+troubleshoot.CLASS_SECTION_ENTRY_TITLE+'"> \
						<nobr>{{#statuslastnotablechange}}{{statuslastnotablechange}}{{/statuslastnotablechange}}</nobr> \
					</span> \
				</td> \
				<td width=1 style="border-bottom: 1px solid #aaaaaa"> \
					<span class="'+troubleshoot.CLASS_SECTION_ENTRY_TITLE+'"> \
						<nobr>{{#lastdone}}{{lastdone}}{{/lastdone}}</nobr> \
					</span> \
				</td> \
				<!--<td width=1 style="border-bottom: 1px solid #aaaaaa"> \
					<span class="'+troubleshoot.CLASS_SECTION_ENTRY_TITLE+'"> \
						<nobr>{{#statuslastchange}}{{statuslastchange}}{{/statuslastchange}}</nobr> \
					</span> \
				</td>--> \
		{{/istimegraph}}\
		{{#istimegraph}}\
				<td width=1 style="border-bottom: 1px solid #aaaaaa"> \
					<span class="'+troubleshoot.CLASS_SECTION_ENTRY_TITLE+'"> \
						<nobr>&nbsp;</nobr> \
					</span> \
				</td> \
				<td width=1 style="border-bottom: 1px solid #aaaaaa"> \
					<span class="'+troubleshoot.CLASS_SECTION_ENTRY_TITLE+'"> \
						<nobr>&nbsp;</nobr> \
					</span> \
				</td> \
				<td width=1 style="border-bottom: 1px solid #aaaaaa"> \
				</td> \
				<td width=1 style="border-bottom: 1px solid #aaaaaa"> \
				</td> \
		{{/istimegraph}}\
			</tr> \
			<tr class="'+troubleshoot.CLASS_SECTION_ENTRY_SUBROW+'"> \
				<td></td> \
				<td></td> \
				<td colspan=3 class="'+troubleshoot.CLASS_SECTION_ENTRY_SUBCELL+'"></td> \
			</tr> \
		</tbody> \
		{{/entries}} \
	';
	
	

	var html_content = Mustache.to_html(template, section);
	var html_section = $(html_content);

	// finding section in table
	var sectionbody = $(this).find("."+troubleshoot.CLASS_SECTION_HEADGROUP+"[data-esection="+sectionid+"]");
	if (sectionbody.length > 0) {
		var removables = sectionbody.nextAll("tbody[data-esection="+sectionid+"]");

		removables.remove();
		sectionbody.replaceWith(html_section);
	}
	else {
		// for some reason this section is NOT in the table, so we append it
		var table = $(this).find("."+troubleshoot.CLASS_SECTION_TABLE);
		table.append(html_section);
	}

	var choosers = html_section.find("."+troubleshoot.CLASS_SECTION_ENTRY_SELECTOR);
	var button = wcore.aux.renderFA(troubleshoot.GLYPH_CHECKBOX_UNSEL, "", ['fw']).addClass(troubleshoot.CLASS_CTRL_CHECK);
	wcore.aux.setButton(button);
	choosers.append(button).addClass(troubleshoot.CLASS_CTRL_CHECK);
	
	choosers.find("."+troubleshoot.CLASS_CTRL_CHECK).bind('click', {widget: this}, troubleshoot.toggleInFront);
	
	
	html_section.find("."+troubleshoot.CLASS_PAGER_PAGELINK).bind('click' , {widget: this}, troubleshoot.pagerloader);
	html_section.find(".pagersize")                          .change({widget: this}, troubleshoot.pagerloader);

	var generators = html_section.find("."+troubleshoot.CLASS_WLOADER_GEN);
	for (var i = 0; i < generators.length; i++)
	{
		var gen = $(generators[i]);
		var target = gen.closest("tbody").find("."+troubleshoot.CLASS_SECTION_ENTRY_SUBCELL);

		var gentype = gen.data('etype');
		var views = troubleshoot.VIEWS[gentype];
		for (var v = 0; v < views.length; v++)
		{
			// todo: skip outright if the item has no wtype (while building this it makes sense to only avoid the binding)
			var meta = views[v];
			
			var wtype = meta['wtype'];
			var icon = wcore.aux.renderFA(meta['icon'], null, ['fw']);
			var iconspan = $("<span/>");
			iconspan.addClass(troubleshoot.CLASS_WLOADER+' gui-button gui-gradient');
			iconspan.data({
				gentype: wtype,
				genid  : gen.data('eid')
			});
			iconspan.attr('title', meta['title'])
			iconspan.append(icon);
			gen.append(iconspan);

			var lib = meta['wlib'] == 'wcore' ? WDS.wlib : lwp.getlib();

			if (lib.hasOwnProperty(wtype)) {
				var remote = gentype+'_'+gen.data('eid')+"."+meta['wop'];
				var details = {
					widget   : this,
					target   : target,
					wid      : gen.data('eid'),
					wtype    : wtype,
					wlib     : meta['wlib'],
					remote   : remote,
					operation: meta['wop']
				};
				iconspan.bind('click', details, troubleshoot.spawnWidgetInto)
			}
			else {
				// todo: add more handling
//				console.warn("Unknown widget requested in troubleshooting item ",gen," w view ",meta)
			}
		}
	}
};


troubleshoot.toggleInFront = function (ev)
{
//	console.log("Triggered toggleInFront w event ",ev," context ",this," and data ",ev.data);
	ev.preventDefault();
	ev.stopPropagation();

	var entrybody = $(this).closest('tbody');


	// rowident is "source" for the original tbody (never removed) and "clone" for version in the summary area
	var rowident = entrybody.data('rowident');

	// this means the entity was selected WHEN clicked on, so we must INVERT this now
	var issel = $(this).hasClass("fa-"+troubleshoot.GLYPH_CHECKBOX_SEL);

	// now we shift copy the critical version from one area to the other
	// note that the SUMMARY area copy exists always and only when issel == true

	var table = $(this).closest("."+troubleshoot.CLASS_SECTION_TABLE);
//	var hl = table.find("."+troubleshoot.CLASS_SECTION_HIGHLIGHT);
	var eid = entrybody.data('eid');
	var sectionfrom = entrybody.data('esection');

	/* NEW FLOW */

	var title, bookmark;

	var highlightprefix = sectionfrom+": ";
	if (issel)
	{
		$(this).removeClass("fa-"+troubleshoot.GLYPH_CHECKBOX_SEL).addClass("fa-"+troubleshoot.GLYPH_CHECKBOX_UNSEL);

		title = entrybody.find("."+troubleshoot.CLASS_SECTION_ENTRY_ELEMENT);
		title.empty();
		title.append(title.data('original'));

		bookmark = table.find("tbody[data-fromhl="+eid+"]");
//		console.log("Bookmark for re-entry: "+bookmark.length);
		bookmark.before(entrybody);
		bookmark.remove();

	}
	else
	{
//		console.warn("adding entry "+eid+" to highlights");
		// not previously selected, so can only be from the "actual" table
		$(this).removeClass("fa-"+troubleshoot.GLYPH_CHECKBOX_UNSEL).addClass("fa-"+troubleshoot.GLYPH_CHECKBOX_SEL);

		title = entrybody.find("."+troubleshoot.CLASS_SECTION_ENTRY_ELEMENT);
		title.data("original", title.html());
		title.prepend(highlightprefix);

		// todo: add this form of rendering in main render in case of paging

		bookmark = $("<tbody/>");
		bookmark.attr("data-fromhl", eid);
		bookmark.insertBefore(entrybody);

		table.prepend(entrybody);
	}



};

troubleshoot.spawnWidgetInto = function (ev)
{

	// should be mostly static since it creates a new widget

	// this is the CONTAINER (i.e. the TD) of the widget,
	// the div is created on the fly INSIDE it
	var target = ev.data['target'];
	target.empty();

	var clicked = $(ev.currentTarget);
	if (clicked.hasClass('troubleshoot_active'))
	{
		clicked.removeClass('troubleshoot_active');
		target.hide();
		return;
	}
	else
	{
		clicked.closest("td").find(".jswlib2_ts_widget_loader").removeClass('troubleshoot_active');
		clicked.addClass('troubleshoot_active');
	}

	var wtype   = ev.data['wtype'];
	var wid     = ev.data['wid'];
	var premote = ev.data['remote'];

	var rtimer  = ev.data['rtimer'];

	var div     = $("<div/>");
	div.attr('id', wid);
	div.css('width', '800px');

	div.addClass("datadset_"+premote.replace(".","_"));
	
	data = {
		wtype  : wtype,
		premote: premote,
		height : "min"
	};

	if (!(wtype == 'bandgraph' || wtype == 'timegraph')) {
		data['wparams'] = {
			'autosize': true
		}
	}
	else 
		div.css('min-height', '196px');

	div.data(data);


	var wlib = ev.data['wlib'];
	var lib = wlib == 'wcore' ? WDS.wlib : lwp.getlib();

	target.append(div);
	target.show();

	// this sets the remote already
    
	$(div)[wlib]('winit');
	wcore.update.call($(div), true);
};


// saving all widgets to library for finalization and use

WDS.wlib['troubleshoot'] = troubleshoot;
