# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

from sanet_common.sanetdefs.constants import ELEMENT_KIND_NODE, ELEMENT_KIND_IFACE, ELEMENT_KIND_STORAGE, ELEMENT_KIND_SERVICE, ELEMENT_KIND_DEVICE

from core.models import MonitoredNode, MonitoredIface, MonitoredStorage, MonitoredService, MonitoredDevice, DataGroup, Condition, TimeGraph


#-----------------------------------------------------------------------------#
#                                                                             #
#-----------------------------------------------------------------------------#

TAG_PATH_DIVIDER = '/'

TAG_ELEMENTTYPE_NODE      = 'node'
TAG_ELEMENTTYPE_IFACE     = 'interface'
TAG_ELEMENTTYPE_STORAGE   = 'storage'
TAG_ELEMENTTYPE_SERVICE   = 'service'
TAG_ELEMENTTYPE_DEVICE    = 'device'
TAG_ELEMENTTYPE_DATAGROUP = 'datagroup'
TAG_ELEMENTTYPE_CONDITION = 'condition'
TAG_ELEMENTTYPE_TIMEGRAPH = 'timegraph'

TAG_ELEMENTTYPE_TO_MODEL = {
	'node'     : MonitoredNode,
	'interface': MonitoredIface,
	'storage'  : MonitoredStorage,
	'service'  : MonitoredService,
	'device'   : MonitoredDevice,
	'datagroup': DataGroup,
	'condition': Condition,
	'timegraph': TimeGraph,
}

MODEL_TO_TAG_ELEMENTTYPE = dict([ (v,k) for k,v in TAG_ELEMENTTYPE_TO_MODEL.items()])

ELEMENT_KIND_TO_TAG_ELEMENTTYPE = {
	ELEMENT_KIND_NODE    : TAG_ELEMENTTYPE_NODE,
	ELEMENT_KIND_IFACE   : TAG_ELEMENTTYPE_IFACE,
	ELEMENT_KIND_STORAGE : TAG_ELEMENTTYPE_STORAGE,
	ELEMENT_KIND_SERVICE : TAG_ELEMENTTYPE_SERVICE,
	ELEMENT_KIND_DEVICE  : TAG_ELEMENTTYPE_DEVICE,
}

TAG_ELEMENTTYPE_TO_ELEMENT_KIND = {
	TAG_ELEMENTTYPE_NODE    : ELEMENT_KIND_NODE    ,
	TAG_ELEMENTTYPE_IFACE   : ELEMENT_KIND_IFACE   ,
	TAG_ELEMENTTYPE_STORAGE : ELEMENT_KIND_STORAGE ,
	TAG_ELEMENTTYPE_SERVICE : ELEMENT_KIND_SERVICE ,
	TAG_ELEMENTTYPE_DEVICE  : ELEMENT_KIND_DEVICE  ,
}
