# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

"""

get_tag_uuid
=====================================================================================

Usage:

	::
		
		sanet-manage get_tag_uuid  <tag path>

Prints on standard output the UUID of the given <tag path>.

Example:

	::
		
		$ sanet-manage get_tag_uuid geo:/geo
		9677479ea62143ccb6c35e0913b43f57

If the give <tag path> does not exist, the command exits with return code -1.

"""

import sys

from core.management.commands import TenantBasedCommand

from tags.models import Tag

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

class Command(TenantBasedCommand):
    
	help = "Get tAG UUID by path."

	#option_list = TenantBasedCommand.option_list

	def add_arguments(self, parser):

		super(Command, self).add_arguments(parser)

		#
		# Positional arguments
		#
		parser.add_argument('path', default='')

	def handle(self, *args, **options):
		
		path = options['path']

		tenant = self.get_tenant(options)

		try:
			t = Tag.objects.get(path=path)
			print t.uuid
		except Tag.DoesNotExist, e:
			sys.exit(-1)

