# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

from optparse import make_option

from django.core.management.base import BaseCommand

from core.api.base import db_set_current_tenant_schema

from core.api.base import tenant_get_primary, tenant_get

from tags.models import Tag

from tags.server.tagsd.api import get_tags_state_safe

#----------------------------------------------------------------------#
#                                                                      #
#----------------------------------------------------------------------#

class Command(BaseCommand):

	help = "** INTERNAL COMMAND. DO NOT USE **"

	sanet_internal = True

	def add_arguments(self, parser):
		parser.add_argument('--tenant', action='store', dest='tenant', default=None, help=''),
		parser.add_argument('tag_path_or_uuid', action='store', nargs='?', default=None, help=''),

	def handle(self, *args, **options):

		tag_path_or_uuid = options['tag_path_or_uuid']

		tenant_name = options['tenant']
		if tenant_name == None:
			tenant  = tenant_get_primary()
		else:
			tenant  = tenant_get(tenant_name)
		if tenant == None:
			raise Exception("No primary tenant found. You must specify a tenant name")		

		db_set_current_tenant_schema(tenant.name)

		try:
			tag = Tag.objects.get(uuid = tag_path_or_uuid)
		except Exception, e:
			tag = Tag.objects.get(path = tag_path_or_uuid)

		#states = load_tags_state_data([tag,])
                #
		#status_data = states.get(tag.uuid)
                #
		#def _visit_fun(level, t):
		#	print " " * level, t
		#
		#status_data.visit(visit_fun=_visit_fun)
		
		state = get_tags_state_safe(tenant.uuid, [tag.uuid])
		
		print state

