# -*- coding: utf-8 -*-
# Generated by Django 1.11.14 on 2018-10-08 08:43
from __future__ import unicode_literals

import time

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion

import sanet_common.uuids


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('auth', '0008_alter_user_username_max_length'),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('core', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='ElementTag',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('elementtype', models.TextField(db_index=True)),
                ('elementid', models.TextField(db_index=True)),
                ('is_explosive', models.BooleanField(db_index=True, default=False)),
                ('explosive_group', models.IntegerField(db_index=True, default=None, null=True)),
                ('directly_tagged', models.BooleanField(db_index=True, default=True)),
                ('unique_sentinel', models.CharField(default=sanet_common.uuids.create_global_uuid, max_length=32)),
                ('tagged_parent', models.CharField(default=None, max_length=32, null=True)),
            ],
        ),
        migrations.CreateModel(
            name='Tag',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('name', models.TextField(blank=True, db_index=True, default=None, null=True)),
                ('description', models.TextField(blank=True, default=None, null=True)),
                ('icon', models.TextField(blank=True, default=None, null=True)),
                ('path', models.TextField(db_index=True)),
                ('parent', models.ForeignKey(default=None, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='child_tags', to='tags.Tag')),
                ('tenant', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='tags_tag_related', to='core.Tenant')),
            ],
            options={
                'db_table': 'tagentry',
            },
        ),
        migrations.CreateModel(
            name='TagEntryInsertRule',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('rule', models.TextField(db_index=True)),
                ('tagentry', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='tagrules', to='tags.Tag')),
                ('tenant', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='tags_tagentryinsertrule_related', to='core.Tenant')),
            ],
            options={
                'db_table': 'tagentryinsertrule',
            },
        ),
        migrations.CreateModel(
            name='TagGroupAuth',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('auth_type', models.PositiveSmallIntegerField(default=2)),
                ('group', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='auth.Group')),
                ('root_direntry', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='tags.Tag')),
                ('tenant', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='tags_taggroupauth_related', to='core.Tenant')),
            ],
            options={
                'db_table': 'tagentry_group',
            },
        ),
        migrations.CreateModel(
            name='TagMetaData',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('name', models.TextField(blank=True, db_index=True)),
                ('value', models.TextField(blank=True, default=b'')),
                ('tag', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='metadata', to='tags.Tag')),
                ('tenant', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='tags_tagmetadata_related', to='core.Tenant')),
            ],
            options={
                'db_table': 'tagentrymetadata',
            },
        ),
        migrations.CreateModel(
            name='TagTree',
            fields=[
                ('mtime', models.IntegerField(db_index=True, default=time.time)),
                ('uuid', models.CharField(db_index=True, default=sanet_common.uuids.create_global_uuid, max_length=32, primary_key=True, serialize=False)),
                ('name', models.CharField(db_index=True, max_length=254, unique=True)),
                ('descr', models.TextField(blank=True, default=b'')),
                ('allnodes', models.BooleanField(default=False)),
                ('uniques', models.BooleanField(default=False)),
                ('nostate', models.BooleanField(default=False)),
                ('nomap', models.BooleanField(default=False)),
                ('stime', models.FloatField(default=time.time)),
                ('owner', models.ForeignKey(default=None, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='owned_trees', to=settings.AUTH_USER_MODEL)),
                ('tenant', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='tags_tagtree_related', to='core.Tenant')),
            ],
            options={
                'db_table': 'tagtree',
            },
        ),
        migrations.CreateModel(
            name='TagTreeGroupPermission',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('auth_type', models.PositiveSmallIntegerField(default=2)),
                ('dirtree', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='tags.TagTree')),
                ('group', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='auth.Group')),
                ('tenant', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='tags_tagtreegrouppermission_related', to='core.Tenant')),
            ],
            options={
                'db_table': 'tagtree_group',
            },
        ),
        migrations.AddField(
            model_name='tag',
            name='tree',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='tags', to='tags.TagTree'),
        ),
        migrations.AddField(
            model_name='elementtag',
            name='tag',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='tagged', to='tags.Tag'),
        ),
        migrations.AddField(
            model_name='elementtag',
            name='tenant',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='tags_elementtag_related', to='core.Tenant'),
        ),
        migrations.AddField(
            model_name='elementtag',
            name='tree',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='taggedelements', to='tags.TagTree'),
        ),
        migrations.AlterUniqueTogether(
            name='tagtree',
            unique_together=set([('tenant', 'owner', 'name')]),
        ),
        migrations.AlterUniqueTogether(
            name='tagmetadata',
            unique_together=set([('tenant', 'tag', 'name')]),
        ),
        migrations.AlterUniqueTogether(
            name='tagentryinsertrule',
            unique_together=set([('tenant', 'tagentry', 'rule')]),
        ),
        migrations.AlterUniqueTogether(
            name='tag',
            unique_together=set([('tenant', 'tree', 'parent', 'name')]),
        ),
        migrations.AlterUniqueTogether(
            name='elementtag',
            unique_together=set([('tenant', 'tree', 'elementid', 'unique_sentinel')]),
        ),
    ]
