# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

#"""
#         IPC      |
#        LAYER     |                  SERVER
#                  |  
#   STATED_QUEUE --|------------>  ListenThread
#                  |                    |         
#                  |             [request queue]  
#                  |                    |         
#                  |                    v         
#                  |              worker thread
#                  |                    |
#                  |                    v
#                  |             [response queue]
#                  |                    |
#                  |                    v
#                  |              ResponseThread
#                  |                    |
#              * <-|--------------------+
#                  |
#"""
#
#import os
#import sys
#import time
#import logging
#import socket
#import threading
#
#from sanet_common.sanetdefs.ipc import SANETD_STATE_QUEUE
#
#from sanet_common.ipc import RESPONSE_SUCCESS, RESPONSE_ERROR
#from sanet_common.ipc import decode_request, encode_response_with_id
#
##-----------------------------------------------------------------------------#
##                                                                             #
##-----------------------------------------------------------------------------#
#
#class TagServer(object):
#
#	def __init__(self, logger):
#		self.logger = logger
#
#	def start(self):
#		self.logger.info("Starting server...")
#		
#		while 1:
#			
#			self.logger.info(".")
#			
#			time.sleep(1)
#
#
##-----------------------------------------------------------------------------#
##                                                                             #
##-----------------------------------------------------------------------------#
#
#def init_logger(log_leve, log_file):
#
#	logger = logging.getLogger('statusd')
#	logger.setLevel( log_level )
#
#	hdlr = logging.FileHandler(log_file, "a")
#	hdlr.setFormatter( logging.Formatter('%(asctime)s %(levelname)s discovery > %(message)s') )
#	hdlr.setLevel( log_level )
#	logger.addHandler(hdlr)
#
#	hdlr = logging.StreamHandler()
#	hdlr.setFormatter( logging.Formatter('%(asctime)s %(levelname)s discovery > %(message)s') )
#	hdlr.setLevel( log_level )
#	logger.addHandler(hdlr)
#
#	return logger
#
#if __name__ == "__main__":
#
#	import os
#	import sys
#	import logging
#	
#	import Queue
#
#	#
#	# Be sure django will find modules with the right path
#	#
#	sanet_install_dir = sys.argv[1]
#	if not sanet_install_dir in sys.path:
#		sys.path.insert(0, sanet_install_dir)
#	os.environ.setdefault("DJANGO_SETTINGS_MODULE", "conf.settings")
#
#	# These imports depend on django
#	from django.db import connection
#	from django.conf import settings
#	from conf import get_configuration
#
#	#from core.api.base import *
#	#from core.models import *
#	#from core.api.datasource import init_datasource_store_from_conf
#
#	#from server.sanetd.sanetdlogic import create_ipc_connection_from_config
#
#	#from tags.models import *
#	#from tags.api.state import load_tags_state_data
#
#	#from webtests.models import WebScenario
#
#	#
#	# Start
#	#
#	conf = get_configuration()
#
#	# Set log 
#	log_level = 10
#	log_file  = os.sep.join( [conf.LOG_DIR, 'statusd_log'])
#
#	logger = init_logger(log_level, log_file)
#
#	if sanet_install_dir != conf.SANET_INSTALL_DIR:
#		msg = "Install dir %s is different from configuration install dir %s" % (sanet_install_dir, conf.SANET_INSTALL_DIR)
#		print msg 
#		logger.critical(msg)
#
#	s = TagServer(logger)
#	s.start()
#
#	# never returns
#
