# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

from django.conf.urls import url

import tags.views 

#-----------------------------------------------------------------------------#
#                                                                             #
#-----------------------------------------------------------------------------#

urlpatterns = [ #patterns('tags.views',

	# 
	# Add/Remove Tags
	#
	url(r'^add$'                    , tags.views.add_tag            , name='tags.views.add_tag'),
	url(r'^remove$'                 , tags.views.remove_tag         , name='tags.views.remove_tag'),

	#
	# Tagging/Untagging                                                                                  
	#

	url(r'^tag_element$'            , tags.views.do_tag_element     , name='tags.views.do_tag_element'),
	url(r'^untag_element$'          , tags.views.do_untag_element   , name='tags.views.do_untag_element'),

	url(r'^untag_elementid$'        , tags.views.do_untag_elementid , name='tags.views.do_untag_elementid'),

	url(r'^set_group_perm$'         , tags.views.set_group_perm     , name='tags.views.set_group_perm'),

	# 
	url(r'^reload_state/'           , tags.views.reload_state       , name='tags.views.reload_state'),

] #)
