# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

import time

from webui.api import *

from webui.api.Data import BaseDataSet

from webui.api.utils import render_template

#-------------------------------------------------------------------------------#
#                                                                               #
#-------------------------------------------------------------------------------#


class DataSet(BaseDataSet):

	def __init__(self, id):
		
		super(DataSet, self).__init__(id)

		self.part = "configuration_tenants"

	def get_data(self, options): 
	
		tenants = Tenant.objects.all()
		
		html_text = render_template( 'html/parts/configuration_tenants.html', { 'tenants': tenants })
	
		data = { 
			'structure': {
				'template': html_text
			}
		}

		return {
			'dataset': data
		} 
		




