
import random

from core.compatibility import reverse

# from webui.api import ICON_WARNING, ICON_UNCHECK
from core.api.cache import init_cache_manager_from_conf

from webui.api import *
from webui.api.Data import BaseDataSet
from webui.api.types import WEB_ELEMENT_TYPE_TO_MODEL

from webui.api.constans import ICON_UNCHECK, ICON_WARNING


class DataSet(BaseDataSet):

	def __init__(self, id):

		super(DataSet, self).__init__(id)

		# get class element from 
		self.element_class = WEB_ELEMENT_TYPE_TO_MODEL[self.etype]
		self.resource = self.element_class.objects.get(uuid=self.eid)

		self.part = "elementbadge"

	def get_data(self, options): 

		if isinstance(self.resource, Condition) or isinstance(self.resource, DataGroup) or  isinstance(self.resource, TimeGraph):
			# ATTENZIONE!!: inserito l'if per gestire gli elementi che non hanno una pagina propria. vedi lista sopra alla funzione
			self.etype = 'node'
			self.eid = element.element.get_node().uuid

		cache_manager = init_cache_manager_from_conf()

		
		alarms_count          = 0
		critical_alarms_count = 0
		exploded              = False
		icon_url              = None
		icon_overlay_url      = None
		
		unckechakble          = False
		
		
		status                = self.resource.get_state()
		status_code           = CSTATE_TO_CODENAME(status)
		icon_url              = self.resource.get_icon_url_with_state(status_code)
		
		if status_code == "NONE":
			overlay_add_class = "badge_overlay_icon_small"
		else:
			overlay_add_class = ""
		
			
		#if critical_alarms_count > 0 or exploded:
		#	icon_overlay_url = ICON_WARNING
		#	alarms_count     = 0
		#elif unckechakble:
		#	icon_overlay_url = ICON_UNCHECK


		# change element badget title and description for different elementype and page 
		if isinstance(self.resource, Condition) \
				or isinstance(self.resource, DataGroup) \
				or (isinstance(self.resource, MonitoredElement) \
				and not isinstance(self.resource, MonitoredNode) and self.etype in ('tenant','tag')) :
			if isinstance(self.resource, MonitoredElement):
				title       = self.resource.parent.name
				description = self.resource.name
			else:
				self.resource.load_fields_from_cache(cache_manager)
				title       = " : ".join([item for item in self.resource.element.path.split(":")])
				description = self.resource.expanded_title(cache_manager=cache_manager)
		else:
			title       = self.resource.name
			description = ''

		dataset = { "id"         : self.eid,
					"name"       : title,
					"description": description,
					"state"      : {
							"alarms" : alarms_count,
							"img"    : icon_url,
							"overlay": icon_overlay_url,
					},
		}

		details = {
					"url_page": "%s"    % reverse('resource_page', kwargs={'rt':self.etype, 'uuid': self.eid}),
					"url_delete": None,
		}

		# delete element
		if self.etype in ('tenant','tag') and self.resource.parent:
			if not isinstance(self.resource, Tag):
				details["url_delete"] = "javascript:untag_elementid(\'%s\', \'%s\');" % (rid, self.resource.parent.uuid)
			else:
				details["url_delete"] = "javascript:delete_tag(\'%s\');" % (rid)

		
		dataset['details'] = details

		# get measure for data
		measures = {
					#"type":  "BAR",
					#"data":  75 ,
					#"type":  "PAIR",
					#"data":  [ 10, 30 ],
		}
		# attenzione non mettere il valore se vuoto , problemi col widget
		if measures:
			dataset['measures'] = measures

		clickable = True
		if options.get('rt') in ('tenant','tag') and not isinstance(self.resource, Tag):
			# click or not click this is the trouble ...
			clickable = False

		dataset['clickable'] = clickable
		# update dataset name
		dataset['name']        = title
		dataset['description'] = description
		
		return { 'dataset' : dataset } 
