# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

import time

from django.template import Context, loader

from core.api.base import db_set_current_tenant_schema

from webui.api import *

from webui.api.Data import BaseDataSet

from entables.models import Table

#-------------------------------------------------------------------------------#
#                                                                               #
#-------------------------------------------------------------------------------#

class DataSet(BaseDataSet):

	def __init__(self, id):
		
		super(DataSet, self).__init__(id)

	def get_data(self, options): 

		tenant = options.get('tenant')
		db_set_current_tenant_schema(tenant.name)

		tables = Table.objects.all()

		context = {
			'tables': tables
		}

		t = loader.get_template( 'html/parts/entables_config.html' )
		c = context  #c = Context(context) django 1.11
		html_text = t.render(c)

		data = { 
			'structure': {
				'template': html_text
			}
		}

		return {
			'dataset': data
		} 

