

from core.compatibility import reverse

from sanet_common.sanetdefs.constants import ELEMENT_KIND_STR

from tags.models import *

from webui.api.Data import BaseDataSet

#-------------------------------------------------------------------------------#
#                                                                               #
#-------------------------------------------------------------------------------#

class DataSet(BaseDataSet):

	def __init__(self, id):
		self.id = id

	def get_data(self, options):

		r = []
		for et in ElementTag.objects.filter(elementid = self.id).order_by('path'):

			if et.tag.path is not None:

				url        = reverse('resource_page', kwargs={'rt':'tag', 'uuid':et.tag.uuid})
				url_delete = reverse('tags.views.untag_element')
				
				r.append({
					'path'         : et.tag.path,
					'uuid'         : url,
					'untag_element': url_delete + "?e=%s&t=%s&next=%s" % (
								self.id, et.tag.uuid, 
								reverse('resource_page', kwargs={'rt':ELEMENT_KIND_STR[et.elementkind], 'uuid':self.id})
					)
				})

		return {
			'dataset': {
				'values': {
					'paths':r
				}
			}
		}
