
import types

from webui.views import render_new_timegraph3

from webui.api.Data import BaseDataSet


class DataSet(BaseDataSet):

	def __init__(self, id):

		super(DataSet, self).__init__(id)

	def get_data(self, options):

		el = self.fetch_entity(options)
		if el is None:
			raise Exception("Timegraph not found")

		ts_start     = options.get('ts_start', None)
		ts_end       = options.get('ts_end'  , None)

		widget_state = options.get('params', {})
		
		# FIX: c'e' un bug in vecchio widget e i "params" non sono inviati al server come dizionario.
		#      schiviamo il problema per il momento.
		if not isinstance(widget_state, types.DictType):
			widget_state = {}
			

		render_state = widget_state.get('render_state', None)
		
		data = render_new_timegraph3(el, ts_start=ts_start, ts_end=ts_end, render_state=render_state)

		return {
			'dataset': data
		}
