# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

import types

from webui.views import render_new_timegraph3_datasource

from webui.api.Data import BaseDataSet

#----------------------------------------------------------------------#
#                                                                      #
#----------------------------------------------------------------------#

class DataSet(BaseDataSet):

	def __init__(self, id):
		super(DataSet, self).__init__(id)

	def get_data(self, options):

		el = self.fetch_entity(options)
		if el is None:
			raise Exception("Datasource not found")

		ts_start     = options.get('ts_start', None)
		ts_end       = options.get('ts_end'  , None)

		widget_state = options.get('params', {})

		# FIX: c'e' un bug in vecchio widget e i "params" non sono inviati al server come dizionario.
		#      schiviamo il problema per il momento.
		if not isinstance(widget_state, types.DictType):
			widget_state = {}

		render_state = widget_state.get('render_state', None)

		data = render_new_timegraph3_datasource(el, ts_start=ts_start, ts_end=ts_end, render_state=render_state)

		return {
			'dataset': data
		}
