
from core.models import MonitoredNode

from webui.api import *

from webui.models import *

from webui.api.Pages.element import ElementPage, ElementConfigPage

#-------------------------------------------------------------------------------#
#                                                                               #
#-------------------------------------------------------------------------------#

class Page(ElementPage, ElementConfigPage):
	
	TAB_CONFIG    = 'general'
	
	_element_class = MonitoredNode

	def __init__(self, rid, tenant, global_settings):

		super(Page, self).__init__(rid, tenant, global_settings)

		self.pagetype = 'node'

		# Carichiamo l'oggetto giusto per questa pagina
		self.element = self._element_class.objects.get(uuid=self.rid)
		
		self.resource = self.element


		# adjacency tab only for node
		
		self.tabs = ElementConfigPage.get_tab_def(self) 
		self.tabs[0]['active_tab'] = True


	def get_page_layout(self):

		layout = {}
		#layout.update( super(Page, self).get_page_layout() )
		
		layout.update( ElementConfigPage.get_layouts(self) )

		return layout


	def get_additional_jsfile_urls(self):
		urls = super(Page, self).get_additional_jsfile_urls()
		urls += ElementConfigPage.get_additional_jsfile_urls(self)
		return urls



	def get_widgets(self):

		widgets = []
		
		#widgets += super(Page, self).get_widgets()

		widgets += self.get_config_widgets()

		return widgets
		

