# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

from sanet_common.sanetdefs.constants import *

from sanet_common.sanetdefs.constants import *

from core.models import TimeGraph 

from webui.models import *

from webui.api.Pages import PageTab
from webui.api.Pages import VerticalLayout

from webui.api.Pages import BasePage

from webui.api.widgets import widget_resource_section_title

from webui.api.widgets import TimeGraph3Widget

#-------------------------------------------------------------------------------#
#                                                                               #
#-------------------------------------------------------------------------------#

class Page(BasePage):

	_element_class = TimeGraph

	TAB_GENERAL         = 'general'
	LAYOUT_INFO         = 'L-info' 

	def __init__(self, rid, tenant, global_settings):
		
		super(Page, self).__init__(rid, tenant, global_settings)
		
		user = global_settings.get('user')
		
		# Carichiamo l'oggetto giusto per questa pagina
		self.element = self._element_class.objects.get(uuid=self.rid)
		
		self.resource = self.element
		
		
	def get_tabs(self):
		return [
			PageTab(**{
				'name'      : self.TAB_GENERAL,       # name for tab
				'title'     : 'Info',       # title human readable
				'icontype'  : 'fonticon',      # choose icon: fonticon, image
				'iconvalue' : 'icon-list-alt', # icon url, run for icon and image
				'active_tab': True,            # active tab information
			})
		]		


	def get_page_layout(self):

		tabs_layout = {}

		tabs_layout[self.TAB_GENERAL ] = VerticalLayout(self.LAYOUT_INFO)

		return tabs_layout

	#-------------------------------------------------------------------------------#

	def render(self):

		tabs    = self.get_tabs()
		layout  = self.get_page_layout()
		widgets = self.get_widgets()

		page_struct =  {
			'name'   : self.pagetype,   
			'layout' : layout,
			'widgets': widgets,
			'tabs'   : tabs,
		}

		return page_struct


	def get_widgets(self):

		widgets = []
		
		ts = self.element

		title = widget_resource_section_title(ts, "Timegraph", self.TAB_GENERAL, self.LAYOUT_INFO)
		widgets.append(title)

		w = TimeGraph3Widget(ts, tab=self.TAB_GENERAL, container=self.LAYOUT_INFO).to_dict()
		widgets.append(w)		

		return widgets


