# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

import uuid
import random
import json
import operator

from django.conf import settings

from django.utils.html import *
from django.template import Context, Template as DjangoTemplate

#from core.models import *
#from core.api.cache import init_cache_manager_from_conf

#from tags.models import *
#from webui.models import *

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

DEFAULTS_CUSTOM_SETTINGS = {
	'page.tabs.show_title'                     : 1,
	'page.tenant.troubleshoot_view'            : 0,
	'page.element.troubleshoot_view'           : 0,
	'page.tag.troubleshoot_view'               : 0,
	'page.badge_sort_type'                     : 'name',
	'page.alarms_list.show_last_notable_change': 1,
}

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

#
# FIX: SPOSTARE DA QUA 
#

#DIVIDER = {
#	'id'        : str(uuid.uuid4()),
#	'tab'       : ' '.join(['general','technical', 'map']),
#	'wtype'     : ["customdiv"],
#	'hide_tools': True,
#	'wconf'     : None,
#	'wparams': {
#		'template': '''<div class="divider"></div>'''
#	},
#	'width' : "max",
#	'height':  0.1,
#	'setup' : None,
#}

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

# FIX: questa funzione non deve stare qui. Spostare in una API CONDIVISA PER GESTIRE LA CACHE
#      dei TAG e INTERFACCIA WEB

#def flush(uuid, tenant):
#	cache_manager = init_cache_manager_from_conf()
#	
#	key_2 = cache_manager.create_key( 'content_structure', tenant, uuid)
#	
#	cache_manager.delete(key_2)

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

# Questi due template sono usati in molti punti

#BUBBLE_WARNING_TEMPLATE = """
#	{{#icon_warning}}
#		<span title="{{amount}} Alarms >= priority level %(plevel)s" class="bubble_conditions_counter node">
#			{{amount}}
#		</span>
#	{{/icon_warning}}
#"""

#BUBBLE_EXPLODED_TEMPLATE = """                              
#	{{#exploded}}
#		<span class="bubble_exploded">
#			<i style="font-size: 1.2em;color:red;" class="icon-exclamation"></i>
#		</span>
#	{{/exploded}}
#"""

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

#def EXPAND_TEMPLATE(template_string, d):
#	# FUnzione di comodo usata nel codice per razionalizzare l'assemblaggio/espansione dei template
#	return (template_string % d)

def format_html(st):
	return st
	# PER FAR FUNZIONARE IL WDATA DELLA PAGINA ABBIAMO DOVUTO DISABILITARE L'ESCAPE DI QUESTA FUNZIONE
	# PECHE' IN TROPPI PUNTI ESCAPIAMO LE STRINGHE.
	# PER IL MOMENTO LASCIAMOC COSI', MA BISOGNA TROVARE IL MODO DI PASSARE IL JSON CON I DATI DELLA
	# PAGINA IN MANIERA PIU' PULITA SENZA ACCROCCHI COME QUESTO.
	# DISABILITATO <<<<<<<<
	html = escape(st)
	return html
	# DISABILITATO >>>>>>>>
	

def format_html_template(st, params):

	t = DjangoTemplate(st)
	c = Context(params)

	html = t.render(c)

	return html

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#
    
def _da_import(name, klass):
	mod = __import__(name)

	components = name.split('.')

	for comp in components[1:]:
		mod = getattr(mod, comp)

	return getattr(mod, klass)

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

_cached_ds_modules = {}

def get_ds_module(name):
	
	global _cached_ds_modules
	
	ds = _cached_ds_modules.get(name, None)
	if ds is not None:
		#print "DataSet '%s' already loaded" % (name)
		return ds


	subapps = ['webui'] + settings.INSTALLED_APPS

	for subapp in subapps:

		try:

			if subapp == 'webui':
				module_path  = '%s.api.Data.%s' % (subapp, name,)
			else:
				module_path  = '%s.web.api.Data.%s' % (subapp, name,)

			module_class = 'DataSet'

			ds = _da_import(module_path, module_class)

			#print "Found DataSet '%s' module in: %s" % (name, module_path)

			_cached_ds_modules[name] = ds

			return ds
		except ImportError, e:
			pass

	raise ImportError("DataSet %s module not found" % (name))

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

def _load_page_module(name):

	subapps = ['webui'] + settings.INSTALLED_APPS

	for subapp in subapps:
		try:
			if subapp == 'webui':
				module_path = "%s.api.Pages.%s" % (subapp, name)
			else:
				module_path = "%s.web.api.Pages.%s" % (subapp, name)
			return _da_import(module_path, 'Page')
		except ImportError, e:
			#print __file__, "_load_page_module", type(e), str(e)
			pass

	raise ImportError("Page %s module not found" % (name))

def get_page_instance(rtype, rid, tenant, global_settings):

	page_module   = _load_page_module(rtype)

	page_instance =  page_module(rid, tenant, global_settings)

	return page_instance

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

def _load_part(name):
	return _da_import("webui.api.Parts.%s" % name, 'Part')

def get_part(rtype, rid, tenant):

	part_module = _load_part(rtype)

	part_instance = part_module(rid, tenant)

	struct = part_instance.render()

	return struct


