# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

import os
import time

import json

from django.db.models import Q

#from django.contrib.auth.models import User, Group

from sanet_common.exceptions import *
from sanet_common.sanetdefs.constants import *

from conf import get_configuration

DEBUG = get_configuration().DEBUG

from core.models import Tenant
from core.models import MonitoredElement
#from core.models import MonitoredNode
#from core.models import MonitoredIface
#from core.models import MonitoredStorage
#from core.models import MonitoredService
#from core.models import MonitoredDevice
#from core.models import DataGroup
#from core.models import DataSource
#from core.models import TimeGraph, Event
#from core.models import ELEMENT_KIND_STR
from core.models import Condition 

from core.api.base import db_set_current_tenant_schema

from core.api.cache import init_cache_manager_from_conf

#
# FIX: controllare se questi importo ancora necessari per gestire segnali o cose simili
#

#from notes.models import *

from tags.models import *

#from maps.models import *

#-------------------------------------------------------------------------------#
#                                                                               #
#-------------------------------------------------------------------------------#

cache_manager = init_cache_manager_from_conf()

#def get_structure(rtype, uuid, tenant):
#	
#    cache_manager = init_cache_manager_from_conf()
#    key = cache_manager.create_key( 'content_structure', tenant.uuid, uuid)
#    
#    struct = cache_manager.get(key)
#    # struct = None
#
#    if struct is not None:
#        struct = json.loads(struct)
#
#    if struct is None:
#        if rtype == "tags":
#            struct =  get_tag_struct(uuid, tenant.name)
#        elif rtype == "sites":
#            struct = get_site_struct(tenant.name)
#        elif rtype == "nodes":
#            struct = get_struct(uuid, tenant.name)
#        elif rtype == "ifaces":
#            struct = get_struct(uuid, tenant.name)
#        elif rtype == "storages":
#            struct = get_struct(uuid, tenant.name)
#        elif rtype == "devices":
#            struct = get_struct(uuid, tenant.name)
#        elif rtype == "services":
#            struct = get_struct(uuid, tenant.name)
#        elif rtype == "alarms":
#            struct = get_struct_alarm(uuid, tenant.name)
#        else:
#            struct = {}
#        # comment to disable cache
#        cache_manager.set(key, json.dumps(struct))
#    
#    return struct

"""
def safe_str(str):
    str = str.replace('\'', '&quot;')
    return htmlentities.encode(str)
"""

#def node_get_by_uuid(uuid, tenant=None):
#
#    if tenant:
#        db_set_current_tenant_schema(tenant.name)
#
#    try:
#        n = MonitoredNode.objects.get(uuid=uuid)
#        return n
#    except MonitoredNode.DoesNotExist, e:
#        return None

#def get_struct_alarm(uuid, tenant_name):
#    
#    uuid, label = uuid.split("_")
#
#    db_set_current_tenant_schema(tenant_name)
#    pri = PriorityLabel.objects.get(label=label)
#    
#    resp = {}
#    resp['data'] = element_get_info(label)
#
#
#    filter = {}
#    filter['datagroup__suspended'] = False
#    filter['priority__gte'] = pri.min_level
#    filter['priority__lte'] = pri.max_level
#    filter['status'] = CSTATE_DN
#    if uuid != 'default':
#        element = Tag.objects.get(uuid=uuid)
#        filter['uuid__in'] = list(element.get_conditions().values_list('uuid', flat=True))
#
#    order = ['status', '-priority']
#
#    # condition
#    resp['content'] = {}
#    resp['content']['additional'] = {}
#
#    cs = Condition.objects.order_by(*order).filter(**filter).select_related('element','element__parent')
#    resp['content']['additional']['conditions'] = list(cs.values())
#    resp['content']['elements'] = []
#
#    # node
#    element = set()
#    edict = {}
#    pelement = set()
#    pdict = {}
#    for c in cs:
#        element.add(c.element.uuid)
#        edict.setdefault(c.element.uuid, edict.get(c.element.uuid, 1)+1)
#        if c.element.parent:
#            pelement.add(c.element.parent.uuid)
#            pdict.setdefault(c.element.parent.uuid, edict.get(c.element.parent.uuid, 1)+1)
#
#    # get elements and classes to draw
#    for uuid in element:
#        einfo = element_get_info(uuid)
#        einfo['count_conditions'] = edict[uuid]
#        if einfo['values']['kind'] == 'node':
#            einfo['values']['additional_classes'] = 'nodes elements'
#        else:
#            einfo['values']['additional_classes'] = 'elements'
#        resp['content']['elements'].append(einfo)
#    
#    for uuid in pelement:
#        if uuid in element:
#            continue
#        einfo = element_get_info(uuid)
#        einfo['count_conditions'] = pdict[uuid]
#        einfo['values']['additional_classes'] = 'nodes'
#        resp['content']['elements'].append(einfo)    
#
#    return resp

#def get_map_info(uuid, tenant_name):
#    db_set_current_tenant_schema(tenant_name)
#    return LogicMap.objects.get(uuid = uuid)
    

#def tag_get_all(tenant_name, uuid=None):
#    db_set_current_tenant_schema(tenant_name)
#    els = {}
#    el = Tag.objects.filter(tenant__name = tenant_name, uuid=uuid)[0]
#
#    conditions = el.get_conditions().count()
#
#    els['element'] = Tag.objects.filter(tenant__name = tenant_name, uuid=uuid).values('uuid', 'name', )[0]
#    
#    els['elements'] = []
#    elements = ElementTag.objects.filter(tag = el)
#
#    els['parents'] = []
#    par = els['parents']
#    p = el.parent
#    while p != None:
#        par.extend([tag_get_info(p.uuid), []])
#        par = par[1]
#        p = p.parent
#    
#    for elem in elements:
#        els['elements'].append(element_get_info(elem.elementid))
#    
#
#    els['additional'] = {}
#    els['additional']['trees'] = []
#    els['additional']['tags'] = {}
#    els['additional']['element_tags'] = {}
#    #for x in TagTree.objects.filter(cached=True):
#    for x in TagTree.objects.all():
#        for t in Tag.objects.filter(parent = el, tree=x).distinct():
#            els['additional']['trees'].append({
#                                                          #'slug':t.slug, 
#                                                          'name':safe_str(t.name), 
#                                                          'uuid':t.uuid, 
#                                                          })
#            els['additional']['tags'][t.uuid] = []
#            for u in Tag.objects.filter(parent=t):
#                els['additional']['tags'][t.uuid].append({
#                                                          #'slug':u.slug, 
#                                                          'name':safe_str(u.name), 
#                                                          'uuid':u.uuid, 
#                                                          })
#    for e in els['additional'] :
#        for el in els['additional'][e] :
#            if "element__kind" in el:
#                el['element__kind'] = ELEMENT_KIND_STR[el['element__kind']]
#                if el['element__kind'] == "node":
#                    el['element__parent__uuid'] = el['element__uuid']
#                    el['element__parent__name'] = el['element__name']
#                    el['element__uuid'] = None
#                    el['element__kind'] = None
#            for ee in el:
#                if ee == "name":
#                    el[ee].replace("'", '&apos;')
#    maps = MapTag.objects.filter(tagid = uuid).values('mapid')
#    if len(maps) > 0:
#        els['additional']['map'] = list(maps)[0]
#
#    els['additional']['conditions'] = {}
#    els['additional']['conditions']['count'] = conditions
#    return els



#def element_get_all(tenant_name, uuid=None):
#
#    db_set_current_tenant_schema(tenant_name)
#    
#    el = MonitoredElement.objects.filter(uuid = uuid).values('uuid','name', 'kind','parent__uuid')[0]
#    
#    if uuid:
#        all_els =  MonitoredElement.objects.filter(tenant__name=tenant_name, parent__uuid=uuid)
#    else:
#        all_els =  MonitoredElement.objects.filter(tenant__name=tenant_name, parent__isnull=True)
#
#    # FIX: els e' gia' un dizionario. Se devi cambiare solo il kind puoi farlo senza ricreare un nuovo vettore di dati?
#    # FIX: sarebbe meglio impostare 'kind' fuori dalle api di base.
#
#
#    els = {}
#    els['element'] = el
#    els['elements'] = []
#    for a_el in all_els:
#        els['elements'].append(element_get_info(a_el.uuid))
#
#    if el['kind'] != 1:
#        els['parent'] = element_get_info(el['parent__uuid'])
#    
#
#    els['mode'] = el
#    els['additional'] = {}
#    els['additional']['datagroups'] = list(DataGroup.objects.filter(element__uuid = uuid).values('path','uuid','classification', 'suspended', 'suspend_time', 'suspend_resume_time', 'suspend_reason', 'mtime', 'element_id', 'element__name', 'title', 'name'))
#    els['additional']['conditions'] = list(Condition.objects.filter(element__uuid = uuid).values('datagroup__suspended','path','uuid','statuschange_action','expr', 'classification', 'uncheckable_fallback', 'msg_upsubj', 'msg_downsubj', 'primary', 'mtime', 'statuslastchange', 'statuslast', 'element_id', 'element__name', 'datagroup_id', 'datagroup__name', 'title', 'name', 'status'))
#    els['additional']['datasources'] = list(DataSource.objects.filter(save_value=True, element__uuid = uuid).values('datagroup__suspended','path','uuid', 'gauge','classification', 'cascade', 'expr', 'order', 'mtime', 'title', 'status', 'element_id', 'element__name', 'datagroup_id', 'datagroup__name', 'title', 'name', 'status'))
#    els['additional']['timegraphs'] = list(TimeGraph.objects.filter(element__uuid = uuid).values('datagroup__suspended','name','title', 'uuid','primary',  'datagroup_id', 'datagroup__name','stacked'))
#    
#
#    for e in  els['additional'].keys():
#        for el in els['additional'][e] :
#            if "element__kind" in el:
#                el['element__kind'] = ELEMENT_KIND_STR[el['element__kind']]
#                if el['element__kind'] == "node":
#                    el['element__parent__uuid'] = el['element__uuid']
#                    el['element__parent__name'] = el['element__name']
#                    el['element__uuid'] = None
#                    el['element__kind'] = None
#            for ee in el:
#                if ee == "name":
#                    el[ee].replace("'", '&apos;')
#    # add node number
#    els['additional']['notes'] = UserNote.objects.filter(object_pk = uuid).count()        
#            
#    for dg in els['additional']['datagroups']:
#        key = cache_manager.create_key( 'cache', 'expanded_title', Tenant.objects.get(name=tenant_name).uuid, dg['uuid'], )
#        dg['expandedtitle'] = cache_manager.get(key)
#        if dg['expandedtitle'] is not None:
#            dg['expandedtitle'] = dg['expandedtitle'][1]
#        else:
#            dg['expandedtitle'] = dg['title']
#
#    return els

#def element_get(tenant_name, kind, name):
#
#    db_set_current_tenant_schema(tenant_name)
#
#    return MonitoredElement.objects.get(kind=kind, name=name, tenant__name=tenant_name)

#def element_get_itm(uuid):
#    try:
#        me = MonitoredElement.objects.get(uuid = uuid)        
#        if me.kind == 1:
#            return  MonitoredNode.objects.get(uuid=me.uuid)
#        elif me.kind == 2:
#            return  MonitoredIface.objects.get(uuid=me.uuid)
#        elif me.kind == 3:
#            return  MonitoredStorage.objects.get(uuid=me.uuid)
#        elif me.kind == 4:
#            return  MonitoredService.objects.get(uuid=me.uuid)
#        elif me.kind == 5:
#            return  MonitoredDevice.objects.get(uuid=me.uuid)
#    except:
#        try:
#            return  Condition.objects.get(uuid=uuid)
#        except:
#            try:
#                return  TimeGraph.objects.get(uuid=uuid)
#            except:
#                try:
#                    return DataSource.objects.get(uuid=uuid)
#                except:
#                    return Event.objects.get(uuid=uuid)

#def element_get_info(uuid, child=False):
#    ret = {}
#    try:
#        me = MonitoredElement.objects.get(uuid = uuid)
#        ret['rt'] = me.kind
#        
#        if me.kind == 1:
#            ret['values'] = MonitoredNode.objects.filter(uuid=me.uuid).values()[0]
#        
#        elif me.kind == 2:
#            ret['values'] = MonitoredIface.objects.filter(uuid=me.uuid).values()[0]
#            
#        elif me.kind == 3:
#            ret['values'] = MonitoredStorage.objects.filter(uuid=me.uuid).values()[0]
#        
#        elif me.kind == 4:
#            ret['values'] = MonitoredService.objects.filter(uuid=me.uuid).values()[0]
#        
#        elif me.kind == 5:
#            ret['values'] = MonitoredDevice.objects.filter(uuid=me.uuid).values()[0]
#            
#        ret['values']['kind'] = ELEMENT_KIND_STR[ret['values']['kind']]
#    except:
#        try:
#            ret['values'] = Condition.objects.filter(uuid=uuid).values()[0]
#            ret['values'].update(Condition.raw_load_fields_from_cache(cache_manager, uuid, Condition.cached_fields))
#            # ret['values'] = dict([ (k,v) for k,v in ret['values'].items() if k in ['expr', 'verbstatus']   ])
#            ret['values'] = dict([ (k,v) for k,v in ret['values'].items()])
#            ret['values']['kind']= "condition"
#        except:
#            try:
#                ret['values'] = TimeGraph.objects.filter(uuid=uuid).values()[0]
#                ret['values']['kind'] = "timegraph"
#            except:
#                try:
#                    ret['values'] = DataSource.objects.filter(uuid=uuid).values()[0]
#                    ret['values']['kind'] = "datasource"
#                except:
#                        try:
#                            ret['values'] = Event.objects.filter(uuid=uuid).values()[0]
#                            ret['values']['kind']= "event"
#                        except:
#                            ret['values'] = PriorityLabel.objects.filter(label=uuid).values()[0]
#                            ret['values']['kind']= "priority"
#    return ret
        

#def tag_get_info(uuid):
#    ret = {}
#    ret ['values'] = Tag.objects.filter(uuid = uuid).values()[0]
#    return ret

#def eltag_get_info(uuid):
#    ret = {}
#    ret ['values'] = ElementTag.objects.filter(uuid = uuid).values()[0]
#    return ret

#def get_struct(uuid, tenant_name):
#    db_set_current_tenant_schema(tenant_name)
#    ret = {}
#    ret['data'] = element_get_info(uuid)
#    if ret['data']['values']['kind'] != ELEMENT_KIND_STR[1]:
#        ret['parent'] = element_get_info(ret['data']['values']['parent_id'])
#    ret['content'] = element_get_all(tenant_name, uuid)
#    return ret



#def site_get_all(tenant_name):    
#
#    db_set_current_tenant_schema(tenant_name)
#
#    els = {}
#    els['additional'] = {}
#
#    t1 = time.time()
#
#    els['additional']['datagroups'] = {}
#    els['additional']['datagroups']['count'] = DataGroup.objects.all().count()
#
#    t2 = time.time()
#
#    # conditions
#    els['additional']['conditions'] = {}
#    els['additional']['conditions']['count'] = Condition.objects.all().count()
#    # datasources
#    els['additional']['datasources'] = {}
#    els['additional']['datasources']['count'] = DataSource.objects.filter(save_value=True).count()
#    # timegraphs
#    els['additional']['timegraphs'] = {}
#    els['additional']['timegraphs']['count'] = TimeGraph.objects.all().count()
#
#    t3 = time.time()
#
#    els['additional']['trees'] = []
#    els['additional']['tags'] = {}
#    els['additional']['element_tags'] = {}
#
#    return els



#def get_site_struct(tenant_name):
#    db_set_current_tenant_schema(tenant_name)
#    
#    ret = {}
#    
#    ret['content'] = site_get_all(tenant_name)
#    return ret


#def get_tag_struct(uuid, tenant_name):
#    db_set_current_tenant_schema(tenant_name)
#    
#    ret = {}
#    
#    ret['content'] = tag_get_all(tenant_name, uuid)
#    return ret

#---------------------------------------------------------------------------------------

# get condition for DASHBOARD visualization
def condition_get_data(tenant_name, data_filter):
    
    db_set_current_tenant_schema(tenant_name)
    tenant = Tenant.objects.get(name=tenant_name)
    
    try:
        summary      = int( data_filter.pop('summary') )
    except ValueError:
        summary      = 0
    
    summary_data = data_filter.pop('summary_data') 
    tree_id_or_path      = data_filter.pop('tree_id')

    conditions = []
    
    # filtraggio: vediamo se la stringa richiesta e' contenuta negli elementi (in maniera ricorsiva).
    # Cerchiamo l'elemento e mostriamo anche tutti i suoi sottoelementi.
    # es. di un nodo localhost, vogliamo mostrare anche tutti i suoi storage
    element_name_filter = None
    if "element__name__icontains" in data_filter:
        element_name = data_filter.pop('element__name__icontains')
        element_name_filter = Q(element__name__icontains=element_name) | Q(element__parent__name__icontains=element_name)
    
    element_list_filter = None
    if "element__uuid__in" in data_filter:
        element_list = data_filter.pop('element__uuid__in')
        element_list_filter = Q(element__uuid__in=element_list) | Q(element__parent__uuid__in=element_list)
    
    
    if tree_id_or_path:

        # try to get uuid
        f = Q(tenant= tenant, uuid=tree_id_or_path) | Q(tenant = tenant, path=tree_id_or_path)  
        tag = Tag.objects.get(f)  

        tree_id_or_path = tag.uuid

        base_selected_conditions = tag.get_all_conditions()
        
        # applichiamo il filtro sull'element name
        if element_name_filter != None:
            base_selected_conditions = base_selected_conditions.filter(element_name_filter)
        
        if element_list_filter != None:
            base_selected_conditions = base_selected_conditions.filter(element_list_filter)
    
        # applichiamo tutti gli altri filtri
        if  data_filter:
            conds = base_selected_conditions.filter(**data_filter)
        else:
            conds = base_selected_conditions

    else:
        conds = Condition.active_objects.all()
        
        # applichiamo il filtro sull'element name
        if element_name_filter != None:
            conds = conds.filter(element_name_filter)
        
        if element_list_filter != None:
            conds = conds.filter(element_list_filter)
        
        
        # applichiamo tutti gli altri filtri
        if data_filter:
            conds = conds.filter(**data_filter)

    conds = conds.select_related('element', 'element__parent')
            
    for item in conds:
        conditions.append(_get_conditions_data(item))
    # removing duplicates...
    # serve per rimuovere i duplicati di elementi che si trovano due volte nello stesso tag (magari in due sottotag diversi)
    conditions = [dict(t) for t in set([tuple(d.items()) for d in conditions])]

    if (not summary and not summary_data) or (not summary_data and summary):
        return conditions
    else:
        result = {}
        for item in conditions:
            try:
                result["%s|%s" % (item[summary_data], item['status'])] += 1
            except KeyError:
                result.setdefault("%s|%s" % (item[summary_data], item['status']), 1)
        return result

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

#
# FIX: dbilli - questa funzione (e tutte quelle richiamate) e' usata solo per la dashboard.
#               spostare nella dashboard se non necessarie.
#
def _get_tags_conditions_data(tenant_name, data_filter):

	db_set_current_tenant_schema(tenant_name)
	tenant = Tenant.objects.get(name=tenant_name)

	tag_id = data_filter.get('tree_uuid', None)

	if tag_id:

		# try to get uuid
		f = Q(tenant= tenant, uuid=tag_id) | Q(tenant=tenant, path=tag_id)  

		#element = Tag.objects.filter(f) 
		#tag_id = element[0].uuid
		#original_list = element
		#tag_list = element    

		tag_list = Tag.objects.filter(f)
	else:
		# general data for site
		element = tenant

		tag_list = element.child_tags

	data = _get_tag_dict(tenant, tag_list, data_filter)

	return data

def _get_tag_dict(tenant, tag_list, data_filter):

	#
	# Chiediamo lo stato di
	#   * tutti i tag
	#      * tutti i sotto-tag di primo livello
	#      * tutti gli elementi taggati direttamente
	#
	from tags.server.tagsd.api import get_tags_state_safe

	uuid_to_ask = []
	for tag in tag_list:
		uuid_to_ask.append( tag.uuid )
		for e  in tag.child_tags.all()                         : uuid_to_ask.append(e.uuid )
		for et in tag.tagged.filter(directly_tagged=True).all(): uuid_to_ask.append(et.uuid)

	states_by_uuid = get_tags_state_safe(tenant.uuid, uuid_to_ask)

	#
	# Produciamo l'output
	#
	result = []

	for tag in tag_list:
		status = _get_status(tag.uuid, states_by_uuid)
		d = _get_elements_data(tag, status)

		#
		# Tutti i sotto tag di primo livello
		#
		subtags = tag.child_tags.all()
		for e in subtags:

			status = _get_status(e.uuid, states_by_uuid)

			d['children'  ].append( _get_elements_data(e, status) )

		#
		# Elementi taggati direttamente (elementi o condition)
		#
		tagged, elements = tag.get_elementtags_with_elements()

		elements_by_uuid = dict([(el.uuid, el) for el in elements])

		for et in tagged:
			el = elements_by_uuid[et.elementid]

			status = _get_status(et.uuid, states_by_uuid)

			if et.elementtype == 'condition':
				d['conditions'].append( _get_conditions_data(el, status) )
			else:                 
				d['children'  ].append( _get_elements_data  (el, status) )

		d['children'  ] = sorted(d['children'  ], key=lambda k: k['status']) 
		d['conditions'] = sorted(d['conditions'], key=lambda k: k['status']) 

		result.append(d)

	result = sorted(result, key=lambda k: k['status']) 

	return result

def _get_elements_data(e, status):

	if isinstance(e, MonitoredElement):
		return {
			'element__parent__name': e.parent.name if e.parent is not None else None,
			'uuid'                 : e.uuid, 
			'name'                 : e.name,
			'kind'                 : e.kind, 
			'description'          : e.description, 
			'status'               : status,
			'title'                : e.name,
			'priority'             : e.priority,
		}
	elif isinstance(e, Tag):
		return {
			'element__parent__name': e.parent.name if e.parent is not None else None,
			'uuid'                 : e.uuid, 
			'name'                 : e.name,
			'description'          : e.description, 
			'status'               : status,
			'title'                : e.name,
			'kind'                 : 'tag',

			'children'   : [],
			'conditions' : [],
			'datagroups' : [],
		}
	else:
		return {
			'element__parent__name': e.parent.name if e.parent is not None else None,
			'uuid'                 : e.uuid, 
			'name'                 : e.name,
			'description'          : e.description, 
			'status'               : status,
			'title'                : e.name,

			'children'   : [],
			'conditions' : [],
			'datagroups' : [],
		}

def _get_status(uuid, states_by_uuid):

	status = CSTATE_UU
	if states_by_uuid:
		state_data = states_by_uuid.get(uuid, None)
		if state_data:
			status = state_data['visible_status']
	
	return status

def _get_conditions_data(c, status=None): #state_id, states_by_uuid):

	return {
		# FIXME: alcuni degli attributi dela condition sono foreign keys e l'accesso e' inefficente
		# bisogna usare select_related sul queryset che estrae questa condition
		'element__parent__name': c.element.parent.name if c.element.parent is not None else None,
		'uuid'                 : c.uuid, 
		'element__name'        : c.element.name,
		'element__kind'        : c.element.kind, 
		'element__uuid'        : c.element.uuid, 
		'name'                 : c.name, 
		'title'                : c.expanded_title(cache_manager=cache_manager), 
		'status'               : status or c.status, 
		'statuslastchange'     : c.statuslastchange, 
		'classification'       : c.classification, 
		'priority'             : c.priority,
		'element__description'  : c.element.description,
	}

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

from tags.server.tagsd.api import get_tags_state_safe

def get_tree_data(tenant_name, uuid_or_path=None):
	#
	# FIX: NOTA DI dbilli 
	#      LA LOGICA DI ESTRAZIONE DEI DATI E' __MOLTO STRANA__  E NON MI E' FACILE CAPIRE
	#      SE LA CONVERSIONE CHE HO FATTO E' CORRETTA.
	#
	#      QUESTA VIEW SERVE ALLA DASHBOARD (gadget "Tag Tree Table"). BISOGNA RIVEDERE LE SPECIFICHE DEL GADGET.
	#
	#
	#      1) RIVEDERE LA LOGICA
	#  
	#

	db_set_current_tenant_schema(tenant_name)
	tenant = Tenant.objects.get(name=tenant_name)

	if not uuid_or_path:
		# no uuid selected, set tenant data
		element = Tenant.objects.get(name=tenant_name)

		tag_list = element.child_tags.all()

		original_list = element
	else:
		# try to get uuid
		f = Q(tenant= tenant, uuid=uuid_or_path) | Q(tenant = tenant, path=uuid_or_path)  

		element = Tag.objects.get(f)    

		original_list = [ element ] 

		tag_list = [ element ]

		tag_list.extend(element.sub_tags.all())

	# get Elements for selected tags

	elements = ElementTag.objects.filter(tag__in=original_list).exclude(elementtype__in=['datagroup', 'condition'])

	uuid_to_ask = [ e.uuid for e in elements ]

	result = {}
	if tag_list:
		uuid_to_ask += [ t.uuid for t in tag_list ]

		states_by_uuid = get_tags_state_safe(tenant.uuid, uuid_to_ask )
		if states_by_uuid is not None:
			for _t in tag_list:
				status_data = states_by_uuid.get(_t.uuid, None)

				#print status_data
				if status_data is not None:
					status      = CSTATE_TO_CODENAME(status_data['visible_status'])
				else:
					status      = CSTATE_TO_CODENAME(CSTATE_UU)

				result[_t.uuid] = (_t.name, status , 'tree', '')
	else:
		uuid_to_ask += [ t.uuid for t in original_list ]

		states_by_uuid = get_tags_state_safe(tenant.uuid, uuid_to_ask )


	for _e in elements:

		if states_by_uuid is not None:
			status_data = states_by_uuid.get(_e.uuid, None)

			#print status_data
			if status_data is not None:
				CSTATE_TO_CODENAME(status_data['visible_status'])
			else:
				status      = CSTATE_TO_CODENAME(CSTATE_UU)
		else:
			status      = CSTATE_TO_CODENAME(CSTATE_UU)

		#
		# FIX: NOTA DI dbilli 
		#      ESTREMAMENTE INFEFFICIENTE!!!!!!!!! UNA QUERY SUL DB PER OGNI ELEMENTO DEL TAG. DA CAMBIARE SUBITO!!!

		_melement = MonitoredElement.objects.filter(tenant__name = tenant_name, uuid=_e.elementid)[0]
		if _melement.parent:
			result[_e.elementid] = (_melement.name, status, _melement.kind, _melement.parent.name)
		else:
			result[_e.elementid] = (_melement.name, status, _melement.kind, '')

	return result

