
from cli.clilib.ioslike import *
from cli.tokens import *

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

def cmd_set_minimum_priority_level(cli):

	tenant_name = cli.env['CONFIG_TENANT']
	tenant = tenant_get(tenant_name)
	db_set_current_tenant_schema(tenant.name)
	
	if cli.canonical_words[0] != 'no':

		selected_label = cli.canonical_words[1]
		selected_level = PriorityLabel.objects.get(tenant=tenant, label=selected_label)

		current_minimum_priority  = tenant.get_setting(TenantSetting.SETTING_MINIMUM_LEVEL)

		if selected_level.min_level == current_minimum_priority:
			return

		current_critical_priority = tenant.get_setting(TenantSetting.SETTING_CRITICAL_LEVEL)

		if selected_level.min_level > current_critical_priority:
			print "Minimum level (%s) can not be greater than critical level (%s)" % (selected_level.min_level, current_critical_priority)
			return

		TenantSetting.save_setting(tenant, TenantSetting.SETTING_MINIMUM_LEVEL, selected_level.min_level)
	else:
		TenantSetting.save_setting(tenant, TenantSetting.SETTING_MINIMUM_LEVEL, PRIORITY_NONE)


def cmd_set_critical_priority_level(cli):

	tenant_name = cli.env['CONFIG_TENANT']
	tenant = tenant_get(tenant_name)
	db_set_current_tenant_schema(tenant.name)

	if cli.canonical_words[0] != 'no':

		selected_label = cli.canonical_words[1]
		selected_level = PriorityLabel.objects.get(tenant=tenant, label=selected_label)

		current_critical_priority  = tenant.get_setting(TenantSetting.SETTING_CRITICAL_LEVEL)

		if selected_level.min_level == current_critical_priority:
			return

		current_minimum_priority = tenant.get_setting(TenantSetting.SETTING_MINIMUM_LEVEL)

		if selected_level.min_level < current_minimum_priority:
			print "Critical level (%s) can not be lower than minimum level (%s)" % (selected_level.min_level, current_minimum_priority)
			return

		TenantSetting.save_setting(tenant, TenantSetting.SETTING_CRITICAL_LEVEL, selected_level.min_level)
	else:
		TenantSetting.save_setting(tenant, TenantSetting.SETTING_CRITICAL_LEVEL, PRIORITY_MAX + 1)



menu_config_web_settings = [

	T_Keyword('critical-priority-level', help='', pipe=None, subtree=[
		T_PriorityLevelCompleter( help='Label', pipe=None, callback=cmd_set_critical_priority_level)
	]),
	T_Keyword('minimum-priority-level', help='', pipe=None, subtree=[
		T_PriorityLevelCompleter( help='Label', pipe=None, callback=cmd_set_minimum_priority_level)
	]),

]


menu_config_no_web_settings = [

		T_Keyword('minimum-priority-level' , help='Unset minimum priority' , pipe=None, callback=cmd_set_minimum_priority_level),
		T_Keyword('critical-priority-level', help='Unset critical priority', pipe=None, callback=cmd_set_critical_priority_level),

]
