
from core.models import *

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

def tenant_show_settings(cli, tenant):
	
	minimum_priority  = tenant.get_setting(TenantSetting.SETTING_MINIMUM_LEVEL)
	critical_priority = tenant.get_setting(TenantSetting.SETTING_CRITICAL_LEVEL)

	cli.prnt('Settings:')
	cli.prnt('\tMinimum  priority: %s %s'  % (minimum_priority  if minimum_priority  != PRIORITY_NONE      else '-', PriorityLabel.get_label(minimum_priority) or ''))
	cli.prnt('\tCritical priority: %s %s'  % (critical_priority if critical_priority != (PRIORITY_MAX + 1) else '-', PriorityLabel.get_label(critical_priority) or ''))

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

def tenant_show_configuration_web_settings(cli, tenant, level=0):
	
	minimum_priority  = tenant.get_setting(TenantSetting.SETTING_MINIMUM_LEVEL)
	critical_priority = tenant.get_setting(TenantSetting.SETTING_CRITICAL_LEVEL)

	cli.pij(level, cli.CLI_COMMENT("#")             )
	cli.pij(level, cli.CLI_COMMENT("# WEB SETTINGS"))
	cli.pij(level, cli.CLI_COMMENT("#")             )

	if critical_priority and ( PRIORITY_MIN <= critical_priority and critical_priority <= PRIORITY_MAX) :
		cli.pij(level, cli.CLI_COMMENT("# critical priority = %s" % (critical_priority)))
		pl = PriorityLabel.get_label(critical_priority)
		if pl:
			cli.pij(level, cli.CLI_KEYWORD("critical-priority-level"), pl )

	if minimum_priority and ( PRIORITY_MIN <= minimum_priority and minimum_priority <= PRIORITY_MAX) :
		cli.pij(level, cli.CLI_COMMENT("# Minimum priority = %s" % (minimum_priority)))
		pl = PriorityLabel.get_label(minimum_priority)
		if pl:
			cli.pij(level, cli.CLI_KEYWORD("minimum-priority-level") , pl )
