
import time

from django.template import Context, Template
	
from webui.gui.components.widgets import BaseWidget

class DummyWidget(BaseWidget):
	
	def __init__(self, widget_module_name):
		
		super(DummyWidget, self).__init__(widget_module_name)
		
		self.name = 'dummy'
	
	def render_content(self):
		
		_ = self.get_translator()
		
		locale_text = _("This is a i18n dummy text")
		
		template_string = self.load_template_string('dummy.html')
		
		
		t = Template(template_string)
		c = Context({
			"WIDGET_NAME": self.get_module(),
			"TIME"       : time.time(),
			'locale_text': locale_text
		})
		output_text = t.render(c)
		
		return output_text


def get_widget_class(widget_module_name):
	return DummyWidget(widget_module_name)
