# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

import time
from django.conf import settings

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

def webui_template_processor(request):

	"""
	Automatically defines WEBUI settings inside templates' context
	"""

	user = request.user

	capabilities = request.user.get_capabilities(request.tenant) if request.user.is_authenticated() else []

	context = {
		'SETTINGS'              : settings,
		'INSTALLED_APPS'        : settings.INSTALLED_APPS,
		'BASE_WEB_URL_PREFIX'   : settings.BASE_WEB_URL_PREFIX,
		'STATIC_WEB_URL_PREFIX' : settings.STATIC_WEB_URL_PREFIX,
		'TENANT'                : (request.tenant if hasattr(request, 'tenant') else None),

		'USER_CAPABILITIES'     : capabilities,
		'TIME'                  : int(time.time())
	}

	return context

