# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

import os
import os.path
import re

from django import template
from django.conf import settings

register = template.Library()

#-------------------------------------------------------------------------------#
#                                                                               #
#-------------------------------------------------------------------------------#

@register.simple_tag
def static_content(fileurl):

	if 0:
		text = """<link rel="stylesheet" type="text/css" href="/static/%s" />""" % (fileurl)
	
	else:
		file_path = os.path.join(settings.STATIC_WEB_ROOT, fileurl)
		f = open(file_path, "r+")
		file_content = f.read()
		f.close()

		text = """
		<style>
		%s
		</style>
		""" % (file_content)

	return text

#-------------------------------------------------------------------------------#
#                                                                               #
#-------------------------------------------------------------------------------#

@register.simple_tag
def static_javascript(fileurl):

	if 1:
		text = """<script type="text/javascript" src='/static/%s'></script>""" % (fileurl)
	else:
		file_path = os.path.join(settings.STATIC_WEB_ROOT, fileurl)
		f = open(file_path, "r+")
		file_content = f.read()
		f.close()

		text = """
		<script>
		%s
		</script>
		""" % (file_content)

	return text

#-------------------------------------------------------------------------------#
#                                                                               #
#-------------------------------------------------------------------------------#

@register.filter(name='url2link', is_safe=True)
def url2link(value):

	if not value:
		return value

	# Replace url to link
	urls = re.compile(r"((https?):((//)|(\\\\))+[\w\d:#@%/;$()~_?\+-=\\\.&]*)", re.MULTILINE|re.UNICODE)

	value = urls.sub(r'<a href="\1" target="_blank">\1</a>', value)

	# Replace email to mailto
	#urls = re.compile(r"([\w\-\.]+@(\w[\w\-]+\.)+[\w\-]+)", re.MULTILINE|re.UNICODE)
	#
	#value = urls.sub(r'<a href="mailto:\1">\1</a>', value)

	return value

#-------------------------------------------------------------------------------#
#                                                                               #
#-------------------------------------------------------------------------------#

@register.filter(name='ishtml')
def ishtml(value):

	if not value:
		return False

	has_tags = re.search('<[^<]+?>', value) is not None  # FIX: use better regexp

	return has_tags

#-------------------------------------------------------------------------------#
#                                                                               #
#-------------------------------------------------------------------------------#

@register.filter(name='debug')
def debug(value):

	print ">" * 80, "START"
	print value
	print ">" * 80, "STOP"

	return value


#-------------------------------------------------------------------------------#
#                                                                               #
#-------------------------------------------------------------------------------#

@register.filter(name='removespaces')
def removespaces(value):
	return value.replace(' ','')
