# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.

import os

from django.http import HttpResponse
from django.http import Http404	
from django.core.exceptions import PermissionDenied
from django.template import RequestContext
from django.template import Context
from django.utils.translation import ugettext as _


import sanet_common


import sanet_poller
import conf
from conf import get_configuration

from core.api.base import db_set_current_tenant_schema
from core.models import *

	
from webui.decorators import tenant_dependent


from tags.api.state import *



def test500(request):
	
	raise Exception("Test 500")

def test404(request):
	
	raise Http404

def test403(request):
	
	from django.core.exceptions import PermissionDenied
	
	raise PermissionDenied

def environment(request):
	
	if not request.user.is_authenticated():
		return HttpResponse("User not authenticated.")

	if not settings.DEBUG:
		return HttpResponse("DEBUG MODE not active.")
	

	context = RequestContext(request, {})
	
	
	show_keys = [
		'BASE_DIR',
		'LOG_DIR',
		'PID_DIR',
		'DATA_DIR',
		'MEDIA_DIR',
		'BASE_URL_PREFIX',
		'STATIC_WEB_ROOT',
		'MEDIA_WEB_ROOT',
	]
	
	request_keys = [
		'HTTP_USER_AGENT',
	]
	
	import sys
        from pprint import pformat
        from django.utils.html import escape
        
        from conf import get_configuration

	config = get_configuration()
        
        output = []

	output += [
		'SETTINGS',
		'========',
	]
        output += [ "%s = %s" % (k,getattr(config,k)) for k in sorted(show_keys) ]
        output += [""]


	output += [
		'SYS ENVIRONMENT',
		'===============',
	]
        output += [ "%s = %s" % (k,v) for k,v in sorted(os.environ.items()) ]
        output += [""]


        output += [ 
		'HTTP REQUEST DATA', 
		'==========='
	]
        output += [ "%s = %s" % (k,request.META[k]) for k in sorted(request_keys) ]
        output += [""]
        
        output += [ 
		'CONTEXT', 
		'==========='
        ]
        output += [pformat(val) for val in sorted(context) if val]


        output.append('\n\n')
        
        output.append( pformat(sys.modules) )
        
        body_text = '\n'.join(output)	
	
	return HttpResponse('<pre>' + escape(body_text) + '<pre>')


#def get_anchestors(tags_by_id, tag):
#	r = []
#	while tag.parent_id is not None:
#		
#		parent = tags_by_id.get( tag.parent_id, None)
#		r.append(parent)
#		tag = parent
#	return r





@tenant_dependent
def testxxx(request):
	
	from tags.models import Tag
	
	#n = MonitoredNode.objects.get(uuid=request.GET_OR_POST()['uuid'])
	#d = read_data_from_ipmon(n)
	
	tenant = request.tenant
	
	data = None
	
	db_set_current_tenant_schema(tenant.name)
	
	dgid = request.GET_OR_POST()['id']
	
	dg = DataGroup.objects.get(uuid=dgid)
	
	return HttpResponse( dg.get_state() )



@tenant_dependent
def test(request):
	
	return HttpResponse("test")

#	from tags.models import Tag
#	
#	#n = MonitoredNode.objects.get(uuid=request.GET_OR_POST()['uuid'])
#	#d = read_data_from_ipmon(n)
#
#	tenant = request.tenant
#
#	data = None
#
#	db_set_current_tenant_schema(tenant.name)
#	
#	
#	v = [ None ] * (PRIORITY_MAX+1)
#	for label in PriorityLabel.objects.order_by('min_level'):
#		for i in xrange(label.min_level , label.max_level + 1):
#			v[i] = label.id
#	
#	
#	
#
#	path = request.GET_OR_POST()['path']
#
#
#
#	
#	#tag = Tag.objects.get(path=path)
#	
#	#
#	# Costruisco l'albero dei tag
#	#
#	#all_tags = tenant.child_tags
#	
#	tags = tenant.child_tags
#	
#	for tag in tags:
#		
#		
#		print "*******************************************************************************"
#		print "*******************************************************************************"
#		print "*******************************************************************************"
#		print "*******************************************************************************"
#		print "*******************************************************************************"
#		print tag
#	
#		all_tags = [ tag, ] + list(tag.sub_tags.all())
#
#		tree_nodes = create_tag_tree_structure(all_tags)
#
#		root_node = tree_nodes.get(tag.uuid)
#
#		root_node.visit()
#
#		print "------------------------------------------------"
#		
#		#
#		# Trovo gli elementi taggati
#		#
#		result = get_tag_data(tag.path)
#
#		ids = [ r['et_id'] for r in result ]
#		
#		conditions_by_id = dict([ (c.uuid , c ) for c  in  Condition.objects.filter(uuid__in=ids).all()        ])
#		element_by_id    = dict([ (me.uuid, me) for me in  MonitoredElement.objects.filter(uuid__in=ids).all() ])
#
#		#
#		# Prendo gli elementi e costruisco l'albero degli elementi sotto i tag
#		#
#		create_tree_structure(tree_nodes, result, element_by_id, conditions_by_id)
#
#		#
#		# Elaborazione stati
#		#
#		root_node = tree_nodes.get(tag.uuid)
#		root_node.visit()
#		root_node.get_state()
#
#		for tn in tree_nodes.values():
#			print tn, tn.e, tn.status, tn.exploded, tn.alarms
#
#	#
#	# FINE
#	# 
#	data = tree_nodes 	
#	s = pprint.pformat(data)
#	return HttpResponse('<pre>' + s + '<pre>')






"""
def update_tree_counters( root, tree, totals_by_entity_id ):
	
	return _update_tree_counters( root, tree, totals_by_entity_id )
	
def _update_tree_counters( tag, tree, totals_by_entity_id ):	

	subtotals = totals_by_entity_id.get(tag.uuid, TOTALS('tag', tag.uuid))
	
	subs = tree[tag.uuid]
	if subs:
		for sub in subs:
			totals = _update_tree_counters(sub, tree, totals_by_entity_id)
			subtotals = SUM_TOTALS(subtotals, totals)
			
		totals_by_entity_id[tag.uuid] = subtotals

	return subtotals


def update_totals(etype, eid, totals_by_entity_id, row, critical_priority):
	totals = totals_by_entity_id.get( eid, totals_by_entity_id.setdefault( eid, TOTALS(etype, eid) ) )
	
	totals['count_alarms'       ] += 1
	totals['count_alarms_down'  ] += 1 if (row['c_s'] == CSTATE_DN) else 0
	totals['count_critical_down'] += 1 if ((row['c_priority'] >= critical_priority) and (row['c_s'] == CSTATE_DN)) else 0
	totals['count_primary'      ] = 0
	totals['count_primary_down' ] = 0


def TOTALS(etype, eid):
	return {
		'etype'              : etype,
		'eid'                : eid, 
		'count_alarms'       : 0,
		'count_alarms_down'  : 0,
		'count_critical_down': 0,
		'count_primary'      : 0,
		'count_primary_down' : 0,
	}
	
	
def SUM_TOTALS(t1,t2):
	d = dict(t1)
	d['count_alarms'        ] += t2['count_alarms']
	d['count_alarms_down'   ] += t2['count_alarms_down']
	d['count_critical_down' ] += t2['count_critical_down']
	d['count_primary'       ] += t2['count_primary'      ]
	d['count_primary_down'  ] += t2['count_primary_down' ]
	return d
	
"""
	
	
	
	









































"""	
	#
	# Calcoliamo i totali
	#
	critical_priority = 0

	tag_ids = {}
	element_ids = {}
	
	totals_by_entity_id = {}
	result = dictfetchall(cursor)
	for row in result:
		
		etype = row['et_type']
		eid   = row['et_id']

		# Ricordiamoci che abbiamo visto questo tag
		tag_id = row['t_id']
		tag_ids[tag_id] = True

		if row['et_type'] == 'condition':
			element_id = row['c_e_id']
			
			update_totals('tag'    , tag_id    , totals_by_entity_id, row, critical_priority)
			update_totals('element', element_id, totals_by_entity_id, row, critical_priority)
			
			parent_element_id = row['e_p_id']
			if parent_element_id is not None:
				update_totals('element', parent_element_id, totals_by_entity_id, row, critical_priority)
				
		elif row['et_type'] in ['node', 'interface', 'storage', 'service', 'device']:
			if row['et_dt']:
				element_ids[eid] = True
				
	#
	# DEBUG
	#
	for eid, entry in totals_by_entity_id.items():
		if entry['etype'] == 'tag':
			e = Tag.objects.get(uuid=eid)
		if entry['etype'] == 'element':
			e = MonitoredElement.objects.get(uuid=eid)

		print "%-20s %s %s" % (e.path, eid, entry, )
	
	
	update_tree_counters(root, tree, totals_by_entity_id)
	
	#
	# 
	#
	print "------------- FINALE ------------"
	for eid, entry in totals_by_entity_id.items():
		if entry['etype'] == 'tag':
			e = Tag.objects.get(uuid=eid)
		if entry['etype'] == 'element':
			e = MonitoredElement.objects.get(uuid=eid)

		print "%-20s %s %s" % (e.path, eid, entry, )

	#
	# Update tree counters 
	#

	s = pprint.pformat(data)
	return HttpResponse('<pre>' + s + '<pre>')
"""




























import pprint
from core.models import MonitoredNode


class fakelog(object):
	def log(self, *args):
		self.p(*args)
	def debug(self, *args):
		self.p(*args)
	def warning(self, *args):
		self.p(*args)
	def p(self, *args):
		pass 

def read_data_from_ipmon(resource):
	from ipmon.discovery.protocols.snmp import SnmpProtocolHandler
	from ipmon.discovery.helpers.snmp import SnmpHelper
	from ipmon.discovery.helpers.snmp import IFTYPE_STR
	from ipmon.discovery.helpers.snmp import *

	IFACE_STATUS_UP      = 1
	IFACE_STATUS_DN      = 2
	IFACE_STATUS_TESTING = 3

	IFACE_STATUS_STR_SHORT = {
		 IFACE_STATUS_UP: 'Up',
		 IFACE_STATUS_DN: 'Down',
		 IFACE_STATUS_TESTING: 'Testing',
	}

	SELECTED_IFACES = [
		SNMP_IFTYPE_SOFTWARELOOPBACK,
		SNMP_IFTYPE_ETHERNET_CSMACD,
		117                        ,  # obsolete "gigabitEthernet" (117)
		#SNMP_IFTYPE_E1            ,
		SNMP_IFTYPE_ATM           ,
		SNMP_IFTYPE_ATMSUB        ,
		SNMP_IFTYPE_ATMIMA        ,
		SNMP_IFTYPE_ADSL          ,
		SNMP_IFTYPE_IEEE80211     ,
		SNMP_IFTYPE_SERIAL        ,
		SNMP_IFTYPE_XDSL          ,
		SNMP_IFTYPE_PROPVIRTUAL   ,
		117,  # gigabitEthernet (117)
	]
	
	l = fakelog()
	if resource.__class__ == MonitoredNode:
		nodes = [resource]
	else:
		nodes = resource.nodes
		
	data = []
	for node in nodes:
		#try:
		if 1:
			snmp = SnmpProtocolHandler(node.name)
			
			snmp.set_supported_version(node.snmp_version, node.snmp_community)
			helper = SnmpHelper(snmp)
			helper.set_log(l)
			
			ifaces  = helper.get_ifaces_by_ifindex()

			node_ifaces_by_ifindex = {}
			
			for ni in node.get_ifaces():
				ni = ni.get_specific_element()
				node_ifaces_by_ifindex[ ni.ifindex ] = ni

			for (ifindex, i) in ifaces.items():
				#if i['ifType'] not in SELECTED_IFACES:
				#	continue
				data += [ { 
					'node'     : node,
					'type'     : fix_iftype_str(IFTYPE_STR(i['ifType']) if IFTYPE_STR(i['ifType']) != None else 'unknown(%s)' % (i['ifType'])),
					'status'   : IFACE_STATUS_STR_SHORT.get(i['ifOperStatus'], 'n/a'), 
					'admstatus': IFACE_STATUS_STR_SHORT.get(i.get('ifAdminStatus',-1), 'n/a'), 
					'descr'    : i['ifDescr'], 
					'alias'    : i['ifAlias'],
					'addr'     : i['ifPhysAddress'],
					'speed'    : readable_speed(i['ifHighSpeed']),
					'ifindex'  : ifindex, 
					'iface'    : node_ifaces_by_ifindex.get(ifindex, None),
				}]
		#except Exception, e:
		#	print e
		#	pass
	return data
		
def readable_speed(highspeed):
	if highspeed == 0: return ''
	if highspeed < 1000   : return '%s M' % ( highspeed )
	return '%s G' % ( highspeed/1000 )
	
def fix_iftype_str(iftypestr):
	if iftypestr.startswith('atm'):
		return 'atm';
	else:
		return iftypestr



from sanet_common.sanetdefs.constants import _CSTATE_TO_CODENAME
from django.template.response import TemplateResponse

@tenant_dependent
def set_conditions_status(request):
	
	tenant = request.tenant
	db_set_current_tenant_schema(tenant.name)

	if request.POST:
		
		changed_conditions = {}
		
		for k, v in request.POST.items():
			c_uuid, field = k.split('_')
			
			c = changed_conditions.get( c_uuid, changed_conditions.setdefault( c_uuid, Condition.objects.get(uuid=c_uuid) ) )
			
			if v:
				v = int(v)
			else:
				v = 0
			
			setattr(c, field, v)

		for c in changed_conditions.values():
			c.save()


	conditions = Condition.objects.order_by('path').all().values()
	
	states = dict(_CSTATE_TO_CODENAME.items())
	
	del states[None]
	
	context = {
		'states'     : states.items() ,
	
		'conditions': conditions,
	}
	
	print states
	
	return TemplateResponse(request, "debug/set_conditions_status.html", context)


