# Copyright (C) 2018 Laboratori Guglielmo Marconi S.p.A. <http://www.labs.it>
#
# This file is part of SANET
# SANET is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, version 3 of the License
#
# SANET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with SANET. If not, see <http://www.gnu.org/licenses/>.


from django.http import HttpResponseRedirect

from core.compatibility import reverse
from core.models import TimeGraph

from tags.models import ElementTag

from webui.models import *
from webui.decorators import tenant_dependent

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

@tenant_dependent
def timegraph_to_node(request, uuid):

	# USATA DALLA DASHBOARD

	try:
		t = TimeGraph.objects.get(uuid = uuid)
	except TimeGraph.DoesNotExist, e:
		t = TimeGraph.get_by_path(uuid) #uuid could be a path

	e = t.datagroup.element

	url = reverse('resource_page', kwargs={'rt': e.resource_type, 'uuid': e.uuid} )

	return HttpResponseRedirect( url )

#------------------------------------------------------------------------------#
#                                                                              #
#------------------------------------------------------------------------------#

@tenant_dependent
def taguuid_to_element(request, uuid):
	return _taguuid_to_element(request, uuid)
	
def _taguuid_to_element(request, uuid):

	et = ElementTag.objects.get(uuid=uuid)
	e  = et.element
	url = reverse('resource_page', kwargs={'rt':e.resource_type, 'uuid': e.uuid} )

	return HttpResponseRedirect( url )


@tenant_dependent
def timegraph_to_conditions(request, uuid):

	# USATA DALLA DASHBOARD

	try:
		c = Condition.objects.get(uuid = uuid)
	except Condition.DoesNotExist, e:
		c = Condition.objects.get(path = uuid) #uuid could be a path

	e = c.element

	url = reverse('resource_page', kwargs={'rt': e.resource_type, 'uuid': e.uuid} )

	return HttpResponseRedirect( url )
