
import tempfile
import base64

import cairo
import rsvg

from django.http import HttpResponse
from django.contrib.auth.decorators import login_required

#-------------------------------------------------------------------------------#
#                                                                               #
#-------------------------------------------------------------------------------#

@login_required
def render_img(request):
    
	maxwidth  = 3000
	maxheight = 3000

	format = request.GET_OR_POST().get('format', 'png')
	data   = request.GET_OR_POST().get('svgdata')
	
	data   = data.encode('ascii', 'xmlcharrefreplace')
	#data.decode('latin-1')

	svg = rsvg.Handle(data=data)

	x = width  = svg.props.width
	y = height = svg.props.height

	yscale = xscale = 3
   
	if format == "png":
		surface = cairo.ImageSurface(cairo.FORMAT_ARGB32, x*xscale, y*yscale)
		context = cairo.Context(surface)
		
		# Disegno uno sfondo bianco
		context.set_source_rgb(255, 255, 255)
		context.rectangle(0, 0, x*xscale, y*yscale)
		context.fill()
		
		context.scale(xscale, yscale)
		
		svg.render_cairo(context)
		ofile = tempfile.NamedTemporaryFile()
		surface.write_to_png(ofile)

		ofile.seek(0)

		a = ofile.read()

		ofile.close()

		return HttpResponse("data:image/png;base64,%s" % base64.b64encode(a))

	elif format == "pdf":
		ofile = tempfile.NamedTemporaryFile(delete=False)
		surface = cairo.PDFSurface(ofile.name, x*xscale, y*yscale)
		context = cairo.Context(surface)
		context.scale(xscale, yscale)
		svg.render_cairo(context)

		ofile.seek(0)

		a = ofile.read()

		ofile.close()

		return HttpResponse("data:application/pdf;base64,%s" % base64.b64encode(a))
